#!/bin/sh
#
# bindist.sh
# $Id: bindist.sh,v 2.3 1998/10/05 07:22:57 schmitzj Exp $
#

die()
{
	echo "ERROR: $*"
	exit 1
}

version=`sed -e 's/^[ 	]*VERSION[ 	]*=[ 	]*//p' -e 'D' VERSION`
package=`sed -e 's/^[ 	]*PACKAGE[ 	]*=[ 	]*//p' -e 'D' VERSION`
DEST=`pwd`/$package

rm -fr $DEST

echo "creating $DEST"
mkdir $DEST || die 

echo "creating $DEST/converters"
mkdir $DEST/converters || die

echo "creating $DEST/plugins"
mkdir $DEST/plugins || die

make -s \
	INSTALL=`pwd`/config/install-sh \
	bin_PROGRAMS="xc-mail xc-mail_s" \
	converterdir=$DEST/converters \
	pluginsdir=$DEST/plugins \
	bindir=$DEST \
	install-strip | grep -v "^[/ 	]"

for i in plugins/*/ABOUT; do
	if test -f $i -a -f $DEST/`dirname $i`_pl.o ; then
		cp $i $DEST/`dirname $i`.ABOUT
	fi
done

echo "creating other files"
cp FAQ README config/Install.sh src/xc-mail.xpm $DEST || die

tar cf - xc-mail | gzip -c > XCmail-${version}.bin.`uname`.tar.gz
rm -fr ./xc-mail

echo
echo XCmail-${version}.bin.`uname`.tar.gz created
