dnl Process this file with autoconf to produce a configure script.

AC_INIT(src/mailer.h)
AC_PREREQ(2.12)
AC_CONFIG_AUX_DIR(config)
AM_INIT_AUTOMAKE(__PACKAGE,__VERSION)
AM_MAINTAINER_MODE
AM_EXEEXT

AC_ARG_WITH(plugins,   [  --without-plugins       no plugins (link them static)])
AC_ARG_WITH(pgp,       [  --without-pgp           no pgp support])
AC_ARG_WITH(dmalloc,   [  --with-dmalloc          include dmalloc (for debugging)])

AC_PREFIX_DEFAULT(/usr/local)

AC_PATH_PROGS(PERL, perl,perl,[$PATH /bin /usr/bin /usr/local/bin /usr/net/bin])

AM_CONDITIONAL(STATIC_PLUGINS, test x$with_plugins = xno)
AM_CONDITIONAL(USE_PGP, test x$with_pgp != xyes)
AM_CONDITIONAL(USE_DMALLOC, test x$with_dmalloc = xyes)

AC_CONFIG_SUBDIRS([plugins src])
AC_OUTPUT([
	Makefile
	converters/Makefile
	converters/elm2xcmail
	converters/ns2xcmail
	config/Makefile])
