m4_changequote(<<<,>>>)m4_dnl
m4_ifelse(FOR_PLUGINS,1,,m4_define(FOR_PLUGINS,0))m4_dnl

dnl Process this file with autoconf to produce a configure script.

AC_INIT(Makefile.am)
AC_PREREQ(2.12)
AC_CONFIG_AUX_DIR(../config)
AM_INIT_AUTOMAKE(__PACKAGE,__VERSION)

AC_ARG_PROGRAM

AM_CONFIG_HEADER(configure.h)
AM_MAINTAINER_MODE

AC_SUBST(LIBOBJS)
AC_SUBST(DYNA_LIBS)
AC_SUBST(DYNA_LDFLAGS)
AC_SUBST(STAT_LIBS)

AC_ARG_WITH(plugins,   [  --without-plugins       no plugins (link them static)])
AC_ARG_WITH(pgp,       [  --without-pgp           no pgp support])
AC_ARG_WITH(dmalloc,   [  --with-dmalloc          include dmalloc (for debugging)])

dnl ********************************************************************
dnl   Main
dnl ********************************************************************

AC_PREFIX_DEFAULT(/usr/local)

if test ${prefix=NONE} = NONE ; then
	prefix=/usr/local
fi

if test ${with_plugins=yes} != yes ; then
	XC_MSG_NO_PLUGINS
fi

if test ${with_pgp=yes} = yes ; then
	AC_DEFINE(USEPGP)
fi

dnl determine system type
dnl 
XC_CHECK_UNAME
XC_CHECK_RELEASE
XC_CHECK_ARCH
AC_CANONICAL_HOST
dnl AC_CANONICAL_BUILD

dnl Checks for programs.
dnl 
AC_PROG_CC
AC_PROG_CXX
AC_PROG_AWK
AM_PROG_INSTALL
AM_PROG_LIBTOOL
AC_PROG_LN_S
AC_CHECK_PROGS(LS, ls)
AC_CHECK_TOOL(LD, ld, true)
AC_CHECK_TOOL(RANLIB, ranlib, true)
AC_CHECK_TOOL(LDD, ldd, true)
AC_PATH_PROGS(PERL, perl,perl,[$PATH /bin /usr/bin /usr/local/bin /usr/net/bin])

m4_ifelse(FOR_PLUGINS,0,m4_dnl

	AC_PATH_PROGS(SENDMAIL,sendmail,sendmail,[/usr/lib /usr/sbin /usr/local/lib /usr/local/sbin])
	AC_DEFINE_UNQUOTED(SENDMAIL,"$SENDMAIL")

	AC_PATH_PROGS(PGPPRG,pgp,pgp,[/usr/bin /usr/local/bin])
	AC_DEFINE_UNQUOTED(PGPPRG,"$PGPPRG")

	AC_PATH_PROGS(ISPELLPRG,ispell,ispell,[/usr/bin /usr/local/bin])
	AC_DEFINE_UNQUOTED(ISPELLPRG,"$ISPELLPRG")

)m4_dnl

AC_AIX
AC_C_CONST
AC_C_BIGENDIAN
AC_C_CHAR_UNSIGNED
AM_EXEEXT

AC_PATH_X
AC_PATH_XTRA
XC_CHECK_INCLUDEPATH(/opt/SUNWspro/SC4.0/include/CC)

dnl Checks for libraries.
dnl 
AC_MSG_CHECKING(for Xclasses lib environment)
if test "$XCLASSESLIB" != "" ;then
	LIBS="-L$XCLASSESLIB $LIBS"
	AC_MSG_RESULT(yes)
else
	AC_MSG_RESULT(no)
fi

AC_MSG_CHECKING(for Xclasses include environment)
if test "$XCLASSESINCLUDE" != "" ;then
	CPPFLAGS="$CPPFLAGS -I$XCLASSESINCLUDE"
	AC_MSG_RESULT(yes)
else
	AC_MSG_RESULT(no)
fi

AC_CHECK_LIB(m, main)
AC_CHECK_LIB(g++, main)
XC_CHECK_LIBA(LIBA_GPP, g++)
AC_CHECK_LIB(stdc++, main)
XC_CHECK_LIBA(LIBA_STDCPP, stdc++)
AC_CHECK_LIB(compat, main)
AC_CHECK_LIB(posix4, main)
AC_CHECK_LIB(X11, main,,[
	AC_MSG_RESULT(checking for X11 library path manually)
	if test ${x_libraries=NONE} != NONE ; then
		LIBS="-L$x_libraries $LIBS"
	fi
	AC_CHECK_LIB(X11,exit)
])
AC_CHECK_LIB(Xext, main)
AC_CHECK_LIB(Xpm, main)
XC_CHECK_LIBA(LIBA_XPM, Xpm)
AC_CHECK_LIB(bsd, main)
XC_CHECK_LIBA(LIBA_XCLASSES, Xclasses)
AC_CHECK_LIB(Xclasses, main,,[
	if test ${LIBA_XCLASSES=NONE} = NONE ; then
		AC_MSG_ERROR("\nXclasses is needed to build XCmail\nYou will find it at http://www.fsai.fh-trier.de/~schmitzj/Xclasses/\n")
	fi
	LIBS="$LIBS ${LIBA_XCLASSES}"
])
AC_CHECK_LIB(dl, main,[
	DYNA_LIBS="$DYNA_LIB -ldl"
])

if test ${with_dmalloc=no} = yes ;then
	AC_CHECK_LIB(dmalloc, main)

	XC_CHECK_LIBA(LIBA_DMALLOC, dmalloc)

	AC_MSG_CHECKING(for dmalloc++.o)
	if test ${LIBA_DMALLOC=NONE} != NONE ; then
		__DMALLOCPP_O=`dirname $LIBA_DMALLOC`/dmalloc++.o
		if test -f $__DMALLOCPP_O ; then
			LIBS="$__DMALLOCPP_O $LIBS"
		fi
		AC_MSG_RESULT(yes)
	else
		AC_MSG_RESULT(no)
	fi
fi

dnl Checks for header files.
AC_HEADER_STDC
AC_CHECK_HEADERS(fcntl.h strings.h sys/select.h sysent.h)
AC_CHECK_HEADERS(sys/time.h Xclasses/Xclasses.h)
AC_CHECK_HEADERS(X11/X.h)

if test ${with_dmalloc=no} = yes ;then
	AC_CHECK_HEADERS(dmalloc.h,
	[
		AC_MSG_CHECKING(location of dmalloc header)
		AC_CACHE_VAL(xc_cv_dmalloc_header,
		[
			echo "#include <dmalloc.h>">/tmp/$$.c
			xc_cv_dmalloc_header=`($CC -E -H /tmp/$$.c >/dev/null )2>&1| grep dmalloc.h`
			rm -f /tmp/$$.c
		])
		if test ${xc_cv_dmalloc_header=NONE} = NONE ; then
			AC_MSG_RESULT(none)
		else
			AC_MSG_RESULT($xc_cv_dmalloc_header)
			CPPFLAGS="-include $xc_cv_dmalloc_header $CPPFLAGS"
		fi
	])
fi

if test ${with_plugins=yes} = yes ; then

m4_ifelse(FOR_PLUGINS,1,<<<m4_dnl

	case $host in
	
		*-freebsd*)
			CXXFLAGS="-fPIC $CXXFLAGS"
			CCFLAGS="-fPIC $CXXFLAGS"
			;;
	esac

	XC_DO_TEXT2H(freemail_h,spam_bouncer/freemail,spam_bouncer/freemail.h)
	XC_DO_TEXT2H(legitlists_h,spam_bouncer/legitlists,spam_bouncer/legitlists.h)
	XC_DO_TEXT2H(notify_h,spam_bouncer/notify,spam_bouncer/notify.h)
	XC_DO_TEXT2H(spam_h,spam_bouncer/spam,spam_bouncer/spam.h)
	XC_DO_TEXT2B(sb_rc_h,spam_bouncer/sb.rc,spam_bouncer/sb_rc.h)
	
>>>)m4_dnl

	AC_CHECK_HEADERS(dlfcn.h,[

		XC_CHECK_DLOPEN_FLAGS
		AC_DEFINE(PLUGINS,1)
		xc_can_plugins=yes
	])
fi

if test ${xc_can_plugins=no} = no ; then
	if test ${with_plugins=yes} = yes ; then
		XC_MSG_NO_PLUGINS
	fi
	with_plugins=no
fi


dnl Checks for library functions.

AC_CHECK_FUNCS(longjmp siglongjmp)

dnl -----------------------------------------------------------------
dnl do something usefull
dnl -----------------------------------------------------------------

m4_ifelse(FOR_PLUGINS,0,<<<m4_dnl

	dnl --- system mailfolder?
	dnl ---
	AC_MSG_CHECKING(for system mail folder)
	AC_CACHE_VAL(xc_cv_mailfolder,	
		[	
			for i in ${MAIL} /var/spool/mail /var/mail /usr/spool/mail
			do
				if test -d $i ; then
					xc_cv_mailfolder=$i
					break
				fi
			done
		])
	if test ${xc_cv_mailfolder=NONE} != NONE; then
		AC_DEFINE_UNQUOTED(MAILFOLDER,"$xc_cv_mailfolder")
		AC_MSG_RESULT($xc_cv_mailfolder)

		AC_MSG_CHECKING(for system mail folder permissions)

		t=$xc_cv_mailfolder
		while $LS -ld $t | grep ["^l"] >/dev/null ; do
			d=`$LS -ld $xc_cv_mailfolder|$AWK '{print [$]9}'`
			t=`$LS -ld $xc_cv_mailfolder|$AWK '{print [$]11}'`
			if echo $t | grep ["^/"] >/dev/null ; then :
			else
				t=`dirname $d`/`$LS -ld $xc_cv_mailfolder|$AWK '{print [$]11}'`
			fi
		done
		xc_cv_mailfolder_perm=`$LS -ld $t|$AWK '{print [$]1}'`
		
		changequote([<<],[>>])dnl
		
		case ${xc_cv_mailfolder_perm=NONE} in

			drw[xs]rw[xs]rw[xt])
				xc_cv_mailfolder_perm_com=ok
				;;

			d???????-?)
				xc_cv_mailfolder_perm_com=critical
				;;
				
			*)
				xc_cv_mailfolder_perm_com=failure
				;;
		esac
		
		changequote(<<[>>,<<]>>)dnl

		AC_MSG_RESULT(${xc_cv_mailfolder_perm_com=NONE})
	else
		AC_MSG_RESULT(not found)
	fi

>>>)m4_dnl


dnl --- global int sys_nerr exists?
dnl ---

AC_MSG_CHECKING(for sys_nerr)
AC_CACHE_VAL(xc_cv_have_sys_nerr,
[	AC_TRY_RUN([
		#include <stdio.h>
		#include <errno.h>
		int main(){sys_nerr=0;return 0;}
	],xc_cv_have_sys_nerr=1,xc_cv_have_sys_nerr=0)
])
if test $xc_cv_have_sys_nerr = 1 ; then
	AC_DEFINE(HAVE_SYS_NERR)
	AC_MSG_RESULT(yes)
else
	AC_MSG_RESULT(no)
fi


AC_MSG_CHECKING(for timezone)
AC_CACHE_VAL(xc_cv_have_timezone,
[	AC_TRY_RUN([
		#include <time.h>
		int main(){timezone=0;return 0;}
	],xc_cv_have_timezone=1,xc_cv_have_timezone=0)
])
if test $xc_cv_have_timezone = 1 ; then
	AC_DEFINE(HAVE_TIMEZONE)
	AC_MSG_RESULT(yes)
else
	AC_MSG_RESULT(no)
fi

AC_MSG_CHECKING(for daylight)
AC_CACHE_VAL(xc_cv_have_daylight,
[	AC_TRY_RUN([
		#include <time.h>
		int main(){daylight=0;return 0;}
	],xc_cv_have_daylight=1,xc_cv_have_daylight=0)
])
if test $xc_cv_have_daylight = 1 ; then
	AC_DEFINE(HAVE_DAYLIGHT)
	AC_MSG_RESULT(yes)
else
	AC_MSG_RESULT(no)
fi
dnl -----------------------------------------------------------------

AC_DEFINE_UNQUOTED(GLOBALCFGDEFAULT,"$prefix/XCmail")

AM_CONDITIONAL(STATIC_PLUGINS, test x$with_plugins = xno)
AM_CONDITIONAL(USE_PGP, test x$with_pgp != xyes)
AM_CONDITIONAL(USE_DMALLOC, test x$with_dmalloc = xyes)

m4_ifelse(FOR_PLUGINS,0,m4_dnl

	XC_DO_TEXT2H(readme,${srcdir}/../README,XCmail.readme.h)

changequote(+++,---)dnl

	AC_MSG_CHECKING(local regex source)
	ls -1 ${srcdir}/regex-*.tar.gz | if read n
	then
		if gzip -cd $n | tar xf -
		then
        	AC_MSG_RESULT(done)
		else
        	AC_MSG_ERROR(failed)
		fi
		
		AC_MSG_CHECKING(regex source permissions)
		gzip -cd $n | tar tf - | while read a
		do
			chmod u+w $a
		done
		AC_MSG_RESULT(done)
	fi

	AC_MSG_CHECKING(for local regex source file)
	ls -1 ${srcdir}/regex*/regex.c | if read n
	then
		sed \
			-e 's:\([^a-zA-Z0-9_]\)re\([_g]\):\1xc_re\2:g' \
			-e 's:^re\([_g]\):xc_re\1:g' \
			-e 's:xc_register:register:g' \
			$n \
		>xc_regex.c
    	AC_MSG_RESULT(built)
	else
    	AC_MSG_ERROR(failed)
	fi

	AC_MSG_CHECKING(for local regex header file)
	ls -1 ${srcdir}/regex*/regex.h | if read n
	then
    	echo '#ifdef __cplusplus' >xc_regex.h
    	echo 'extern "C" {' >>xc_regex.h
    	echo '#endif' >>xc_regex.h
    	sed \
			-e 's:\([^a-zA-Z0-9_]\)re\([_g]\):\1xc_re\2:g' \
			-e 's:^re\([_g]\):xc_re\1:g' \
			-e 's:xc_register:register:g' \
			$n \
		>>xc_regex.h
    	echo '#ifdef __cplusplus' >>xc_regex.h
    	echo '}' >>xc_regex.h
    	echo '#endif' >>xc_regex.h

    	AC_MSG_RESULT(built)
	else
    	AC_MSG_ERROR(failed)
	fi
	
changequote([,])dnl

	AC_OUTPUT([
		Makefile
		helpers/Makefile
		encoders/Makefile
		xface/Makefile
	])
	DEFS=

	xc_bin=$bindir
	for i in 1 2 3 4 5 6; do eval xc_bin=$xc_bin; done

	xc_conf=$prefix/XCmail
	for i in 1 2 3 4 5 6; do eval xc_conf=$xc_conf; done
	
	AC_MSG_RESULT()
	AC_MSG_RESULT(SUMMARY:)
	AC_MSG_RESULT([ program package is................. ${PACKAGE=unknown}])
	AC_MSG_RESULT([ package version is................. ${VERSION=unknown}])
	AC_MSG_RESULT([ installing binary files to......... $xc_bin])
	AC_MSG_RESULT([ installing configuration files to.. $xc_conf])
	AC_MSG_RESULT([ plugins are dynamically linked..... ${with_plugins=no}])
	AC_MSG_RESULT([ pgp support........................ ${with_pgp=yes}])
	AC_MSG_RESULT([ sendmail binary.................... ${SENDMAIL=not found}])
	AC_MSG_RESULT([ system mail folder................. ${xc_cv_mailfolder=not found}])
	AC_MSG_RESULT([ system mail folder permissions..... ${xc_cv_mailfolder_perm_com=unknown}])
	AC_MSG_RESULT()

	if test ${xc_cv_mailfolder_perm_com=unknown} != ok ; then
	AC_MSG_RESULT([ -------------------------------------------------])
	AC_MSG_RESULT([  your current system mail folder permissions])
	AC_MSG_RESULT([  may cause problems when using programms without])
	AC_MSG_RESULT([  user or group s-bit of the folders owner.])
	AC_MSG_RESULT([  When you have trouble writing your inbox])
	AC_MSG_RESULT([  read the FAQ!])
	AC_MSG_RESULT([ -------------------------------------------------])
	AC_MSG_RESULT()
	fi	

,m4_dnl

	AC_OUTPUT([
		Makefile
		linkshared
		include/Makefile
		binhex_encoding/Makefile
		trashmgr/Makefile
		mhstyle/Makefile
		simple_filter/Makefile
		check_new_release/Makefile
		js_code/Makefile
		rot13_encoding/Makefile
		search/Makefile
		test/Makefile
		dictionary/Makefile
		dateresend/Makefile
	],[ chmod +x linkshared ])
	DEFS=

)m4_dnl


