
dnl *********************************************************
dnl Funktions
dnl *********************************************************

dnl ----------------------------------------------------
dnl  XC_MSG_NO_PLUGINS
dnl  Input:        -
dnl  Output:       -
dnl  Define:       -
dnl  Substitution: -
dnl  Action:       -
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_MSG_NO_PLUGINS,[
	AC_MSG_RESULT([----------------------------------------------------------------])
	AC_MSG_RESULT()
	AC_MSG_RESULT([  building without dynamic plugins, linking plugins statically])
	AC_MSG_RESULT()
	AC_MSG_RESULT([----------------------------------------------------------------])
])

dnl ----------------------------------------------------
dnl  XC_CHECK_UNAME
dnl  Input:        -
dnl  Output:       -
dnl  Define:       -
dnl  Substitution: XC_UNAME
dnl  Action:       -
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_CHECK_UNAME,[
	AC_MSG_CHECKING(for XC_UNAME)
	AC_CACHE_VAL(xc_cv_os_uname,[
		xc_cv_os_uname=`uname`
	])
	AC_MSG_RESULT($xc_cv_os_uname)
	XC_UNAME="$xc_cv_os_uname"
	AC_SUBST(XC_UNAME)
	AC_DEFINE_UNQUOTED(XC_UNAME,"$xc_cv_os_uname")
])

dnl ----------------------------------------------------
dnl  XC_CHECK_RELEASE
dnl  Input:        <none>
dnl  Output:       <none>
dnl  Define:       <none>
dnl  Substitution: XC_RELEASE
dnl  Action:       -
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_CHECK_RELEASE,[
	AC_REQUIRE([XC_CHECK_UNAME])
	AC_MSG_CHECKING(for XC_RELEASE)
	AC_CACHE_VAL(xc_cv_os_release,[
		if test "$xc_cv_os_uname" = AIX ; then
			xc_cv_os_release=`oslevel`
		elif test "$xc_cv_os_uname" = FreeBSD ; then
			xc_cv_os_release=`uname -r|sed 's:-.*$::'`
		else
			xc_cv_os_release=`uname -r 2>/dev/null`
			if test -z "$xc_cv_os_release"; then
				xc_cv_os_release="unknown"
			fi
		fi
	])
	AC_MSG_RESULT($xc_cv_os_release)
	XC_RELEASE="$xc_cv_os_release"
	AC_SUBST(XC_RELEASE)
	AC_DEFINE_UNQUOTED(XC_RELEASE,"$xc_cv_os_release")
])

dnl ----------------------------------------------------
dnl  XC_CHECK_ARCH
dnl  Input:        <none>
dnl  Output:       <none>
dnl  Define:       <none>
dnl  Substitution: XC_ARCH
dnl  Action:       -
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_CHECK_ARCH,[
	AC_MSG_CHECKING(for XC_ARCH)
	AC_CACHE_VAL(xc_cv_os_arch,
	[
		changequote(<<<,>>>)dnl
		if test "$xc_cv_os_uname" = "IRIX" ; then
			xc_cv_os_arch=`hinv\
				|sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' \
				     -e 's/CPU: *\([^ ]*\).*$/\1/p' -e 'D'`
		elif test "$xc_cv_os_uname" = "AIX" ; then
			xc_cv_os_arch=`/usr/sbin/lsattr -EHl proc0\
				|sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' \
				     -e 's/^type *\([^ _]*\).*$/\1/p' -e 'D'`
			if test "$xc_cv_os_arch" = "power" ; then
				xc_cv_os_arch=rs6000
			fi
		elif test "$xc_cv_os_uname" = "FreeBSD" ; then
			xc_cv_os_arch=`uname -m`
		else
			xc_cv_os_arch=`uname -p 2>/dev/null`
			if test -z "$xc_cv_os_arch" ; then
				xc_cv_os_arch="unknown"
			fi
		fi
		changequote([,])dnl
	])
	AC_MSG_RESULT($xc_cv_os_arch)
	XC_ARCH="$xc_cv_os_arch"
	AC_SUBST(XC_ARCH)
	AC_DEFINE_UNQUOTED(XC_ARCH,"$xc_cv_os_arch")
])

dnl ----------------------------------------------------
dnl  XC_DO_TEXT2H
dnl  Input:        var,in,out
dnl  Output:       <none>
dnl  Define:       <none>
dnl  Substitution: <none>
dnl  Action:       creates <file>.h from <file>
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_DO_TEXT2H,[
	if test "$3" = "" ; then
		_d=.$2.h
	else
		_d=$3
	fi
	AC_MSG_RESULT(creating $_d)
	(	echo "static char *$1=\""
		sed -e "s/\\\\/\\\\\\\\/g" -e "s/\"/\\\\\"/g"
		echo "\";"
	) <$2 >$_d
])

dnl ----------------------------------------------------
dnl  XC_DO_TEXT2B
dnl  Input:        var,in,out
dnl  Output:       <none>
dnl  Define:       <none>
dnl  Substitution: <none>
dnl  Action:       creates <file>.h from <file>
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_DO_TEXT2B,[
	if test "$3" = "" ; then
		_d=.$2.h
	else
		_d=$3
	fi
	AC_MSG_RESULT(creating $_d)
	(	$CC spam_bouncer/conv.c -o spam_bouncer/conv
		spam_bouncer/conv $1
		rm -f spam_bouncer/conv
	) <$2 >$_d
])

dnl ----------------------------------------------------
dnl  XC_CHECK_LIBA
dnl  Input:        <string to substitute> <short lib name>
dnl  Output:       <none>
dnl  Define:       <none>
dnl  Substitution: <string to substitute>
dnl  Action:       find static library
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_CHECK_LIBA,
[	AC_MSG_CHECKING(for lib$2.a)
	xc_cv_liba=`gcc -print-file-name=lib$2.a`
	if test "$xc_cv_liba" = "lib$2.a" ; then
		for i in $XCLASSESLIB $x_libraries /usr/local/lib /usr/net/lib /opt/lib ; do
			if test -f "$i/lib$2.a" ; then
				xc_cv_liba=$i/lib$2.a
				break
			fi
		done
	fi
	if test "$xc_cv_liba" = "lib$2.a" ; then	
		xc_cv_liba=
		AC_MSG_RESULT(no)
	else
		if test -n "$1" ; then
			eval $1=$xc_cv_liba
		fi
		STAT_LIBS="$xc_cv_liba $STAT_LIBS"
		AC_MSG_RESULT($xc_cv_liba)
	fi
	AC_SUBST($1)dnl
])


dnl ----------------------------------------------------
dnl  XC_CHECK_DLOPEN_FLAGS
dnl  Input:        <none>
dnl  Output:       <none>
dnl  Define:       DLOPEN_RTLD
dnl  Substitution: <none>
dnl  Action:       -
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_CHECK_DLOPEN_FLAGS,[
	AC_MSG_CHECKING(for dlopen flags)
	AC_CACHE_VAL(xc_cv_cc_dlopen_flags,
	[AC_EGREP_CPP(yes,[
	 #include <dlfcn.h>
	 #if defined(RTLD_GLOBAL) && defined(RTLD_LAZY) 
	 yes
	 #endif],xc_cv_cc_dlopen_flags=1,xc_cv_cc_dlopen_flags=0)])
	if test $xc_cv_cc_dlopen_flags = 1 ; then
		AC_DEFINE(HAVE_DLOPEN_FLAGS)
		AC_MSG_RESULT(yes)
	else
		AC_MSG_RESULT(no)
	fi
])

dnl ----------------------------------------------------
dnl  XC_CHECK_SYSDEFINE
dnl  Input:        <none>
dnl  Output:       <none>
dnl  Define:       <none>
dnl  Substitution: XC_SYSDEFINE
dnl  Action:       -
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_CHECK_SYSDEFINE,[
	AC_REQUIRE([XC_CHECK_UNAME])
	AC_MSG_CHECKING(for $CXX knows -D__${XC_UNAME}__)
	AC_CACHE_VAL(xc_cv_cc_knowns_uname,
	[AC_EGREP_CPP(yes,[
	 #ifdef __${XC_UNAME}__
	 yes
	 #endif],xc_cv_cc_knowns_uname=1,xc_cv_cc_knowns_uname=0)])
	if test $xc_cv_cc_knowns_uname = 1 ; then
		XC_SYSDEFINE=""
		AC_MSG_RESULT(yes)
	else
		XC_SYSDEFINE="-D__${XC_UNAME}__"
		AC_MSG_RESULT(no)
	fi
	AC_SUBST(XC_SYSDEFINE)
	CPPFLAGS="-D__${XC_UNAME}__ $CPPFLAGS"
])

dnl ----------------------------------------------------
dnl  XC_CHECK_INCLUDEPATH
dnl  Input:        path to test
dnl  Output:       <none>
dnl  Define:       <none>
dnl  Substitution: <none>
dnl  Action:       append path to CPPFLAGS if path exists
dnl ----------------------------------------------------
dnl 
AC_DEFUN(XC_CHECK_INCLUDEPATH,[
	AC_MSG_CHECKING(for special include path)
	if test -d $1 ; then
		CPPFLAGS="$CPPFLAGS -I$1"
		AC_MSG_RESULT($1)
	else
		AC_MSG_RESULT(no)
	fi
])

