/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

// $Id: dateresend.cxx,v 1.10 2002/09/14 18:11:26 schmitzj Exp $

#include "../configure.h" 
#include "dateresend.h"
#include <time.h>

dateresend::dateresend() : showmailplugin("Date Resend","Jrgen Schmitz",PLF_CLONEUSE|PLF_CONFIGURABLE,"Sends a sent mail back to you at a specifed time")
{
	awin=NULL;
	sm=NULL;
	cfg_gp=NULL;
	cfgsetup();
}
dateresend::dateresend(dateresend *p) : showmailplugin(p)
{
	awin=NULL;
	sm=NULL;
	cfg_gp=NULL;
	strcpy(resendserviceaddress,p->resendserviceaddress);
	enabled=p->enabled;
	show1h=p->show1h;
	show24h=p->show24h;
	show1w=p->show1w;
	usesubject=p->usesubject;
}
dateresend::~dateresend()
{
	if (awin)
		DeleteObjectTree(awin->FullName());
	awin=NULL;
}
void dateresend::init(Xclasses *)
{
	if (enabled)
	{
		addmenu(1,"Resend at date...");
		if (show1h)
			addmenu(2,"Resend in 1 hour");
		if (show24h)
			addmenu(3,"Resend in 24 hours");
		if (show1w)
			addmenu(4,"Resend in 1 week");
	}
}
void dateresend::resendmail(int mode,char *datestr=NULL)
{
	int size;
	char *body=sm->ml->mailbody(size,1);
	createmail *cm=new createmail;

	cm->to(resendserviceaddress);
	cm->subject(sm->ml->subject());
	switch (mode)
	{
		case 1:
			mkdate(cm,datestr);
			break;
		case 2:
			mkdate(cm,"1h");
			break;
		case 3:
			mkdate(cm,"24h");
			break;
		case 4:
			mkdate(cm,"1w");
			break;
	}
	cm->vcardtype(AddressBook::NOVCARD);
	cm->body(body);
	cm->send();	
	delete cm;
}

void dateresend::handle(int i, Xclasses *xcl)
{
	sm = (showmail*)xcl;

	if (i>1)
		resendmail(i);
	else
	{
		if (awin)
		{
			awin->Raise();
			return;
		}
		awin=new appwindow;
		awin->Name("resenddate");
		awin->ParentClass(sm);
		awin->InitSize(1);
		awin->Init();
		awin->Title("Resend mail date");
		awin->IconTitle("Resend mail date");

		char buf[10];
		time_t t;
		time(&t);
		t+=60*30;
		struct tm *tm_st=localtime(&t);

		spacegroup *gp=new spacegroup;
		gp->Name(NULL);
		gp->Vert();
		gp->Border(4);
		 Xclasses_text *txt=new Xclasses_text;
//		 txt->FixedText();
		 txt->Center();
		 txt->Font(FONT_SMALL);
		 txt->Text("Resend Service will send this mail back\nto you at the given time - so you remember it again.");
		gp->Add(txt);
		 bordergroup *bg=new bordergroup;
		 bg->Name(NULL);
		 bg->Horiz();
		 bg->Title("Date & time");
		  group *gp2=new group;
		  gp2->Name(NULL);
		  gp2->Center();
		  gp2->Vert();
		   txt=new Xclasses_text;
		   txt->FixedText();
		   txt->Text("Year");
		  gp2->Add(txt);
		   input *ip=new input;
		   ip->Name("year");
		   ip->MaxChars(4);
		   ip->IntegerMode();
		   sprintf(buf,"%d",1900+tm_st->tm_year);
		   ip->Default(buf);
		  gp2->Add(ip);
		 bg->Add(gp2);
		  gp2=new group;
		  gp2->Name(NULL);
		  gp2->Center();
		  gp2->Vert();
		   txt=new Xclasses_text;
		   txt->FixedText();
		   txt->Text("Month");
		  gp2->Add(txt);
		   ip=new input;
		   ip->Name("month");
		   ip->MaxChars(2);
		   ip->IntegerMode();
		   sprintf(buf,"%d",tm_st->tm_mon+1);
		   ip->Default(buf);
		  gp2->Add(ip);
		 bg->Add(gp2);
		  gp2=new group;
		  gp2->Name(NULL);
		  gp2->Center();
		  gp2->Vert();
		   txt=new Xclasses_text;
		   txt->FixedText();
		   txt->Text("Day");
		  gp2->Add(txt);
		   ip=new input;
		   ip->Name("day");
		   ip->MaxChars(2);
		   ip->IntegerMode();
		   sprintf(buf,"%d",tm_st->tm_mday);
		   ip->Default(buf);
		  gp2->Add(ip);
		 bg->Add(gp2);
		  gp2=new group;
		  gp2->Name(NULL);
		  gp2->Center();
		  gp2->Vert();
		   txt=new Xclasses_text;
		   txt->FixedText();
		   txt->Text("Hour");
		  gp2->Add(txt);
		   ip=new input;
		   ip->Name("hour");
		   ip->MaxChars(2);
		   ip->IntegerMode();
		   sprintf(buf,"%d",tm_st->tm_hour);
		   ip->Default(buf);
		  gp2->Add(ip);
		 bg->Add(gp2);
		  gp2=new group;
		  gp2->Name(NULL);
		  gp2->Center();
		  gp2->Vert();
		   txt=new Xclasses_text;
		   txt->FixedText();
		   txt->Text("Minute");
		  gp2->Add(txt);
		   ip=new input;
		   ip->Name("minute");
		   ip->MaxChars(2);
		   ip->IntegerMode();
		   sprintf(buf,"%d",tm_st->tm_min);
		   ip->Default(buf);
		  gp2->Add(ip);
		 bg->Add(gp2);
		gp->Add(bg);
		 txt=new Xclasses_text;
//		 txt->FixedText();
		 txt->Center();
		 txt->Font(FONT_SMALL);
		 txt->Text("Your mail will be send to the XCmail home server\nand sent back to you at the given time. This is unencrypted\nand your mail may be seen by the administrator!");
		gp->Add(txt);
		gp->Add(new ruler);
		 gp2=new group;
		 gp2->Name(NULL);
		 gp2->Horiz();
		 gp2->DialogMode();
		  button *bt=new button;
		  bt->Name("okbutton");
		  bt->Text("_Send");
		  bt->Callback(this,(CALLBACK)&dateresend::sendmail);
		 gp2->Add(bt);
		  bt=new button;
		  bt->Name("okbutton");
		  bt->Text("_Cancel");
		  bt->Callback(this,(CALLBACK)&dateresend::closewindow);
		 gp2->Add(bt);
		gp->Add(gp2);
		awin->SetGroup(gp);
		awin->Callback(this,(CLOSECALLBACK)&dateresend::closewindow);
		awin->Create();
	}
}
void dateresend::closewindow(void)
{
	if (awin)
		DeleteObjectTree(awin->FullName());
	awin=NULL;
}
void dateresend::sendmail(void)
{
	char hour[3],minute[3],day[3],month[3],year[5];
	input *ip;
	((input*)FindObject(awin->FullName(),".minute"))->Input(minute);
	((input*)FindObject(awin->FullName(),".hour"))->Input(hour);
	((input*)FindObject(awin->FullName(),".day"))->Input(day);
	((input*)FindObject(awin->FullName(),".month"))->Input(month);
	((input*)FindObject(awin->FullName(),".year"))->Input(year);

	if (day[0] && month[0] && year[0])
	{
		closewindow();
		char datestr[15];
		sprintf(datestr,"%s.%s.%s %s:%s",day,month,year,hour,minute);

		resendmail(1,datestr);
	}
	else
	{
		Alert(awin,"No date specified");
		closewindow();
	}
}
void dateresend::mkdate(createmail *cm,char *datestr)
{
	char buf[MAXSUBJECTLENGTH];
	if (usesubject)
	{
		xc_snprintf(buf,MAXSUBJECTLENGTH,"%s - XCmail resend service reminder",datestr);
		cm->subject(buf);
	}
	else
	{
		xc_snprintf(buf,MAXSUBJECTLENGTH,"X-Resend-Date: %s\n",datestr);
		cm->headers(buf);
	}
}
showmailplugin *dateresend::clone(void)
{
	return new dateresend(this);
}

void dateresend::cfg_restore(gadget *,int)
{
	((input*)FindObject(cfg_gp->FullName(),".resendaddress"))->Default(RESENDSERVICE);
}
group *dateresend::makeconfig(void)
{
	group *gp=new group;
	gp->Name("dateresend_group");
	gp->Vert();
	 checkbox *cb=new checkbox;
	 cb->Name("enabled");
	 cb->Text("enable menu");
	 cb->State(enabled?PRESSED:RELEASED);
	gp->Add(cb,"");
	 input *ip=new input;
	 ip->Name("resendaddress");
	 ip->MaxChars(40);
	 ip->Default(resendserviceaddress);
	 ip->Text("resend service email address");
	gp->Add(ip);
	 fbutton *fb=new fbutton;
	 fb->Name("restoreold");
	 fb->Text("restore original address");
	 fb->Callback(this,(CALLBACK)&dateresend::cfg_restore);
	gp->Add(fb,"");
	 cb=new checkbox;
	 cb->Name("show1h");
	 cb->Text("show 1 hour menu");
	 cb->State(show1h?PRESSED:RELEASED);
	gp->Add(cb,"");
	 cb=new checkbox;
	 cb->Name("show24h");
	 cb->Text("show 24 hours menu");
	 cb->State(show24h?PRESSED:RELEASED);
	gp->Add(cb,"");
	 cb=new checkbox;
	 cb->Name("show1w");
	 cb->Text("show 1 week menu");
	 cb->State(show1w?PRESSED:RELEASED);
	gp->Add(cb,"");
	cfg_gp=gp;
	return gp;
}
void dateresend::readconfig(group *gp)
{
	((input*)FindObject(gp->FullName(),".resendaddress"))->Input(resendserviceaddress);
	enabled=((checkbox*)FindObject(gp->FullName(),".enabled"))->State()==PRESSED?1:0;
	show1h=((checkbox*)FindObject(gp->FullName(),".show1h"))->State()==PRESSED?1:0;
	show24h=((checkbox*)FindObject(gp->FullName(),".show24h"))->State()==PRESSED?1:0;
	show1w=((checkbox*)FindObject(gp->FullName(),".show1w"))->State()==PRESSED?1:0;
}
void dateresend::readconfigfile(void)
{
	cfg->Read();
}
void dateresend::writeconfigfile(void)
{
	cfg->Write();
}

void dateresend::cfgsetup(void) {

	static configopts cfgitems[] = {
		{"B:enabled",(char*)&enabled},
		{"S45:resendserviceaddress",resendserviceaddress},
		{"B:show_1h",(char*)&show1h},
		{"B:show_24h",(char*)&show24h},
		{"B:show_1d",(char*)&show1w},
		{"B:usesubject",(char*)&usesubject},
		{NULL,NULL}
	};
	cfg = new config("~/.XCmail/plugin-preferences-dateresend");
	cfg->SetItems(cfgitems);

	strcpy(resendserviceaddress,RESENDSERVICE);
	enabled=1;
	show1h=1;
	show24h=1;
	show1w=1;
	usesubject=0;
}

static dateresend _drs;

datesender::datesender() : mainplugin("Send me @ date","Jrgen Schmitz",PLF_CLONEUSE|PLF_CONFIGURABLE,"Sends a mail to you at a specifed time")
{
	awin=NULL;
}
datesender::datesender(datesender *p) : mainplugin(p)
{
	awin=NULL;
}
datesender::~datesender()
{
	if (awin)
		DeleteObjectTree(awin->FullName());
	awin=NULL;
}
void datesender::init(void)
{
	if (_drs.enabled)
	{
		addmenu(MPMENU_GENERAL,1,"Send me @ date...");
	}
}
void datesender::sendmail(char *subject,char *body,char *datestr=NULL)
{
	int size;
	createmail *cm=new createmail;

	cm->to(_drs.resendserviceaddress);
	cm->subject(subject);
	mkdate(cm,datestr);
	cm->headers("X-XCmail-VisualBell: 1");
	cm->vcardtype(AddressBook::NOVCARD);
	cm->body(body);
	cm->send();	
	delete cm;
}

void datesender::handle(int i)
{
	if (awin)
	{
		awin->Raise();
		return;
	}
	awin=new appwindow;
	awin->Name("datesender");
	awin->ParentClass(readerwin);
	awin->InitSize(10);
	awin->Init();
	awin->Title("Send me @ date");
	awin->IconTitle("Send me @ date");

	char buf[10];
	time_t t;
	time(&t);
	t+=60*30;
	struct tm *tm_st=localtime(&t);

	spacegroup *gp=new spacegroup;
	gp->Name(NULL);
	gp->Vert();
	gp->Border(4);
	 Xclasses_text *txt=new Xclasses_text;
//		 txt->FixedText();
	 txt->Center();
	 txt->Font(FONT_SMALL);
	 txt->Text("Send this text as mail back to you at the given time\n- so you remember it again.");
	gp->Add(txt);
	 bordergroup *bg=new bordergroup;
	 bg->Name(NULL);
	 bg->Horiz();
	 bg->Title("Text");
	  textbox *tb=new textbox;
	  tb->Name("sendtext");
	  tb->MinRows(5);
	  tb->MinCols(60);
	  tb->MaxLineLength(programconfig.writelinelength);
	 bg->Add(tb);
	gp->Add(bg);
	 bg=new bordergroup;
	 bg->Name(NULL);
	 bg->Horiz();
	 bg->Title("Date & time");
	  group *gp2=new group;
	  gp2->Name(NULL);
	  gp2->Center();
	  gp2->Vert();
	   txt=new Xclasses_text;
	   txt->FixedText();
	   txt->Text("Year");
	  gp2->Add(txt);
	   input *ip=new input;
	   ip->Name("year");
	   ip->MaxChars(4);
	   ip->IntegerMode();
	   sprintf(buf,"%d",1900+tm_st->tm_year);
	   ip->Default(buf);
	  gp2->Add(ip);
	 bg->Add(gp2);
	  gp2=new group;
	  gp2->Name(NULL);
	  gp2->Center();
	  gp2->Vert();
	   txt=new Xclasses_text;
	   txt->FixedText();
	   txt->Text("Month");
	  gp2->Add(txt);
	   ip=new input;
	   ip->Name("month");
	   ip->MaxChars(2);
	   ip->IntegerMode();
	   sprintf(buf,"%d",tm_st->tm_mon+1);
	   ip->Default(buf);
	  gp2->Add(ip);
	 bg->Add(gp2);
	  gp2=new group;
	  gp2->Name(NULL);
	  gp2->Center();
	  gp2->Vert();
	   txt=new Xclasses_text;
	   txt->FixedText();
	   txt->Text("Day");
	  gp2->Add(txt);
	   ip=new input;
	   ip->Name("day");
	   ip->MaxChars(2);
	   ip->IntegerMode();
	   sprintf(buf,"%d",tm_st->tm_mday);
	   ip->Default(buf);
	  gp2->Add(ip);
	 bg->Add(gp2);
	  gp2=new group;
	  gp2->Name(NULL);
	  gp2->Center();
	  gp2->Vert();
	   txt=new Xclasses_text;
	   txt->FixedText();
	   txt->Text("Hour");
	  gp2->Add(txt);
	   ip=new input;
	   ip->Name("hour");
	   ip->MaxChars(2);
	   ip->IntegerMode();
	   sprintf(buf,"%d",tm_st->tm_hour);
	   ip->Default(buf);
	  gp2->Add(ip);
	 bg->Add(gp2);
	  gp2=new group;
	  gp2->Name(NULL);
	  gp2->Center();
	  gp2->Vert();
	   txt=new Xclasses_text;
	   txt->FixedText();
	   txt->Text("Minute");
	  gp2->Add(txt);
	   ip=new input;
	   ip->Name("minute");
	   ip->MaxChars(2);
	   ip->IntegerMode();
	   sprintf(buf,"%d",tm_st->tm_min);
	   ip->Default(buf);
	  gp2->Add(ip);
	 bg->Add(gp2);
	gp->Add(bg);
	 txt=new Xclasses_text;
//		 txt->FixedText();
	 txt->Center();
	 txt->Font(FONT_SMALL);
	 txt->Text("Your mail will be send to the XCmail home server\nand sent back to you at the given time. This is unencrypted\nand your mail may be seen by the administrator!");
	gp->Add(txt);
	gp->Add(new ruler);
	 gp2=new group;
	 gp2->Name(NULL);
	 gp2->Horiz();
	 gp2->DialogMode();
	  button *bt=new button;
	  bt->Name("okbutton");
	  bt->Text("_Send");
	  bt->Callback(this,(CALLBACK)&datesender::sendit);
	 gp2->Add(bt);
	  bt=new button;
	  bt->Name("okbutton");
	  bt->Text("_Cancel");
	  bt->Callback(this,(CALLBACK)&datesender::closewindow);
	 gp2->Add(bt);
	gp->Add(gp2);
	awin->SetGroup(gp);
	awin->Callback(this,(CLOSECALLBACK)&datesender::closewindow);
	awin->Create();
}
void datesender::closewindow(void)
{
	if (awin)
		DeleteObjectTree(awin->FullName());
	awin=NULL;
}
void datesender::sendit(gadget *,int)
{
	char hour[3],minute[3],day[3],month[3],year[5];
	input *ip;
	((input*)FindObject(awin->FullName(),".minute"))->Input(minute);
	((input*)FindObject(awin->FullName(),".hour"))->Input(hour);
	((input*)FindObject(awin->FullName(),".day"))->Input(day);
	((input*)FindObject(awin->FullName(),".month"))->Input(month);
	((input*)FindObject(awin->FullName(),".year"))->Input(year);

	if (day[0] && month[0] && year[0])
	{
		textbox *tb=(textbox*)FindObject(awin->FullName(),".sendtext");
		char datestr[15];
		sprintf(datestr,"%s.%s.%s %s:%s",day,month,year,hour,minute);
		
		char *body=new char[tb->TextSize()+2];
		tb->CopyText(body,tb->TextSize()+1);

		closewindow();
		sendmail(datestr,body,datestr);
		delete [] body;
	}
	else
	{
		Alert(awin,"No date specified");
		closewindow();
	}
}
void datesender::mkdate(createmail *cm,char *datestr)
{
	_drs.mkdate(cm,datestr);
}
mainplugin *datesender::clone(void)
{
	return new datesender(this);
}
void datesender::readconfigfile(void)
{
	_drs.readconfigfile();
}
group *datesender::makeconfig(void)
{
	group *gp=new group;
	gp->Name("dateresend_group");
	gp->Vert();
	Xclasses_text *txt=new Xclasses_text;
	 txt->Text("\nThis uses the configs of the dateresend plugin!");
	 txt->Center();
	gp->Add(txt);
	return gp;
}
static datesender _dsd;
