/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

// $Id: dateresend.h,v 1.5 2002/09/14 18:07:17 schmitzj Exp $

#ifndef DATERESEND_H
#define DATERESEND_H

#include "../configure.h" 

#include "../include/encoder.h"
#include "../include/plugins.h"
#include "../../src/mailer.h"
#include "../../src/createmail.h"

#define RESENDSERVICE		"resendservice@js-home.org"
#define MAXSUBJECTLENGTH	200

class dateresend : public showmailplugin
{
friend class datesender;
	config *cfg;
	void cfgsetup(void);

	appwindow *awin;
	group *cfg_gp;
	showmail *sm;
	void mkdate(class createmail *,char *datestr);

	char resendserviceaddress[50];
	int enabled;
	int show1h;
	int show24h;
	int show1w;
	int usesubject;

	void resendmail(int mode,char *datestr=NULL);
	void closewindow(void);
	void sendmail(void);
	void cfg_restore(gadget *,int);
public:
	dateresend();
	dateresend(dateresend *p);
	~dateresend();
	void init(Xclasses *);
	void handle(int i, Xclasses *x);
	virtual showmailplugin *clone(void);

	group *makeconfig(void);
	void readconfig(group *);

	void readconfigfile(void);
	void writeconfigfile(void);
};

class datesender : public mainplugin
{
	appwindow *awin;
	void mkdate(class createmail *,char *datestr);

	void sendmail(char *subject,char *body,char *datestr=NULL);
	void closewindow(void);
	void sendit(gadget *,int);
public:
	datesender();
	datesender(datesender *p);
	~datesender();
	void init(void);
	void handle(int i);
	virtual mainplugin *clone(void);
	void readconfigfile(void);
	group *makeconfig(void);
};


#endif
