/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: js_code.cxx,v 2.3 2002/01/10 09:27:22 schmitzj Exp $ */


#include "../configure.h" 
#include <stdio.h>
#include <string.h>
#include "js_code.h"

//--------------------------------------------------------------------

encoder_js::encoder_js(void) : encoder("J-Encoding","Jrgen Schmitz")
{
}
encoder_js::~encoder_js()
{
}

char *encoder_js::data2mail(char *d,int size,int &newsize,char *path,char *filename)
{
#define NAME	"#J-Encoding 1.0\n"
	int j=0,off=0;
	char *work=new char[size*2+2+(size*2/58+1)*2+strlen(NAME)];

	strcpy(work,NAME);
	off=strlen(work);
	for(int i=0;i<size;i++)
	{
		if (j%60==0)
		{
			work[off+j++]='\n';
			work[off+j++]='J';
		}
		work[off+j++]=(d[i]&127)|32;
		work[off+j++]=32|(d[i]&32?1:0)|(d[i]&128?2:0); // 128 u. 32 gesetzt merken
	}
	work[off+j++]='\n';
	work[off+j]=0;
	newsize=off+j;
	return work;
}
char *encoder_js::mail2data(char *d,int size,int &newsize,char *path,char *filename)
{
	int j=0,v,i=0,m1=0;
	char *work=new char[size/2+1];

	do
	{
		if (m1 && d[j]!='\n')
		{
			v=d[j++]&223;
			v|=(d[j]&1?32:0)|(d[j]&2?128:0);
			work[i++]=v;
		}
		else if (d[j]=='\n')
		{
			m1=0;
		}
		else if (d[j]=='J' && d[j-1]=='\n' && m1==0)
		{
			m1=1;
		}
		j++;
	}
	while (j<size);

	work[i]=0;
	newsize=i;
	return work;
}
void encoder_js::dispose(char *b)
{
	delete b;
}

static encoder_js e1;
