/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: mhstyle.cxx,v 1.10 2002/03/22 20:13:49 schmitzj Exp $ */


#include "../configure.h" 
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <string.h>

#include "../include/plugins.h"
#include "../../src/mailer.h"
#include "../../src/strbuf.h"

extern multilistview mailslv;
extern appwindow readerwin;

class mhstyle : public mainplugin
{
	void import(char *dir);
	void readfile(char *n);
public:
	mhstyle(void);
	~mhstyle();

	void init(void);
	void finish(void);
	void handle(int id);
};

static mhstyle mhs;

mhstyle::mhstyle(void) : mainplugin("MH Style import","Jrgen Schmitz",
									PLF_STATICUSE,
									"Import MH style mailbox")
{
}
mhstyle::~mhstyle()
{
}

void mhstyle::init(void)
{
	addmenu(MPMENU_GENERAL,1,"import MH mailbox...");
}
void mhstyle::finish(void)
{
}
void mhstyle::handle(int id)
{
	if (folderlist()->currentfolder())
	{
		file_dialog fd;

		fd.LoadMode();
		fd.DirSelector();
		if (fd.Start(readerwin))
		{
			char buf[500];
			fd.GetDir(buf,sizeof(buf));
			import(buf);
		}
	}
}

void mhstyle::import(char *dir)
{
	struct stat st;
	DIR *dfd;
	struct dirent *dptr;
	char buf[1000];

	if (dfd=opendir(dir))
	{
		while (dptr=readdir(dfd))
		{
			if (dptr->d_name[0]!='.')
			{
				strcpy(buf,dir);
				strcat(buf,dptr->d_name);
				if (!stat(buf,&st))
				{
					if (S_ISREG(st.st_mode))
					{
						readfile(buf);
					}
				}
			}
		}
		closedir(dfd);
	}
}
void mhstyle::readfile(char *n)
{
	FILE *f;
	xcm_strbuf b;
	char buf[120];

	if (f=fopen(n,"r"))
	{
		struct utsname nts;
		uname(&nts);

		time_t now=time(NULL);
		sprintf(buf,"From mhstyle@%s %s",nts.nodename,ctime(&now));
		b+=buf;

		while (fgets(buf,sizeof(buf),f)>0)
		{
			b+=buf;
		}
		fclose(f);

		b+="\n\n";
		mail *mm=new mail(strdup(b()));
		if (mm)
			folderlist()->currentfolder()->appendmail_default(mm);
	}
}
