/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: search.cxx,v 1.6 1999/12/15 08:34:07 schmitzj Exp $ */


//
// Rot13 encoding fuer xc-mail
// (C)1997 Ralf Becker (Ra.Becker@fh-trier.de)
//
// erzeugt: 13.04.97 (r.b.)
//
#include "../configure.h" 

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "../include/encoder.h"
#include "../include/plugins.h"
#include "../../src/mailer.h"

//--------------------------------------------------------------------

class Search : public callable
{
	appwindow *parent;
	appwindow *aw;
	int ro;
	int curx,cury;
	char *text;
	char *cur;
	int is_open;
		
	void handle_dialog(gadget *gg, int);
	void open_dialog(void);
	void close_dialog(void);
public:
	Search();
	~Search();
	void handle(int id, Xclasses *,int ro);
};

Search::Search()
{
	aw=NULL;
	parent=NULL;
	is_open=0;
	ro=0;
	cur=NULL;
	text=NULL;
}
Search::~Search()
{
	if (aw)
	{
		DeleteObjectTree(aw->FullName(),0);
	}
	if (text) delete[] text;
}

void Search::handle_dialog(gadget *gg, int)
{
	if (strcmp(gg->Name(),"cancel")==0)
	{
		close_dialog();
		return;
	}
	else if (strcmp(gg->Name(),"regex")==0)
	{
		if (((checkbox*)FindObject(aw->FullName(),".regex"))->State()==PRESSED)
		{
			((checkbox*)FindObject(aw->FullName(),".ncase"))->Lock();
		}
		else
		{
			((checkbox*)FindObject(aw->FullName(),".ncase"))->Unlock();
		}
	}
	else if (strcmp(gg->Name(),"search")==0 ||
			 strcmp(gg->Name(),"replace_n_search_next")==0 ||
			 strcmp(gg->Name(),"replace_all")==0 ||
			 strcmp(gg->Name(),"search_next")==0 ||
			 strcmp(gg->Name(),"replace")==0)
	{
		char b[256]="",r[256]="";
		int (*cmp)(char *,char *)=NULL;

		int replall=strcmp(gg->Name(),"replace_all")==0;

		textbox *tb=(textbox*)FindObject(parent->FullName(),".mailbody");
		
		((input*)FindObject(aw->FullName(),".string"))->Input(b);

		if (!ro)
		{
			((input*)FindObject(aw->FullName(),".replace_with"))->Input(r);
		}
				
		if (((checkbox*)FindObject(aw->FullName(),".ncase"))->State()==PRESSED)
		{
			cmp=strcncmp;
		}
		else if (((checkbox*)FindObject(aw->FullName(),".regex"))->State()==PRESSED)
		{
			cmp=strregcmp;
		}
		else
		{
			cmp=strnncmp;
		}

		if (!is_open)
		{
			curx=cury=0;
			int size=tb->TextSize();
			if (!size) return;	
			if (text) delete[] text;
			cur=text=new char[size+1];
			if (!text) return;

			tb->CopyText(text,size+1);

			int cx,cy;
			tb->Cursor(cx,cy);
			while (*cur && cury<cy)
			{
				if (*cur=='\n') cury++;
				cur++;
			}
			while (*cur && *cur!='\n' && curx<cx)
			{
				cur++;
				curx++;
			}
		}
		if (!cur ||
			strcmp(gg->Name(), "search")==0 ||
			strcmp(gg->Name(), "replace_all") == 0)
		{
			curx=cury=0;

			int size=tb->TextSize();
			if (!size) return;
	
			if (text) delete[] text;
			cur=text=new char[size+1];
			if (!text) return;

			tb->CopyText(text,size+1);
		}
		else
		{
			if (strcmp(gg->Name(),"replace_n_search_next")==0
				|| strcmp(gg->Name(),"replace")==0)
			{
				if (tb->MarkedTextSize()>0 && cmp(b,cur)==0)
				{
					int bl=strlen(b);
					int rl=strlen(r);
					tb->ReplaceMarkedText(r);
					tb->CursorTo(curx,cury);
					tb->MarkTo(curx+rl,cury);
					cur+=bl-1;
					curx+=rl-1;
				}
			}
			else if (*cur=='\n')
			{
				cury++;
				curx=-1;
			}
			curx++;
			cur++;
		}
		int marked=0;
// T.H. Do a search, but not for just a replace 
		if (!(strcmp(gg->Name(),"replace")==0)) 
			while (*cur)
			{
				if (cmp(b,cur)==0)
				{
					tb->CursorTo(curx,cury);
					tb->MarkTo(curx+strlen(b),cury);
				
					if (replall)
					{
						int bl=strlen(b);
						int rl=strlen(r);
						tb->ReplaceMarkedText(r);
						tb->CursorTo(curx,cury);
						tb->MarkTo(curx+rl,cury);
						cur+=bl-1;
						curx+=rl-1;
					}
					else
					{
						marked=1;				
						break;
					}
				}
				if (*cur=='\n')
				{
					cury++;
					curx=-1;
				}
				curx++;
				cur++;
			}
		if (is_open)
		{
			((input*)FindObject(aw->FullName(),".string"))->ActivateKey();
		}
		if (!*cur)
		{
		 	if (strcmp(gg->Name(),"replace_all")!=0)
			{
				aw->Beep(95,50);
			}
			cur=NULL;
			curx=cury=0;
		}
		if (!ro)
		{
			if (marked)
			{
				((fbutton*)FindObject(aw->FullName(),".replace"))->Unlock();
				((fbutton*)FindObject(aw->FullName(),".replace_n_search_next"))->Unlock();
			}
			else
			{
				((fbutton*)FindObject(aw->FullName(),".replace"))->Lock();
				((fbutton*)FindObject(aw->FullName(),".replace_n_search_next"))->Lock();
			}
		}
		if (((checkbox*)FindObject(aw->FullName(),".keep"))->State()!=PRESSED)
		{
			close_dialog();
		}
	}
}

void Search::close_dialog(void)
{
	if (!aw) return;
	if (is_open)
	{
		parent->Unblock();
		aw->Xwindows::Close();
		is_open=0;
	}
}

void Search::open_dialog(void)
{
	if (aw)
	{
		aw->Open();
		is_open=1;
		((input*)FindObject(aw->FullName(),".string"))->ActivateKey();
		return;
	}

	aw=new appwindow;

	if (!aw->Init()) return;

	aw->TransientFor(parent);

	char myname[256];
	sprintf(myname,"searchpl_%p",(void*)this);
	aw->Name(myname);

	if (ro)
	{
		aw->Title("Find...");
		aw->IconTitle("Find...");
	}
	else
	{
		aw->Title("Find/Replace...");
		aw->IconTitle("Find/Replace...");
	}

	spacegroup *sg1=new spacegroup;
	sg1->Border(5);
	sg1->YDistance(5);
	sg1->Vert();
	sg1->Name(NULL);
		input *ip=new input;
		ip->Name("string");
		ip->Text("String to find");
		ip->MaxChars(100);
		ip->Default("");
		ip->Callback(this,(CALLBACK)&Search::handle_dialog);
	sg1->Add(ip);

	if (!ro)
	{
		input *iip=new input;
		iip->Name("replace_with");
		iip->Text("Replace with");
		iip->MaxChars(100);
		iip->Default("");
		iip->Callback(this,(CALLBACK)&Search::handle_dialog);
	sg1->Add(iip);
	
	}
		group *g=new group;
		g->Horiz();
		g->Name(NULL);
		g->DialogMode();
			checkbox *cb=new checkbox;
			cb->Name("regex");
			cb->Text("Regulare expression");
			cb->Callback(this,(CALLBACK)&Search::handle_dialog);
		g->Add(cb);
			cb=new checkbox;
			cb->Name("keep");
			cb->Text("Keep dialog");
			cb->State(RELEASED);
		g->Add(cb);
	sg1->Add(g,"");
		g=new group;
		g->Horiz();
		g->Name(NULL);
			cb=new checkbox;
			cb->Name("ncase");
			cb->Text("Ignore case");
			cb->State(PRESSED);
		g->Add(cb);
	sg1->Add(g,"");
	sg1->Add(new ruler);
		group *g1=new group;
		g1->Horiz();
		g1->Name(NULL);
		g1->DialogMode();
			button *bt1=new button;
			bt1->Name("search");
			bt1->Text("_Find");
 			bt1->Callback(this,(CALLBACK)&Search::handle_dialog);
		g1->Add(bt1);
			bt1=new button;
			bt1->Name("search_next");
			bt1->Text("Find _next");
 			bt1->Callback(this,(CALLBACK)&Search::handle_dialog);
		g1->Add(bt1);

	if (!ro)
	{
			bt1=new button;
			bt1->Name("replace");
			bt1->Text("_Replace");
 			bt1->Callback(this,(CALLBACK)&Search::handle_dialog);
			bt1->Lock();
		g1->Add(bt1);
			bt1=new button;
			bt1->Name("replace_all");
			bt1->Text("Replace\n_All");
 			bt1->Callback(this,(CALLBACK)&Search::handle_dialog);
		g1->Add(bt1);
			bt1=new button;
			bt1->Name("replace_n_search_next");
			bt1->Text("Replace &\nFind next");
 			bt1->Callback(this,(CALLBACK)&Search::handle_dialog);
			bt1->Lock();
		g1->Add(bt1);
	}
			bt1=new button;
			bt1->Name("cancel");
			bt1->Text("_Cancel");
 			bt1->Callback(this,(CALLBACK)&Search::handle_dialog);
			bt1->ApplyXKey(XK_Escape);
		g1->Add(bt1);
	sg1->Add(g1);
	aw->SetGroup(sg1);
	aw->Create();
	ip->ActivateKey();
	parent->Block();
	is_open=1;
}
void Search::handle(int id, Xclasses *xcl, int ro)
{
	parent=(appwindow*)FindObject(xcl->FullName(),".window");
	this->ro=ro;
	
	switch (id)
	{
		case 1:
			open_dialog();
			break;
		case 2:
			if (!aw) return;
			handle_dialog((fbutton*)FindObject(aw->FullName(),".search_next"),0);
			break;
		case 3:
		{
			textbox *tb=(textbox*)FindObject(parent->FullName(),".mailbody");
			if (!tb || tb->MarkedTextSize()<=0)
			{
				parent->Beep(95,50);
				break;
			}
			if (!aw)
			{
				open_dialog();
				close_dialog();
			}
			if (aw)
			{
				char b[tb->MarkedTextSize()+2];
				tb->CopyMarkedText(b,tb->MarkedTextSize()+1);
				((input*)FindObject(aw->FullName(),".string"))->Default(b);
				handle_dialog((fbutton*)FindObject(aw->FullName(),".search_next"),0);
			}
			break;
		}
		case 4:
			if (!aw || ro) return;
			handle_dialog((fbutton*)FindObject(aw->FullName(),".replace_n_search_next"),0);
			break;
	}
}

class Search_showmail : public showmailplugin, Search
{
public:
	Search_showmail():showmailplugin("Find/Replace (hidden)","Ralf Becker",PLF_CLONEUSE|PLF_INVISIBLE,"(hidden)")
	{
	};
	Search_showmail(Search_showmail *p):showmailplugin(p)
	{
	};
	void init(Xclasses *)
	{
		addmenu(1,"Find...","f");
		addmenu(2,"Find again","g");
		addmenu(3,"Find selected","h");
	};
	void handle(int i, Xclasses *x)
	{
		Search::handle(i,x,1);
	};
	virtual showmailplugin *clone(void)
	{
		return new Search_showmail(this);
	};
};
static Search_showmail _ss;


class Search_newmail : public newmailplugin, Search
{
public:
	Search_newmail():newmailplugin("Find/Replace","Ralf Becker",PLF_CLONEUSE,"Find/Replace enhancement")
	{
	};
	Search_newmail(Search_newmail *p):newmailplugin(p)
	{
	};
	void init(Xclasses *)
	{
		addmenu(1,"Find/Replace...","f");
		addmenu(2,"Find again","g");
		addmenu(3,"Find selected","h");
		addmenu(4,"Replace again","t");
	};
	void handle(int i, Xclasses *x)
	{
		Search::handle(i,x,0);
	};
	virtual newmailplugin *clone(void)
	{
		return new Search_newmail(this);
	};
};
static Search_newmail _sn;
