/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: buildin_jobs.cxx,v 1.14 2001/11/11 13:21:47 schmitzj Exp $ */


#include "../../src/mailer.h"
#include "../../src/npop3get.h"
#include "../../src/folder.h"
#include "job.h"
#include "filter.h"
#include "simple_filter.h"

// class job_setprio : public job
// {
// public:
// 	job_setprio(void);
// 	job_setprio(job_setprio *,char *);
// 	~job_setprio();
// 
// 	job_setprio *clone(char *);
// 
// 	int work(class mail *);
// 	int load(tokenizer *);
// 	int save(tokenizer *);
// 
// 	group *makeprefs(void);
// 	void setupprefs(group *);
// 	void readprefs(group *);
// };
// 
// job_setprio::job_setprio(void) : job("job_setprio","Jrgen Schmitz")
// {
// }
// job_setprio::job_setprio(job_setprio *j,char *n) : job(j,n)
// {
// }
// job_setprio::~job_setprio()
// {
// }
// 
// job_setprio *job_setprio::clone(char *n)
// {
// 	return new job_setprio(this,n);
// }
// 
// int job_setprio::work(mail *m)
// {
// 	m->sortAcct(m->sortAcct()+1);
// 	return 0;
// }
// int job_setprio::load(tokenizer *tk)
// {
// 	return 0;
// }
// int job_setprio::save(tokenizer *tk)
// {
// 	tk->append(new token("+1"));
// 	return 0;
// }
// 
// group *job_setprio::makeprefs(void)
// {
// 	return NULL;
// }
// void job_setprio::setupprefs(group *g)
// {
// }
// void job_setprio::readprefs(group *g)
// {
// }
// 
// static job_setprio jsp;

// -----------------------------------------------------------------------

class job_setvisualBell : public job
{
	unsigned int vb;
public:
	job_setvisualBell(void);
	job_setvisualBell(job_setvisualBell *,char *);
	~job_setvisualBell();

	job_setvisualBell *clone(char *);

	int work(class mail *);
	int load(tokenizer *);
	int save(tokenizer *);

	group *makeprefs(void);
	void setupprefs(group *);
	void readprefs(group *);
};

job_setvisualBell::job_setvisualBell(void) : job("visual bell","Jrgen Schmitz")
{
	vb=0;
}
job_setvisualBell::job_setvisualBell(job_setvisualBell *j,char *n) : job(j,n)
{
	vb=0;
}
job_setvisualBell::~job_setvisualBell()
{
}

job_setvisualBell *job_setvisualBell::clone(char *n)
{
	return new job_setvisualBell(this,n);
}

int job_setvisualBell::work(mail *m)
{
	m->visualBell(vb);
	return 0;
}
int job_setvisualBell::load(tokenizer *tk)
{
	vb=atoi((*tk)[0]);
	return 0;
}
int job_setvisualBell::save(tokenizer *tk)
{
	char buf[20];
	sprintf(buf,"%d",vb);
	tk->append(new token(buf));
	return 0;
}

group *job_setvisualBell::makeprefs(void)
{
	static char *vbells[]={"none","type 1",NULL};
	group *gp=new group;
	gp->Name("group");
	gp->Vert();
	 choice *ch=new choice;
	 ch->Name("vb");
	 ch->Items(vbells);
	gp->Add(ch);
	return gp;
}
void job_setvisualBell::setupprefs(group *g)
{
	((choice*)FindObject(g->FullName(),".vb"))->Selected(vb);
}
void job_setvisualBell::readprefs(group *g)
{
	vb=((choice*)FindObject(g->FullName(),".vb"))->Selected();
}

static job_setvisualBell jsvB;

// -----------------------------------------------------------------------

class job_dropMail : public job
{
	int mode;
	int delmode;
public:
	job_dropMail(void);
	job_dropMail(job_dropMail *,char *);
	~job_dropMail();

	job_dropMail *clone(char *);

	int work(class mail *);
	int load(tokenizer *);
	int save(tokenizer *);

	group *makeprefs(void);
	void setupprefs(group *);
	void readprefs(group *);
};

job_dropMail::job_dropMail(void) : job("drop mail","Jrgen Schmitz")
{
	mode=0;
}
job_dropMail::job_dropMail(job_dropMail *j,char *n) : job(j,n)
{
	mode=0;
	delmode=0;
}
job_dropMail::~job_dropMail()
{
}

job_dropMail *job_dropMail::clone(char *n)
{
	return new job_dropMail(this,n);
}

int job_dropMail::work(mail *m)
{
	int r=0;
	if (mode)
	{
		switch (delmode)
		{
			case 3:
				m->deleteLocalMail();
				m->deleteServerMail();
				break;
			case 2:
				m->deleteServerMail();
				break;
			case 1:
				m->deleteLocalMail();
				break;
			case 0:
			default:
				m->deleteMail();
				break;
		}
		if (m->status() & STATUS_DELETE)
			r=1;
		if (m->status() & STATUS_SERVERDELETE)
		{
			UIDLhistory *dele_uidlhist=new UIDLhistory(m->pop3host(),m->pop3user(),REMOVEFILE);
			dele_uidlhist->Add(m->xuidl());
			dele_uidlhist->Write();
			delete dele_uidlhist;
		}
	}
	else
	{
		switch (delmode)
		{
			case 3:
				m->deleteLocalMail();
				m->deleteServerMail();
				break;
			case 2:
				m->deleteServerMail();
				break;
			case 1:
				m->deleteLocalMail();
				break;
			case 0:
			default:
				m->deleteMail();
				break;
		}
	}
//printf("dropMail R: %d (%s)\n",r,m->subject());
	return r;
}
int job_dropMail::load(tokenizer *tk)
{
	if (!strcscmp("drop",(*tk)[0]))
		mode=1;
	else if (!strcscmp("delete",(*tk)[0]))
		mode=0;

	if (!strcscmp("settings",(*tk)[1]))
		delmode=0;
	else if (!strcscmp("local",(*tk)[1]))
		delmode=1;
	else if (!strcscmp("server",(*tk)[1]))
		delmode=2;
	else if (!strcscmp("both",(*tk)[1]))
		delmode=3;

	return 0;
}
int job_dropMail::save(tokenizer *tk)
{
	if (mode)
		tk->append(new token("drop"));
	else
		tk->append(new token("delete"));

	switch (delmode)
	{
		case 1:
			tk->append(new token("local"));
			break;
		case 2:
			tk->append(new token("server"));
			break;
		case 3:
			tk->append(new token("both"));
			break;
		case 0:
		default:
			tk->append(new token("settings"));
			break;
	}
	return 0;
}

group *job_dropMail::makeprefs(void)
{
	static char *modes[]={"mark deleted","drop",NULL};
	static char *delmodes[]={"by global settings","local","on server","both",NULL};
	group *gp=new group;
	gp->Name("group");
	gp->Vert();
	 choice *ch=new choice;
	 ch->Name("mode");
	 ch->Items(modes);
	gp->Add(ch,"");
	 ch=new choice;
	 ch->Name("delmode");
	 ch->Items(delmodes);
	gp->Add(ch,"drop/delete");
	return gp;
}
void job_dropMail::setupprefs(group *g)
{
	((choice*)FindObject(g->FullName(),".mode"))->Selected(mode);
	((choice*)FindObject(g->FullName(),".delmode"))->Selected(delmode);
}
void job_dropMail::readprefs(group *g)
{
	mode=((choice*)FindObject(g->FullName(),".mode"))->Selected();
	delmode=((choice*)FindObject(g->FullName(),".delmode"))->Selected();
}

static job_dropMail jdM;

// -----------------------------------------------------------------------

class job_subOrder : public job
{
	namenode *order;
public:
	job_subOrder(void);
	job_subOrder(job_subOrder *,char *);
	~job_subOrder();

	job_subOrder *clone(char *);

	int work(class mail *);
	int load(tokenizer *);
	int save(tokenizer *);

	group *makeprefs(void);
	void setupprefs(group *);
	void readprefs(group *);

	void renameRef(char *old,char *newn);
};

job_subOrder::job_subOrder(void) : job("sub order","Jrgen Schmitz")
{
	order=NULL;
}
job_subOrder::job_subOrder(job_subOrder *j,char *n) : job(j,n)
{
	order=NULL;
}
job_subOrder::~job_subOrder()
{
	delete order;
}

job_subOrder *job_subOrder::clone(char *n)
{
	return new job_subOrder(this,n);
}

int job_subOrder::work(mail *m)
{
	class order *o=simple_filter::getMaster()->getOrder(order);
	if (o)
		return o->work(m);
	return 0;
}
int job_subOrder::load(tokenizer *tk)
{
	order=new namenode((*tk)[0]);
	return 0;
}
int job_subOrder::save(tokenizer *tk)
{
	if (order)
		tk->append(new token((char*)*order));
	return 0;
}

group *job_subOrder::makeprefs(void)
{
	saveabledlist *olst=simple_filter::getMaster()->getOrderlst();
	class order *o=(class order*)olst->head;
	group *gp=new group;
	gp->Name("group");
	gp->Vert();
	 listview *lv=new listview;
	 lv->Name("orderslist");
	 lv->ShowSelected();
	 while (o->next)
	 {
	 	lv->AddAtEnd(o->getname());
		if (order && !strcmp((char*)*order,o->getname()))
		{
			lv->Selected(lv->Count());
		}
	 	o=(class order*)o->next;
	 }
	gp->Add(lv);
	return gp;
}
void job_subOrder::setupprefs(group *g)
{
}
void job_subOrder::readprefs(group *g)
{
	delete order;
	order=NULL;
	int sel=((listview*)FindObject(g->FullName(),".orderslist"))->Selected();
	saveabledlist *olst=simple_filter::getMaster()->getOrderlst();
	class order *o=(class order*)olst->Find(sel);
	if (o)
	{
		order=new namenode(o->getname());
	}
}
void job_subOrder::renameRef(char *old,char *newn)
{
	if (order && !strcmp((char*)*order,old))
	{
		delete order;
		order=NULL;
		order=new namenode(newn);
	}
}

static job_subOrder jsO;

// -----------------------------------------------------------------------

class job_moveMail : public job
{
	char	folder_id[UNIQUE_ID_LEN];
	int		mode_movemail;
public:
	job_moveMail(void);
	job_moveMail(job_moveMail *,char *);
	~job_moveMail();

	job_moveMail *clone(char *);

	int work(class mail *);
	int load(tokenizer *);
	int save(tokenizer *);

	group *makeprefs(void);
	void setupprefs(group *);
	void readprefs(group *);
};

job_moveMail::job_moveMail(void) : job("move mail","Jrgen Schmitz")
{
	folder_id[0]=0;
	mode_movemail=0;
}
job_moveMail::job_moveMail(job_moveMail *j,char *n) : job(j,n)
{
	folder_id[0]=0;
	mode_movemail=0;
}
job_moveMail::~job_moveMail()
{
}

job_moveMail *job_moveMail::clone(char *n)
{
	return new job_moveMail(this,n);
}

int job_moveMail::work(mail *m)
{
	int ret=0;
	folders *fl=simple_filter::getMaster()->folderlist();
	vfolder *v=fl->getfolder_byid(folder_id);
	if (v)
	{
		mail *m2=new mail(m);
		v->appendmail_default(m2);
		ret=mode_movemail;
	}
	return ret;
}
int job_moveMail::load(tokenizer *tk)
{
	strncpy(folder_id,(*tk)[0],sizeof(folder_id));
	mode_movemail=atoi((*tk)[1]);
	return 0;
}
int job_moveMail::save(tokenizer *tk)
{
	char buf[5];
	sprintf(buf,"%d",mode_movemail);
	tk->append(new token((char*)folder_id));
	tk->append(new token((char*)buf));
	return 0;
}

group *job_moveMail::makeprefs(void)
{
	folders *fl=simple_filter::getMaster()->folderlist();
	vfolder *v=fl->getfolder_byid(folder_id);

	group *gp=new group;
	gp->Name("group");
	gp->Vert();
	 choice *ch=new choice;
	 ch->Name("vfolderlist");
	 ch->Items(fl->readlist(RL_WRITEABLES));
	 if (v)
	 {
	 	ch->Selected(fl->getfolder(v,RL_WRITEABLES));
	 }
	gp->Add(ch,"Destination folder");
	 checkbox *cb=new checkbox;
	 cb->Name("movemail");
	 cb->Text("move mail (instead of copy)");
	 cb->State(mode_movemail?PRESSED:RELEASED);
	gp->Add(cb,"");
	return gp;
}
void job_moveMail::setupprefs(group *g)
{
}
void job_moveMail::readprefs(group *g)
{
	folders *fl=simple_filter::getMaster()->folderlist();
	vfolder *v=fl->getfolder(((choice*)FindObject(g->FullName(),".vfolderlist"))->Selected(),RL_WRITEABLES);

	folder_id[0]=0;
	if (v)
	{
		strncpy(folder_id,v->g_id(),sizeof(folder_id));
	}
	mode_movemail=((checkbox*)FindObject(g->FullName(),".movemail"))->State()==PRESSED?1:0;
}

static job_moveMail jmM;
