/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: filter.h,v 1.11 2001/10/10 17:11:57 schmitzj Exp $ */


#ifndef FILTER_H
#define FILTER_H

#include "misc.h"
#include "../../src/strbuf.h"

class filter : public workablenode
{
friend class simple_filter;
friend class c_cfg;
	class simple_filter *parent;
	nameabledlist 		conds;
	namenode			*order;

	xcm_strbuf 			buf;

	unsigned int		enabled:1;
public:
	filter(char *n,class simple_filter *p);
	~filter();

	int load(tokenizer *);
	int save(tokenizer *);

	int work(class mail *);

	int getenable(void);
	void setenable(int);
	char *getcondname(void);
	char *getordername(void);

	void renameRef(char *old,char *newn);
};

class order : public workablenode
{
friend class simple_filter;
friend class j_cfg;
	class simple_filter *parent;
	nameabledlist	myorder;

public:
	order(char *n,class simple_filter *p);
	~order();

	int load(tokenizer *);
	int save(tokenizer *);

	int work(class mail *);

	void renameRef(char *old,char *newn);
};

#endif
