/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: misc.cxx,v 1.8 1999/03/05 21:23:09 schmitzj Exp $ */


#include "misc.h"

saveablenode::saveablenode(char *n)
{
	if (n)
		name=strdup(n);
	else
		name=NULL;
	text=name;
}
saveablenode::~saveablenode()
{
	if (name) free(name);
}
int saveablenode::load(tokenizer *)
{
}
int saveablenode::save(tokenizer *)
{
}
void saveablenode::setname(char *n)
{
	if (name) free(name);
	if (n)
		name=strdup(n);
	else
		name=NULL;
	text=name;
}
void saveablenode::renameRef(char *old,char *newn)
{
}

// -------------------------------------------------------------------

saveabledlist::saveabledlist(void) : dlist()
{
}
saveabledlist::~saveabledlist()
{
}
int saveabledlist::load(tokenizer *)
{
}
int saveabledlist::save(tokenizer *tk,int l)
{
	saveablenode *f=(saveablenode*)Find(l+1);
	if (!f) return 0;
	f->save(tk);
	return l+1;
}
void saveabledlist::renameRef(char *old,char *newn)
{
	saveablenode *n=(saveablenode*)head;

	while (n->next)
	{
		n->renameRef(old,newn);
		n=(saveablenode*)n->next;
	}
}

// -------------------------------------------------------------------

workablenode::workablenode(char *n) : saveablenode(n)
{
}
workablenode::~workablenode()
{
}
int workablenode::work(class mail *m)
{
}

// -------------------------------------------------------------------

workabledlist::workabledlist(void) : saveabledlist()
{
}
workabledlist::~workabledlist()
{
}
int workabledlist::workOr(class mail *m)
{
	int r=0;
	workablenode *n=(workablenode*)head;

	while (n->next)
	{
		r=n->work(m)|r;
		n=(workablenode*)n->next;
	}
	return r;
}
int workabledlist::workAnd(class mail *m)
{
	int r=1;
	workablenode *n=(workablenode*)head;

	while (n->next)
	{
		r=r&n->work(m);
		n=(workablenode*)n->next;
	}
	return r;
}

// -------------------------------------------------------------------

nameabledlist::nameabledlist(saveabledlist *w) : saveabledlist()
{
	worklist=w;
}
nameabledlist::~nameabledlist()
{
}
int nameabledlist::workOr(class mail *m,named_visitor *v)
{
	int r=0;
	namenode *n=(namenode*)head;

	while (n->next)
	{
		workablenode *wn=(workablenode*)worklist->FindText(n->text);
		if (wn)
			r=v->visit(wn,m)|r;
		n=(namenode*)n->next;
	}
	return r;
}
int nameabledlist::workAnd(class mail *m,named_visitor *v)
{
	int r=1;
	namenode *n=(namenode*)head;

	while (n->next)
	{
		workablenode *wn=(workablenode*)worklist->FindText(n->text);
		if (wn)
			r=r&v->visit(wn,m);
		n=(namenode*)n->next;
	}
	return r;
}
int nameabledlist::save(tokenizer *tk,int l)
{
	namenode *n=(namenode*)head;

	while (n->next)
	{
		tk->append(new token(n->text));
		n=(namenode*)n->next;
	}
	return 0;
}

cfg_plugin::cfg_plugin(char *name,char *author,enum PLUGINTYPE t,unsigned int flags) : plugins(name,author,t,flags,"part of the \"simple filter\" filter spec"), workablenode(NULL)
{
}
cfg_plugin::cfg_plugin(cfg_plugin *c,char *n) : plugins(c), workablenode(n)
{
}
cfg_plugin::~cfg_plugin()
{
}
