/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: orderlist.cxx,v 1.4 1999/03/05 21:23:09 schmitzj Exp $ */


#include "../configure.h" 
#include "simple_filter.h"
#include "filter.h"
#include "job.h"

orderlist::orderlist(simple_filter *p) : saveabledlist()
{
	parent=p;
}
orderlist::~orderlist()
{
}

int orderlist::load(tokenizer *tk)
{ // <name> <jName>+
	order *j=new order((char*)(*tk)[0],parent);
	if (j)
	{
		AddTail(j);
		tk->remove(0);
		j->load(tk);
	}
	else
		return 0;
}
int orderlist::save(tokenizer *tk,int l)
{
	order *n=(order*)Find(l+1);
	if (n)
	{
		tk->append(new token(n->getname()));
		return saveabledlist::save(tk,l);
	}
	return 0;
}

// ----------------------------------------------------------------------------

class order_visitor : public named_visitor
{
public:
	int visit(workablenode *wn,class mail *m)
	{
		return ((job*)wn)->work(m);
	};
};
order::order(char *n,simple_filter *p) : workablenode(n), myorder(p->getJoblst())
{
	parent=p;
}
order::~order()
{
	namenode *nn;
	while (nn=(namenode*)myorder.RemTail())
	{
		delete nn;
	}
}

int order::load(tokenizer *tk)
{ // <jName>+
	for (int i=0;i<tk->count();i++)
	{ // a new job
		namenode *nn=new namenode((*tk)[i]);
		myorder.AddTail(nn);
	}
}
int order::save(tokenizer *tk)
{
	return myorder.save(tk,0);
}
int order::work(class mail *m)
{
	order_visitor v;
	return myorder.workOr(m,&v);
}
void order::renameRef(char *old,char *newn)
{
	namenode *nn=(namenode*)myorder.head;

	while (nn->next)
	{
		if (!strcmp(nn->text,old))
		{
			nn->setname(newn);
		}
		nn=(namenode*)nn->next;
	}
}

// ----------------------------------------------------------------------------

joblist::joblist(simple_filter *p) : saveabledlist()
{
	parent=p;
}
joblist::~joblist()
{
}

int joblist::load(tokenizer *tk)
{ // <name> <pluginName> <parameter>
	int r=0;
	job *jb=simple_filter::findJob((*tk)[1]);
	if (jb)
	{
		jb=jb->clone((*tk)[0]);
		if (jb)
		{
			AddTail((workablenode*)jb);
			tk->remove(0);
			tk->remove(0);
			r=jb->load(tk);
		}
	}
	return r;
}
int joblist::save(tokenizer *tk,int l)
{
	job *n=(job*)(workablenode*)Find(l+1);
	if (n)
	{
		tk->append(new token(n->getname()));
		tk->append(new token(n->plugin_name()));
		return saveabledlist::save(tk,l);
	}
	return 0;
}

// ----------------------------------------------------------------------------

job::job(char *name,char *author) : cfg_plugin(name,author,PT_SJob,PLF_INVISIBLE|PLF_CLONEUSE)
{
}
job::job(class job *j,char *n) : cfg_plugin(j,n)
{
}
job::~job()
{
}
