/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: simple_filter.h,v 1.20 1999/03/07 15:22:01 schmitzj Exp $ */


#ifndef SIMPLE_FILTER_H
#define SIMPLE_FILTER_H

#include "../include/plugins.h"
#include "../include/filter_spec.h"
#include <Xclasses/Xclasses.h>
#include "misc.h"

class filterlist : public workabledlist
{ // all FILTER
	class simple_filter *parent;
public:
	filterlist(class simple_filter *);
	~filterlist();

	int load(tokenizer *);
	int save(tokenizer *,int);
};

class orderlist : public saveabledlist
{ // all JOBS
	class simple_filter *parent;
public:
	orderlist(class simple_filter *);
	~orderlist();
	int load(tokenizer *);
	int save(tokenizer *,int);
};
class conditionlist : public saveabledlist
{ // all CONDITION
	class simple_filter *parent;
public:
	conditionlist(class simple_filter *);
	~conditionlist();
	int load(tokenizer *);
	int save(tokenizer *,int);
};
class joblist : public saveabledlist
{ // all JOB
	class simple_filter *parent;
public:
	joblist(class simple_filter *);
	~joblist();
	int load(tokenizer *);
	int save(tokenizer *,int);
};

class jc_cfg : public callable
{
	int					old_selected;
	class namenode		*sel_name;
	class cfg_plugin	*sel_plugin;
	group				*pl_group;

	int					old_jctype;
protected:
	char 				*title;
	char				*prefix;
	saveabledlist 		*lst;		// conditionlist,joblist
	nameabledlist		*nlst;		// filter.condition,order.job
	char 				**alljc;

	class simple_filter	*parent;
	group				*parentgroup;
public:
	jc_cfg(class simple_filter *p,group *po);
	~jc_cfg();

	void open(int x,int y);
	void lvhandler(gadget *,int);
	void close(gadget *,int);
	void close(appwindow *);
	void showvalues(void);
	void main_lockcheck(void);
	void checkvalues(void);

	virtual class cfg_plugin *clone(int,char *)=0;
	virtual void finish(void)=0;
};
class c_cfg : public jc_cfg
{
public:
	c_cfg(class simple_filter *p,group *po,class filter *,char **all);
	~c_cfg();

	class cfg_plugin *clone(int,char *);
	void finish(void);
};
class j_cfg : public jc_cfg
{
public:
	j_cfg(class simple_filter *p,group *po,class order *,char **all);
	~j_cfg();

	class cfg_plugin *clone(int,char *);
	void finish(void);
};

class simple_filter : public filter_spec
{
	filterlist		flst;
	orderlist		jlst;
	conditionlist	clst;
	joblist			blst;
	
	unsigned int	dellock;
	unsigned int	odellock;
	char			**allconds;
	char			**alljob;

	int				old_selected;
	class filter	*filter_selected;

	int				old_oselected;

	j_cfg			*j_window;
	c_cfg			*c_window;

	void main_lockcheck(group *g);
	void checkvalues(group *g);
	void showvalues(group *g);

	int lvhook(struct hook_data *hd);

	void lvhandler(gadget *,int);
	void condhandler(gadget *,int);
	void orderhandler(gadget *,int);
	void SUForderhandler(class order *sel);

	void openorder(int x,int y);
	void orderwin_lvhandler(gadget *,int);
	void orderwin_close(gadget *,int);
	void orderwin_close(appwindow *);
	void orderwin_showvalues(void);
	void orderwin_main_lockcheck(void);
	void orderwin_checkvalues(void);

	static plugins *findPlugin(char *name,enum plugins::PLUGINTYPE t);
public:
	void SUFcondhandler(void);
	void orderwin_SUFlvhandler(void);

	simple_filter(void);
	~simple_filter();

	int save(void);
	int load(void);
	group *genprefs(void);
	void readprefs(group *);

	int filter(class mail *);		// 0: add mail, 1: don't add, free memory

	static class job *findJob(char *name);
	static class condition *findCondition(char *name);

 	class condition *getCondition(namenode *n)
 	{
 		return (condition*)clst.FindText((char*)*n);
 	};
	class order *getOrder(namenode *n)
	{
		return (order*)jlst.FindText((char*)*n);
	};
//  	class job *getJob(namenode *n)
//  	{
//  		return (job*)(workablenode*)blst.FindText((char*)*n);
//  	};

	saveabledlist *getCondlst(void) { return &clst; };
	saveabledlist *getOrderlst(void) { return &jlst; };
	saveabledlist *getJoblst(void)  { return &blst; };

	static simple_filter *getMaster(void);
};

#endif
