/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: address_book.h,v 2.17 2002/07/31 10:58:16 schmitzj Exp $ */


#ifndef ADDRESS_BOOK_HEADER
#define ADDRESS_BOOK_HEADER

#include "strbuf.h"

class AddressBook : public dlist
{
	xcm_strbuf vcard;
	char *getEmailByAliasRecursion(char *, int=0);

	class Address *getAddress(char *alias);
	int new_or_old_entry(class Address *,int nonew);		// Address is copied!

public:
	enum FIELDS {LASTNAME=0,FIRSTNAME=1,
				 ALIAS=2,EMAIL=3,
				 NOTE=4,QUICKMENU=5,
				 HOMEPHONE=6,WORKPHONE=7,
				 FAX=8,URL=9,
				 ORGANISATION=10,
				 ADDRESS=11,CITY=12,
				 STATE=13,ZIP=14,COUNTRY=15,
				 UNREMOVEABLE=16,FIXEDALIAS=17,
				 MOBIL=18,UNIQUEID=19,XFACE=20,
				 ADDDATE=21,USEDATE=22,MODIFIEDDATE=23,
				 };
#define FIELDSIZE	24

	enum VCARDTYPE {PRIVATE,WORK,NOVCARD};

	AddressBook(void); 
	~AddressBook(void);
	
	int save(FILE *);	// 0: OK
	int load(FILE *);	// 0: OK

	int new_entry(void);
	int new_entry(class Address *);		// Address is copied!
	int new_or_old_entry(class Address *);		// Address is copied!
	int update_old_entry(class Address *);
	int erase_entry(int i);	// 0: OK
	
	int setField(int entry,enum FIELDS f,char *value); 	// 0: ERROR, ELSE: new entry number
	int setField(int entry,enum FIELDS f,int); 			// 0: ERROR, ELSE: new entry number
	char *getField(int entry,enum FIELDS f);

	Address *getEntry(int entry);

	char *getEmailByAlias(char *aliasList);
	char *getName(int i,char *buf);
	int getAddressByAlias(char *alias);

	int getAddressByMatch(char *string,class tokenizer *dest);
	int getEntryByEmail(char *email);

	void clearall(void);

	int mix(class AddressBook *);

	int addZmailrc(void);

	char *vcardtext(enum VCARDTYPE vct=PRIVATE);
};

class Address : public node
{
	char *fields[FIELDSIZE];
public:
	Address(void);
	Address(Address &);
	Address(Address *);
	~Address();

	char* getField(int n);
	int setField(int n,char *);	// 0: OK
};

void add_auto_book(char *from);
void add_auto_book(char *name,char *email,char *xface=NULL);

extern AddressBook abook;
extern AddressBook abook_auto;

#endif
