/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: addressbookwindow.cxx,v 2.25 2002/07/31 11:21:40 schmitzj Exp $ */


#include "configure.h"

#include "mailer.h"
#include "encoder.h"
#include "address_book.h"
#include "extraggs.h"
#include <Xclasses/Xclasses.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>
#include <ctype.h>
#include "xc_snprintf.h"

static int  s_selected=0;
static card *theaddcard=NULL;
static AddressBook *s_abook;
static choice *abook_mode=NULL;
static popup *ad_popup=NULL;

static void fill_fields(void)
{
	if (s_selected>0)
	{
		((input*)FindObject(".addressbook.maingroup.alias"))->Default(s_abook->getField(s_selected,AddressBook::ALIAS));
		((input*)FindObject(".addressbook.maingroup.firstname"))->Default(s_abook->getField(s_selected,AddressBook::FIRSTNAME));
		((input*)FindObject(".addressbook.maingroup.lastname"))->Default(s_abook->getField(s_selected,AddressBook::LASTNAME));
		((input*)FindObject(".addressbook.maingroup.email"))->Default(s_abook->getField(s_selected,AddressBook::EMAIL));
		((input*)FindObject(".addressbook.maingroup.organisation"))->Default(s_abook->getField(s_selected,AddressBook::ORGANISATION));
		((checkbox*)FindObject(".addressbook.maingroup.quickaddress"))->State(atoi(s_abook->getField(s_selected,AddressBook::QUICKMENU))?PRESSED:RELEASED);

		((input*)FindObject(".addressbook.maingroup.address"))->Default(s_abook->getField(s_selected,AddressBook::ADDRESS));
		((input*)FindObject(".addressbook.maingroup.city"))->Default(s_abook->getField(s_selected,AddressBook::CITY));
		((input*)FindObject(".addressbook.maingroup.state"))->Default(s_abook->getField(s_selected,AddressBook::STATE));
		((input*)FindObject(".addressbook.maingroup.zip"))->Default(s_abook->getField(s_selected,AddressBook::ZIP));
		((input*)FindObject(".addressbook.maingroup.country"))->Default(s_abook->getField(s_selected,AddressBook::COUNTRY));

		((input*)FindObject(".addressbook.maingroup.url"))->Default(s_abook->getField(s_selected,AddressBook::URL));
		((input*)FindObject(".addressbook.maingroup.homephone"))->Default(s_abook->getField(s_selected,AddressBook::HOMEPHONE));
		((input*)FindObject(".addressbook.maingroup.mobilphone"))->Default(s_abook->getField(s_selected,AddressBook::MOBIL));
		((input*)FindObject(".addressbook.maingroup.workphone"))->Default(s_abook->getField(s_selected,AddressBook::WORKPHONE));
		((input*)FindObject(".addressbook.maingroup.fax"))->Default(s_abook->getField(s_selected,AddressBook::FAX));

		((textbox*)FindObject(".addressbook.maingroup.infobox"))->ReplaceText(s_abook->getField(s_selected,AddressBook::NOTE));
	}
}
static void addr_checkbuttons(void)
{
	if (s_selected>0)
	{
		if (atoi(s_abook->getField(s_selected,AddressBook::UNREMOVEABLE)))
			((input*)FindObject(".addressbook.maingroup.rem"))->Lock();
		else
			((input*)FindObject(".addressbook.maingroup.rem"))->Unlock();

		if (atoi(s_abook->getField(s_selected,AddressBook::FIXEDALIAS)))
			((input*)FindObject(".addressbook.maingroup.alias"))->Lock();
		else
			((input*)FindObject(".addressbook.maingroup.alias"))->Unlock();

		((gadget*)FindObject(".addressbook.maingroup.firstname"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.lastname"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.email"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.organisation"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.quickaddress"))->Unlock();

		((gadget*)FindObject(".addressbook.maingroup.address"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.city"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.state"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.zip"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.country"))->Unlock();

		((gadget*)FindObject(".addressbook.maingroup.url"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.homephone"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.mobilphone"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.workphone"))->Unlock();
		((gadget*)FindObject(".addressbook.maingroup.fax"))->Unlock();

		((gadget*)FindObject(".addressbook.maingroup.infobox"))->Unlock();
	}
	else
	{
		((gadget*)FindObject(".addressbook.maingroup.rem"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.alias"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.firstname"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.lastname"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.email"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.organisation"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.quickaddress"))->Lock();

		((gadget*)FindObject(".addressbook.maingroup.address"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.city"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.state"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.zip"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.country"))->Lock();

		((gadget*)FindObject(".addressbook.maingroup.url"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.homephone"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.mobilphone"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.workphone"))->Lock();
		((gadget*)FindObject(".addressbook.maingroup.fax"))->Lock();

		((gadget*)FindObject(".addressbook.maingroup.infobox"))->Lock();
	}
}

static void addr_showlist(int replace=0)
{
	listview *lv=(listview*)FindObject(".addressbook.maingroup.addresslist");
	choice *ch=(choice*)FindObject(".addressbook.maingroup.abooktype");
	char buf[400];
	int tp=lv->Top();
	if (!replace)
		lv->RemoveAll();
	int i=1,j=1;
	for (j=1;j<=s_abook->Count();j++)
	{
		int kl=0;
		buf[0]=0;
		if (s_abook->getField(j,AddressBook::LASTNAME)[0]) strcat(buf,s_abook->getField(j,AddressBook::LASTNAME));
		if (s_abook->getField(j,AddressBook::FIRSTNAME)[0] && buf[0]) strcat(buf,", ");
		if (s_abook->getField(j,AddressBook::FIRSTNAME)[0]) strcat(buf,s_abook->getField(j,AddressBook::FIRSTNAME));
		if (!buf[0]) strcat(buf,s_abook->getField(j,AddressBook::EMAIL));
		if (s_abook->getField(j,AddressBook::ALIAS)[0] && buf[0]) { strcat(buf," ("); kl=1; }
		if (s_abook->getField(j,AddressBook::ALIAS)[0]) strcat(buf,s_abook->getField(j,AddressBook::ALIAS));
		if (kl) strcat(buf,")");
		if (s_abook->getField(j,AddressBook::ORGANISATION)[0])
		{
			if (buf[0])
				strcat(buf,", ");
			strcat(buf,s_abook->getField(j,AddressBook::ORGANISATION));
		}
		if (!replace)
			lv->AddAtEnd(buf);
		else
			lv->Replace(i,buf);
		i++;
	}
	if (!replace)
		lv->Top(tp);

	xc_snprintf(buf,sizeof(buf),"%d entries",s_abook->Count());
	((text*)FindObject(".addressbook.maingroup.entry_field"))->Text(buf);
}
void makemenu(int md=0);
static int cmpcheck(int noshow=0)
{
	if (s_selected>0)
	{
		char str[MAXLENGTH+1];
		char *info;
		int  quickmenu=0;

		((input*)FindObject(".addressbook.maingroup.alias"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::ALIAS,str);
		((input*)FindObject(".addressbook.maingroup.firstname"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::FIRSTNAME,str);
		((input*)FindObject(".addressbook.maingroup.lastname"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::LASTNAME,str);
		((input*)FindObject(".addressbook.maingroup.email"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::EMAIL,str);
		((input*)FindObject(".addressbook.maingroup.organisation"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::ORGANISATION,str);

		((input*)FindObject(".addressbook.maingroup.address"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::ADDRESS,str);
		((input*)FindObject(".addressbook.maingroup.city"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::CITY,str);
		((input*)FindObject(".addressbook.maingroup.state"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::STATE,str);
		((input*)FindObject(".addressbook.maingroup.zip"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::ZIP,str);
		((input*)FindObject(".addressbook.maingroup.country"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::COUNTRY,str);

		((input*)FindObject(".addressbook.maingroup.url"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::URL,str);
		((input*)FindObject(".addressbook.maingroup.homephone"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::HOMEPHONE,str);
		((input*)FindObject(".addressbook.maingroup.mobilphone"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::MOBIL,str);
		((input*)FindObject(".addressbook.maingroup.workphone"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::WORKPHONE,str);
		((input*)FindObject(".addressbook.maingroup.fax"))->Input(str);
		s_selected=s_abook->setField(s_selected,AddressBook::FAX,str);

		quickmenu=((checkbox*)FindObject(".addressbook.maingroup.quickaddress"))->State()==PRESSED?1:0;
		s_selected=s_abook->setField(s_selected,AddressBook::QUICKMENU,quickmenu);

		textbox *tb=(textbox*)FindObject(".addressbook.maingroup.infobox");
		int s=tb->TextSize();
		info=new char[s+1];
		tb->CopyText(info,s+1);
		s_selected=s_abook->setField(s_selected,AddressBook::NOTE,info);

		((input*)FindObject(".addressbook.maingroup.alias"))->Default(s_abook->getField(s_selected,AddressBook::ALIAS));
		addr_showlist(1);
		if (!noshow)
			((listview*)FindObject(".addressbook.maingroup.addresslist"))->Selected(s_selected);

		delete [] info;
		makemenu(1);
	}
	return 0;
}
static void addr_handler(gadget *g, int i)
{
	if (!strcmp(g->Name(),"addresslist"))
	{
		int s=((listview*)g)->Selected();
		cmpcheck(1);
		s_selected=s;
		((listview*)g)->Selected(s);

		fill_fields();
		addr_checkbuttons();
		if (s_abook==&abook_auto)
			ad_popup->UnlockItem(1);
	}
	else if (!strcmp(g->Name(),"new"))
	{
		char str[20];
		cmpcheck();
		s_selected=s_abook->new_entry();
		s_abook->setField(s_selected,AddressBook::ALIAS,"new_entry");
		
		addr_showlist(0);
		listview *lv=(listview*)FindObject(".addressbook.maingroup.addresslist");
		lv->Selected(s_selected);

		fill_fields();
		addr_checkbuttons();
		addr_handler(lv,0);
		makemenu(1);
		theaddcard->Selected(0);
	}
	else if (!strcmp(g->Name(),"rem"))
	{
		easy_dialog ed;
		char buf[1000];
		xc_snprintf(buf,sizeof(buf),"Really remove address\n'%s'?",s_abook->getField(s_selected,AddressBook::EMAIL));
		ed.Text(buf);
		ed.Options("_Yes|_No");
		if (ed.Start((appwindow*)FindObject(readerwin.FullName(),"addressbook"))==1)
		{
			s_abook->erase_entry(s_selected);
			((listview*)FindObject(".addressbook.maingroup.addresslist"))->Selected(0);
			s_selected=0;
			addr_showlist(0);
			addr_checkbuttons();
			makemenu(1);
			ad_popup->LockItem(1);
		}
	}
	else if (!strcmp(g->Name(),"alias"))
	{
		cmpcheck();
		((input*)FindObject(".addressbook.maingroup.lastname"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"lastname"))
	{
		cmpcheck();
		((input*)FindObject(".addressbook.maingroup.firstname"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"firstname"))
	{
		cmpcheck();
		((input*)FindObject(".addressbook.maingroup.email"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"email"))
	{
		cmpcheck();
		((input*)FindObject(".addressbook.maingroup.organisation"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"organisation"))
	{
		cmpcheck();
		((input*)FindObject(".addressbook.maingroup.quickaddress"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"quickaddress"))
	{
		cmpcheck();
//		((input*)FindObject(".addressbook.maingroup.infobox"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"addresslist_popup"))
	{
		cmpcheck();
		abook.new_or_old_entry(s_abook->getEntry(s_selected));
		s_selected=0;
		((listview*)FindObject(".addressbook.maingroup.addresslist"))->Selected(0);
		addr_checkbuttons();
		ad_popup->LockItem(1);
	}
	else if (!strcmp(g->Name(),"abooktype"))
	{
		cmpcheck();
		switch (((choice*)FindObject(".addressbook.maingroup.abooktype"))->Selected())
		{
			case 1:
				s_abook=&abook_auto;
				break;
			default:
				s_abook=&abook;
				ad_popup->LockItem(1);
				break;
		}

		addr_showlist(0);
		s_selected=0;

		fill_fields();
		addr_checkbuttons();
	}
}
//static void deleteconverters(void);
static void addr_close(void)
{
	theaddcard=NULL;
	appwindow *aw=(appwindow*)FindObject(readerwin.FullName(),"addressbook");
	aw->Close();
	cmpcheck();
	DeleteObjectTree(aw->FullName());
	writeABook();
//	deleteconverters();
	makemenu(1);
}
static void addr_search(gadget *g,int)
{
	tokenizer tk;
	int n=0;
	char buf[MAXLENGTH];
	abookinput *abi=(abookinput*)FindObject(".addressbook.maingroup.search_string");

	abi->Input(buf);
	if (buf[0])
	{
		cmpcheck();

		mail::parse_from_address(buf);
		if (n=s_abook->getEntryByEmail(buf))
		{
		}
		else if (n=s_abook->getAddressByAlias(buf))
		{
		}
		else if (s_abook->getAddressByMatch(buf,&tk)>0)
		{
			char *b=strdup(tk[0]);
			mail::parse_from_address(b);
			if (n=s_abook->getEntryByEmail(b))
			{
			}
			free(b);
		}
		else if (n=abook.getEntryByEmail(buf))
		{
			abook_mode->Selected(0);
		}
		else if (n=abook.getAddressByAlias(buf))
		{
			abook_mode->Selected(0);
		}
		else if (abook.getAddressByMatch(buf,&tk)>0)
		{
			char *b=strdup(tk[0]);
			mail::parse_from_address(b);
			if (n=abook.getEntryByEmail(b))
			{
				abook_mode->Selected(0);
			}
			free(b);
		}
		else if (n=abook_auto.getEntryByEmail(buf))
		{
			abook_mode->Selected(1);
		}
		else if (n=abook_auto.getAddressByAlias(buf))
		{
			abook_mode->Selected(1);
		}
		else if (abook_auto.getAddressByMatch(buf,&tk)>0)
		{
			char *b=strdup(tk[0]);
			mail::parse_from_address(b);
			if (n=abook_auto.getEntryByEmail(b))
			{
				abook_mode->Selected(1);
			}
			free(b);
		}

		if (n>0)
		{
			abi->Default("");
			theaddcard->Selected(0);
			addr_handler(abook_mode,0);

			((listview*)FindObject(".addressbook.maingroup.addresslist"))->Selected(n);
			((listview*)FindObject(".addressbook.maingroup.addresslist"))->Top(n);
			addr_handler((listview*)FindObject(".addressbook.maingroup.addresslist"),0);
		}
	}
}

// #define MAXC	MAXUSERMAIL
// static char *allconverters[MAXC+1];
// static char *allconvertersprg[MAXC+1];
// void readABook(void);
// 
void addr_menuhandler(gadget *g,int i)
{
	switch (((menu*)g)->Selection())
	{
		case 0x01000001: // XCmail
			{
				cmpcheck();
				file_dialog fd;
				fd.LoadMode();
				if (fd.Start((appwindow*)FindObject(readerwin.FullName(),"addressbook")))
				{
					class AddressBook abook_tmp;
					FILE *f;
					char dir[500],fn[200];
					fd.GetDir(dir,sizeof(dir)-sizeof(fn)-1);
					fd.GetFile(fn,sizeof(fn));
					strcat(dir,"/");
					strcat(dir,fn);
					if (f=fopen(dir,"r"))
					{
						setvbuf(f,NULL,_IOFBF,2000);
						abook_tmp.load(f);
						fclose(f);
						s_abook->mix(&abook_tmp);
					}
					s_selected=0;
					addr_showlist(0);
					addr_checkbuttons();
				}
			}
			break;
		default:
// 			if (((menu*)g)->Selection()>=0x01000002 && ((menu*)g)->Selection()<0x02000000)
// 			{
// 				cmpcheck();
// 				writeABook();
// 				system(allconvertersprg[((menu*)g)->MID()]);
// 				readABook();
// 				s_selected=0;
// 				addr_showlist(0);
// 				addr_checkbuttons();
// 			}
			break;
	}
}
// static char **scanconverters(void)
// {
// 	int c=0;
// 	char dir[700],wdir[700];
// 	DIR *dfd;
// 	struct dirent *dptr;
// 	struct stat sbuf;
// 
// 	strcpy(dir,getenv("HOME"));
// 	strcat(dir,"/."PROGRAMNAME"/converters/");
// 	if (dfd=opendir(dir))
// 	{
// 		while ((dptr=readdir(dfd))&& c<MAXC)
// 		{
// 			if (dptr->d_name[0]!='.')
// 			{
// 				strcpy(wdir,dir);
// 				strcat(wdir,dptr->d_name);
// 				stat(wdir,&sbuf);
// 				if (S_ISREG(sbuf.st_mode) && !S_ISDIR(sbuf.st_mode))
// 				{
// 					strcpy(wdir,dir);
// 					strcat(wdir,dptr->d_name);
// 					if (!access(wdir,X_OK))
// 					{
// 						allconvertersprg[c]=strdup(wdir);
// 						allconverters[c++]=strdup(dptr->d_name);
// 					}
// 				}
// 			}
// 		}
// 		closedir(dfd);
// 	}
// 	strcpy(dir,GLOBALCFGDIR);
// 	strcat(dir,"/converters/");
// 	if (dfd=opendir(dir))
// 	{
// 		while ((dptr=readdir(dfd))&& c<MAXC)
// 		{
// 			if (dptr->d_name[0]!='.')
// 			{
// 				strcpy(wdir,dir);
// 				strcat(wdir,dptr->d_name);
// 				stat(wdir,&sbuf);
// 				if (S_ISREG(sbuf.st_mode) && !S_ISDIR(sbuf.st_mode))
// 				{
// 					strcpy(wdir,dir);
// 					strcat(wdir,dptr->d_name);
// 					if (!access(wdir,X_OK))
// 					{
// 						allconvertersprg[c]=strdup(wdir);
// 						allconverters[c++]=strdup(dptr->d_name);
// 					}
// 				}
// 			}
// 		}
// 		closedir(dfd);
// 	}
// 	allconverters[c]=NULL;
// }
// static void deleteconverters(void)
// {
// 	int c=0;
// 	while (allconverters[c])
// 	{
// 		free(allconverters[c]);
// 		free(allconvertersprg[c]);
// 		c++;
// 	}
// }
void addressbookwindow(void)
{
	appwindow *aw;
	if (aw=(appwindow*)FindObject(".addressbook"))
	{
		aw->Raise();
		aw->Open();
		return;
	}

	pstatus("Open addressbook window");

	aw=new appwindow;
	aw->Name("addressbook");
	aw->ParentClass(readerwin);
	aw->InitSize(50);
	aw->Init();
//	aw->TransientFor(readerwin.window());
	aw->Title(PROGRAMNAME" Addressbook");
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
	aw->IconTitle("Addressbook");

	aw->Callback((void (*)(appwindow*))addr_close);


	spacegroup *sg=new spacegroup;
	sg->Border(4);
	sg->Vert();
	sg->Name("maingroup");
   	  choice *ch=new choice;
  	  static char *atype[]={"private addressbook","automatic addressbook",NULL};
  	  ch->Name("abooktype");
  	  ch->Items(atype);
  	  ch->Selected(0);
//	  ch->Lock();
// 	  ch->HelpText("");
	  ch->Callback(addr_handler);
	  abook_mode=ch;
	  s_abook=&abook;
  	 sg->Add(ch);
	  listview *lv=new listview;
	  lv->Name("addresslist");
	  lv->ShowSelected();
	  lv->Weight(200);
	  lv->Callback(addr_handler);
	   ad_popup=new popup;
	   ad_popup->Name("addresslist_popup");
	   ad_popup->AddHeadline("Entry");
	   ad_popup->AddRuler();
	   ad_popup->Add("Copy to private book","c",1);
	   ad_popup->LockItem(1);
	   ad_popup->Callback(addr_handler);
	  lv->ContextPopup(ad_popup);
	 sg->Add(lv);
	  group *gp1=new group;
	  gp1->Vert();
	  gp1->Name(NULL);
	   group *gp2=new group;
	   gp2->Name(NULL);
	   gp2->Horiz();
	    fbutton *b=new fbutton;
	    b->Name("new");
	    b->Text("_New");
	    b->Callback(addr_handler);
	   gp2->Add(b);
	    b=new fbutton;
	    b->Name("rem");
	    b->Text("_Remove...");
	    b->Callback(addr_handler);
	   gp2->Add(b);
	  gp1->Add(gp2);
	   card *cd=new card;
	   theaddcard=cd;
	   cd->Name(NULL);
	   cd->Weight(10);
	    gp2=new group;
	    gp2->Name(NULL);
	    gp2->Vert();
	    gp2->YDistance(4);
	     input *ip=new input;
	     ip->Name("alias");
	     ip->Text("Alias");
	     ip->MaxChars(MAXLENGTH);
	     ip->Callback(addr_handler);
		 ip->HelpText("This name in the newmail will be\nreplaced by the email address.\nMultiple aliases separated by comma\npossible.");
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("lastname");
	     ip->Text("Last name");
	     ip->MaxChars(MAXLENGTH);
	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("firstname");
	     ip->Text("First name");
	     ip->MaxChars(MAXLENGTH);
	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("email");
	     ip->Text("Email address");
	     ip->MaxChars(MAXLENGTH);
	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("organisation");
	     ip->Text("Organisation");
	     ip->MaxChars(MAXLENGTH);
	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     checkbox *cb=new checkbox;
	     cb->Name("quickaddress");
	     cb->Text("_Quick address");
	     cb->HelpText("show address in 'quick mail' menu");
	     cb->Callback(addr_handler);
	    gp2->Add(cb,"");
	   cd->Add("Name",gp2);
	    gp2=new group;
	    gp2->Name(NULL);
	    gp2->Vert();
	    gp2->YDistance(4);
	     ip=new input;
	     ip->Name("address");
	     ip->Text("Address");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("city");
	     ip->Text("City");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("state");
	     ip->Text("State");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("zip");
	     ip->Text("ZIP");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("country");
	     ip->Text("Country");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	   cd->Add("Address",gp2);
	    gp2=new group;
	    gp2->Name(NULL);
	    gp2->Vert();
	    gp2->YDistance(4);
	     ip=new input;
	     ip->Name("url");
	     ip->Text("Url");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("homephone");
	     ip->Text("Homephone");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("mobilphone");
	     ip->Text("Cellular");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("workphone");
	     ip->Text("Workphone");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
	     ip=new input;
	     ip->Name("fax");
	     ip->Text("Fax");
	     ip->MaxChars(MAXLENGTH);
//	     ip->Callback(addr_handler);
	    gp2->Add(ip);
#ifdef USEPGP
//    	   choice *ch=new choice;
//  	   static char *ctxt[]={"no default","Unencoded","PGP signed","PGP encoded","PGP signed & encoded",NULL};
//  	   ch->Name("defaultpgp");
//  	   ch->Items(ctxt);
//  	   ch->Selected(0);
// 	   ch->HelpText("{FONT_BIG}This does not work,{/FONT}\ndue to a limitation in current addressbook backend.");
//  	  gp2->Add(ch,"default PGP mode");
//   	   if (!programconfig.usepgp)
//   	   {
//   		 ch->Lock();
//   	   }
#endif
	   cd->Add("Contact",gp2);
	    gp2=new group;
	    gp2->Name(NULL);
	    gp2->Vert();
	    gp2->YDistance(4);
	     textbox *tb=new textbox;
	     tb->Name("infobox");
	    gp2->Add(tb);
	   cd->Add("Note",gp2);
	  gp1->Add(cd);

	  gp1->Add(new ruler);
	   gp2=new group;
	   gp2->Name(NULL);
	   gp2->Horiz();
	   gp2->DialogMode();
	   gp2->Center();
	    group *gp3=new group;
		gp3->Name(NULL);
		gp3->Horiz();
		gp3->UseSmallest();
		 abookinput *abi=new abookinput;
		 abi->Name("search_string");
		 abi->MaxChars(MAXLENGTH);
		 abi->Callback(addr_search);
		gp3->Add(abi);
	     button *bt=new button;
		 bt->Name("search_button");
		 bt->Callback(addr_search);
		 bt->Font(FONT_SMALL);
		 bt->Text("_Search");
		gp3->Add(bt);
	   gp2->Add(gp3);
		text *txt=new text;
		txt->Name("entry_field");
		txt->Font(FONT_SMALL);
		txt->Center();
 	   gp2->Add(txt);
	    b=new fbutton;
	    b->Name("close");
	    b->Text("_Close");
	    b->Callback((void (*)(gadget*,int))addr_close);
	    b->ApplyXKey(XK_Escape);
	   gp2->Add(b);
	  gp1->Add(gp2);
	sg->Add(gp1);

	aw->SetGroup(sg);

//	scanconverters();
	menu *mn=new menu;
	mn->AddMenu("File");
	mn->Add("Import XCmail addressbook...",1);
// 	for(int i=0;allconverters[i];i++)
// 	{
// 		mn->Add(allconverters[i],i+2);
// 	}

	mn->Callback(addr_menuhandler);
	aw->SetMenu(mn);
	aw->Create();
	s_selected=0;

	addr_showlist(0);
	addr_checkbuttons();
}

void auto_addressbookupdate(void)
{
	appwindow *aw=(appwindow*)FindObject(readerwin.FullName(),"addressbook");

	if (aw)
	{
		cmpcheck();
		if (abook_mode->Selected()==1)
		{
//			addr_handler(abook_mode,0);
			addr_showlist();
		}
	}
}

void addressbookupdate(Address *a)
{
	appwindow *aw=(appwindow*)FindObject(readerwin.FullName(),"addressbook");

	if (aw)
	{
		aw->Raise();
		aw->Open();

		cmpcheck();
	}
	else
	{
		addressbookwindow();
	}
	cmpcheck();
	theaddcard->Selected(0);
	abook_mode->Selected(0);
	addr_handler(abook_mode,0);

	int s=s_abook->new_or_old_entry(a);
	addr_showlist();
	((listview*)FindObject(".addressbook.maingroup.addresslist"))->Selected(s);
	((listview*)FindObject(".addressbook.maingroup.addresslist"))->Top(s);
	addr_handler((listview*)FindObject(".addressbook.maingroup.addresslist"),0);
}
void addressbookupdate(char *from,char *email,char *fname, char *lname,char *com,char *xface)
{
	Address *a=new Address;

	char *sp=strrchr(from,' ');
	char *co=strchr(from,',');
	if (fname || lname)
	{
		a->setField(AddressBook::FIRSTNAME,fname);
		a->setField(AddressBook::LASTNAME,lname);
	}
	else if (co)
	{
		char *s=new char[strlen(from)+1];
		if (s)
		{
			strcpy(s,from);
			char *c=s+(co-from);
			while (c>s && *(c-1)==' ')c--;
			*c=0;
			c=s+(co-from)+1;
			while (*c && *c==' ')c++;

			a->setField(AddressBook::FIRSTNAME,c);
			a->setField(AddressBook::LASTNAME,s);
			delete [] s;
		}
	}
	else if (sp)
	{
		char *s=new char[strlen(from)+1];
		if (s)
		{
			strcpy(s,from);
			char *c=s+(sp-from);
			while (c>s && *(c-1)==' ')c--;
			*c=0;
			c=s+(sp-from)+1;
			while (*c && *c==' ')c++;

			a->setField(AddressBook::FIRSTNAME,s);
			a->setField(AddressBook::LASTNAME,c);
			delete[]s;
		}
	}
	else
	{
		a->setField(AddressBook::FIRSTNAME,"");
		a->setField(AddressBook::LASTNAME,from);
	}
	char *s=new char[strlen(from)+1];
	if (s)
	{
		char *f=from;
		char *c=s;
		while(*f)
		{
			if (!isalnum(*f))
			{
				if (c>s && *(c-1)!='_') *(c++)='_';
			}
			else
				*(c++)=*f;
			f++;
		}
		*c=0;
		a->setField(AddressBook::ALIAS,s);

		delete [] s;
	}
	a->setField(AddressBook::EMAIL,email);
	a->setField(AddressBook::NOTE,com);
	if (xface && xface[0])
	{
		a->setField(AddressBook::XFACE,xface);
	}

	addressbookupdate(a);
	delete a;
}

void addressbookselect(char *alias)
{
	appwindow *aw=(appwindow*)FindObject(readerwin.FullName(),"addressbook");

	if (aw)
	{
		aw->Raise();
		aw->Open();

		cmpcheck();
	}
	else
	{
		addressbookwindow();
	}
	cmpcheck();
	theaddcard->Selected(0);
	abook_mode->Selected(0);
	addr_handler(abook_mode,0);

	int s=s_abook->getAddressByAlias(alias);
	if (s>0)
	{
//		addr_showlist();
		((listview*)FindObject(".addressbook.maingroup.addresslist"))->Selected(s);
		((listview*)FindObject(".addressbook.maingroup.addresslist"))->Top(s);
		addr_handler((listview*)FindObject(".addressbook.maingroup.addresslist"),0);
	}
	else
	{
		Address *a=new Address;
		a->setField(AddressBook::ALIAS,alias);
		a->setField(AddressBook::NOTE,"This is your personal card.");
		a->setField(AddressBook::FIXEDALIAS,"1");
		a->setField(AddressBook::UNREMOVEABLE,"1");
		addressbookupdate(a);
		delete a;
	}
}
void ownAddressMode(gadget *g,int)
{
	if (!strcmp(g->Name(),"vcsettings_priv"))
		addressbookselect("me");
	else
		addressbookselect("me_work");

	appwindow *aw=(appwindow*)FindObject(readerwin.FullName(),"addressbook");

	if (!strcmp(g->Name(),"vcsettings_priv"))
	{
		aw->Title(PROGRAMNAME" own address");
		aw->IconTitle("Own address");
	}
	else
	{
		aw->Title(PROGRAMNAME" work address");
		aw->IconTitle("Work address");
	}

	((gadget*)FindObject(".addressbook.maingroup.rem"))->Lock();
	((gadget*)FindObject(".addressbook.maingroup.new"))->Lock();
	((listview*)FindObject(".addressbook.maingroup.addresslist"))->Lock();
	((input*)FindObject(".addressbook.maingroup.alias"))->Lock();
	((input*)FindObject(".addressbook.maingroup.search_button"))->Lock();
	((input*)FindObject(".addressbook.maingroup.search_string"))->Lock();
	((choice*)FindObject(".addressbook.maingroup.abooktype"))->Lock();
}
