/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: bannertext.cxx,v 2.15 2002/02/27 08:31:01 schmitzj Exp $ */


#include "configure.h"

#include "mailer.h"
#include "bannertext.h"
#include "address_book.h"
#include <string.h>
#include "maillist.h"
#include "readme.h"

struct banners
{
	char *text;
	int	 shown;
} bannertexts[]={	{"this is "PROGRAMNAME" "VERSION".",},
					{"use right mouse button in mail list for popup menu",},
					{"look at the right 'Xclasses' pull down menu for layout settings",},
					{"look in the general preferences window for some usefull settings",},
					{"use helpers to show MIME encoded mail or launch external programs",},
					{"tell your friends of "PROGRAMNAME" if you like it",},
					{"save your mail in different folders to keep your inbox small",},
					{"remember to clear your trashcan - or disable it or use the auto clean plugin 'trashmgr'",},
					{"see the readme for usefull X resources to configure "PROGRAMNAME" to your needs",},
					{"to disable this help banner set 'misc_helpline' in ~/."PROGRAMNAME"/settings to 'false'",},
					{"put your favorite email addresses in the quick address menu",},
					{"place all email addresses of others in the address book to remember them",},
					{"create new mail folders in the folder manager",},
					{"for new releases look at "HOMEPAGE,},
					{"middle mouse button or left button and SHIFT will (un)mark at mail in mailslist",},
					{"use POP3 for your mail? enable \"spool outgoing mail before sending\" in SMTP setup",},
					{"put your mail in an envelope - use PGP",},
					{"want to write mail and send all messages together when you are online? Use mail spooling!",},
					{"send a nice picture of you with any mail - XFace!",},
					{"to delete the biggest mail in a folder use the 'Sort by size' feature",},
					{"if more than one person should receive the reply answer the reply to all question with YES",},
					{"worried about misspelled messages? Use the XCmail spell checker with ispell",},
					{"in addresses starting with MAILTO: this will be removed",},
					{"found yourself in the 'group reply' window? add your alternating addresses in the prefs-address list",},
					{"using POP3 and inbox? Add both folders in one vfolder",},
					{"want to read new mail when it arrives? enable 'open window when new mail arrived' in misc prefs",},
					{"always connected to a DNS? 'enable hostname resolution by DNS' should be enabled",},
					{"read your mail from different places and "PROGRAMNAME"s? enable 'mark unknown mail as new' or 'mark all POP3 received mail as new",},
					{"want different signatures? have a look in the signature editor",},
					{"don't need all this plugins? disable unwanted plugins in the plugin prefs-plugin manager",},
					{"change the fonts? have a look in the Xclasses pull down menu",},
//					{"to restore a mail simply press 'undelete' in trashcan",},
					{"dont' want to save sent attachments in your outbox? disable this in preferences",},
					{"don't know what a functions is for? Check to docu...",},
					{"some function description is missing in the docu? Help writing it, check "HOMEPAGE" for more",},
					{"don't forget to press RETURN after writing an recipient in the newmail window",},
					{"to create new folders use the 'folder manager' in the 'special' pull down menu",},
					{NULL,}
					};
static int MAXBANNER=0;
static int highest=1;
int bannertext::Create(void)
{
	while(bannertexts[MAXBANNER].text)
	{
		bannertexts[MAXBANNER].shown=0;
		MAXBANNER++;
	}

	NoUnderline();
	if (text::Create())
	{
		Mode(gg_mode()|GM_NORMALTICK|GM_BUTTON1);
		return 1;
	}
	return 0;
}
int bannertext::GActivate(XEvent *e,int why)
{
	if (why==GA_TICK)
	{
		if (--bannerc==0)
		{
			text::Text("");
			if (len) bannerc=0; else bannerc=-90;
		}
		else if (bannerc==-100 && programconfig.helpline)
		{
			int r,c=0;
			do
			{
				do
				{
					r=rand() % MAXBANNER;
				}
				while (r==bannerp);
			}
			while (bannertexts[r].shown>=highest && (c++<MAXBANNER));
			bannerp=r;
			Center();
			strcpy(buf,bannertexts[bannerp].text);
			len=strlen(buf);
			bannerl=0;
			bannertexts[r].shown++;
			if (bannertexts[r].shown>highest)
				highest=bannertexts[r].shown;
		}
		else if (programconfig.helpline && bannerc<-100)
		{
			while (buf[bannerl] && buf[bannerl]!=' ') bannerl++;
			bannerl++;
			char c=buf[bannerl];
			buf[bannerl]=0;
			text::Text(buf);
			buf[bannerl]=c;
			if (bannerl>len) bannerc=300+len;
		}
		return 0;
	}
	else if (why==GA_BUTTONPRESS)
	{
		bannerc=-99;
		return GActivate(NULL,GA_TICK);
	}
	else
		return text::GActivate(e,why);
}
void bannertext::Text(char *t)
{
	bannerc=200;
	text::Text("");
	Left();
	text::Text(t);
   	readerwin.Update();
   	len=0;
}
extern menu mn;
extern char *allfolders[];
extern unsigned int quickmenustart;
extern unsigned int pluginsmenustart;

void bannertext::MenuHelpText(int m)
{
	char *t=NULL;
	switch (m)
	{
		case 0x01000001: // open folder
			t="Opens any mailfolder by file dialog";
			break;
		case 0x01000002: // mailbox
			t="Opens default mailfolder";
			break;
		case 0x01000003: // save in folder
			t="Saves mail in an existing folder or creates a new one";
			break;
		case 0x01000004: // save ASCII
			t="Saves complete mail including attachments";
			break;
		case 0x01000005: // print
			t="Prints complete mail including attachments!";
			break;
		case 0x01000006: // quit
			t="Leaves program";
			break;
		case 0x02000001: // sort by 0:unsorted, 1:sender, 2:subject, 3: send date, 4: rev send date
			t="Sorting of mail";
			break;
		case 0x02000002: // create new...
			t="Creates a new message";
			break;
		case 0x02000003: // read...
			t="Reads selected message(s)";
			break;
		case 0x02000004: // reply to...
			t="Replies selected message(s)";
			break;
		case 0x02000005: // forward to...
			t="Forwards selected message(s)";
			break;
		case 0x02000006: // search...
			t="Searches in current mailfolder";
			break;
		case 0x02000007: // search again
			t="Continues searching";
			break;
		case 0x02000008: // folder information...
			t="Some information and statistics";
			break;
		case 0x02000009: // mark doubles
			t="Marks double messages in current folder";
			break;
		case 0x0200000a: // sort by settings
			t="Set default sorting of mail";
			break;
		case 0x03000001: // save prefs
			t="Saves preferences now";
			break;
		case 0x03000002: // edit sig
			t="Opens signature editor";
			break;
		case 0x03000003: // sel: autoquote
			t="Automatically quotes when replying to mail";
			break;
		case 0x03000004: // sel: quotename
			t="Uses reply/forward opening defined in general settings";
			break;
		case 0x03000005: // sel: usepgp
			t="Turns PGP support on/off";
			break;
		case 0x03000006: // mx: pgp
			t="Sets default PGP mode for new mail - may be changed";
			break;
		case 0x03000007: // general prefs
			t="Opens general preferences window";
			break;
		case 0x03000008: // address book
			t="Opens addressbook window";
			break;
		case 0x03000009: // mail filter
			t="Opens mail filter window";
			break;
		case 0x0300000a: // autosave prefs
			t="Automatically saved preferences when leaving program";
			break;
		case 0x0300000b: // sort by 0:unsorted, 1:sender, 2:subject, 3: send date, 4: rev send date
			t="Default sorting of mail";
			break;
		case 0x0300000c: // general prefs
			t="Opens MIME & helpers preferences window";
			break;
		case 0x04000001: // programnews
			break;
		case 0x04000002: // mail the authors
			t="Opens new mail window to the authors - use mailing list instead";
			break;
#ifdef MAILLIST
#ifdef MAILLIST_TO
		case 0x04000003: // to maillist
			t="Write to the XCmail mailing list";
			break;
#endif
#ifdef MAILLISTSUB_TO
		case 0x04000004: // subscribe maillist
			t="Subscribe to the XCmail mailing list";
			break;
		case 0x04000007: // subscribe announce maillist
			t="Subscribe to the XCmail announcement mailing list";
			break;
#endif
#endif
#ifdef SHOWREADME
		case 0x04000005: // show readme
			break;
		case 0x04000006: // show tips
			break;
#endif
		case 0x05000001: // pop
			t="Gets POP3 mail";
			break;
		case 0x05000002: // send spool
			t="Sends spooled mail";
			break;
		case 0x05000003: // emtpy trash folder
			t="Clears trash folder now";
			break;
		case 0x05000004: // folder archiv
			t="Mail folder manager and archive";
			break;
		default:
			if (m>=0x01000100 && m<0x02000000)
			{ // save in folder
// 				static char dir[400];
// 				strcpy(dir,getenv("HOME"));
// 				strcat(dir,"/"HOMEMAIL"/");
// 				strcat(dir,allfolders[m-0x01000100]);
// 				t=dir;
			}
			else if (m>=quickmenustart && m<(quickmenustart+0x01000000-1))
			{ // quick mail
				t=abook.getField(mn.MID(),AddressBook::EMAIL);
			}
			else if (m>=pluginsmenustart && m<(pluginsmenustart+0x01000000-1))
			{ // quick mail
				t="This is an external plugin functionality";
			}
			break;
	}
	Text(t);
}
void bannertext::GSetLimits(void)
{
	text::GSetLimits();
}
