/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: createmail.h,v 2.8 2001/10/22 16:49:02 schmitzj Exp $ */


#ifndef CREATEMAIL_H
#define CREATEMAIL_H

#include <Xclasses/Xclasses.h>
#include "mailer.h"
#include "address_book.h"

struct attachments
{
	char *body;
	char *mime;
	char *name;
	char *filename;
};

class createmail
{
	char *_to;
	char *_cc;
	char *_subject;
	char *_bcc;
	char *_body;
	char *_replyto;
	int _priority;
	int _pgpmode;
	enum AddressBook::VCARDTYPE _vcardtype;
	int attacount;
	struct attachments	**attas;
	char *_headers;
	class mail *_forwardtomail;
	class mail *_replytomail;
	appwindow *aw;
	class statusobj *sobj;

	void freestring(char *&t);
	void setstring(char *&t,char *);
	void setemailstring(char *&t,char *);
	int send_mail(char *head, char *outboxhead, char *b,char *bound);
	int RCPT(FILE *file,char *buf);
public:
	createmail(void);
	~createmail();

	void to(char *);
	void cc(char *);
	void bcc(char *);
	void subject(char *);
	void replyto(char *);
	void priority(int);
	void body(char *);
	void pgpmode(int);		// 0: nothing, 1: sign, 2: code, 3: sign&code
	void attachments(int count,struct attachments **);	// array with attachments*
	void headers(char *);
	void replytomail(class mail *);
	void forwardtomail(class mail *);
	void vcardtype(enum AddressBook::VCARDTYPE vct);

	void referingwindow(appwindow *aw);
	void outputobject(class statusobj *);

	int send(void);	// 0: error, 1: sent, 2: async sending
};

#define SAVESTRING(s)	(s?s:(char*)"")
#define ISSET(s)		(SAVESTRING(s)[0])

int sendmail(char *mailfile,appwindow *aw,class statusobj *nm=NULL);

#endif
