/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: descrypt.h,v 2.1 1999/01/07 16:08:55 beckerr Exp $ */


class DESCrypt {

	private:
		int init_ok;
		
		static char ip[];
		static char fp[];
		static char pc1[];
		static char totrot[];
		static char pc2[];
		static char si[8][64];
		static char p32i[];
		static int bytebit[];
		static int nibblebit[];
		
		long (*sp)[64];			/* Combined S and P boxes */
		char (*iperm)[16][8];	/* Initial and final permutations */
		char (*fperm)[16][8];	/* 8 6-bit subkeys for each of 16 rounds, initialized by setkey() */
		unsigned char (*kn)[8];

	private:

		void permute(char *inblock, char perm[16][16][8], char *outblock);
		void round(int num, unsigned long *block);
		long f(unsigned long r, unsigned char subkey[8]);
		void perminit(char perm[16][16][8], char p[64]);
		int spinit(void);
		unsigned long byteswap(unsigned long x);
	
	public:
	
		DESCrypt(int permutations = 1);
		~DESCrypt();

		/* Set key (initialize key schedule array)
		 * key: 64 bits (will use only 56)
		 */
		int SetKey(char key[8]);
		
		/* In-place encryption of 64-bit block
		 */
		int EncodeBlock(char block[8]);

		/* In-place decryption of 64-bit block
		 */
		int DecodeBlock(char block[8]);
		
		/* Data encryption
		 */
		char* Encode(char *data, int ilen, int *lenP);

		/* C-String encryption
		 */
		char* Encode(char *str, int *lenP);

		/* Data decryption
		 */
		char* Decode(char *data, int len);
};
