/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: quoted_encoding.cxx,v 2.3 1999/01/15 11:06:56 beckerr Exp $ */


#include "../configure.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "../encoder.h"

#define	MAX	512

//--------------------------------------------------------------------

class encoder_quoted : public encoder {

	public:
		encoder_quoted(void) : encoder("quoted-printable;x-quoted-printable;X-Zm-quoted-printable;X-XC-quoted-printable", "Ralf Becker") {};
		~encoder_quoted() {};
		virtual char *data2mail(char *,int size,int &newsize,char *path,char *filename);
		virtual char *mail2data(char *,int size,int &newsize,char *path,char *filename);
		virtual void dispose(char *b) { free(b);}
};
static encoder_quoted quoted;


//--------------------------------------------------------------------


// quoted-printable decode
//
char *encoder_quoted::mail2data(char *inbuf,int size,int &newsize,char */*path*/,char */*filename*/) {

	char *outbuf, *cP;
	int count;
	
	count = 0,
	newsize = 0;
	if (outbuf = cP = (char *)malloc(size + 1), !cP)
		return NULL;

	for (int i = 0; i < size; i++) {

		unsigned char c = (unsigned char)inbuf[i];

		if (c == '=') {

			switch (inbuf[i+1]) {

				// String: =\n wird ignoriert
				//
				case '\n':
					i++;
					c = 0;
					break;

				// String: =xx (xx ist Hex) -> ASCII-Code
				//
				default:			
					if (isxdigit(inbuf[i+1]) && isxdigit(inbuf[i+2])) {
						char h[3] = "00";
						h[0] = inbuf[++i];
						h[1] = inbuf[++i];
						c = strtol(h, NULL, 16);
					}
					break;
			}
		}
		if (c) {
			*(cP++) = c;
			newsize++;
		}
	}
	*cP = 0;
	cP = (char *)realloc(outbuf, newsize + 1);
	return cP ? cP : outbuf;
}

// quoted-printable encode
//
char *encoder_quoted::data2mail(char *inbuf, int size, int &newsize,char *path,char *filename) {

	char *outbuf, *cP;
	int count, i;
	
	newsize = 0;
	outbuf = cP = (char *)malloc(size * 3);
	if (!outbuf) return NULL;

	for (i = 0, count = 0; inbuf[i]; i++) {

		unsigned char c = (unsigned char)inbuf[i];
		
		if (count > 74) {
			strcpy(cP, "=\n");
			newsize += 2;
			count = 0;
			cP += 2;
		}
		if (((c == '\t' || c == ' ') && (inbuf[i+1] == '\n' || !inbuf[i+1])) || c == '=' || c > 126) {
			sprintf(cP, "=%02X", (unsigned int)c);
			newsize += 3;
			count += 3;
			cP += 3;
		} else {
			*(cP++) = c;
			newsize++;
			if (c == '\n')
				count = 0;
			else
				count++;			
		}
	}
	*cP = 0;
	cP = (char *)realloc(outbuf, newsize + 1);
	return cP ? cP : outbuf; 
}

char *TranslateQuotedPrintable(char *s)
{
	int n;
	return quoted.mail2data(s,strlen(s),n,NULL,NULL);
}
