/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: extraggs.cxx,v 2.14 2001/10/23 23:28:27 schmitzj Exp $ */


#include "configure.h"

#include <string.h>
#include "mailer.h"
#include "extraggs.h"
#include "address_book.h"

#define ARWSIZE	12

void go_sleep(int milli);
popupbutton::popupbutton(): gadget(), Ddraw(this), pup(), arw()
{
	text=strdup("");
	Name("popupbutton");
	SetKeyHandler(KHM_SELECT);
	pup.ParentClass(this);
	arw.ParentClass(this);
	arw.Adjust(ADJUST_MIDDLE|ADJUST_RIGHT);
	arw.Direction(ARROW_DOWN);
	itemcount=0;
	ticker=0;
	selected=0;
	enabled=0;
}
popupbutton::~popupbutton()
{
	if (win) Free();
	if (text) free(text);
}
void popupbutton::Text(char *t)
{
	if (text) free(text);
    text=strdup(t);
    ApplyKey(gfx_text::ShortCut(t));
}
void popupbutton::Add(char *t)
{
	itemcount++;
	pup.Add(t,"",itemcount);
}
int popupbutton::Selected(void)
{
	return selected;
}
void popupbutton::EnablePopup(void)
{
	enabled=1;
	if (win) draw();
}
void popupbutton::DisablePopup(void)
{
	enabled=0;
	if (win) draw();
}
int popupbutton::Create(void)
{ 
	Background(col_background());
	BorderSize(2);
	KeyBorder();
	
    if (gadget::Create())
    {
    	char *res=GetResource("hilight");
    	if (!res || strcscmp(res,"True"))
	        Mode(GM_BUTTON1|GM_ONEEXPOSE|GM_KEY|GM_ACTIVETICK);
		else
    	    Mode(GM_BUTTON1|GM_ONEEXPOSE|GM_KEY|GM_ABOVE|GM_LOCKATONCE|GM_ACTIVETICK);

		if (itemcount>0)
		{
			pup.SendEventTo(this);
			pup.CopyFont(this);
			return pup.Create();
		}
		else
			return 1;
    } 
    return 0;
}
void popupbutton::draw(int pressed)
{
	if (pressed==2)
	{
	   	borderUpShineFill(this,0,0,width,height);
		bordertext(this,0,0,width,height,text);
		if (enabled)
			arw.draw_normal(this,width-ARWSIZE-RealSize(),(height-ARWSIZE)/2,ARWSIZE,ARWSIZE);
		if (locked)
		{
			borderlocked(this,0,0,width,height);
			borderlockedtext(this,0,0,width,height,text);
			if (enabled)
				arw.draw_locked(this,width-ARWSIZE-RealSize(),RealSize(),ARWSIZE,ARWSIZE);
		}
	}
	else if (pressed==1)
	{
   		borderDownFill(this,0,0,width,height);
		borderselectedtext(this,0,0,width,height,text);
		if (enabled)
			arw.draw_selected(this,width-ARWSIZE-RealSize(),(height-ARWSIZE)/2,ARWSIZE,ARWSIZE);
		if (locked) 
		{
			borderlockedtext(this,0,0,width,height,text);
			borderlocked(this,0,0,width,height);
			if (enabled)
				arw.draw_selectedlocked(this,width-ARWSIZE-RealSize(),(height-ARWSIZE)/2,ARWSIZE,ARWSIZE);
		}
	}
	else
	{
		borderUpFill(this,0,0,width,height);
		bordertext(this,0,0,width,height,text);
		if (enabled)
			arw.draw_normal(this,width-ARWSIZE-RealSize(),(height-ARWSIZE)/2,ARWSIZE,ARWSIZE);
		if (locked)
		{
			borderlocked(this,0,0,width,height);
			borderlockedtext(this,0,0,width,height,text);
			if (enabled)
				arw.draw_locked(this,width-ARWSIZE-RealSize(),(height-ARWSIZE)/2,ARWSIZE,ARWSIZE);
		}
	}
    if (active & GA_KEY)
    {
   	    bordermark(this,0,0,width,height);   	    
    }
    else
    {
		borderunmark(this,0,0,width,height);
    }
}
void popupbutton::GExpose(XEvent *event)
{
	if (wasfor)
	{
		wasfor->GExpose(event);
		return;
	}

	draw();
}
void popupbutton::GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason)
{
	if (pup.PopupOpen())
	{
		pup.GActionPress(mx,my,rx,ry,state,button,reason);
	}
	else
	{
		if (active&GA_BUTTONPRESS||reason&GB_BUTTON)
    	{
			draw(1);
	    }
		if (reason&GB_KEY)
		{
			bordermark(this,0,0,width,height);
		}
	}
}
void popupbutton::GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason)
{
	if (pup.PopupOpen())
	{
		pup.GActionRelease(mx,my,mx,my,state,button,reason);
	}
	else
	{
		if (active&GA_BUTTONPRESS||reason&GB_BUTTON)
		{
			draw();
		}
		if (reason&GB_KEY)
		{
			borderunmark(this,0,0,width,height);
		}
	}
}
int popupbutton::GActivate(XEvent *event,int why)
{
	int ret=0;
	if (pup.PopupOpen())
	{
		return pup.GActivate(event,why)&GAR_ACTIVE;
	}
	else
	{
		int r;
		r=DefaultKeyHandler(event);
		if (r==DKH_NOKEYEVENT)
		{
    		ret=GAR_ACTIVE;   // always active
			if (why==GA_BUTTONPRESS) ActivateKey();
			if (why==GA_ABOVE)
			{
				draw(2);
			}
			if (why==GA_TICK)
			{
				ret=0;
				if (itemcount>0 && enabled && ++ticker>5)
				{
					int x,y;
					GetPositionOnRoot(display(),win,x,y);
					pup.Open(x,y+height,width);
					ret=GAR_ACTIVE;
				}
			}
			else
			{
				ticker=0;
				selected=0;
			}
	    }
    	if (r==DKH_SELECT)
	    {
    	 	GActionPress(0,0,0,0,0,0,GB_BUTTON); XFlush(display());
     		go_sleep(200000);
     		GActionRelease(0,0,0,0,0,0,GB_BUTTON);
			selected=0;
	    	ret=GAR_ACTIVE;
    	}
	}
    return ret;
}
int popupbutton::GSelected(XEvent *event,int why,int wasabove)
{
	if (pup.PopupOpen())
	{
		if (pup.GSelected(event,why,wasabove))
		{
			draw();
			selected=pup.PID();
			return GSR_SELECTION|GSR_MESSAGE;
		}
		if (!pup.PopupOpen())
			draw();
	}
	else
	{
		if (why==GA_ABOVE)
		{
			draw();
			return 0;
		}
    	return (wasabove|(why==GA_KEY))?GSR_SELECTION|GSR_MESSAGE:0;   // selected if above
	}
	return 0;
}
int popupbutton::GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button)
{
	if (pup.PopupOpen())
	{
		return pup.GMouseMove(mx,my,rx,ry,state,button) & GSR_SELECTION;
	}
	return 0;
}
void popupbutton::GSetLimits(void)
{
	minwidth=textlength(this,text)+6+8+ARWSIZE*2;
	minheight=textheight(this,text)+6+4;
	maxheight=minheight;
}


int deletebutton::Create(void)
{
	Add("delete local");
	Add("delete on server");
	Add("delete both");
	return popupbutton::Create();
}
void deletebutton::CheckMailStatus(mail *m)
{
	if (m && (m->status() & STATUS_POPMAIL))
	{
		EnablePopup();
	}
	else
	{
		DisablePopup();
	}
}


int tindicator::Create(void)
{
	count=10*60*5;
	MaxValue(count);
	Value(count);
	if (indicator::Create())
	{
		Mode(gg_mode()|GM_NORMALTICK);
		return 1;
	}
	return 0;
}
int tindicator::GActivate(XEvent *ev,int why)
{
	if (why==GA_TICK)
	{
		Value(count);
		if (count--<0)
		{
			return GAR_ACTIVE;
		}
		return 0;
	}
	else
		return indicator::GActivate(ev,why);
}
int tindicator::GSelected(XEvent *ev,int why,int wasabove)
{
	if (why==GA_TICK)
	{
		CallCallback();
		return GSR_SELECTION;
	}
	else
		return indicator::GActivate(ev,why);
}

static int aed_cc=0;
autoeasy_dialog::autoeasy_dialog(void) : Xclasses("autoeasy_dialog")
{
	aw=NULL;
	txt=NULL;
	opts=strdup("_Ok");
	waitmode=0;
	selected=0;
	char buf[40];
	sprintf(buf,"autoeasy_dialog_%d",aed_cc);
	Name(buf);
}
autoeasy_dialog::~autoeasy_dialog()
{
	if (aw)
	{
		aw->Close();
	}
	DeleteObjectTree(FullName(),DOT_NOTBASE);
	if (opts) free(opts);
	if (txt) free(txt);
}
void autoeasy_dialog::WaitMode(void)
{
	waitmode=1;
}
void autoeasy_dialog::Text(char *t)
{
	if (txt) free(txt);
	txt=strdup(t);
}
void autoeasy_dialog::Options(char *t)
{
	if (opts) free(opts);
	opts=strdup(t);
}
int autoeasy_dialog::Start(Xwindows *w)
{
	if (w) ParentClass(w);
	aw=new appwindow;
	if (!aw)
	{
		delete this;
		return -1;
	}
	aw->ParentClass(this);
	aw->Name("window");
	aw->InitSize(1);
	aw->Init();
	aw->TransientFor(w);
	aw->PlaceUnderPointer();
	tindicator *ind=NULL;
	button *b=NULL;

	spacegroup *maingp=new spacegroup;
	maingp->Name("maingroup");
	maingp->Border(10);
	maingp->Vert();
	maingp->YDistance(10);
	 text *t=new text;
	 t->Name("dialogtext");
	 t->NoUnderline();
	 t->Text(txt);
	 t->Font(FONT_BIG);
	maingp->Add(t);
	maingp->Add(new ruler);
	 group *gp=new group;
	 gp->Horiz();
	 gp->DialogMode();
	 gp->Name(NULL);	

	int i=0;
	int c=0;
	int s=0;
	while (opts[i])
	{
		if (opts[i]=='|')
		{
			c++;
			opts[i]=0;
			b=new button;
			b->Name("button");
			b->Font(FONT_BIG);
			b->Text(&opts[s]);
			b->userdata=(void*)c;
			b->Callback(this,(CALLBACK)&autoeasy_dialog::close);
			gp->Add(b);
			s=i+1;
		}
		i++;
	}			
	if (opts[strlen(opts)-1]!='|') 
	{
		c++;
		b=new button;
		b->Name("button");
		b->Font(FONT_BIG);
		b->Text(&opts[s]);
		b->userdata=(void*)c;
		b->Callback(this,(CALLBACK)&autoeasy_dialog::close);
		gp->Add(b);
	}
	maingp->Add(gp);
//	maingp->Add(new ruler);
	 ind=new tindicator;
	 ind->Name("counter");
	 ind->Font(FONT_SMALL);
	 ind->HorizIndicator();
	 ind->Weight(1);
	 ind->Text("autoclose of window");
	 ind->Callback(this,(CALLBACK)&autoeasy_dialog::close);
	maingp->Add(ind);

	aw->SetGroup(maingp);
	aw->Callback(this,(CLOSECALLBACK)&autoeasy_dialog::wclose);
	aw->Create();
	if (b)
	{
		b->ActivateKey();
		b->ApplyXKey(XK_Escape);
		if (ind) ind->userdata=(void*)c;
	}

	int r=0;
	if (waitmode)
	{
		aw->BlockExcept();
		while(appwindow::NextEvent()!=EV_WAKEUP) ;
		r=selected;
		aw->UnblockExcept();
		aw->Close();
		appwindow::UpdateEvent();
		delete this;
	}
	return r;
}
void autoeasy_dialog::close(gadget *g,int)
{
	if (g)
		selected=(int)g->userdata;

	if (waitmode)
		aw->WakeUp();
	else
		delete this;
}
void autoeasy_dialog::wclose(appwindow *)
{
	if (waitmode)
		aw->WakeUp();
	else
		delete this;
}

xcfx_gadget::xcfx_gadget(void) : gadget(), Ddraw(this)
{
	Name("xcfx_gadget");
	onmode=0;
	mcount=0;
	pos=0;
	dmode[0]=0;
	dmode[1]=0;
	dmode[2]=0;
	dmode[3]=0;
}
xcfx_gadget::~xcfx_gadget()
{
}

int xcfx_gadget::Create(void)
{
	if (gadget::Create())
	{
		BorderSize(1);
		Background(col_background());
		Mode(GM_ONEEXPOSE|GM_NORMALTICK);
		cols[0]=col_background();
		cols[1]=AllocColor("+11+11+11");
		cols[2]=AllocColor("+22+22+22");
		cols[3]=AllocColor("+33+33+33");
		bgcols[0]=col_background();
		bgcols[1]=AllocColor("+55-22-22");
		return 1;
	}
	return 0;
}
void xcfx_gadget::Free(void)
{
	gadget::Free();
}

void xcfx_gadget::GExpose(XEvent *event)
{
	borderDown(this,0,0,width,height);
	int w=width-RealSize();
	int h=height-RealSize();

	XSetForeground(display(),gc,bgcols[onmode>0?1:0]);
	XFillRectangle(display(),win,gc,RealSize()+1,RealSize()+1,w-(RealSize()+1)-1,h-(RealSize()+1)-1);
	for(int i=RealSize()+1;i<(3+RealSize()+1);i++)
	{
		XSetForeground(display(),gc,cols[dmode[0]]);
		XDrawLine(display(),win,gc,i,i,w-i,i);

		XSetForeground(display(),gc,cols[dmode[1]]);
		XDrawLine(display(),win,gc,w-i,1+i,w-i,h-1-i);

		XSetForeground(display(),gc,cols[dmode[2]]);
		XDrawLine(display(),win,gc,i,h-i,w-i,h-i);

		XSetForeground(display(),gc,cols[dmode[3]]);
		XDrawLine(display(),win,gc,i,1+i,i,h-1-i);
	}
}
int xcfx_gadget::GActivate(XEvent *event,int why)
{
	if (why==GA_TICK)
	{
		mcount++;
		if (mcount%4==0)
		{
			for(int i=0;i<4;i++)
				if (dmode[i]>0) dmode[i]--;
			GExpose(NULL);
		}
		if (mcount>7)
		{
			mcount=0;
			if (onmode)
			{
				dmode[pos++]=3;
				if (pos>3)
					pos=0;
			}
			GExpose(NULL);
		}
	}
	return 0;
}
int xcfx_gadget::GSelected(XEvent *event,int why,int wasabove)
{
	return 0;
}
void xcfx_gadget::GSetLimits(void)
{
	minxaspect=minyaspect=maxxaspect=maxyaspect=1;
}

void xcfx_gadget::On(void)
{
	onmode++;
	mcount=8;
	if (win)
		GExpose(NULL);
}
void xcfx_gadget::Off(void)
{
	onmode--;
	if (onmode<0)
		onmode=0;
	if (win)
		GExpose(NULL);
}


abookinput::abookinput(void) : input(), pup(), atk()
{
	lastchange=0;
	taste[0]=0;
	maxlen=64;
	sbuf=new char[maxlen+1];
}
abookinput::~abookinput()
{
	delete [] sbuf;
}
int abookinput::Create(void)
{
	if (input::Create())
	{
		pup.SendEventTo(this);
		pup.CopyFont(this);
		return pup.Create();
	} 
	return 0;
}
void abookinput::Free(void)
{
	pup.Free();
	input::Free();
}
int abookinput::MaxChars(int m)
{
	maxlen=m;
	delete [] sbuf;
	sbuf=new char[maxlen+1];
	return input::MaxChars(m);
}
void abookinput::GExpose(XEvent *event)
{
	if (wasfor)
	{
		wasfor->GExpose(event);
		return;
	}
	else
		input::GExpose(event);
}
void abookinput::GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason)
{
	if (pup.PopupOpen())
	{
		pup.GActionPress(mx,my,rx,ry,state,button,reason);
	}
	else
	{
		input::GActionPress(mx,my,rx,ry,state,button,reason);
	}
}
void abookinput::GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason)
{
	if (pup.PopupOpen())
	{
		pup.GActionRelease(mx,my,mx,my,state,button,reason);
	}
	else
	{
		if (reason==GB_KEY)
		{
			Input(sbuf);
			char *t;
			if (t=abook.getEmailByAlias(sbuf))
			{
//				Default(t);
			}
		}
		input::GActionRelease(mx,my,mx,my,state,button,reason);
	}
}
int abookinput::GActivate(XEvent *event,int why)
{
	if (pup.PopupOpen())
	{
		if (why==GA_KEY)
		{
			int status,c;
			c=LookupString(event,taste,sizeof(taste),key,status);
			switch (key)
			{
				case XK_Return:
				case XK_KP_Enter:
					if (pup.PID()==0)
					{
						pup.Close();
						return input::GActivate(event,why);
					} // cont!!
				case XK_Up:
				case XK_KP_Up:
				case XK_Down:
				case XK_KP_Down:
				case XK_Escape:
					return pup.GActivate(event,why)&GAR_ACTIVE;
					break;
				default:
					pup.Close();
					lastchange=5;
					if (taste[0]==',' || taste[0]==';')
					{
						return GAR_ACTIVE;
					}
					else
						return input::GActivate(event,why);
					break;
			}
	    }
		return pup.GActivate(event,why)&GAR_ACTIVE;
	}
	else
	{
		int r=0;
		if (why==GA_KEY)
		{
			int status,c;
			c=LookupString(event,taste,sizeof(taste),key,status);
			if (taste[0]==',' || taste[0]==';')
			{
				r=GAR_ACTIVE;
			}
			else
				r=input::GActivate(event,why);
		}
		else
			r=input::GActivate(event,why);

		switch (why)
		{
			case GA_KEY:
				lastchange=5;
			    break;
			case GA_TICK:
				if (lastchange>0)
					lastchange--;
				else if (lastchange==0)
				{
					int c=0;
					lastchange=-1;
					atk.removeall();
					pup.Clear();
					Input(sbuf);
					c+=abook.getAddressByMatch(sbuf,&atk);
					c+=abook_auto.getAddressByMatch(sbuf,&atk);
					if (c>0)
					{
						c=0;
						do
						{
							int cc=c+1;
							while(cc<atk.count())
							{
								if (!strcscmp((char*)atk[c],(char*)atk[cc]))
								{
									atk.remove(cc);
								}
								else
									cc++;
							}
							c++;
						}
						while (c<atk.count());
						for(int i=0;i<c;i++)
						{
							pup.Add((char*)atk[i],NULL,i+1);
						}
						int x,y;
						GetPositionOnRoot(display(),win,x,y);
						ActivateKey();
						pup.OpenAt(x+4+before_x,y+height,0,width-4-before_x);
					}
				}
				break;
		}
		return r;
	}
    return 0;
}
int abookinput::GSelected(XEvent *event,int why,int wasabove)
{
	if (pup.PopupOpen())
	{
		if (pup.GSelected(event,why,wasabove))
		{
			if (pup.PID()>0)
			{ // names[PID] -> Default
				Default(atk[pup.PID()-1]);
				return GSR_MESSAGE;
			}
		}
		return 0;
	}
	if (why==GA_KEY)
	{
		if (taste[0]==',' || taste[0]==';')
		{
			return GSR_SELECTION;
		}
	}
	return input::GSelected(event,why,wasabove);
}
int abookinput::GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button)
{
	if (pup.PopupOpen())
		return pup.GMouseMove(mx,my,rx,ry,state,button) & GSR_SELECTION;
	else
		return input::GMouseMove(mx,my,rx,ry,state,button);
}
