/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: extraggs.h,v 2.7 2001/10/22 15:07:29 schmitzj Exp $ */


#ifndef EXTRAGGS_H
#define EXTRAGGS_H

#include <Xclasses/Xclasses.h>
#include "stringTokenizer.h"

class popupbutton : public gadget, private Ddraw
{
	char *text;
	popup pup;
	gfx_arrow arw;
	int enabled:1;
	int ticker;
	int itemcount;
	int selected;

	void draw(int pressed=0);
	// 0: normal, 1: pressed, 2: shine normal
public:
	virtual void GExpose(XEvent *event);
	virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GSetLimits(void);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);
	virtual int GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button);

    popupbutton();
    virtual ~popupbutton();

    int Create(void);
    void Text(char *t);
	void Add(char *t);
	int Selected(void);

	void EnablePopup(void);
	void DisablePopup(void);
};

class deletebutton : public popupbutton
{
public:
    int Create(void);
	void CheckMailStatus(class mail *);
};

class tindicator : public indicator
{
	int count;
	int val;
public:
	int GActivate(XEvent *ev,int);
	int GSelected(XEvent *ev,int,int);

	int Create(void);
};
class autoeasy_dialog : public Xclasses
{
	appwindow *aw;
	char *txt;
	char *opts;
	int selected;
	int waitmode:1;

	void close(gadget *,int);
	void wclose(appwindow *);

public:
	autoeasy_dialog(void);
	~autoeasy_dialog();
	void Text(char *);
	void Options(char *);
	void WaitMode(void);
	int Start(Xwindows *w);
	int Start(Xwindows &w) { return Start(&w); };
};

class xcfx_gadget : public gadget, private Ddraw
{
	int onmode;
	int mcount;
	int pos;
	int dmode[4];
	int cols[4];
	int bgcols[2];
public:
	virtual void GExpose(XEvent *event);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);
	virtual void GSetLimits(void);

	xcfx_gadget(void);
	~xcfx_gadget();

	virtual int Create(void);
	virtual void Free(void);

	void On(void);
	void Off(void);
};

class abookinput : public input
{
	popup pup;
	char taste[20];
	KeySym key;
	int lastchange;
	tokenizer atk;

	int maxlen;
	char *sbuf;

public:
	abookinput(void);
	~abookinput();

	int MaxChars(int m);
	virtual int Create(void);
	virtual void Free(void);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);
	virtual void GExpose(XEvent *event);
	virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual int GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button);


};


#endif
