/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: filter_mgr.cxx,v 2.18 1999/11/21 19:11:23 schmitzj Exp $ */


#include <Xclasses/Xclasses.h>
#include "plugins.h"
#include "pluginsmgr.h"
#include "filter_spec.h"
#include "mailer.h"
#include "filter_mgr.h"
#include "strbuf.h"

filter_mgr filtermaster;

filter_spec::filter_spec(char *name,char *author) : plugins(name,author,PT_Filterspec,PLF_STATICUSE|PLF_INVISIBLE,"Filter spec - this is required for every filter card in the filter settings window")
{
}
filter_spec::~filter_spec()
{
}


filter_mgr::filter_mgr(void) : Xclasses()
{
	Name("filtermanager");
	ParentClass(readerwin);
	aw=NULL;
}
filter_mgr::~filter_mgr()
{
}

int filter_mgr::filterMail(mail *m)
{
	int r=0;
	filter_spec *f=NULL;
	while (f=(filter_spec*)prgplugins->nextOfType(plugins::PT_Filterspec,f))
	{
		r=r | f->filter(m);
	}
	if (r) m->deleteLocalMail();
	return r;
}
int filter_mgr::hasFilters(void)
{
	return (int)prgplugins->nextOfType(plugins::PT_Filterspec);
}
int filter_mgr::loadPrefs(void)
{
	filter_spec *f=NULL;
	if (prgplugins)
	{
		while (f=(filter_spec*)prgplugins->nextOfType(plugins::PT_Filterspec,f))
		{
			f->load();
		}
	}
	return 0;
}
int filter_mgr::savePrefs(void)
{
	filter_spec *f=NULL;
	while (f=(filter_spec*)prgplugins->nextOfType(plugins::PT_Filterspec,f))
	{
		f->save();
	}
	return 0;
}
void filter_mgr::filterPrefs(void)
{
	filter_spec *f=NULL;
	group *fg;
	int x,y,w,h;

	if (aw)
	{
		aw->Raise();
		return;
	}
// open window

	pstatus("Open mail filter settings window");


	readerwin.Position(x,y);
	readerwin.Size(w,h);

	aw=new appwindow;
	aw->ParentClass(this);
	aw->Name("settingswindow");

	aw->InitSize(x,y,20);
	aw->Init();
	aw->Adjust(x,y,w,h,ADJUST_CENTER|ADJUST_MIDDLE);

	aw->Title("XCmail filter settings");
	aw->IconTitle("XCmail filter settings");
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());

	spacegroup *sgp=new spacegroup;
	sgp->Name("maingroup");
	sgp->Vert();
	sgp->Border(4);
	sgp->YDistance(4);
	 card *cd=new card;
	 cd->Name("specs");

	 while (f=(filter_spec*)prgplugins->nextOfType(plugins::PT_Filterspec,f))
	 {
		xcm_strbuf name;
		name+=f->plugin_name();
		TranslateName(name());
		f->mygroup=f->genprefs();
		f->mygroup->Name(name());
		cd->Add(f->plugin_name(),f->mygroup);
	 }
	sgp->Add(cd);
	 group *g1=new group;
	 g1->Horiz();
	 g1->Name("control");
	 g1->DialogMode();
	  fbutton *fb=new fbutton;
	  fb->Name("save");
	  fb->Callback(this,(CALLBACK)(void(filter_mgr::*)(gadget*,int))&filter_mgr::save);
	  fb->Text(" _Save ");
	 g1->Add(fb);
	  fb=new fbutton;
	  fb->Name("close");
	  fb->Callback(this,(CALLBACK)(void(filter_mgr::*)(gadget*,int))&filter_mgr::close);
	  fb->Text(" _Close ");
	  fb->ApplyXKey(XK_Escape);
	 g1->Add(fb);
	sgp->Add(g1);
	aw->Callback(this,(CLOSECALLBACK)(void(filter_mgr::*)(appwindow*))&filter_mgr::close);
	aw->SetGroup(sgp);
	aw->Create();
}

void filter_mgr::save(gadget *,int)
{
	close(aw);
	savePrefs();
}
void filter_mgr::close(gadget *,int)
{
	close(aw);
}
void filter_mgr::close(appwindow *)
{
	filter_spec *f=NULL;

	aw->Close();
	while (f=(filter_spec*)prgplugins->nextOfType(plugins::PT_Filterspec,f))
	{
		if (f->mygroup)
		{
			f->readprefs(f->mygroup);
		}
	}
	DeleteObjectTree(aw->FullName());
	aw=NULL;
}
