/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: folder_io_mbox.h,v 2.6 2002/06/27 09:26:22 schmitzj Exp $ */


#ifndef FOLDER_IO_MBOX_H
#define FOLDER_IO_MBOX_H
#include "config.h"
#include <Xclasses/Xclasses.h>
#include "folder.h"

#define MAXFOLDERS	100

class io_mbox : public io_class
{
	char *dirname;
	char *dir;

	unsigned int isfile:1;

	int dolock(char *lockname);
	void data2int(char *data,time_t &fsize,time_t &fdate);
	char *int2data(time_t fsize,time_t fdate);

public:
	io_mbox(char *dir,char *dirname=NULL);	// Dir or file
	virtual ~io_mbox();

	virtual char *io_name(void);
	virtual char *io_type(void);
	virtual char *io_username(void);

	virtual io_data *open(char *foldername,char mode,char *data=NULL,class folder *f=NULL);
	virtual int close(io_data *);
	virtual int fgets(io_data *,char *,int);

	virtual class folder **getfolders(void);

	virtual class mail *nextmail(io_data *);
	virtual int writemail(io_data *,class mail *);
	virtual int firstmail(io_data *);
	virtual int lastmail(io_data *);
	virtual int lock(char *foldername);
	virtual int unlock(char *foldername);

	virtual void *getFolderInfo(io_data *,int datatype);

	virtual int cknew(io_data *,char *);
	virtual char *getdata(io_data *);

	virtual int createfolder(char *foldername);
	virtual int removefolder(char *foldername);
	virtual int renamefolder(char *foldername,char *newfoldername);
};

#endif
