/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: folder_manager.h,v 2.14 2002/02/18 19:01:42 schmitzj Exp $ */


#ifndef FOLDER_MANAGER_H
#define FOLDER_MANAGER_H

#include "configure.h"
#include "mailer.h"
#include "folder.h"

static void changeHandler(void);
static void changeCFHandler(void);

class folder_manager : public Xclasses
{
	void makewin(void);
	void raise(void);
	void quit(gadget *,int);
	void menuhandler(gadget *,int);
	void folder_controller(gadget *,int);
	void folder_editor(gadget *,int);
friend void changeHandler(void);
friend void changeCFHandler(void);
	void show_io_list(void);
	void show_folder_list(void);
	void check_folder_list(void);

	io_class *getiofromlist(int source);

	int (folder_manager::*askCall)(char *);
	void askString(gadget *g,char *title,char *oldstring,int (folder_manager::*)(char *));
	void closeaskString(gadget *g,int i);
	void closeaskStringAW(appwindow *a);
	void askStringWork(gadget *g,int i);

	unsigned int delete_all:1,
	             delete_abort:1,
				 abort_pressed:1;

	appwindow *delaywindow;
	void openDelayWindow(char *);
	void closeDelayWindow(void);
	void delayWindow_cb(gadget *,int);

	vfolder *old_vfolder_selected;

	folder *folder_new2(char *n);
	int folder_del_v_of_f(folder *f);
	void folder_copy(void *);
	void folder_move(void *);
	void folder_movemails(void *);

	int folder_new(char *);
	int folder_rename(char *);
	int folder_delete(void *);

	int vfolder_new(char *);
	int vfolder_rename(char *);
	int vfolder_delete(void *);

public:
	folder_manager(void);
	~folder_manager();
};

#endif
