/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: gfxobjects.cxx,v 2.2 2001/10/10 17:12:00 schmitzj Exp $ */


#include "configure.h"

#include "mailer.h"
#include "gfxobjects.h"

gfx_folder::gfx_folder() : gfx_object()
{
	Name("gfx_folder");
	col=-1;
}
gfx_folder::~gfx_folder()
{
}
void gfx_folder::draw(class gadget *g,int x,int y,int w,int h,int c)
{
#define PTS1C	7
#define PTS2C	7
	XPoint pts1[PTS1C]={{x+1,y+5},{0,h-6},
					  {w-2,0},{0,-(h-6)},
					  {-2,-2},{-(w-2-4),0},
					  {-2,2}};
	XPoint pts11[PTS1C]={{x+1,y+5},{0,h-6},
					  {w-2,0},{0,-(h-6)},
					  {-2,-1},{-(w-2-4),0},
					  {-2,1}};
  	XPoint pts2[PTS2C]={{x+3,y+1},{2,0},
					  {2,2},{0,3},
					  {-(2+4),0},{0,-3},
					  {2,-2}};

	if (col==-1)
	{
		col=AllocColor(0xdddd,0xdddd,0xbbbb);
	}

	XSetLineAttributes(display(),g->gg_gc(),0,LineSolid,CapNotLast,JoinMiter);

	XSetForeground(display(),g->gg_gc(),col_white());
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,Convex,CoordModePrevious);
	XSetForeground(display(),g->gg_gc(),c);
	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,CoordModePrevious);


	XSetForeground(display(),g->gg_gc(),col);
//  shape: Complex, Convex, or Nonconvex
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts11,PTS1C,Convex,CoordModePrevious);
	XSetForeground(display(),g->gg_gc(),c);
	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts1,PTS1C,CoordModePrevious);

//	XSetForeground(display(),g->gg_gc(),o->col_white());
//	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,Convex,CoordModePrevious);
//	XSetForeground(display(),g->gg_gc(),c);
//	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,CoordModePrevious);

	XSetLineAttributes(display(),g->gg_gc(),0,LineSolid,CapButt,JoinRound);
}

void gfx_folder::Adjust(int a)
{
}
void gfx_folder::draw_normal(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_folder::draw_selected(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
void gfx_folder::draw_locked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_folder::draw_selectedlocked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
int gfx_folder::height(class gadget *g)
{
	return NOLIMIT;
}
int gfx_folder::width(class gadget *g)
{
	return NOLIMIT;
}

// -------------------------------------------------------------------------

gfx_readonly::gfx_readonly() : gfx_object()
{
	Name("gfx_readonly");
	col=-1;
}
gfx_readonly::~gfx_readonly()
{
}
void gfx_readonly::draw(class gadget *g,int x,int y,int w,int h,int c)
{
#define PTS1C	7
#define PTS2C	7
	XPoint pts1[PTS1C]={{x+1,y+5},{0,h-6},
					  {w-2,0},{0,-(h-6)},
					  {-2,-2},{-(w-2-4),0},
					  {-2,2}};
	XPoint pts11[PTS1C]={{x+1,y+5},{0,h-6},
					  {w-2,0},{0,-(h-6)},
					  {-2,-1},{-(w-2-4),0},
					  {-2,1}};
  	XPoint pts2[PTS2C]={{x+3,y+1},{2,0},
					  {2,2},{0,3},
					  {-(2+4),0},{0,-3},
					  {2,-2}};

	if (col==-1)
	{
		col=AllocColor(0xdddd,0x7777,0x7777);
	}

	XSetLineAttributes(display(),g->gg_gc(),0,LineSolid,CapNotLast,JoinMiter);

	XSetForeground(display(),g->gg_gc(),col_white());
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,Convex,CoordModePrevious);
	XSetForeground(display(),g->gg_gc(),c);
	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,CoordModePrevious);


	XSetForeground(display(),g->gg_gc(),col);
//  shape: Complex, Convex, or Nonconvex
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts11,PTS1C,Convex,CoordModePrevious);
	XSetForeground(display(),g->gg_gc(),c);
	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts1,PTS1C,CoordModePrevious);

//	XSetForeground(display(),g->gg_gc(),o->col_white());
//	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,Convex,CoordModePrevious);
//	XSetForeground(display(),g->gg_gc(),c);
//	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,CoordModePrevious);

	XSetLineAttributes(display(),g->gg_gc(),0,LineSolid,CapButt,JoinRound);
}

void gfx_readonly::Adjust(int a)
{
}
void gfx_readonly::draw_normal(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_readonly::draw_selected(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
void gfx_readonly::draw_locked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_readonly::draw_selectedlocked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
int gfx_readonly::height(class gadget *g)
{
	return NOLIMIT;
}
int gfx_readonly::width(class gadget *g)
{
	return NOLIMIT;
}

// -------------------------------------------------------------------------

gfx_trash::gfx_trash() : gfx_object()
{
	Name("gfx_trash");
	col=-1;
}
gfx_trash::~gfx_trash()
{
}
void gfx_trash::draw(class gadget *g,int x,int y,int w,int h,int c)
{
	y+=2;
	if (col==-1)
	{
		col=AllocColor("sandy brown");
	}

	XSetForeground(display(),g->gg_gc(),col_black());
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+1,y,w-2,h);
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x,y+1,w,3);

	XSetForeground(display(),g->gg_gc(),col);
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+2,y+1,w-4,h-2);
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+1,y+2,w-2,1);

	XSetForeground(display(),g->gg_gc(),col_black());
	int p=3;
	while (p<(w-3))
	{
		XDrawLine(display(),g->gg_win(),g->gg_gc(),x+p,y+h-2,x+p,y+5);
		XDrawLine(display(),g->gg_win(),g->gg_gc(),x+w-p,y+h-2,x+w-p,y+5);
		p+=2;
	}
}

void gfx_trash::Adjust(int a)
{
}
void gfx_trash::draw_normal(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_trash::draw_selected(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
void gfx_trash::draw_locked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_trash::draw_selectedlocked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
int gfx_trash::height(class gadget *g)
{
	return NOLIMIT;
}
int gfx_trash::width(class gadget *g)
{
	return NOLIMIT;
}

// -------------------------------------------------------------------------

gfx_inbox::gfx_inbox() : gfx_object()
{
	Name("gfx_inbox");
	col1=-1;
	col2=-1;
}
gfx_inbox::~gfx_inbox()
{
}
void gfx_inbox::draw(class gadget *g,int x,int y,int w,int h,int c)
{
	y+=2;
	if (col1==-1)
	{
		col1=AllocColor("gray95");
	}
	if (col2==-1)
	{
		col2=AllocColor("yellow");
	}

	XSetForeground(display(),g->gg_gc(),col_black());
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+3,y+1,w-2,h-1);

	XSetForeground(display(),g->gg_gc(),col1);
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+4,y+2,w-4,h-3);


	XPoint pts1[4]={{x+8,y+h/2-1},{x,y+h-2},{x,y+2},{x+8,y+h/2-1}};
	XPoint pts2[4]={{1+x+8,1+y+h/2},{1+x,1+y+h-2},{1+x,1+y+2},{1+x+8,1+y+h/2}};

	XSetLineAttributes(display(),g->gg_gc(),0,LineSolid,CapNotLast,JoinMiter);

	XSetForeground(display(),g->gg_gc(),col_black());
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts2,4,Convex,CoordModeOrigin);

	XSetForeground(display(),g->gg_gc(),col2);
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts1,4,Convex,CoordModeOrigin);
	XSetForeground(display(),g->gg_gc(),col_black());
	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts1,4,CoordModeOrigin);
}

void gfx_inbox::Adjust(int a)
{
}
void gfx_inbox::draw_normal(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_inbox::draw_selected(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
void gfx_inbox::draw_locked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_inbox::draw_selectedlocked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
int gfx_inbox::height(class gadget *g)
{
	return NOLIMIT;
}
int gfx_inbox::width(class gadget *g)
{
	return NOLIMIT;
}

// -------------------------------------------------------------------------

gfx_outbox::gfx_outbox() : gfx_object()
{
	Name("gfx_outbox");
	col1=-1;
	col2=-1;
}
gfx_outbox::~gfx_outbox()
{
}
void gfx_outbox::draw(class gadget *g,int x,int y,int w,int h,int c)
{
	y+=2;
	if (col1==-1)
	{
		col1=AllocColor("gray95");
	}
	if (col2==-1)
	{
		col2=AllocColor("green");
	}

	XSetForeground(display(),g->gg_gc(),col_black());
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x,y+1,w-3,h-2);

	XSetForeground(display(),g->gg_gc(),col1);
	XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+1,y+2,w-5,h-4);

	XPoint pts1[4]={{x+w,y+h/2-1},{x+w-8,y+h-3-1},{x+w-8,y+3-1},{x+w,y+h/2-1}};
	XPoint pts2[4]={{1+x+w,1+y+h/2},{1+x+w-8,1+y+h-3},{1+x+w-8,1+y+3},{1+x+w-8,1+y+h/2}};

	XSetLineAttributes(display(),g->gg_gc(),0,LineSolid,CapNotLast,JoinMiter);

	XSetForeground(display(),g->gg_gc(),col_black());
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts2,4,Convex,CoordModeOrigin);

	XSetForeground(display(),g->gg_gc(),col2);
	XFillPolygon(display(),g->gg_win(),g->gg_gc(),pts1,4,Convex,CoordModeOrigin);
	XSetForeground(display(),g->gg_gc(),col_black());
	XDrawLines(display(),g->gg_win(),g->gg_gc(),pts1,4,CoordModeOrigin);
}

void gfx_outbox::Adjust(int a)
{
}
void gfx_outbox::draw_normal(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_outbox::draw_selected(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
void gfx_outbox::draw_locked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_outbox::draw_selectedlocked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
int gfx_outbox::height(class gadget *g)
{
	return NOLIMIT;
}
int gfx_outbox::width(class gadget *g)
{
	return NOLIMIT;
}

// -------------------------------------------------------------------------

gfx_received::gfx_received() : gfx_object()
{
	Name("gfx_received");
	col=-1;
}
gfx_received::~gfx_received()
{
}
void gfx_received::draw(class gadget *g,int x,int y,int w,int h,int c)
{
	y+=2;
	if (col==-1)
	{
		col=AllocColor(0xdddd,0x7777,0x7777);
	}

	for(int p=6;p>=0;p-=3)
	{
		XSetForeground(display(),g->gg_gc(),col_black());
		XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+p,y+p,w-6,h-6);

		XSetForeground(display(),g->gg_gc(),col);
		XFillRectangle(display(),g->gg_win(),g->gg_gc(),x+p+1,y+p+1,w-8,h-8);
	}
}

void gfx_received::Adjust(int a)
{
}
void gfx_received::draw_normal(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_received::draw_selected(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
void gfx_received::draw_locked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x,y,w,h,col_text());
}
void gfx_received::draw_selectedlocked(class gadget *g,int x,int y,int w,int h)
{
	draw(g,x+1,y+1,w,h,col_selectedtext());
}
int gfx_received::height(class gadget *g)
{
	return NOLIMIT;
}
int gfx_received::width(class gadget *g)
{
	return NOLIMIT;
}

