/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: urltools.cxx,v 2.2 1999/01/07 16:09:10 beckerr Exp $ */


#include "../configure.h"

#include <string.h>
#include <strings.h>
#include "urltools.h"

// ----------------------------------------------------------------
//
// classUrlList
//
// ----------------------------------------------------------------
//


// Alle URLs vergessen
//
void classUrlList::UrlForgetAll(void) {
	while (urlP) {
		URL *tmp = urlP->next;
		delete urlP;
		urlP = tmp;
	}
	urlCount = 0;
}

// URL mit Index idx ermitteln
//
char *classUrlList::UrlByIndex(int idx) {
	URL *uP = urlP;
	for (int i = 0; i < idx && uP; i++)
		uP = uP->next;
	return uP ? uP->value : (char*)NULL;
}

// URL mit Index idx ermitteln
//
char *classUrlList::UrlByIndexCleaned(int idx) {
	URL *uP = urlP;
	for (int i = 0; i < idx && uP; i++)
		uP = uP->next;
	if (!uP) return NULL;

	char *s = new char[strlen(uP->value)*3+1];
	char *c,*p;
	int i;
	
	if (!s) return NULL;
	
	for (p=s, c=uP->value; *c; c++) {
		switch ((unsigned char)*c) {
			case ',':
				strcpy(p, "%2c");
				p+=3;
				break;
			default:
				*(p++)=*c;
				break;
		}
	}
	*p = 0;
	return s;
}


// Neue URL an Liste anhaengen (len ist -1 wenn cP null terminiert)
//
void classUrlList::UrlAppend(char *cP, int len) {
		
	if (len < 0)
		len = strlen(cP);

	URL *uP = urlP;
	
	for (; uP; uP = uP->next)
		if (strncmp(cP, uP->value, len) == 0 && uP->value[len] == 0)
			break;
		
	if (!uP) {

		/* In Liste einfuegen...
		 */
		*urlPP = new URL(len + 1);

		if (*urlPP) {
			strncat((*urlPP)->value, cP, len);
			urlPP = &((*urlPP)->next);
			*urlPP = NULL;
			urlCount++;
		}
	}
};

// Neue URL in einfuegen Liste anhaengen (len ist -1 wenn cP null terminiert)
//
void classUrlList::UrlInsert(char *cP, int len) {

	if (len < 0)
		len = strlen(cP);

	char buf[len + 1];
	*buf = 0;
	strncat(buf, cP, len);

	URL **uPP = &urlP;
	
	for (; *uPP; uPP = &((*uPP)->next)) {
		int i = strcasecmp(buf, (*uPP)->value);
		if (i == 0) return;
		if (i < 0) break;
	}
		
	/* In Liste einfuegen...
	 */
	URL *uP = new URL(len + 1);

	if (uP) {
		strcpy(uP->value, buf);
		uP->next = *uPP;
		*uPP = uP;
		urlCount++;
	}
};

