/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: urltools.h,v 2.1 1999/01/07 16:09:10 beckerr Exp $ */


#ifndef URL_TOOLS_H
#define URL_TOOLS_H

// -----------------------------------------------------
//
// classUrlList - Verwalten einer URL-Liste
//
// -----------------------------------------------------
//
class classUrlList {

	private:
		struct URL {
			URL *next;
			char *value;
			URL(int i) {
				value = new char[i + 1];
				value[0] = 0;
			};
			~URL() { delete[] value; }
		};

		URL   *urlP;
		URL   **urlPP;
		int   urlCount;

	public:
		classUrlList () {
			urlP = 0;
			urlPP = &urlP;
			urlCount = 0;
		};
		~classUrlList() {
			UrlForgetAll();
		};

		void  UrlForgetAll(void);					// Alle URL vergesseb
		void  UrlAppend(char *ut, int len = -1);	// URL mit Laenge len anfuegen
		void  UrlInsert(char *ut, int len = -1);	// URL mit Laenge len einfuegen
		char* UrlByIndex(int i);					// URL mit Index i ermitteln
		char* UrlByIndexCleaned(int i);				// URL mit Index i ermitteln
		int   UrlCount(void) { return urlCount; };	// Anzahl der URL ermitteln
};

#endif
