/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: level.cxx,v 2.4 2001/11/11 14:10:43 schmitzj Exp $ */


#include "configure.h"

#include "mailer.h"
#include "encoder.h"
#include "xc_snprintf.h"


levelwindow::levelwindow(appwindow *parent,char *t,int max,char *it,int flag) : Xclasses(), aw(), gp(), ind(), t1(), t2(), ab_button(), ab_group()
{
	int x,y,w,h;

	maxlevel=max;
	lastlevel=-1;
	infotext=it;
	flags=flag;
	animcc=0;
	strcpy(animbuf,"running....................................................");
	animdelay=0;
	animsize=strlen(animbuf);
	aborted=0;

	bps_lbytes=0;
	bps_ltime=0;

	ParentClass(parent);
	if (flags & LWF_ABORT)
		Name("levelwindow_abort");
	else
		Name("levelwindow");
//	parent->WMPosition(x,y);
	parent->Size(w,h);
	aw.ParentClass(this);
	aw.InitSize(x,y,w-(w/3),14);
	aw.Init();
//	aw.Adjust(x,y,w,h);
	aw.Adjust(0,0,w,h);
	aw.BorderWidth(3);
	aw.Title("Status");
	aw.IconTitle(t);
	aw.TransientFor(parent);
	aw.Group(parent);
	aw.Callback(this,(CLOSECALLBACK)&levelwindow::dummy);

	XReparentWindow(aw.display(),aw.window(),parent->window(),0,0);

	gp.Vert();
	gp.Border(10);
	gp.YDistance(5);
	gp.Add(t1);
	 t1.Text(t);
	gp.Add(ind);
	 ind.HorizIndicator();
	 ind.MaxValue(maxlevel);
	 ind.Value(0);
	gp.Add(t2);
	 t2.Text("\n");

	if (flags & LWF_ABORT)
	{
		gp.Add(ab_group);
		ab_group.Horiz();
		ab_group.DialogMode();
		ab_group.Add(ab_button);
		 ab_button.Text("_Abort");
		 ab_button.Callback(this,(CALLBACK)&levelwindow::abort);
	}

	if (parent->IsIconified()) aw.OpenAsIcon();

	aw.SetGroup(gp);
	aw.Create();
	aw.BlockExcept();
	aw.Update();
}
levelwindow::~levelwindow()
{
	aw.UnblockExcept();
	aw.Close();
}
void levelwindow::dummy(void)
{
}
void levelwindow::abort(gadget *g,int i)
{
	aborted=1;
	g->Lock();
}

int levelwindow::update(int level,int n,int bytes)
{
	if (level!=lastlevel)
	{
		if (flags & LWF_BPS && bytes>0)
		{
			time_t t;
			static int v=0;
			t=time(NULL);

			if (bps_ltime>0 && t-bps_ltime>0)
			{
				int vv=(bytes-bps_lbytes)/(t-bps_ltime)/1024;
				if (abs(v-vv)>v/2)
				{
					v=v+(vv-v)/2;
				}
				else
					v=vv;
			}
			bps_ltime=t;
			bps_lbytes=bytes;
			if (v>0)
				xc_snprintf(txt,sizeof(txt),"%s %d (%d Kbps)",infotext,n,v);
			else
				xc_snprintf(txt,sizeof(txt),"%s %d",infotext,n);
		}
		else if (flags & LWF_NONUM)
			xc_snprintf(txt,sizeof(txt),"%s",infotext);
		else
			xc_snprintf(txt,sizeof(txt),"%s %d",infotext,n);
		ind.Value(level,txt);
		aw.Update();
		if (animcc>0)
		{
			t2.Text("");
			animcc=0;
			animdelay=0;
		}
		appwindow::UpdateEvent();
	}
	else if (flags & LWF_ANIM && --animdelay<=0)
	{
		animdelay=30;
		animwbuf[animcc]=animbuf[animcc];
		animcc++;
		if (animcc>animsize) animcc=0;
		animwbuf[animcc]=0;
		t2.Text(animwbuf);
		aw.Update();
		appwindow::UpdateEvent();
	}
	lastlevel=level;
	return aborted;
}
