/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: license_dialog.cxx,v 2.4 2000/05/30 00:39:05 schmitzj Exp $ */


#include "configure.h"

#include "mailer.h"
#include "license_dialog.h"
#include "readme.h"
#include "strbuf.h"

#include <string.h>

#define USE_HTML_GADGET

license_dialog::license_dialog(char *n,int a) : Xclasses()
{
	if (n) Name(n); else Name("license_dialog");
	text=NULL;
	asciitext=0;
	async=a==1;
}

license_dialog::~license_dialog()
{
}

void license_dialog::close(gadget *g,int i)
{
	((appwindow*)FindObject(FullName(),"window"))->Close();
	DeleteObjectTree(FullName());
}
int license_dialog::Start(appwindow *par)
{
	int ret=0,r;
	appwindow *aw=new appwindow;

	ParentClass(par);

	aw->ParentClass(this);
	aw->Name("window");
	aw->InitSize(0,0,20);
	if (!aw->Init())
	{
		delete aw;
		return 0;
	}
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());

	spacegroup *g1=new spacegroup;
	group *bg1=new group;
#ifdef USE_HTML_GADGET
	html_gadget *htb=NULL;
#else
	htmltextbox *htb=NULL;
#endif
	textbox *tb=NULL;
	fbutton *b1=new fbutton;

	if (async) aw->Title(PROGRAMNAME" "VERSION); else aw->Title("License agreement");
	aw->TransientFor(par);
	g1->Vert();
	g1->Border(4);
	 if (asciitext)
	 {
	 	tb=new textbox;
	    tb->ReadOnly();
	 	tb->AppendText(text);
	    tb->MinCols(50);
	    tb->MinRows(12);
	   g1->Add(tb);
	 }
	 else
	 {
#ifdef USE_HTML_GADGET
	    htb=new html_gadget;
	 	htb->Text(text);
	    htb->MinCols(35);
	    htb->MinRows(16);
		tb=(textbox*)(gadget*)htb;
#else
	    htb=new htmltextbox;
	 	htb->AppendText(text);
	    tb=htb;
	    tb->MinCols(50);
	    tb->MinRows(12);
#endif
	   g1->Add(htb);
	  }
	g1->Add(new ruler);
	 bg1->Horiz();
	 bg1->DialogMode();
	  b1->Text("Okay");
	  if (async) b1->Callback(this,(CALLBACK)&license_dialog::close); else b1->ID(1);
	 bg1->Add(b1);
	g1->Add(bg1);
	aw->SetGroup(g1);

	if (async) aw->Callback(this,(CLOSECALLBACK)&license_dialog::close);

	aw->Create();
	tb->ActivateKey();

	if (!async)
	{
		aw->BlockExcept();
		while (!ret)
		{
			r=appwindow::NextEvent();
			switch(r)
			{
				case EV_WINDOWCLOSE:
					ret=2;
					break;
				case EV_GADGET:
					ret=aw->ID();
					break;
			}
		}
		aw->UnblockExcept();
		aw->Close();
		DeleteObjectTree(aw->FullName());
	}
	return ret;
}
void license_dialog::Text(char *t)
{
	text=t;
}
void license_dialog::ASCIIText(char *t)
{
	text=t;
	asciitext=1;
}

#ifdef SHOWREADME
#include "XCmail.readme.h"
void showreadme(void)
{
	if (FindObject(".readme_dialog")) return;
	license_dialog *ld=new license_dialog("readme_dialog",1);

	ld->ASCIIText(readme);
	ld->Start(readerwin);
}

extern struct banners
{
	char *text;
	int	 shown;
} bannertexts[];

void showtips(void)
{
	if (FindObject(".tips_dialog")) return;
	license_dialog *ld=new license_dialog("tips_dialog",1);

	xcm_strbuf txt;
	int m=0;

	txt+="<body>\nSome usage tips from the bannerline for "PROGRAMNAME":\n<ul>";
	while(bannertexts[m].text)
	{
		txt+="\n<li>";
		txt+=bannertexts[m].text;
		m++;
	}
	txt+="\n</ul>\n</body>\n";
	ld->Text(txt());
	ld->Start(readerwin);
}
#endif
