/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: mail_stat.cxx,v 2.6 2001/06/24 00:02:10 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include "mailer.h"
#include "folder.h"

static void folderinfomail(vfolder *folder,mail *current);
static void folderinfoclose_aw(appwindow *aw)
{
	aw->Close();
	DeleteObjectTree(aw->FullName());
}
static void folderinfoclose_gg(gadget *g,int i)
{
	appwindow *aw=(appwindow*)FindObject(".folderinfowindow");
	folderinfoclose_aw(aw);
}
void folderinfo_update(vfolder *folder,mail *current)
{
	appwindow *aw=(appwindow*)FindObject(".folderinfowindow");
	if (aw) folderinfo(folder,current);
}
void folderinfo_updatecurrent(vfolder *folder,mail *current)
{
	appwindow *aw=(appwindow*)FindObject(".folderinfowindow");
	if (aw) folderinfomail(folder,current);
}

static void folderinfomail(vfolder *folder,mail *current)
{
	if (current)
	{
		char buf[200];
		xc_snprintf(buf,sizeof(buf),"%d",folder->getpos(current));
		((output*)FindObject(".folderinfowindow.mailgroup.mailnumber"))->Output(buf);
		xc_snprintf(buf,sizeof(buf),"%d",strlen(current->themailtext()));
		((output*)FindObject(".folderinfowindow.mailgroup.mailsize"))->Output(buf);
		xc_snprintf(buf,sizeof(buf),"%d",abs(current->totalparts()));
		((output*)FindObject(".folderinfowindow.mailgroup.mailparts"))->Output(buf);

		((output*)FindObject(".folderinfowindow.mailgroup.from"))->Output(current->from());
		((output*)FindObject(".folderinfowindow.mailgroup.from_email"))->Output(current->from_email());
		((output*)FindObject(".folderinfowindow.mailgroup.to"))->Output(current->to());
		((output*)FindObject(".folderinfowindow.mailgroup.cc"))->Output(current->cc());
		((output*)FindObject(".folderinfowindow.mailgroup.replyto"))->Output(current->replyto());
		((output*)FindObject(".folderinfowindow.mailgroup.subject"))->Output(current->subject());
		((output*)FindObject(".folderinfowindow.mailgroup.senddate"))->Output(current->date());

		((output*)FindObject(".folderinfowindow.mailgroup.client"))->Output(current->getTag("X-Mailer:"));
		((output*)FindObject(".folderinfowindow.mailgroup.xuidl"))->Output(current->xuidl());
		((output*)FindObject(".folderinfowindow.mailgroup.savedate"))->Output(current->getTag("X-Savedate:"));
	}
	else
	{
		((output*)FindObject(".folderinfowindow.mailgroup.mailnumber"))->Output("");

		((output*)FindObject(".folderinfowindow.mailgroup.from"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.from_email"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.to"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.cc"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.replyto"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.subject"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.senddate"))->Output("");

		((output*)FindObject(".folderinfowindow.mailgroup.client"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.xuidl"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.savedate"))->Output("");

		((output*)FindObject(".folderinfowindow.mailgroup.mailsize"))->Output("");
		((output*)FindObject(".folderinfowindow.mailgroup.mailparts"))->Output("");
	}
}
void folderinfo(vfolder *folder,mail *current)
{
	appwindow *aw=(appwindow*)FindObject(".folderinfowindow");

	if (!folder)
	{
		if (aw) folderinfoclose_aw(aw);
		return;
	}

	if (!aw)
	{
		aw=new appwindow;
		aw->Name("folderinfowindow");
		aw->ParentClass(readerwin);
		aw->InitSize(90);
		if (!aw->Init())
		{
			delete aw;
			return;
		}
		aw->TransientFor(readerwin);
		aw->Title("Mail folder information");
		aw->IconTitle("Mail folder information");
		aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
		aw->Callback(folderinfoclose_aw);

		spacegroup *g1=new spacegroup;
		g1->Name("mailgroup");
		g1->Vert();
		g1->Border(4);
		 output *op=new output;
		 op->Name("foldername");
		 op->Text("Foldername");
		g1->Add(op);
		 op=new output;
		 op->Name("size");
		 op->Text("Size");
		g1->Add(op);
		 op=new output;
		 op->Name("totalmails");
		 op->Text("Total messages");
		g1->Add(op);
		 op=new output;
		 op->Name("mimemails");
		 op->Text("Mime encoded");
		g1->Add(op);
		 op=new output;
		 op->Name("biggest");
		 op->Text("Biggest mail");
		g1->Add(op);
		 text *txt=new text;
		 txt->Name("message");
		 txt->Text("\n");
		g1->Add(txt,"");
		 ruler *rl=new ruler;
		g1->Add(rl);
		 visible *vi=new visible;
		 vi->Name(NULL);
		  group *g2=new group;
		  g2->Name(NULL);
		  g2->Vert();
		   op=new output;
		   op->Name("mailnumber");
		   op->Text("Mail number");
		  g2->Add(op);
		   op=new output;
		   op->Name("from");
		   op->Text("From");
		  g2->Add(op);
		   op=new output;
		   op->Name("from_email");
		   op->Text("From address");
		  g2->Add(op);
		   op=new output;
		   op->Name("to");
		   op->Text("To");
		  g2->Add(op);
		   op=new output;
		   op->Name("cc");
		   op->Text("Cc");
		  g2->Add(op);
		   op=new output;
		   op->Name("replyto");
		   op->Text("Replyto");
		  g2->Add(op);
		   op=new output;
		   op->Name("subject");
		   op->Text("Subject");
		  g2->Add(op);
		   op=new output;
		   op->Name("senddate");
		   op->Text("Send date");
		  g2->Add(op);

		   op=new output;
		   op->Name("mailsize");
		   op->Text("Size");
		  g2->Add(op);
		   op=new output;
		   op->Name("mailparts");
		   op->Text("Parts");
		  g2->Add(op);

		   op=new output;
		   op->Name("client");
		   op->Text("MUA");
		  g2->Add(op);
		   op=new output;
		   op->Name("xuidl");
		   op->Text("X-UIDL");
		  g2->Add(op);
		   op=new output;
		   op->Name("savedate");
		   op->Text("Save date");
		  g2->Add(op);
	     vi->Apply(g2);
		g1->Add(vi);

		 rl=new ruler;
		g1->Add(rl);
		 fbutton *fb=new fbutton;
		 fb->Name("closebutton");
		 fb->Text("_Close");
		 fb->Callback(folderinfoclose_gg);
		 fb->ApplyXKey(XK_Escape);
		g1->Add(fb);
		
		aw->SetGroup(g1);
		aw->Create();
	}

	char buf[200];
	class mail *m;
	int j,big,bigc;

	((output*)FindObject(".folderinfowindow.mailgroup.foldername"))->Output(folder->g_foldername());
	xc_snprintf(buf,sizeof(buf),"%d bytes",folder->g_size());
	((output*)FindObject(".folderinfowindow.mailgroup.size"))->Output(buf);
	xc_snprintf(buf,sizeof(buf),"%d",folder->count());
	((output*)FindObject(".folderinfowindow.mailgroup.totalmails"))->Output(buf);

	j=0;
	big=0;
	bigc=0;
	for(int i=0;i<folder->count();i++)
	{
		m=folder->getmail(i+1);
		if (abs(m->totalparts())>1) j++;
		if (strlen(m->themailtext())>big)
		{
			big=strlen(m->themailtext());
			bigc=i+1;
		}
		m->freemem();
	}
	xc_snprintf(buf,sizeof(buf),"%d",j);
	((output*)FindObject(".folderinfowindow.mailgroup.mimemails"))->Output(buf);
	xc_snprintf(buf,sizeof(buf),"%d (%d bytes)",bigc,big);
	((output*)FindObject(".folderinfowindow.mailgroup.biggest"))->Output(buf);

	if (folder->g_size()>500000)
	{
		strcpy(buf,"This folder is bigger than 500 KB!");
	}
	else
	{
		buf[0]=0;
	}
	((text*)FindObject(".folderinfowindow.mailgroup.message"))->Text(buf);

	folderinfomail(folder,current);
}
