/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: mailer.h,v 2.87 2002/07/04 13:24:00 schmitzj Exp $ */


#ifndef MAILER_H
#define MAILER_H
#include "config.h"
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <setjmp.h>
#include "config.h"
#include "pluginsmgr.h"
#include <Xclasses/Xclasses.h>
#include "xc_snprintf.h"
#include "folder.h"

extern appwindow readerwin;
extern class mimetype prgmime;
extern class mailcap  prgcap;
extern class encoding *prgencode;
extern class helpers  *prghelper;
extern class XCprogram myprg;
extern int   spooled;

extern gfx_xpm f_xlogo;
extern gfx_xpm f_xicon1;
extern gfx_xpm f_xicon2;

class SpellChecker;

#define PROGRAMNAME		"XCmail"
#ifndef VERSION
#define VERSION			"unsupported release"
#endif
#define PGPVERSION		"PGP engine version 0.5"
#define WINDOWTITLE		PROGRAMNAME" "VERSION
#define ICONTITLE		PROGRAMNAME
#define HOMEPAGE		"http://www.js-home.org/XCmail"

//#define EXPIRE			"28-Feb-2002"
//#define EXPIRE_DAY		20020228

#define XHEADERCOUNT	6

struct prgcfg
{
	int		autoquote;
	int		quotesender;
	int		sortmode;
	int		currentsortmode;
	int		usepgp;
	int		pgpmode;
	int		outbox;
	int		signdash;
	int		opennewmailextras;
	int		autotext;
	int		newbeep;
	char	beepcommand[80];
	int		usetrash;
	int		askmime;
	int		askcompress;
	int		transumlauts;
	int		writelinelength;
	int		old_autoreadnew;
	int		folderwarnsize;
	int		closeOnChangeFolder;
	int		openNewMailDialog;
	char	printcom[81];
	int		papersize;
	char	outboxname[UNIQUE_ID_LEN];
	char	signaturename[40];
	char	replyto[50];
	char	defaultBCC[50];
	char	replyopen[50];
	char	replyclose[50];
	char	forwardopen[50];
	char 	forwardclose[50];
	char	organization[80];
	char	xface[350];
	char	popservers[200];
	char	smtpsender[80];
	char	authname[80];
	char	authaddress[80];
	int		smtpsenderon;
	int		smtpoutspool;
	char    smtp_auth_name[80];
	char    smtp_auth_pw[80];
	int     use_smtp_auth;
	int		popautocheck;
	int		popcheckdelay;
	int		popsendspooled;
	int		popcheckatstart;
	int		popcheckatstartdelayed;
	int		helpline;
	char	pgpcommand[80];
	char	pgpid[40];
	char	pgppassphrase[250];
	int		pgpleaveopen;
	char	spelllanguage[64];
	char	spellpath[200];
	int		spellignoreurl;
	int		spellignorespecials;
	int		spellignoresig;
	int		oneshowmail;
	int		spellignorequoted;
	int		rec_always;
	int		rec_read;
	int		rec_reply;
	int		rec_forward;
	int		rec_older;
	int		rec_older_days;
	char	xheader_name[XHEADERCOUNT][40];
	char	xheader_value[XHEADERCOUNT][100];
	int		xheader_mode[XHEADERCOUNT];
	int		reply_maillist;
	int		reply_group;
	int		addresscmp_dns;
	char	addresslist[500];
	char	encoding8bit[20];
	int		mailnewforXCmail;
	int		mailnewfromPop3;
	char	disabledPlugins[800];
	int		autoupdatefolder;
	int		autoupdatefolderdelay;
	int		outbox_noattachments;
	int		vcard_enable;
	int		longrecipient;
	int		vcard_work_default;
	int		no_pop3statewindow;
	int		no_smtpstatewindow;
	int		smtpafterpop3;
	int		generate_autoabook;
	int		no_mime_preamble;
	int		vfolder_manager;
	int		old_choose_folder;
};

extern prgcfg programconfig;
#define SIGNATURE		programconfig.signaturename

// settings.cxx
void readconfig(void);
void readmoreconfig(void);
void writeconfig(void);
void generalprefs(void);
void netprefs(void);
void generalMIMEprefs(void);
void writeABook(void);
int checkExpire(appwindow *);
void programnews(void);
void sendWelcomeTestMail(void);
void welcome(void);
void addMail2Folder(vfolder *v,char *from,char *subject,char *txt);

// signatureed.cxx
void editsig(void);

// addressbookwindow.cxx
#define ABF_QUICKADDRESS	0x00000001

void addressbookwindow(void);
void addressbookupdate(char *from,char *email,char *fname=NULL,char *lname=NULL,char *com=NULL,char *xface=NULL);
void addressbookupdate(class Address *);
void addressbookselect(char *alias);
void ownAddressMode(gadget *,int);
void auto_addressbookupdate(void);

// filter.cxx
void openfilterwindow(void);

// mail_stat.cxx
void folderinfo_update(class vfolder *,class mail *);
void folderinfo_updatecurrent(class vfolder *,class mail *);
void folderinfo(class vfolder *,class mail *);

// misc.cxx
int strcncmp(char *s1,char *s2);  // strcmp: nocase, first strlen(s1) chars of s2
int strnncmp(char *s1,char *s2);  // strcmp: case, first strlen(s1) chars of s2
int strcscmp(char *s1,char *s2);  // strcmp: nocase
int strscncmp(char *s1,char *s2); // strcmp: nocase, substring
int strsnncmp(char *s1,char *s2); // strcmp: case, substring
int strregcmp(char *s1,char *s2); // strcmp: regular expression, substring
int struhcmp(char *s1,char *s2);  // strcmp: user & host nocase
int strlistcmp(int (*cmp)(char *,char *),char *s1,char *s2);	// s1 comma separated, call cmp for all with s2 locigally OR: 1 true -> return 0
char *strfilename(char *f);		  // get filename part of string (.../.../this)
char *getPW(class appwindow *par);
int strdecodecpy(char *to,char *from);	// string to PW
int strencodecpy(char *to,char *from);	// PW to string
int myfwrite(char *,FILE *f);
int myfprintf(FILE *file, char *format, ...);
char *getusername(char *buf=NULL);
int Alert(appwindow *, char *, ...);
int tAlert(appwindow *, char *, ...);
char *getHostFromEMail(char *em);
int developLevel(char *tok);
void xc_strncpy(char *,char *,int);
void getUniqueID(char *unique_id);

// time_t is GMT,
// rest is localtime (maybe selectable in future: localtime, gmtime, sender time, ...)
time_t parseDate(char *date,int &day,int &month,int &year,int &hour,int &min,int &sec);
time_t time2localtime(int &day,int &mon,int &year,int &hour,int &min,int &sec,int offset);


// reader.cxx

extern long int int_timezone;
extern int int_daylight;

extern int new_popmail;
extern int new_inboxmail;

void quitprg(void);
void updateoutput(int s=0);
void updateoutput(class mail *m);
void lvnext(class mail *m=NULL,int x=0,int y=0,int w=0,int h=0);
void lvreply(class mail *m);
void lvforward(class mail *m);
void lvnextmailof(class mail *m,int x,int y,int w,int h);
void lvprevmailof(class mail *m,int x,int y,int w,int h);
void pstatus(char *,...);
void newmailarrived(int beeponly=1,class vfolder *v=NULL);
void nonewmail(int foldertype=0);

// encoders/7bit_encoding.cxx
char *Translate827Line(char *,char *);	// returns STATIC buffer
char *Translate827Text(char *,int);		// new string or NULL if unchanged, TranslateFree()
char *Translate728Line(char *);			// overrides string
void TranslateFree(char *);

// encoders/quoted_encoding.cxx
char *TranslateQuotedPrintable(char *s);

// sendmail.cxx
void sendspooled(int forcewindow=0);
void checkspooled(void);
void sendspooledNOW(void);

// pgp.cxx
char *PGPsign(class appwindow*,char *,char *pw);
char *PGPcode(class appwindow*,char *,char *to);
char *PGPcodesign(class appwindow*,char *,char *pw,char *to);
int PGPcheckSign(class appwindow*,char *txt,char *sign);
char *PGPdecode(class appwindow*,char *txt,char *pw,int &sign);
int PGPcode(class appwindow*,char *tfile,char *tofile,char *head,char *bound,int md);
void PGPaddkey(class appwindow*,char *txt);

// plugin.cxx
void readplugins(void);
void freeplugins(void);

// settings_wizzard.cxx
void run_setup_wizard(void);


#define FOLDER_UNKNOWN		0x00000000
#define FOLDER_COMPRESSED	0x00000001
#define FOLDER_INBOX		0x00000002
#define FOLDER_POP3			0x00000004
#define FOLDER_TRASH		0x00000008
#define FOLDER_RECEIVED		0x00000010
#define FOLDER_OUTBOX		0x00000020

// anyopen
extern int   anyopen;
#define AO_NEWMAIL	0x00000001
#define AO_SENDING	0x00000002

// check
#define FT_POP		0x00000000
#define FT_INBOX	0x00000001
#define FT_ANYBOX	0x00000002

enum POP3ERROR {OK=0,POPERROR,UNKNOWNHOST,NOSOCKET,NOBIND,NOCONNECT,NOFILEDESC,READERROR,ANSWERERROR};
enum HANDLEMAIL {SHOW,SAVE,PREVIEW,COMMAND};

// !!obsolete!!
/*
class mailclass
{
	dlist  				allmails;
	dlist  				dropedmails;
	friend class Pop3Get;

	char   				*foldername;
	char   				*lockname;

	int					folder_type;
	int    				flags;
	int    				_lock;
	int    				fsize,fsize2;
	time_t 				fdate;
	time_t 				adate;
	class UIDLhistory	*curr_uidlhist;
	class UIDLhistory	*next_uidlhist;
	unsigned int		changed:1,
						compressed:1;

	configopts 			*cfgitems;

	config				*foldersettings;
	int					foldersortmode;
	int					laststat_size;
	int					laststat_count;

	static const int LK_READ	=0;
	static const int LK_WRITE	=1;

	int dolockf(FILE *,int rw=LK_READ);
	int lockf(FILE *,int rw=LK_READ);
	void unlockf(FILE *);

	int dolock(void);
	int lock(void);
	void unlock(void);

	int mysend(int sockfd,char *txt);
	enum POP3ERROR answer(int sockfd,FILE *in,char *ret);
	enum POP3ERROR pop3info(int sockfd,FILE *in,int flags,char *ret);
	int readuntilend(FILE *in,char *buf);
	void setmodes(char *foldername);

	int filter(class mail *);
public:
	void corehandler(void);

	mailclass(char *folder,int flags=0);
	~mailclass();

	int foldertype(void);
	static int foldertype(char *);
	char *prefsname(void);
	static char *prefsname(char *);
	int ispopfolder(void);
	int isinbox(void);
	int isoutbox(void);
	int isusedinbox(void);
	static char *inboxname(void);		// /var/spool/mail/<user>
	static char *pop3boxname(void);		// ~/Mail/POP3BOX
	static char *usedpop3box(void);		// programconfig.default?
	static char *usedinbox(void);		// programconfig.default?
	static char *trashboxname(void);	// ~/Mail/Trash
	static char *receivedboxname(void);	// ~/Mail/received
	static char *outboxname(void);		// ~/Mail/outbox (settings)
	static char *outboxGZname(void);	// ~/Mail/ARCHIV/outbox.gz (settings)

	int load(void);
	int save(void);		// (OR) 4: nothing to write, 1: written, 2: new, !1&!4: error
	int update(void);	// (OR) 0: error, 1: updated, 2: new, delete
	int loadprefs(void);
	int saveprefs(void);

	int check(multilistview *mlv,int foldertype=FT_INBOX); // check for new and BEEP
	void check(void);					// check for new and save, NO beep!
	int addnew(void);
	enum POP3ERROR pop3(char *host,char *user,char *passwd,int flags,char *ret);
	void change(void); 					// folder changed == TRUE

	char *g_foldername(void) { return foldername; };		// NULL: Folder unread (error durring read: locked, not found)
	int   g_size(void) { return fsize; };
	int   g_compressed(void) { return compressed; };

	int count(void);
	void sort(void);
	
	class mail *getmail(int);
	int getpos(class mail *);

	int search(int start,char *type,char *pattern,short ncase,short substring,short reg);

	int insertmessage(char *mailtext, multilistview *mlv=NULL,int fromPop3=0);
};
*/

struct multipart
{
	int start;
	int end;
	int text:1,
		app:1,
		save:1,
		freeflag1,
		freeflag2,
		freeflag3,
		freeflag4,
		free:1;
	char *allmailtext;
	char *bodyptr;
	char *bodytext;
	int  size;
	char *contenttypeptr;
	char *contenttypetext;
	char *nameptr;				// descr
	char *nametext;				// descr
	char *contentencodingptr;
	char *contentencodingtext;
};

class mail
{
	class folder *parent;
	class vfolder *vparent;
	char *mailtext;
	char *bodytext;
	char *bodyptr;
	char *fromptr;
	char *toptr;
	char *subjectptr;
	char *statusptr;
	char *xstatusptr;
	char *returnptr;
	char *replytoptr;
	char *dateptr;
	char *ccptr;
	char *mimeversionptr;
	char *contenttypeptr;
	char *contentencodingptr;
	char *messageidptr;
	char *xuidlptr;
	char *xfaceptr;
	char *savedateptr;
	char *priorityptr;
	char *oldfolderptr;
	char *pop3cfgptr;
	char *pop3hostptr;
	char *pop3userptr;

	char *fromtext;
	char *fromemailtext;
	char *totext;
	char *subjecttext;
	char *statustext;
	char *xstatustext;
	char *returntext;
	char *replytotext;
	char *datetext;
	char *cctext;
	char *mimeversiontext;
	char *contenttypetext;
	char *contentencodingtext;
	char *messageidtext;
	char *xuidltext;
	char *xfacetext;
	char *savedatetext;
	char *prioritytext;
	char *oldfoldertext;
	char *pop3cfgtext;
	char *pop3hosttext;
	char *pop3usertext;

	char *headertext;
	char *lvlinetext[4];

	char *tagtext;
	int statusval;
	int pgpmode;
	class mail *subm;

	time_t	mail_t;
	int		mail_day;
	int		mail_month;
	int		mail_year;
	int		mail_hour;
	int		mail_min;
	int		mail_sec;

	int priorityValue;
	int sortPriority;				// mail accounting
	unsigned int visualBellValue;	// display mail in list with other colours, etc

	struct multipart multioffsets[MAXMIMEPARTS];
	int totalmulti;

	void init(char *,class io_id_data *id,int partial);
	char *multipart(void);
	char *submultipart(int);
	void subtypes(int);

	int referers;
	unsigned int smallmode:1,
				 haschanged:1,
				 partial:1;

	class io_id_data *_id;
	char	freebytes[4*10];

public:
	void addreferer(void);
	void remreferer(void);

	mail(char *,class io_id_data *id=NULL,int partial=0);
	mail(class mail *);
	~mail();

	class io_id_data *id(void) { return _id; };
	void setfolder(class folder *f);
	void setvfolder(class vfolder *f);
	class folder *getfolder(void) { return parent; };
	class vfolder *getvfolder(void) { return vparent; };
	int changed(void) { return haschanged; };
	int write(FILE *);
	void setbody(char *);	// only if in partial mode

	void freemem(void);
	void makesmall(void);	// makes mail unsaveable!

	Bool operator==(class mail &);

	char *themailtext(void) { return mailtext; };	// TO change for partial mode
	class folder *g_parent(void) { return parent; };

	char **lvline(void);
	char *mailbody(int &size,int p=0);
	char *contentencoding(int p=0);

	static void parse_from_name(char *);	// changes CHAR * !!
	static void parse_from_address(char *);	// changes CHAR * !!

	int PGPdecode(class appwindow *);
	void removeparts(void);

	char *from(void);
	char *from_email(void);
	char *to(void);
	char *cc(void);
	char *subject(void);
	char *returnto(void);
	char *replyto(void);
	char *date(void);
	char *displayfrom(void);
	char *displayto(void);
	char *displaycc(void);
	time_t parsefromdate(int &d,int &m,int &y,int &h,int &min,int &sec);
		// returns time_t GMT, d,m,y,h,min,sec are in localtime !!
	char *mimeversion(void);
	char *contenttype(void);
	int  status(void);
	void status(int);
	char *messageid(void);
	char *header(void);
	char *xface(void);

	void clearsavedate(void);
	time_t parsesavedate(int &d,int &m,int &y,int &h,int &min,int &sec);
		// returns time_t GMT

	void oldfolder(char *);
	char *oldfolder(void);

	char *mime1(void);
	char *mime2(void);

	int totalparts(void);
	char *thesubmailtext(int p);
	char *partname(int p=0);
	char *subcontenttype(int p);
	char *submime1(int p);
	char *submime2(int p);

	void setfreeflag(int p,int flag,int val); // flag: 1-4, val: 0,1
	int  getfreeflag(int p,int flag);

	char *getTag(char *tag,int p=0);
	char *getContentTag(char *tag,int p);

	char *xuidl(void);
	int priority(void);

	char *pop3cfg(void);
	char *pop3user(void);
	char *pop3host(void);

	char *formtext(char *format);

	int sortAcct(void);
	void sortAcct(int);

	unsigned int visualBell(void);
	void visualBell(unsigned int);

// Status-Wrappers, use this if possible for setting!
	void deleteMail(void);
	void deleteMail(class deletebutton *);
	void deleteMail(class deletebutton &d) { deleteMail(&d); };
	void deleteLocalMail(void);
	void deleteServerMail(void);
	void undeleteMail(void);
	void undeleteLocalMail(void);
	void undeleteServerMail(void);
	void readMail(void);
	void unreadMail(void);
};

#define STATUS_NEW			0x0001
#define STATUS_OLD			0x0002
#define STATUS_READ			0x0004
#define STATUS_DELETE		0x0008
#define STATUS_FORWARDED	0x0010
#define STATUS_REPLYED		0x0020
#define STATUS_SAVED		0x0040
#define STATUS_FILTERED		0x0080
#define STATUS_XCMAILNEW	0x0100
#define STATUS_XCMAILREAD	0x0200
#define STATUS_XCPOP3NEW	0x0400
#define STATUS_SERVERDELETE	0x0800
#define STATUS_POPMAIL		0x1000

class decoder_abstract : public Xclasses
{
public:
	mail *ml;
	int ispgpkey;

	decoder_abstract(void) : Xclasses()
	{
		ispgpkey=0;
	};
	decoder_abstract(char *name) : Xclasses(name)
	{
		ispgpkey=0;
	};
	~decoder_abstract()
	{
	};

	virtual void showtext(char *,int size) = 0;
	int decode(appwindow *aw,int,char *path=NULL,char *filename=NULL);
};
class statusobj
{
public:
	virtual void pstatus(char *)=0;
};

class showmail : public decoder_abstract, rfunc_class
{
	char *objname;
	appwindow *headw;
	file_dialog fd;
	int lastselected;
	int helper_count;
	HANDLEMAIL mtype;
	char command[COMMANDLEN];
	class helper *h;

	class dlist clonedplugins;
	int	pluginsmenu;
	int helpermenu;

	char *allfolders[MAXUSERMAIL+1];
	int useautotext;

	struct showmailpluginmenustruct showmailpluginmenu[SHOWMAILPLUGINMENUMAX];
	int showmailpluginmenucount;

	void genname(void);
	void makewin(int x=0,int y=0,int w=0,int h=0);
	void quit(gadget *,int);
	void handler(gadget *,int);
	void makemenu(menu *);
	void bigtext(char *);
	void showtext(char *,int);
	void decode(int,char *path=NULL,char *filename=NULL);

	void updatemail(void);
	void updatehead(void);

	void makeheadw(void);
	void closehead(appwindow *);
	int  attahook(struct hook_data*);

	int  askBeforeShow(void);
public:
	showmail(Xclasses *parent,mail *);
	showmail(Xclasses *parent,mail *,int x,int y,int w,int h);
	~showmail();

	void raise(mail *m=NULL);

	virtual void updatefolders(void);
};

#define MAIL_REPLY			0x01
#define MAIL_FORWARD		0x02
#define MAIL_RESEND			0x04
#define MAIL_DONTAUTOQUOTE	0x08

class newmail : public decoder_abstract, public statusobj
{
	int 			mode;
	char 			*objname;
	int 			totalmulti;
	int				dead_letter;
	file_dialog 		*fd;
	class allsignatures	*allsigs;
	class signature		*sign;
	text				*mstatus;

	class dlist 	clonedplugins;
	int 			pluginsmenu;

	int				spellchecked;

	struct newmailpluginmenustruct newmailpluginmenu[NEWMAILPLUGINMENUMAX];
	int newmailpluginmenucount;

	class minput *addGG;
	void addAdd(void *);
	int addByType(char *,int type=-1);
	int addAdr(char *address,int type,int clearall);
	void chAdr(int sel,char *address);
	void chAdr(int sel,int type);
	void rmAdr(int sel);

	void genname(void);
	void freepart(struct attachments *);
	void makewin(void);
	void showtext(char *,int);
	void quote(void);
	void insertfile(void);
	void saveas(void);
	void quotefile(void);
	void spellchecker(void);
	class encoder *chooseEncoder(char *def,char *m1,char *m2,char *filename,char *retmime,int &compress);
	void attachfile(char *filebuf,int del=0);
	void menuhandler(gadget *,int);
	void attahandler(gadget *,int);
	class popbutton *getAddrList(void);
	void freeAddrList(multilistview *mlv);
	void extrahandler(gadget *,int);

friend class minput;
	void inputhandler(gadget *,int);

	void addsignature(textbox *,char *subname=NULL);
	void send(gadget *g,int i);
	void quit(gadget *,int);

friend class SpellChecker;
	int  send_mail(char *head,char *outboxhead,char *b,char *bound);
	int  RCPT(FILE *file,char *buf);
public:
	newmail(mail *m=NULL,int mode=0);
	~newmail();

	void raise(void);
	void pstatus(char *);

	void addTo(char *,int clearall=0);
	void addCc(char *,int clearall=0);
	void addBcc(char *,int clearall=0);
	void addReplyto(char *,int clearall=0);
};

class printmail : public decoder_abstract
{
	char *objname;
	int md;
	file_dialog fd;
	selgadget *selarr[3];

	void genname(void);
	void makewin(void);
	void quit(gadget *,int);
	void handler(gadget *,int);
	void print(gadget *,int);
	void pfail(char *);
	void showtext(char *,int);
public:
	printmail(appwindow *parent,mail *,int mode=0);
	~printmail();
	void raise(void);
};

// mailcap to handle (show) received: extern cmd, save, show
struct mime
{
	struct node base;
	char mime1[MIMELEN];
	char mime2[MIMELEN];
	char suffix[SUFFIXLEN];
	char mimetype[MIMELEN*2+1];
};
struct cap
{
	struct node base;
	HANDLEMAIL handlemail;
	char mime1[MIMELEN];
	char mime2[MIMELEN];
	char start[COMMANDLEN];
};
struct encode
{
	struct node base;
	int	internal:1,
		isintern:1, 
		free:1;
	class encoder *enc;
	char name[MIMELEN];
	char code[COMMANDLEN];
	char decode[COMMANDLEN];
};
struct help_struct
{
	struct node base;
	class helper *help;
	char name[COMMANDLEN];
	class group *configgp;
};

class mailcap : public dlist
{
public:
	mailcap(void);
	~mailcap();

	void clear(void);
	void sort(void);

	int save(FILE *);
	int load(FILE *);

	void add(char *m1,char *m2,char *cmd);		// cmd: SAVE, SHOW, xxx
	void add(char *m1,char *m2,HANDLEMAIL t,char *cmd);
	cap *find(char *m1,char *m2,enum HANDLEMAIL &typ,char *cmd);
	cap *find(char *m1,char *m2,enum HANDLEMAIL &typ,char *cmd,char *name);
	void del(char *m1,char *m2);
};

// mime for sending
class mimetype : public dlist
{
public:
	mimetype(void);
	~mimetype();

	void clear();
	
	int save(FILE *);
	int load(FILE *);

	void add(char *m1,char *m2,char *suf);
	mime *find(char *suf,char *m1,char *m2);
	mime *findfull(char *filename,char *m1,char *m2);

	void mimeinlistview(class listview *lv,char *m1,char *m2);
};

// encoding to decode (show) received
class encoding : public dlist
{
	char **encarr;
	void set(struct encode*,char *);
public:
	encoding(void);
	~encoding();

	char **encoderarray(void);

	void clear();
	void sort(void);

	int save(FILE *);
	int load(FILE *);

	void add(char *enc,char *cmd);
	void add(char *enc,class encoder *);
	class encoder *find(char *enc);
};
// helpers
class helpers : public dlist
{
	char *pbuf;
	char **harr;
public:
	helpers(void);
	~helpers();

	void makeconfig(class listgroup *);
	void readconfig(void);

	char **helperarray(void);

	void readconfigfiles(void);
	void writeconfigfiles(void);

	void clear();
	void sort(void);

	void add(class helper *);
	class helper *find(char *cmd);
};


#define LWF_ANIM	0x00000001
#define LWF_ABORT	0x00000002
#define LWF_BPS		0x00000004
#define LWF_NONUM	0x00000008

class levelwindow : public Xclasses
{
	int maxlevel;
	int lastlevel;
	appwindow aw;
	spacegroup gp;
	indicator ind;
	text t1,t2;
	fbutton ab_button;
	group ab_group;
	char *infotext;
	char txt[50];
	int flags;
	int animcc,animdelay,animsize;
	char animbuf[101];
	char animwbuf[101];
	int aborted;

	int 	bps_lbytes;
	time_t	bps_ltime;

	void dummy(void);
	void abort(gadget *,int);

public:
	levelwindow(appwindow *parent,char *,int max,char *infotext=NULL,int flags=0);
	~levelwindow();

	int update(int level,int n,int bytes=0);
};

#endif
