/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: newbutton.cxx,v 2.4 2002/01/10 09:27:22 schmitzj Exp $ */


#include "configure.h"

#include "mailer.h"
#include "newbutton.h"

struct tune
{
	short volume;
	short delay;
	short length;
};

static struct tune sound[3][6]={
{{95,4,50},{0,0,0},},
{{95,4,50},{95,4,180},{0,0,0},},
{{95,2,30},{95,2,30},{95,2,30},{95,8,60},{95,8,100},{0,0,0}}
};

newbutton::newbutton(void) : Ddraw(this), gadget(), indy()
//fbutton()
{
	Name("newbutton");
	count=0;
	playsound=0;
	SetKeyHandler(KHM_SELECT);
	text="N";
	fc=0;
	fc_count=0;
}
newbutton::~newbutton()
{
}
int newbutton::Create(void)
{
	Background(col_background());
	BorderSize(2);
	KeyBorder();

	int j=-2;
	for(int i=0;i<6;i++)
	{
		colors[i]=AllocColor(0xeeee -abs(j)*0x2100,0x3333,0x3333);
		j++;
	}

	indy.GSetLimits();

	if (gadget::Create())
	{
		Mode(GM_BUTTON1|GM_ONEEXPOSE|GM_KEY|GM_NORMALTICK);

		indy.Name("indy");
		indy.ParentClass(this);
		indy.CircleIndicator();
		if (!indy.gg_win() && gg_locked() && programconfig.popautocheck)
		{
			indy.Dimensions(win,RealSize()-2,RealSize()-2,width-(RealSize()-2)*2,height-(RealSize()-2)*2);
			indy.Create();
		}
		return 1;
	}
	return 0;
}
void newbutton::Free(void)
{
	indy.Free();
	gadget::Free();
}
void newbutton::GExpose(XEvent *event)
{
	borderUpFill(this,0,0,width,height);
	bordertext(this,0,0,width,height,text);
	if (locked)
	{
		borderlocked(this,0,0,width,height);
		borderlockedtext(this,0,0,width,height,text);
	}
    if (active & GA_KEY)
    {
   	    bordermark(this,0,0,width,height);   	    
    }
    else
    {
		borderunmark(this,0,0,width,height);
    }
}
void newbutton::GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason)
{
	if (active&GA_BUTTONPRESS||reason&GB_BUTTON)
    {
    	borderDownFill(this,0,0,width,height);
		borderselectedtext(this,0,0,width,height,text);
		if (locked) 
		{
			borderlockedtext(this,0,0,width,height,text);
			borderlocked(this,0,0,width,height);
		}
    }
	if (reason&GB_KEY)
	{
		bordermark(this,0,0,width,height);
	}
}
void newbutton::GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason)
{
	if (active&GA_BUTTONPRESS||reason&GB_BUTTON)
	{
	   	borderUpFill(this,0,0,width,height);
		bordertext(this,0,0,width,height,text);    
		if (locked) 
		{
			borderlockedtext(this,0,0,width,height,text);
			borderlocked(this,0,0,width,height);
		}
	}
	if (reason&GB_KEY)
	{
		borderunmark(this,0,0,width,height);
	}
}
int newbutton::GActivate(XEvent *e,int why)
{
	if (why==GA_TICK)
	{
		if (playsound)
		{
			play();
		}
		if (!gg_locked() && !state)
		{
			if (++fc_count>2)
			{
				fc_count=0;
				XSetForeground(display(),gc,colors[fc++]);
				if (fc>=6) fc=0;
				XFillRectangle(display(),win,gc,RealSize(),RealSize(),width-RealSize()*2,height-RealSize()*2);
		   		borderUp(this,0,0,width,height);
				bordertext(this,0,0,width,height,text);
				XFlush(display());
			}
		}
		return 0;
	}

	int r;
	r=DefaultKeyHandler(e);
	if (r==DKH_NOKEYEVENT)
	{
		if (why==GA_BUTTONPRESS) ActivateKey();
		if (why==GA_ABOVE)
		{
		   	borderUpShineFill(this,0,0,width,height);
			bordertext(this,0,0,width,height,text);
		}
    	return GAR_ACTIVE;   // always active
    }
    if (r==DKH_SELECT)
    {
    	return GAR_ACTIVE;
    }
	return 0;
}
int newbutton::GSelected(XEvent *event,int why,int wasabove)
{
	if (why==GA_ABOVE)
	{
	   	borderUpFill(this,0,0,width,height);
		bordertext(this,0,0,width,height,text);
		return 0;
	}
    return (wasabove|(why==GA_KEY))?GSR_SELECTION|GSR_MESSAGE:0;   // selected if above
}
void newbutton::GSetLimits(void)
{
	minwidth=textlength(this,text)+6+8+2+RealSize()*2;
	minheight=textheight(this,text)+6+RealSize()*2;

	minxaspect=1; maxxaspect=1;
	minyaspect=1; maxyaspect=1;

//	maxheight=minheight+6;
//	maxwidth=minwidth;
}

void newbutton::Lock(void)
{
	if (!indy.gg_win() && win && programconfig.popautocheck)
	{
		indy.Dimensions(win,RealSize()-2,RealSize()-2,width-(RealSize()-2)*2,height-(RealSize()-2)*2);
		indy.Create();
	}
	gadget::Lock();
	count=0;
}
void newbutton::Unlock(void)
{
	if (indy.gg_win())
		indy.Free();
	if (locked) startsound();
	gadget::Unlock();
}
void newbutton::play(void)
{
	if (--count<0)
	{
		if (sound[beepmode][pos].delay)
		{
			readerwin.Beep(sound[beepmode][pos].volume,sound[beepmode][pos].length);
			count=sound[beepmode][pos].delay;
			pos++;
		}
		else
			playsound=0;
	}
}
void newbutton::startsound(void)
{
	count=0;
	pos=0;
	fc=0;
	fc_count=0;
	beepmode=programconfig.newbeep;
	if (beepmode>=1)
	{
		playsound=1;
		beepmode--;
	}
	else
	{ // command
		char buf[sizeof(programconfig.beepcommand)+3];
		xc_snprintf(buf,sizeof(buf),"%s &",programconfig.beepcommand);
		system(buf);
	}
}

void newbutton::Text(char *t)
{
}
void newbutton::Value(int v)
{
	indy.Value(v);
}
