/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: pluginsmgr.h,v 2.6 2002/01/14 19:09:20 schmitzj Exp $ */


#ifndef PLUGINSMGR_H
#define PLUGINSMGR_H

#include <Xclasses/Xclasses.h>
#include "plugins.h"

class pluginmgr
{
	dlist pluginslist;

	void clear(void);
public:
	pluginmgr(void);
	virtual ~pluginmgr();

	plugins *next(plugins *old=NULL);
	plugins *nextOfType(enum plugins::PLUGINTYPE, plugins *old=NULL);
	plugins *find(char *name);
	char *typeName(plugins *p);
	char *typeName(enum plugins::PLUGINTYPE);

	void add(plugins *);
	void remove(plugins *);
	void readconfigfiles(void);
	void writeconfigfiles(void);
	virtual void readconfig(void);
	virtual int  makeconfig(listgroup *);
	virtual void setupconfig(void);
	void makemenu(menu *);
};

extern pluginmgr *prgplugins;

// -------------------------------------------------------------------

extern struct mainpluginmenustruct
{
	char *text;
	char *popuptext;
	char *shortcut;
	int  id;
	class mainplugin *pl;
	int	 general:1,
		 marked:1,
		 selected:1;
} mainpluginmenu[];
extern int mainpluginmenucount;

// -------------------------------------------------------------------

extern struct showmailpluginmenustruct
{
	char *text;
	char *shortcut;
	int  id;
	class showmailplugin *pl;
} showmailpluginmenu[];
extern int showmailpluginmenucount;

// -------------------------------------------------------------------

extern struct newmailpluginmenustruct
{
	char *text;
	char *shortcut;
	int  id;
	class newmailplugin *pl;
} newmailpluginmenu[];
extern int newmailpluginmenucount;

#endif
