/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: printmail.cxx,v 2.5 2000/05/30 00:39:05 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include <string.h>
#include <ctype.h>
#include "mailer.h"
#include "ps_printer.h"

void printmail::genname(void)
{
	int l=strlen(ml->from())+strlen(ml->subject())+strlen(ml->messageid());
	objname=new char[l+1];

	strcpy(objname,ml->from());
	strcat(objname,ml->subject());
	strcat(objname,ml->messageid());
	TranslateName(objname);
}
printmail::printmail(appwindow *parent,mail *m,int mode) : decoder_abstract()
{
	printmail *pm;
	ml=m;
	md=mode;
	genname();
	ParentClass(parent);
	Name("printmail");
	if (pm=(printmail*)FindObject(parent->FullName(),objname))
	{
		pm->raise();
		delete this;
	}
	else
	{
		Name(objname);
		makewin();
	}
}
printmail::~printmail()
{
	DeleteObjectTree(FullName(),DOT_NOTBASE);
	ml->freemem();
	delete objname;
}
void printmail::makewin(void)
{
	appwindow *aw=new appwindow;
	int x,y;

	aw->ParentClass(this);
	aw->Name("window");

	((appwindow*)ParentClass())->Position(x,y);
	aw->InitSize(x,y,70);
	pstatus("Open print window");

	if (!aw->Init())
	{
		delete this;
		pstatus("Error in opening window!");
	}
	char buf[300];
	strcpy(buf,"Print: ");
	strcat(buf,ml->subject());
	aw->Title(buf);
	aw->IconTitle(buf);
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
	aw->Callback(this,(CLOSECALLBACK)&printmail::quit);
	aw->Group(readerwin);
	aw->TransientFor(((appwindow*)ParentClass())->window());

	spacegroup *maingp=new spacegroup;
	maingp->Name("maingroup");
	maingp->Border(10);
	maingp->Vert();
	maingp->YDistance(10);
	group *g1=new bordergroup,*g2=new bordergroup;
	mxgadget *mx=new mxgadget;
	selarr[0]=new selknob;
	selarr[1]=new selknob;
	selarr[2]=NULL;
	 g1->Name("lprgroup");
	 g1->Center();
	 g1->Horiz();
	  selarr[0]->Name("lpr");
	  ((selknob*)selarr[0])->Text("");
	 g1->Add(selarr[0]);
	  fileinput *fip=new fileinput;
	  fip->Name("lprcommand");
	  fip->SetFile(programconfig.printcom);
	  fip->ModeCommand();
	 g1->Add(fip);
	maingp->Add(g1,"print");
	 g2->Name("savegroup");
//	 g2->SameSize(g1);
	 g2->Center();
	 g2->Horiz();
	  selarr[1]->Name("save");
	  ((selknob*)selarr[1])->Text("");
	 g2->Add(selarr[1]);
	  fip=new fileinput;
	  fip->Name("savename");
	  fip->SetFile(PROGRAMNAME".ps");
	  fip->ModeSaveFile();
	 g2->Add(fip);
	maingp->Add(g2,"save as file");

 	 mx->Name("printmode");
 	 mx->ManageOnly();
 	 mx->Items((selgadget**)selarr);
 	 mx->Callback(this,(CALLBACK)&printmail::handler);
 	maingp->Add(mx);

	 choice *ch=new choice;
	 static char *chit1[]={"A4","Letter","Legal",NULL};
     ch->Name("papersize");
     ch->Items(chit1);
	 ch->Selected(programconfig.papersize);
	maingp->Add(ch,"Paper_size");
	  
	 ruler *r=new ruler;
	 r->Horiz();
	maingp->Add(r);
	 g1=new group;
	 g1->Horiz();
	 g1->DialogMode();
	 g1->Name("buttongroup");
	  button *b=new button;
	  button *p=b;
	  b->Name("print");
	  b->Text("_Print");
	  b->Callback(this,(CALLBACK)&printmail::print);
	 g1->Add(b);
	  b=new button;
	  b->Name("cancel");
	  b->Text("_Cancel");
	  b->Callback(this,(CALLBACK)&printmail::quit);
	  b->ApplyXKey(XK_Escape);
	 g1->Add(b);
	maingp->Add(g1);

	aw->SetGroup(maingp);
	aw->Create();
	p->ActivateKey();
	handler(mx,0);
}
void printmail::quit(gadget *g,int i)
{
	((appwindow*)FindObject(FullName(),"window"))->Close();
	delete this;
}
void printmail::handler(gadget *g,int i)
{
	if (!strcmp(g->Name(),"printmode"))
	{
		if (((mxgadget*)g)->Selected()==0)
		{
			gadget *gg;
			gg=(gadget*)FindObject(FullName(),".savename");
			gg->Lock();
			gg=(gadget*)FindObject(FullName(),".lprcommand");
			gg->Unlock();
		}
		else
		{
			gadget *gg;
			gg=(gadget*)FindObject(FullName(),".savename");
			gg->Unlock();
			gg=(gadget*)FindObject(FullName(),".lprcommand");
			gg->Lock();
		}
	}
}
int psprint(char *,FILE *,char *,char *,char *,char *,char *,char *);
void printmail::print(gadget *g,int i)
{ // md==0: mail, >0: part
	decode(NULL,md);
	quit(g,i);
}
void printmail::showtext(char *c,int size)
{
	FILE *file;
	char buf[MAXLENGTH+1];

	mxgadget *mx=(mxgadget*)FindObject(FullName(),".printmode");
	if (mx->Selected()==0)
	{
		fileinput *fip=(fileinput*)FindObject(FullName(),".lprcommand");
		fip->GetFile(buf,sizeof(buf));
		if (!(file=popen(buf,"w")))
		{
			pfail("Can't start printer command.");
			return;
		}
	}
	else
	{
		fileinput *fip=(fileinput*)FindObject(FullName(),".savename");
		fip->GetFile(buf,sizeof(buf));
		if (!(file=fopen(buf,"w")))
		{
			pfail("Can't write file.");
			return;
		}
	}
	printMail (ml, file,c, (enum printMail::PAPERSIZE)(((choice*)FindObject(FullName(),".papersize"))->Selected()));

	if (mx->Selected()==0)
		pclose(file);
	else
		fclose(file);
}
void printmail::raise(void)
{
	appwindow *aw=((appwindow*)FindObject(FullName(),"window"));
	aw->Raise();
	aw->Open();
}
void printmail::pfail(char *r)
{
	easy_dialog ed;
	ed.ParentClass(readerwin);
	ed.Text(r);
	ed.Options("_Ok");
	ed.Start(readerwin);
}
