/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: reader.cxx,v 2.116 2002/09/17 09:15:29 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <stdarg.h>
#include <signal.h>

#include "mailer.h"
#include "address_book.h"
#include "logo_xpm.h"
#include "icon1_xpm.h"
#include "icon2_xpm.h"
#include "bannertext.h"
#include "maillist.h"
#include "readme.h"
#include "pluginsmgr.h"
#include "gfxobjects.h"
#include "newbutton.h"
#include "npop3get.h"
#include "xc_snprintf.h"
#include "filter_mgr.h"
#include "extraggs.h"
#include "folder.h"
#include "folder_manager.h"

long int int_timezone;
int int_daylight;

int anyopen=0;
gfx_xpm f_xlogo(logo_xpm);
gfx_xpm f_xicon1(icon1_xpm);
gfx_xpm f_xicon2(icon2_xpm);
XCprogram	myprg(PROGRAMNAME,
					XCP_Version,VERSION" ("__DATE__")",
					XCP_Copyright,"GPL - (c) 1997-2002 by the XCmail development team and Jrgen Schmitz",
					XCP_Author,"XCmail development team",
					XCP_EMail,"js@zet.net",
					XCP_WWW,HOMEPAGE,
					XCP_RequiredXclasses,"1.3.0",

					XCP_MultiAuthorJob,"Main part: GUI, send, read, folders, settings",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"mail folder management",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"asynchon send spooled mails",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"asynchon POP3",
					XCP_MultiAuthor,"Ralf Becker",
					XCP_MultiAuthorEMail,"beckerr@fh-trier.de",

					XCP_MultiAuthorJob,"mail folder archive",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"address book backend",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"ISO-8859-1, encoders, mail parsers",
					XCP_MultiAuthor,"Ralf Becker",
					XCP_MultiAuthorEMail,"beckerr@fh-trier.de",

					XCP_MultiAuthorJob,"helpers",
					XCP_MultiAuthor,"Ralf Becker",
					XCP_MultiAuthorEMail,"beckerr@fh-trier.de",

					XCP_MultiAuthorJob,"mail filter interface",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"postscript modul",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"ispell support",
					XCP_MultiAuthor,"Ralf Becker",
					XCP_MultiAuthorEMail,"beckerr@fh-trier.de",

					XCP_MultiAuthorJob,"PGP",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"many bug fixes",
					XCP_MultiAuthor,"Ralf Becker",
					XCP_MultiAuthorEMail,"beckerr@fh-trier.de",

					XCP_MultiAuthorJob,"mail priorities",
					XCP_MultiAuthor,"Andreas Arens",
					XCP_MultiAuthorEMail,"arensa@fh-trier.de",

					XCP_MultiAuthorJob,"Signature editor",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiAuthorJob,"\"Hacking\"",
					XCP_MultiAuthor,"Ralf Herzog",
					XCP_MultiAuthorEMail,"herogr@fh-trier.de",

					XCP_MultiAuthorJob,"the rest not listed",
					XCP_MultiAuthor,"Jrgen Schmitz",
					XCP_MultiAuthorEMail,"schmitzj@js-home.org",

					XCP_MultiSortByJob,0,
					XCP_gfxobject,&f_xlogo,
					XCP_Resources,"*mainwindow.maingroup.maillist.listfield_1.basecolor: -1a-1a-1a\n"
								  "*addresses.listfield_1.basecolor: +09+09+09\n"
								  "*passphrasewindow.basecolor: +22+11+00\n"
								  "*license_dialog.window*fbutton.hilight: True\n"
								  "*license_dialog.window.basecolor: gray85\n"
								  "*license_dialog.window*fbutton.basecolor: -05-25-25\n"
								  "*gfx_checkbox.check: True\n"
								  "*scroller.up.button4: 1\n"
								  "*scroller.down.button5: 1\n"
								  "*mainwindow.button4redirect: XCmail.mainwindow.maingroup.maillist.scroller.up\n"
								  "*mainwindow.button5redirect: XCmail.mainwindow.maingroup.maillist.scroller.down\n"
								  "*button4redirect: *scroller.up\n"
								  "*button5redirect: *scroller.down\n"
//								  "*timeoutpointer: True\n"
					,
					XCP_OwnHTML,"<h3>Greetings to all those testers and users "
								"who made XCmail their new mail client.</h3>"
								"<ul>"
								"<li>Special thanks to <i>Gerd Pr&uuml;mm</i> for his really "
								"big mail with ideas, test results, "
								"pleased works and his good english ;-)<br>"
								"Hopefully the Sun release of XCmail works "
								"on his machine as good as on Linux."
								"<li>Thanks to <i>Erik Mouw</i> for his first reports "
								"on XCmail, his nice cpp2cxx script (worked fine with Xclasses, too :-) and ideas of course."
								"<li><i>Tobias</i> - who mostly got the beta releases first and always tried to live with it"
								"<li><i>Arensa</i> - who used XCmail IRIX nevertheless what happend with it...\n"
								"<li><i>Andreas</i> \"der Finnische\" - who has courious ideas in using XCmail and so finding bugs\n"
								"<li><i>Heiko Federhenn</i> - hope your job in CH is as nice as XCmail\n"
								"<li><i>Thorsten</i> \"mit H - ohne Haar\" - all will be good!\n"
								"</ul>"
					,
					XCP_Done);

Xclasses subwindows;

appwindow readerwin;
spacegroup maingp;
menu mn;
multilistview mailslv;
popup mailspop;
group allbuttons,buttons1,buttons2,buttons3,buttons4,buttonsshadow1,buttonsshadow2;
fbutton b_read,b_undelete,b_new,b_forward,b_reply,b_exit,b_nextnew,b_resend;
deletebutton b_delete;
bannertext status;
output foldername;
group f_gp;
fbutton f_mailbox;
newbutton f_readnew;
choice f_allboxes;
image mimage;
xcfx_gadget f_busymode;

int spooled=0;
char *mailto_mode=NULL;

int new_popmail=0;
int new_inboxmail=0;

unsigned int quickmenustart=0;
unsigned int pluginsmenustart=0;

//#define MAXC	MAXUSERMAIL
//char *allfolders[MAXC+1];
//char *allarcfolders[MAXC+1];
//char *allfolderspopup[MAXC*2+1];
//char *allfoldersname[MAXC*2+1];

#define POPUP_SELECTALL		1
#define POPUP_UNSELECTALL	2
#define POPUP_READ			3
#define POPUP_DELETE		4
#define POPUP_UNDELETE		5
#define POPUP_MARKNEW		7
#define POPUP_MARKREAD		8
#define POPUP_RESEND		9
#define POPUP_RMATTA		10
#define POPUP_NEWFOLDER		11
#define POPUP_FILTER		12
#define POPUP_VB0			20
#define POPUP_VB1			21
#define POPUP_CHOOSECOPY	22
#define POPUP_CHOOSEMOVE	23
#define POPUP_FOLDERBASE1	0x1000
#define POPUP_FOLDERBASE2	0x2000

void lvunsel(void);
void lvmgr(gadget *g,int i);
void rereadfolders(void);
//void readfolder(char *name,int popon=0);
void folder(gadget *g,int i);
void mn_handler(int m);

void initmainplugins(void);
void finishmainplugins(void);

void OpenNewMailDialog_cancel(gadget *,int);

//static int cmpf(const void *t1,const void *t2)
//{
//	return strcscmp(*(char**)t1,*(char**)t2);
//}
char **scanmaildir(void)
{
	folderlist->init();
	folderlist->registerfolderfunction(rereadfolders);
	return folderlist->readlist(RL_VISIBLES);
}
void checkButtons(void)
{
	if (mailslv.Selected() || mailslv.FindNextMarked(0)>0)
	{
		b_read.Unlock();
		if (folderlist->currentfolder() && !folderlist->currentfolder()->readonly && !folderlist->currentfolder()->nodeletesupport)
		{
			b_delete.Unlock();
			b_undelete.Unlock();
		}
		b_forward.Unlock();
		b_reply.Unlock();
		mn.UnlockItem(1,4);
		mn.UnlockItem(1,5);
		mn.UnlockItem(2,3);
		mn.UnlockItem(2,4);
		mn.UnlockItem(2,5);
		mailspop.UnlockItem(POPUP_READ);
		if (folderlist->currentfolder() && !folderlist->currentfolder()->readonly && !folderlist->currentfolder()->nodeletesupport)
		{
			mailspop.UnlockItem(POPUP_DELETE);
			mailspop.UnlockItem(POPUP_UNDELETE);
			mailspop.UnlockItem(POPUP_RMATTA);
		}
		if (folderlist->currentfolder() && !folderlist->currentfolder()->readonly)
		{
			mailspop.UnlockItem(POPUP_MARKREAD);
			mailspop.UnlockItem(POPUP_MARKNEW);
			mailspop.UnlockItem(POPUP_FILTER);
		}
		mailspop.LockItem(POPUP_RESEND);
		mailspop.UnlockHeadOf(POPUP_CHOOSECOPY);
		mailspop.UnlockHeadOf(POPUP_CHOOSEMOVE);
		mailspop.UnlockHeadOf(POPUP_VB0);

		for(int i=0;i<mainpluginmenucount;i++)
		{
			if (mainpluginmenu[i].selected || mainpluginmenu[i].marked)
			{
				mn.UnlockItem(pluginsmenustart>>24,i+1);
			}
		}
	}
	else
	{
		b_read.Lock();
		b_delete.Lock();
		b_undelete.Lock();
		b_forward.Lock();
		b_reply.Lock();
		mn.LockItem(1,4);
		mn.LockItem(1,5);
		mn.LockItem(2,3);
		mn.LockItem(2,4);
		mn.LockItem(2,5);
		mailspop.LockItem(POPUP_READ);
		mailspop.LockItem(POPUP_DELETE);
		mailspop.LockItem(POPUP_UNDELETE);
		mailspop.LockItem(POPUP_MARKREAD);
		mailspop.LockItem(POPUP_MARKNEW);
		mailspop.LockItem(POPUP_RMATTA);
		mailspop.LockItem(POPUP_FILTER);
		mailspop.LockItem(POPUP_RESEND);
		mailspop.LockHeadOf(POPUP_CHOOSEMOVE);
		mailspop.LockHeadOf(POPUP_CHOOSECOPY);
		mailspop.LockHeadOf(POPUP_VB0);

		for(int i=0;i<mainpluginmenucount;i++)
		{
			if (mainpluginmenu[i].selected || mainpluginmenu[i].marked)
			{
				mn.LockItem(pluginsmenustart>>24,i+1);
			}
		}
	}
	if (folderlist->currentfolder())
	{
		b_nextnew.Unlock();
		
	}
	else
	{
		b_nextnew.Lock();
	}

	if (folderlist->currentfolder() && folderlist->currentfolder()->getftype()==FOLDERTYPE_OUTBOX)
	{
		buttonsshadow2.Show();
		if (mailslv.Selected() || mailslv.FindNextMarked(0)>0)
		{
			mailspop.UnlockItem(POPUP_RESEND);
			b_resend.Unlock();
		}
		else
		{
			mailspop.LockItem(POPUP_RESEND);
			b_resend.Lock();
		}
	}
	else
	{
		buttonsshadow1.Show();
		mailspop.LockItem(POPUP_RESEND);
		b_resend.Lock();
	}
}
static int seenicon=-1;
static int messinfolder=-1;
void setNormalIcon(void)
{
	if (seenicon)
		readerwin.SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());

	char buf[100];
	if (folderlist->currentfolder())
		xc_snprintf(buf,sizeof(buf),"%s: %d messages in %s",ICONTITLE,folderlist->currentfolder()->count(),folderlist->currentfolder()->g_foldername());
	else
		xc_snprintf(buf,sizeof(buf),"%s",WINDOWTITLE);

	if (seenicon || !folderlist->currentfolder() || messinfolder!=folderlist->currentfolder()->count())
	{
		readerwin.IconTitle(buf);
	}

	if (folderlist->currentfolder())
		xc_snprintf(buf,sizeof(buf),"%s: %d messages in %s",WINDOWTITLE,folderlist->currentfolder()->count(),folderlist->currentfolder()->g_foldername());
	else
		xc_snprintf(buf,sizeof(buf),"%s",WINDOWTITLE);
	
	if (seenicon || !folderlist->currentfolder() || messinfolder!=folderlist->currentfolder()->count())
	{
		readerwin.Title(buf);
		if (folderlist->currentfolder())
			messinfolder=folderlist->currentfolder()->count();
		else
			messinfolder=0;
	}
	seenicon=0;
}
void setNewMailIcon(void)
{
	readerwin.IconTitle("New mails!");
	if (seenicon!=1)
		readerwin.SetIcon(f_xicon2.pixmap(),f_xicon2.shadowmap());
	seenicon=1;
}

// void newoutput(void)
// {
// 	mailslv.RemoveAll();
// 	if (!folderlist->currentfolder()) return;
// 	mn.Selected(2,1,programconfig.sortmode);
// 	programconfig.currentsortmode=mn.Selected(2,1);
// 	if (!folderlist->currentfolder()->load())
// 	{
// //		mail *ml;
// //		for(int i=0;i<currentfolder->count();i++)
// //		{
// //			ml=currentfolder->getmail(i+1);
// //			mailslv.AddAtEnd(ml->lvline(),(void*)ml);
// //		}
// 	}
// 	else
// 	{
// 		easy_dialog ed;
// 		ed.Text("Failed to open mail folder!");
// 		ed.Options("_Ok");
// 		ed.Start(readerwin);
// 	}
// }
void updateoutput(int s=0)
{
	mail *ml;
	if (!folderlist->currentfolder()) return;
 	if (s)
	{
		ml=folderlist->currentfolder()->getmail(s);
		mailslv.ChangeData(s,(void*)ml);
		mailslv.Replace(s,ml->lvline());
	}
	else
	{
		for(int i=0;i<folderlist->currentfolder()->count();i++)
		{
			ml=folderlist->currentfolder()->getmail(i+1);
			mailslv.ChangeData(i+1,(void*)ml);
			mailslv.Replace(i+1,ml->lvline());
		}
	}
	setNormalIcon();
}
void updateoutput(mail *m)
{
	if (!folderlist->currentfolder()) return;

	int p=folderlist->currentfolder()->getpos(m);
	if (p>0)
		updateoutput(p);
}
// void readfolder(char *name,int popon)
// {
// // 	if (!popon ||
// // 		(popon && (
// // 			!folderlist->currentfolder() ||
// // 			 strcmp(currentfolder->g_foldername()?currentfolder->g_foldername():"", name)!=0)))
// // 	{
// // 		if (programconfig.closeOnChangeFolder)
// // 			DeleteObjectTree(subwindows.FullName(),DOT_NOTBASE);
// // 		readerwin.Update();
// // 
// // 		if (currentfolder)
// // 		{
// // 			pstatus("Writing mailfolder...");
// // 			currentfolder->save();
// // 			delete currentfolder;
// // 			currentfolder=NULL;
// // 		}
// // 		mailslv.RemoveAll();
// // 
// // 		pstatus("Reading mailfolder...");
// // 		foldername.Output(name);
// // 
// // 		readerwin.UpdateEvent();
// // 
// // 		currentfolder=new mailclass(name);
// // 		newoutput();
// // 
// // 		checkButtons();
// // 	    mailslv.ActivateKey();
// // 		
// // 	    pstatus(NULL);
// // 		folderinfo_update(currentfolder,(mail*)mailslv.GetData(mailslv.Selected()));
// // 	}
// // 	if (popon && currentfolder)
// // 	{
// // 		Pop3Get *p=new Pop3Get(&readerwin,currentfolder,&mailslv);
// // 		if (p)
// // 		{
// // 			switch(popon)
// // 			{
// // 				case 1: p->Start(); break;
// // 				case 2: p->Start(POP_SILENT); break;
// // 				default: delete p;
// // 			}
// // 		}
// // 	}
// }
void folderlockcheck(void)
{
	if (!new_inboxmail && !new_popmail)
	{
		f_readnew.Lock();
	}
	if (folderlist->currentfolder() && folderlist->currentfolder()->getftype()==FOLDERTYPE_OUTBOX)
	{
		column_spec cs;
		cs.title="Recipient";
		cs.flags=CSF_TITLE;
		mailslv.ColumnConfigure(3,&cs);
	}
	else
	{
		column_spec cs;
		cs.title="Sender";
		cs.flags=CSF_TITLE;
		mailslv.ColumnConfigure(3,&cs);
	}
}
// void updatefolder(void)
// {
// 	OpenNewMailDialog_cancel(NULL,0);
// 
// 	if (!currentfolder) return;
// 
// 	int s=mailslv.Selected();
// 	int t=mailslv.Top();
// 	int r=0;
// 
// 	pstatus("Updating mailfolder...");
// 	if (r=currentfolder->update())
// 	{
// 		if (r & 2)
// 		{
// 			mailslv.RemoveAll();
// 			mail *ml;
// 			for(int i=0;i<currentfolder->count();i++)
// 			{
// 				ml=currentfolder->getmail(i+1);
// 				mailslv.AddAtEnd(ml->lvline(),(void*)ml);
// 			}
// 			mailslv.Top(t);
// 			mailslv.Selected(s);
// 
// 			if (new_inboxmail && currentfolder->isinbox())
// 			{
// 				new_inboxmail=0;
// 			}
// 		}
// 		else
// 		{
// 			updateoutput();
// 		}
// 	}
// 	else
// 	{
// 		easy_dialog ed;
// 		ed.Text("Failed to update mail folder!");
// 		ed.Options("_Ok");
// 		ed.Start(readerwin);
// 	}
// 	checkButtons();
// 		
//     pstatus(NULL);
// 	folderinfo_update(currentfolder,(mail*)mailslv.GetData(mailslv.Selected()));
// 	folderlockcheck();
// }
// static int old_sel_folder=0;
// void changefolder(void)
// {
// 	OpenNewMailDialog_cancel(NULL,0);
// 
// 	file_dialog folderdialog;
// 	folderdialog.ParentClass(myprg);
// 	folderdialog.SetDir("~/"HOMEMAIL);
// 	if (folderdialog.Start(readerwin))
// 	{
// 		char dir[400],file[200];
// 		folderdialog.GetDir(dir,sizeof(dir));
// 		folderdialog.GetFile(file,sizeof(file));
// 		strcat(dir,file);
// 		((choice*)FindObject(".allfolders"))->Selected(0);
// 		old_sel_folder=0;
// 		readfolder(dir);
// 	}
// 	folderlockcheck();
// }
// void mailboxfolder(void)
// {
// 	OpenNewMailDialog_cancel(NULL,0);
// 
// 	if (currentfolder && currentfolder->isusedinbox())
// 	{
// 		updatefolder();
// 	}
// 	else
// 	{
// 		char *mf=mailclass::usedinbox();
// 		readfolder(mf);
// 	}
// 	((choice*)FindObject(".allfolders"))->Selected(0);
// 	old_sel_folder=0;
// 	new_inboxmail=0;
// 	folderlockcheck();
// }
// void readnew(void)
// {
// 	int readinbox=new_inboxmail;
// 	int readpop=new_popmail;
// 
// 	if (new_popmail && new_inboxmail)
// 	{
// 		switch(tAlert(&readerwin,
// 			"You have new mail in your inbox and\n"
// 			"new mail on your POP3 server!\n"
// 			"Which do you what to load?|"
// 			"POP3|Inbox"))
// 		{
// 			case 2: readpop=0;   break;
// 			case 1: readinbox=0; break;
// 		}
// 	}
// // 	if (readpop)
// // 	{
// // 		new_popmail=0;
// // 		readfolder(mailclass::usedpop3box(),2);
// // 	}
// // 	else if (readinbox)
// // 	{
// // 		new_inboxmail=0;
// // 		if (!currentfolder || !currentfolder->isinbox())
// // 		{
// // 			((choice*)FindObject(".allfolders"))->Selected(0);
// // 			readfolder(mailclass::inboxname());
// // 		}
// // 		else
// // 		{
// // 			mail *ml;
// // 			int r;
// // 			char buf[100];
// // 			pstatus("Checking mailfolder...");
// // 			lvunsel();
// // 			readerwin.Update();
// // 			r=currentfolder->addnew();
// // 			pstatus("Got %d new mail.",r);
// // 
// // 			for(int i=currentfolder->count()-r;i<currentfolder->count();i++)
// // 			{
// // 				ml=currentfolder->getmail(i+1);
// // 				mailslv.AddAtEnd(ml->lvline(),(void*)ml);
// // 			}
// // 			updateoutput();
// // 			for(int i=1;i<=mailslv.Count();i++)
// // 			{
// // 				ml=currentfolder->getmail(i);
// // 				if (ml->status() & STATUS_NEW)
// // 				{
// // 					mailslv.Selected(i);
// // 					i=mailslv.Count();
// // 				}
// // 			}
// // 			mailslv.ActivateKey();
// // 		}
// // 	}
// // 	else
// // 	{
// // 		fprintf(stderr,"DEBUGINFO: this should not be called!!\n");
// // 		((choice*)FindObject(".allfolders"))->Selected(0);
// // 		folder(&f_mailbox,0);
// // 	}
// 	checkButtons();
// 	if (folderlist->currentfolder()) folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
// 	folderlockcheck();
// }
void folder(gadget *g,int i)
{
	OpenNewMailDialog_cancel(NULL,0);

	if (!strcmp(g->Name(),"mailboxfolder"))
	{
		((choice*)FindObject(".allfolders"))->Selected(0);
		folderlist->currentfolder(folderlist->getfolder(0,RL_VISIBLES));
		setNormalIcon();
		folderlockcheck();
		folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
	}
	else if (!strcmp(g->Name(),"updatefolder"))
	{
		folderlist->currentfolder(folderlist->currentfolder());
		setNormalIcon();
		folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
	}
	else if (!strcmp(g->Name(),"allfolders"))
	{
		folderlist->currentfolder(
			folderlist->getfolder(((choice*)g)->Selected(),RL_VISIBLES));
		setNormalIcon();
		folderlockcheck();
		folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
	}
	else if (!strcmp(g->Name(),"readnew"))
	{
		int i=0;
		vfolder *v;
		while (v=folderlist->getfolder(i,RL_VISIBLES))
		{
			if (v->getftype()==FOLDERTYPE_INBOX)
			{
				if (!v->cknew())
				{
					((choice*)FindObject(".allfolders"))->Selected(i);
					folderlist->currentfolder(v);
					setNormalIcon();
					folderlockcheck();
					folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
					break;
				}
			}
			else
				break;
			i++;
		}
		g->Lock();
	}
	checkButtons();
}

static unsigned int vb_col_1=0;
static int lvhook(struct hook_data *hd)
{
	int w=10;
	mail *ml=(mail*)hd->itemdata;

	if (hd->flags&HD_SELECTED)
		XSetForeground(hd->list->display(),hd->drawable->gg_gc(),hd->drawable->col_selected());
	else if (hd->flags&HD_MARKED)
		XSetForeground(hd->list->display(),hd->drawable->gg_gc(),hd->drawable->col_markbackground());
	else
		XSetForeground(hd->list->display(),hd->drawable->gg_gc(),hd->drawable->col_shinebackground());
	XFillRectangle(hd->list->display(),hd->drawable->gg_win(),hd->drawable->gg_gc(),
						hd->x+1,hd->y,w-2,hd->height);
	if (ml->totalparts())
	{
		int cols[]={hd->list->col_shadow(),hd->list->col_shine2(),hd->list->col_shadow2()};
		for(int i=-1;i<2;i++)
		{
			XSetForeground(hd->list->display(),hd->drawable->gg_gc(),cols[i+1]);
			if (i || abs(ml->totalparts())>1)
			{
				XFillRectangle(hd->list->display(),hd->drawable->gg_win(),hd->drawable->gg_gc(),
								hd->x+(w-4)/2+i*2,hd->y+(hd->height-4)/2+i*2,4,4);
			}
		}
	}
	if (ml->totalparts()<0)
	{
		XSetForeground(hd->list->display(),hd->drawable->gg_gc(),hd->list->col_black());

		XFillRectangle(hd->list->display(),hd->drawable->gg_win(),hd->drawable->gg_gc(),
						hd->x+1,hd->y+2,2,hd->height-4);
		XFillRectangle(hd->list->display(),hd->drawable->gg_win(),hd->drawable->gg_gc(),
						hd->x+1,hd->y+2,6,6);

		XSetForeground(hd->list->display(),hd->drawable->gg_gc(),hd->list->col_shinebackground());
		XFillRectangle(hd->list->display(),hd->drawable->gg_win(),hd->drawable->gg_gc(),
						hd->x+3,hd->y+4,2,2);
	}

	switch(ml->visualBell())
	{
		case 1:
			if (vb_col_1==0)
			{
				vb_col_1=hd->drawable->AllocColor(0xffff,0x0000,0x0000);
			}
			if (vb_col_1>0)
			{
				XSetForeground(hd->list->display(),hd->drawable->gg_gc(),vb_col_1);
				for(int i=0;i<hd->height;i++)
				{
					XDrawLine(hd->list->display(),hd->drawable->gg_win(),hd->drawable->gg_gc(),
								hd->x,hd->y+i,hd->x+w,hd->y+hd->height/2);
				}
			}
			break;
		default:
			break;
	}

	return -w;
}

void destroysearch(void)
{
	appwindow *aw;
	if (aw=(appwindow*)FindObject(readerwin.FullName(),".searchwindow"))
	{
		DeleteObjectTree(aw->FullName(),0);
	}
}
void closesearch(void)
{
	appwindow *aw;
	if (aw=(appwindow*)FindObject(readerwin.FullName(),".searchwindow"))
	{
		aw->CloseU();
	}
}
void searchregexhandler(gadget *g,int i)
{
	if (((mxgadget*)g)->Selected()==1)
	{
		((checkbox*)FindObject(".searchwindow.maingroup.ncase"))->Lock();
	}
	else
	{
		((checkbox*)FindObject(".searchwindow.maingroup.ncase"))->Unlock();
	}
}
// beckerr
static char *searchnames[]={"sender","sender_email","recipient","carbon_copy","subject","word",NULL};
static char *searchtitle[]={"Sender name","Sender address","Recipient","Carbon Copy","Subject","Key word (fulltext)",NULL};
void search(gadget *g,int i)
{
	char buf[MAXLENGTH+1];
	char *oname=g->Name();
	levelwindow *lw=new levelwindow(&readerwin,"Searching...",folderlist->currentfolder()->count(),"",LWF_ABORT);
	choice *ch=(choice*)FindObject(".searchwindow.maingroup.searchtype");
	appwindow::UpdateEvent();

	oname=searchnames[ch->Selected()];
	((input*)FindObject(".searchwindow.maingroup.sword"))->Input(buf);

	if (((checkbox*)FindObject(".searchwindow.maingroup.mark"))->State()==PRESSED)
		lvunsel();

	int s=0;
	if (!strcmp(g->Name(),"searchcont"))
		s=mailslv.Selected();
	readerwin.Update();
	appwindow::UpdateEvent();
	int bk=0,selct=0;
	int markselected=((checkbox*)FindObject(".searchwindow.maingroup.mark"))->State()==PRESSED;
	do
	{
		if (lw->update(s,s)) bk=1;
		s=folderlist->currentfolder()->search(s+1,
			oname,
			buf,
			((checkbox*)FindObject(".searchwindow.maingroup.ncase"))->State()==PRESSED,
			1,
			((mxgadget*)FindObject(".searchwindow.maingroup.searchmode"))->Selected()==1
			);
		if (!selct && s)
		{
			mailslv.Selected(s);
			selct=1;
		}
		else if (!s && !markselected)
		{
			readerwin.Beep(95,50);
		}		
		appwindow::UpdateEvent();
		
		if (markselected && s)
		{
			mailslv.MarkItem(s);
		}
	}
	while (!bk && ((checkbox*)FindObject(".searchwindow.maingroup.mark"))->State()==PRESSED && s);
	delete lw;
	if (((checkbox*)FindObject(".searchwindow.maingroup.keep"))->State()==RELEASED)
	{
		closesearch();
	}
	checkButtons();
	folderinfo_updatecurrent(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
	b_delete.CheckMailStatus((mail*)mailslv.GetData(mailslv.Selected()));
}
void opensearchwindow(void)
{
	appwindow *aw;
	if (aw=(appwindow*)FindObject(readerwin.FullName(),".searchwindow"))
	{
		aw->Raise();
		aw->Open();
		((input*)FindObject(".searchwindow.maingroup.sword"))->ActivateKey();
		return;
	}
	aw=new appwindow;
	int x,y;

	readerwin.Position(x,y);

	aw->ParentClass(readerwin);
	aw->Name("searchwindow");

	aw->InitSize(x,y,20);
	if (!aw->Init())
	{
		delete aw;
		pstatus("Error in opening window!");
		return;
	}
	aw->Title("Search");
	aw->IconTitle("Search");
	aw->TransientFor(readerwin);
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());

	spacegroup *g=new spacegroup;
	group *sg;
	g->Vert();
	g->Name("maingroup");
	g->YDistance(5);
	g->Border(5);

	 sg=new group;
	 sg->Horiz();
	 sg->Name(NULL);
	  choice *ch=new choice;
	  ch->Name("searchtype");
	  ch->Items(searchtitle);
	  ch->Weight(10);
	 sg->Add(ch);
	  input *ip=new input;
	  ip->Name("sword");
	  ip->MaxChars(MAXLENGTH);
	  ip->Callback(search);
	 sg->Add(ip);
	g->Add(sg);

	 mxgadget *mg=new mxgadget;
	 mg->Name("searchmode");
	 mg->Callback(searchregexhandler);
	 mg->ManageOnly();
	g->Add(mg);

	 sg=new group;
	 sg->Horiz();
	 sg->Name(NULL);
	 sg->DialogMode();
	  selknob *sk1,*sk2;
	  checkbox *cb;
	  sk1=new selknob;
	  sk1->Name("textex");
	  sk1->Text("Literal");
	 sg->Add(sk1);
	  sk2=new selknob;
	  sk2->Name("regex");
	  sk2->Text("Regulare expression");
	 sg->Add(sk2);
	  selgadget *sks[]={sk1,sk2,NULL};
	  mg->Items(sks);

	  cb=new checkbox;
	  cb->Name("keep");
	  cb->Text("Keep dialog");
	  cb->State(RELEASED);
	 sg->Add(cb);
	g->Add(sg,"");

	 sg=new group;
	 sg->Horiz();
	 sg->Name(NULL);
	 sg->DialogMode();
	  cb=new checkbox;
	  cb->Name("ncase");
	  cb->Text("Ignore case");
	  cb->State(PRESSED);
	 sg->Add(cb);
	  cb=new checkbox;
	  cb->Name("mark");
	  cb->Text("Mark all matches");
	  cb->State(RELEASED);
	 sg->Add(cb);
	g->Add(sg,"");

	 ruler *rl=new ruler;
	 rl->Horiz();
	g->Add(rl);
	 sg=new group;
	 sg->Name(NULL);
	 sg->Horiz();
	 sg->DialogMode();
	 button *bt=new button;
	  bt->Name("search");
	  bt->Text("_Search");
	  bt->Callback(search);
	 sg->Add(bt);
	 bt=new button;
	  bt->Name("searchcont");
	  bt->Text("C_ontinue search");
	  bt->Callback(search);
	  bt->HelpText("continues search from selected mail");
	 sg->Add(bt);
	 bt=new button;
	  bt->Name("close");
	  bt->Text("_Close");
	  bt->Callback((void (*)(gadget*,int))closesearch);
	 sg->Add(bt);
	g->Add(sg);

	aw->SetGroup(g);
	aw->Callback((void (*)(appwindow*))closesearch);
	aw->Create();

	ip->ActivateKey();

	searchregexhandler((checkbox*)FindObject(".searchwindow.maingroup.searchmode"),0);
}
void searchagain(void)
{
	appwindow *aw = (appwindow*)FindObject(readerwin.FullName(),".searchwindow");
	if (!aw)
	{
		opensearchwindow();
	}
	else
	{
		search((fbutton*)FindObject(".searchwindow.maingroup.searchcont"), 0);
	    mailslv.ActivateKey();
	}
}

void lvunsel(void)
{
	for(int i=1;i<=mailslv.Count();i++) mailslv.UnmarkItem(i);
}
void lvdel(mail *m)
{
	m->deleteMail();
}
void lvbdel(mail *m)
{
	m->deleteMail(b_delete);
}
void lvundel(mail *m)
{
	if (folderlist->currentfolder() && folderlist->currentfolder()->getftype()&FOLDERTYPE_TRASH && !(m->status()&STATUS_DELETE) && m->oldfolder() && m->oldfolder()[0])
	{ // move back to folder
// TODO needs rework

// 		char dir[400]="";
// 		if (!strcmp(strfilename(mailclass::inboxname()),m->oldfolder()))
// 		{ // use INBOX
// 			xc_strncpy(dir,mailclass::inboxname(),sizeof(dir));
// 		}
// 		else
// 		{
// 			strcpy(dir,getenv("HOME"));
// 			strcat(dir,"/"HOMEMAIL"/");
// 			strcat(dir,m->oldfolder());
// 		}
// 		
// 		FILE *fl;
// 		if (fl=fopen(dir,"a"))
// 		{
// 			m->clearsavedate();
// 			m->write(fl);
// 			m->status(m->status() | STATUS_SAVED);
// 			m->deleteLocalMail();
// 			fclose(fl);
// 			rereadfolders();
// 		}
	}
	else
		m->undeleteMail();
}
void lvread(mail *m)
{
	new showmail(&subwindows,m);
	m->readMail();
}
void lvread(mail *m,int x,int y,int w,int h)
{
	new showmail(&subwindows,m,x,y,w,h);
	m->readMail();
}
void lvnext(mail *mm,int x,int y,int w,int h)
{
	mail *m;
	int o,i;
	int found=0;
	lvunsel();
	if (mm) mailslv.Selected(folderlist->currentfolder()->getpos(mm));
	i=o=mailslv.Selected()>0?mailslv.Selected():1;
	do
	{
 		m=folderlist->currentfolder()->getmail(i);
 		if (m && (m->status() & (STATUS_NEW|STATUS_OLD|(programconfig.mailnewforXCmail||programconfig.mailnewfromPop3?(STATUS_XCMAILNEW|STATUS_XCPOP3NEW):0)))&& !(m->status() & STATUS_DELETE))
 		{
 			mailslv.Selected(i);
 			lvread(m,x,y,w,h);
			folderinfo_updatecurrent(folderlist->currentfolder(),m);
			b_delete.CheckMailStatus(m);
			found=1;
 			break;
 		}
		i++;
		if (i>mailslv.Count()) i=1;
	}
	while (i!=o);
	if (!found) readerwin.Beep(95,50);
	readerwin.Update();
}
class newmail *lvnew(void)
{
	class newmail *n=new newmail;
	if (n) pstatus("Open create window");
	return n;
}
void lvreply(mail *m)
{
    pstatus("Open reply window");
	new newmail(m,MAIL_REPLY);
}
void lvforward(mail *m)
{
    pstatus("Open forward window");
	new newmail(m,MAIL_FORWARD);
}
void lvnextmailof(mail *m,int x,int y,int w,int h)
{
	m=folderlist->currentfolder()->getmail(folderlist->currentfolder()->getpos(m)+1);
	if (m) 
	{
		mailslv.Selected(folderlist->currentfolder()->getpos(m));
		lvread(m,x,y,w,h);
		folderinfo_updatecurrent(folderlist->currentfolder(),m);
		b_delete.CheckMailStatus(m);
	}
	else
	{
		readerwin.Beep(95,50);
	}
	readerwin.Update();
}
void lvprevmailof(mail *m,int x,int y,int w,int h)
{
	m=folderlist->currentfolder()->getmail(folderlist->currentfolder()->getpos(m)-1);
	if (m)
	{
		mailslv.Selected(folderlist->currentfolder()->getpos(m));
		lvread(m,x,y,w,h);
		folderinfo_updatecurrent(folderlist->currentfolder(),m);
		b_delete.CheckMailStatus(m);
	}
	else
	{
		readerwin.Beep(95,50);
	}
	readerwin.Update();
}
void lvmarknew(mail *m)
{
	m->unreadMail();
}
void lvmarkread(mail *m)
{
	m->readMail();
}
void lvrmatta(mail *m)
{
	m->removeparts();
}
void lvfilter(mail *m)
{
	filtermaster.filterMail(m);
}
void lvdoubles(void)
{
	levelwindow *lv=new levelwindow(&readerwin,"Scanning of doubles...",mailslv.Count(),"checking ",LWF_ANIM|LWF_ABORT);
	lvunsel();
	int c=0;
	int first=-1;
	if (programconfig.currentsortmode==0)
	{
		for(int i=1;i<=mailslv.Count();i++)
		{
			mail *m1=(mail*)mailslv.GetData(i);
			if (!(m1->status() & STATUS_DELETE) && !mailslv.IsMarked(i))
			{
				for(int j=1;j<=i-1;j++)
				{
					if (*(mail*)mailslv.GetData(i)==*(mail*)mailslv.GetData(j))
					{
						if (first==-1) first=j;
						mailslv.MarkItem(j);
						c++;
					}
					if (i%4==0 && lv->update(i,i))
					{
						i=mailslv.Count();
						j=i;
					}
				}
			}
		}
	}
	else
	{
		for(int i=1;i<=mailslv.Count();i++)
		{
			int cc=0;
			mail *m1=(mail*)mailslv.GetData(i);
			if (!(m1->status() & STATUS_DELETE) && !mailslv.IsMarked(i))
			{
				for(int j=i+1;j<=mailslv.Count();j++)
				{
					if (*m1==*(mail*)mailslv.GetData(j))
					{
						if (first==-1) first=j;
						mailslv.MarkItem(j);
						c++;
						cc=0;
					}
					else if (++cc>50)
						break;
					if (i%4==0 && lv->update(i,i))
					{
						i=j=mailslv.Count();
					}
				}
			}
		}
	}
	if (first!=-1)
	{
		mailslv.Selected(first);
	}
	pstatus("Marked %d doubles.",c);
	delete lv;
	checkButtons();
	folderinfo_updatecurrent(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
	b_delete.CheckMailStatus((mail*)mailslv.GetData(mailslv.Selected()));
}
void lvresend(mail *m)
{
    pstatus("Open mail window");
	new newmail(m,MAIL_RESEND);
}
void lvvisualBell(mail *m)
{
	m->visualBell(mailspop.PID()-POPUP_VB0);
}
void lvplugin(mail *m)
{
	int i=(int)mailslv.userdata;
	class mainplugin *pl=mainpluginmenu[i].pl;
	if (mainpluginmenu[i].pl->flags & PLF_CLONEUSE)
		pl=mainpluginmenu[i].pl->clone();
	if (m)
		pl->handle(mainpluginmenu[i].id,m);
	else
		pl->handle(mainpluginmenu[i].id);
}
void lvmgr(gadget *g,int i)
{
	setNormalIcon();

	if (!strcmp(g->Name(),"readmail"))
	{ // show marked
		lv_forMarked(&mailslv,NULL,(void (*)(void*)) ((void (*)(mail *))&::lvread));
		lvunsel();
	}
	else if (!strcmp(g->Name(),"maillist") && !g->DoubleClick())
	{ // show selected in folderinfo
	}
	else if (!strcmp(g->Name(),"maillist") && g->DoubleClick())
	{ // show selected
		lvread((mail*)mailslv.GetData(mailslv.Selected()));
		lvunsel();
	}
	else if (!strcmp(g->Name(),"deletemail"))
	{
		lv_forMarked(&mailslv,NULL,(void (*)(void*))lvbdel);
		if (!mailslv.FindNextMarked(0))
		{
			mailslv.Selected(mailslv.Selected()+1);
		}
		lvunsel();
	}
	else if (!strcmp(g->Name(),"undeletemail"))
	{
		lv_forMarked(&mailslv,NULL,(void (*)(void*))lvundel);
		if (!mailslv.FindNextMarked(0))
		{
			mailslv.Selected(mailslv.Selected()+1);
		}
		lvunsel();
	}
	else if (!strcmp(g->Name(),"replymail"))
	{
		lvreply((mail*)mailslv.GetData(mailslv.Selected()));
	}
	else if (!strcmp(g->Name(),"newmail"))
	{
		lvnew();
	}
	else if (!strcmp(g->Name(),"forward"))
	{
		lvforward((mail*)mailslv.GetData(mailslv.Selected()));
	}
	else if (!strcmp(g->Name(),"nextunread"))
	{
		lvnext();
		lvunsel();
	}
	else if (!strcmp(g->Name(),"resend"))
	{
		lv_forMarked(&mailslv,NULL,(void (*)(void*))lvresend);
		lvunsel();
	}
	else if (!strcmp(g->Name(),"mailpopup"))
	{
		switch (mailspop.PID())
		{
		case POPUP_SELECTALL:
			for(int i=1;i<=mailslv.Count();i++) mailslv.MarkItem(i);
			break;
		case POPUP_UNSELECTALL:
			lvunsel();
			break;
		case POPUP_READ:
			lv_forMarked(&mailslv,NULL,(void (*)(void*)) ((void (*)(mail *))&::lvread));
			lvunsel();
			break;
		case POPUP_DELETE:
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvdel);
			if (!mailslv.FindNextMarked(0))
			{
				mailslv.Selected(mailslv.Selected()+1);
			}
			lvunsel();
			break;
		case POPUP_UNDELETE:
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvundel);
			if (!mailslv.FindNextMarked(0))
			{
				mailslv.Selected(mailslv.Selected()+1);
			}
			lvunsel();
			break;
		case POPUP_MARKNEW:
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvmarknew);
			lvunsel();
			break;
		case POPUP_MARKREAD:
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvmarkread);
			lvunsel();
			break;
		case POPUP_RESEND:
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvresend);
			lvunsel();
			break;
		case POPUP_RMATTA: // remove attachments
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvrmatta);
			lvunsel();
			break;
		case POPUP_FILTER:
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvfilter);
			lvunsel();
			break;
		case POPUP_VB0:
		case POPUP_VB1:
			lv_forMarked(&mailslv,NULL,(void (*)(void*))lvvisualBell);
			lvunsel();
			break;
		case POPUP_CHOOSECOPY:
		case POPUP_CHOOSEMOVE:
			{
				int sve=(mailspop.PID()==POPUP_CHOOSEMOVE?1:0);
				char *t;
				if (sve==0)
					t="Copy mail to...";
				else
					t="Move mail to...";

				vfolder *v=folderlist->chooseFolder(&readerwin,RL_WRITEABLES,t);
				if (v)
				{
					int i=0;
					mail *ml=NULL,*m2=NULL;
						
					while (i=mailslv.FindNextMarked(i))
					{
						m2=(mail*)mailslv.GetData(i);
						ml=new mail(m2);
						ml->addreferer();
						ml->status(ml->status() & ~STATUS_DELETE & ~STATUS_SERVERDELETE);
						ml->clearsavedate();
						if (!v->appendmail_default(ml))
						{
							m2->status(m2->status() | STATUS_SAVED);
							if (sve==1)
								m2->deleteLocalMail();
						}
						ml->remreferer();
					}
					if (!ml)
					{
						m2=(mail*)mailslv.GetData(mailslv.Selected());						
						ml=new mail(m2);
						ml->addreferer();
						ml->status(ml->status() & ~STATUS_DELETE & ~STATUS_SERVERDELETE);
						ml->clearsavedate();
						v->appendmail_default(ml);
						ml->remreferer();

						m2->status(m2->status() | STATUS_SAVED);
						if (sve==1)
							m2->deleteLocalMail();
					}
				}
			}
			break;
		default:
			if ((mailspop.PID()>=POPUP_FOLDERBASE1 && mailspop.PID()<POPUP_FOLDERBASE2)
			  ||(mailspop.PID()>=POPUP_FOLDERBASE2))
			{
				int m=mailspop.PID();
				int sub=(m>=POPUP_FOLDERBASE2?POPUP_FOLDERBASE2:POPUP_FOLDERBASE1);

				vfolder *v=folderlist->getfolder(m-sub,RL_WRITEABLES);
				if (v)
				{
					int i=0;
					mail *ml=NULL,*m2=NULL;
						
					while (i=mailslv.FindNextMarked(i))
					{
						m2=(mail*)mailslv.GetData(i);
						ml=new mail(m2);
						ml->addreferer();
						ml->status(ml->status() & ~STATUS_DELETE & ~STATUS_SERVERDELETE);
						ml->clearsavedate();
						if (!v->appendmail_default(ml))
						{
							m2->status(m2->status() | STATUS_SAVED);
							if (sub==POPUP_FOLDERBASE2)
								m2->deleteLocalMail();
						}
						ml->remreferer();
					}
					if (!ml)
					{
						m2=(mail*)mailslv.GetData(mailslv.Selected());						
						ml=new mail(m2);
						ml->addreferer();
						ml->status(ml->status() & ~STATUS_DELETE & ~STATUS_SERVERDELETE);
						ml->clearsavedate();
						v->appendmail_default(ml);
						ml->remreferer();

						m2->status(m2->status() | STATUS_SAVED);
						if (sub==POPUP_FOLDERBASE2)
							m2->deleteLocalMail();
					}
				}
				lvunsel();
			}
			break;
		}
	}
	checkButtons();
	mailslv.ActivateKey();
	folderinfo_updatecurrent(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
	b_delete.CheckMailStatus((mail*)mailslv.GetData(mailslv.Selected()));
}

void quitprg(void)
{
	if (mailto_mode)
	{
		freeplugins();
		return;
	}
	if (anyopen || spooled>0)
	{
		easy_dialog ed;
		char buf[80],txt[300];
		txt[0]=0;
		if (anyopen & AO_NEWMAIL)
		{
			xc_snprintf(buf,sizeof(buf),"You have an unsend message window open!\n");
			strcat(txt,buf);
		}
		if (anyopen & AO_SENDING)
		{
			xc_snprintf(buf,sizeof(buf),"WARNING: Still sending mail!\nThis will abort transfer.\n");
			strcat(txt,buf);
		}
		else if (spooled>0)
		{
			xc_snprintf(buf,sizeof(buf),"You have unsent mails in your mail spooler.\n");
			strcat(txt,buf);
		}
		ed.Text(txt);
		ed.Options("_Quit anyway|_Cancel quit");
		if (ed.Start(&readerwin)==2)
		{
			return;
		}
	}
	levelwindow *lv=new levelwindow(&readerwin,"",5,"Shutting down program, please wait...",LWF_NONUM);
	
	lv->update(0,0);
	pstatus("Writing mail folder, don't interrupt.");
	folderlist->currentfolder(NULL);

	lv->update(1,1);
	mailslv.RemoveAll();

	lv->update(2,2);
	if (programconfig.closeOnChangeFolder)
		DeleteObjectTree(subwindows.FullName(),DOT_NOTBASE);

	lv->update(3,3);
	destroysearch();

	lv->update(4,4);
	readerwin.UpdateEvent();

	finishmainplugins();
	lv->update(5,5);

	delete lv;

	readerwin.Close();
	appwindow::CloseAll();
}
void menuhandler(gadget *g,int)
{
	mn_handler(mn.Selection());
}
void mn_handler(int m)
{
	int mid=m & 0x00ffffff;
	switch (m)
	{
//		case 0x01000001: // open folder
//			changefolder();
//			break;
		case 0x01000002: // mailbox
			folder(&f_mailbox,0);
			break;
// 		case 0x01000003: // save in folder
// 			{
// 				static file_dialog fd;
// 				fd.ParentClass(myprg);
// 				fd.SetDir("~/"HOMEMAIL);
// 				if (fd.Start(readerwin))
// 				{
// 					char buf[400];
// 					char f[200];
// 					FILE *fl;
// 					fd.GetDir(buf,sizeof(buf));
// 					fd.GetFile(f,sizeof(f));
// 					strcat(buf,f);
// 					if (fl=fopen(buf,"a"))
// 					{
// 						int i=0;
// 						mail *m=NULL;
// 						
// 						while (i=mailslv.FindNextMarked(i))
// 						{
// 							m=(mail*)mailslv.GetData(i);
// 							m->clearsavedate();
// 							m->write(fl);
// 							m->status(m->status() | STATUS_SAVED);
// 							updateoutput(i);
// 						}
// 						if (!m)
// 						{
// 							m=(mail*)mailslv.GetData(mailslv.Selected());
// 							m->clearsavedate();
// 							m->write(fl);
// 							m->status(m->status() | STATUS_SAVED);
// 							updateoutput(mailslv.Selected());
// 						}
// 						fclose(fl);
// 						rereadfolders();
// 						lvunsel();
// 					}
// 				}
// 			}
// 			break;
		case 0x01000004: // save ASCII
			{
				static file_dialog fd;
				fd.ParentClass(myprg);
				fd.SaveMode();
				if (fd.Start(readerwin))
				{
					char buf[400];
					char f[200];
					FILE *fl;
					fd.GetDir(buf,sizeof(buf));
					fd.GetFile(f,sizeof(f));
					strcat(buf,f);
					if (fl=fopen(buf,"w"))
					{
						mail *m=(mail*)mailslv.GetData(mailslv.Selected());
						m->write(fl);
						fclose(fl);
					}
				}
			}
			break;
		case 0x01000005: // print
			{
				mail *m=(mail*)mailslv.GetData(mailslv.Selected());
				new printmail(&readerwin,m);
			}
			break;
		case 0x01000006: // quit
			quitprg();
			break;
		case 0x01000007: // update
			folderlist->currentfolder(folderlist->currentfolder());
			folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
			break;
		case 0x0300000b: // sort by 0:unsorted, 1:sender, 2: recipient, 2: subject, 3: send date, 4: received date, 5: new first received date, 6: size, 7: priority
			programconfig.sortmode=mn.Selected(3,11);
		case 0x0200000a: // sort by from settings
			mn.Selected(2,1,programconfig.sortmode);
		case 0x02000001: // sort by 0:unsorted, 1:sender, 2: recipient, 2: subject, 3: send date, 4: received date, 5: new first received date, 6: size, 7: priority
			programconfig.currentsortmode=mn.Selected(2,1);
			if (folderlist->currentfolder())
			{
				pstatus("Sorting mail...");
				mail *cur=(mail*)mailslv.GetData(mailslv.Selected());
				folderlist->currentfolder()->sort();
				updateoutput();
				if (cur)
				{
					mailslv.Selected(folderlist->currentfolder()->getpos(cur));
				}
				pstatus(NULL);
				folderinfo_updatecurrent(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
				b_delete.CheckMailStatus((mail*)mailslv.GetData(mailslv.Selected()));
			}
			break;
		case 0x02000002: // create new...
			lvnew();
			break;
		case 0x02000003: // read...
			lv_forMarked(&mailslv,NULL,(void (*)(void*)) (void (*)(mail*))lvread);
			lvunsel();
			break;
		case 0x02000004: // reply to...
			lvreply((mail*)mailslv.GetData(mailslv.Selected()));
			break;
		case 0x02000005: // forward to...
			lvforward((mail*)mailslv.GetData(mailslv.Selected()));
			break;
		case 0x02000006: // search...
			opensearchwindow();
			break;
		case 0x02000007: // search...
			searchagain();
			break;
		case 0x02000008: // folder information...
			folderinfo(folderlist->currentfolder(),(mail*)mailslv.GetData(mailslv.Selected()));
			break;
		case 0x02000009: // mark doubles
			lvdoubles();
			break;
		case 0x03000001: // save prefs
			writeconfig();
			break;
		case 0x03000002: // edit sig
			editsig();
			break;
// 		case 0x03000003: // sel: autoquote
// 			programconfig.autoquote=mn.State(3,3);
// 			break;
// 		case 0x03000004: // sel: quotename
// 			programconfig.quotesender=mn.State(3,4);
// 			break;
		case 0x03000005: // sel: usepgp
			programconfig.usepgp=mn.State(3,5);
			if (mn.State(3,5)==PRESSED)
				mn.UnlockHeadOf(3,6);
			else
				mn.LockHeadOf(3,6);
			break;
		case 0x03000006: // mx: pgp
			programconfig.pgpmode=mn.Selected(3,6);
			break;
		case 0x03000007: // general prefs
			generalprefs();
			break;
		case 0x03000008: // net prefs
			netprefs();
			break;
		case 0x03000009: // mail filter
			filtermaster.filterPrefs();
			break;
		case 0x0300000c: // helpers & MIME prefs
			generalMIMEprefs();
			break;
		case 0x04000001: // programnews
			programnews();
			break;
		case 0x04000002: // mail the authors
			{
				class newmail *n=lvnew();
				if (n)
				{
					n->addTo("xcmail-dev@js-home.org",1);
					input *txt=((input *)FindObject(n, ".subject"));
					txt->Default(PROGRAMNAME" "VERSION":");
					txt->ActivateKey();
				}
			}
			break;
#ifdef MAILLIST
#ifdef MAILLIST_TO
		case 0x04000003: // to maillist
			{
				class newmail *n=lvnew();
				if (n)
				{
					n->addTo(MAILLIST_TO,1);
					input *txt=((input *)FindObject(n, ".subject"));
					txt->Default("");
					txt->ActivateKey();
					textbox *tb=(textbox*)FindObject(n,".mailbody");
					tb->InsertText(MAILLIST_TEXT,0,0);
					tb->CursorTo(0,0);
				}
			}
			break;
#endif
#ifdef MAILLISTSUB_TO
		case 0x04000004: // subscribe maillist
			{
				class newmail *n=lvnew();
				if (n)
				{
					n->addTo(MAILLISTSUB_TO,1);
					input *txt=((input *)FindObject(n, ".subject"));
					txt->Default(PROGRAMNAME" "VERSION);
					textbox *tb=(textbox*)FindObject(n,".mailbody");
					tb->InsertText(MAILLISTSUB_TEXT,0,0);
					tb->ActivateKey();
					tb->CursorTo(0,0);
				}
			}
			break;
		case 0x04000007: // subscribe announce maillist
			{
				class newmail *n=lvnew();
				if (n)
				{
					n->addTo(MAILLISTSUB_TO,1);
					input *txt=((input *)FindObject(n, ".subject"));
					txt->Default(PROGRAMNAME" "VERSION);
					textbox *tb=(textbox*)FindObject(n,".mailbody");
					tb->InsertText(MAILLISTASUB_TEXT,0,0);
					tb->ActivateKey();
					tb->CursorTo(0,0);
				}
			}
			break;
		case 0x04000008: // send testmail
			pstatus("preparing testmail...");
			sendWelcomeTestMail();
			pstatus("Test mail sent.");
			break;
#endif
#endif
#ifdef SHOWREADME
		case 0x04000005: // show readme
			showreadme();
			break;
		case 0x04000006: // show tips
			showtips();
			break;
#endif
		case 0x05000001: // pop now
			checkpop3(1);
			break;
		case 0x05000002: // send spool
			if (spooled>0) sendspooled(1);
			break;
		case 0x05000003: // emtpy trash folder
			{ // TODO v2.2 allow choosing which trash vfolders - or submenu
				easy_dialog ed;
				ed.Text("Empty all trash folders?");
				ed.Options("_Yes|_No");
				if (ed.Start(readerwin)==1)
				{
					vfolder *v=NULL;
					while (v=folderlist->getnextfolderoftype(v,FOLDERTYPE_TRASH))
					{
						v->clear();
						pstatus("Trash %s cleared.",v->g_foldername());
					}
				}
			}
			break;
		case 0x05000004: // folder manager
			{
				new folder_manager;
			}
			break;
		case 0x05000005: // folder archiv
			addressbookwindow();
			break;
		default:
			if ((m>=0x010000100 && m<0x02000000)||(m>=0x020000100 && m<0x03000000))
			{
				fprintf(stderr,"Warning: Deprecated call to copy/move mail into another folder!\nPlease report this to the authors (xcmail-dev@js-home.org)\n");
			}
			else
			if (m>=quickmenustart && m<(quickmenustart+0x01000000-1))
			{ // quick mail
				class newmail *n=lvnew();
				if (n)
				{
					n->addTo(abook.getField(mid,AddressBook::EMAIL));
					input *txt=((input *)FindObject(n, ".subject"));
					txt->ActivateKey();
				}
			}
			else if (m>=pluginsmenustart && m<(pluginsmenustart+0x01000000-1))
			{ // plugins menu
				if (mainpluginmenu[mid-1].general)
				{
					mailslv.userdata=(void*)(mid-1);
					lvplugin(NULL);
				}
				else if (mainpluginmenu[mid-1].marked)
				{
					mailslv.userdata=(void*)(mid-1);
					lv_forMarked(&mailslv,NULL,(void (*)(void*))lvplugin);
					lvunsel();
				}
				else if (mainpluginmenu[mid-1].selected)
				{
					mailslv.userdata=(void*)(mid-1);
					lvplugin((mail*)mailslv.GetData(mailslv.Selected()));
					lvunsel();
				}
			}
			break;
	}
}
void makemenu(int md=0)
{
	if (!readerwin.window()) return;	// workaround if called by addressbook durring program finish

	if (md)
	{
		mn.Clear();
	}

	mn.AddMenu("File");
//	mn.Add("Open folder...","o",1);
	mn.Add("Open inbox","b",2);
	mn.Add("Update folder","u",7);
	mn.AddRuler();
	mn.Add("Save mail as...","s",4);
	mn.AddRuler();
	mn.Add("Print mail...","p",5);
	mn.AddRuler();
	mn.Add("Quit","q",6);

	mn.AddMenu("Messages");
	mn.AddSub("sort by");
	char *sortar[]={"nothing","sender","recipient","subject","send date","rev send date","rev send date, new first","size","priority",NULL};
	char *sortscar[]={"a1","a2","a3","a4","a5","a6","a7","a8","a9",NULL};
	mn.Add("settings","a0",10);
	mn.AddRuler();
	mn.AddMX(sortar,sortscar,1);
	mn.EndSub();
	mn.AddRuler();
	mn.Add("search...","h",6);
	mn.Add("search again","g",7);
	mn.AddRuler();
	mn.Add("create new mail...","m",2);
	mn.AddRuler();
	mn.Add("read...","e",3);
	mn.Add("reply to...","r",4);
	mn.Add("forward to...","f",5);
	mn.AddRuler();
	mn.Add("folder information...","i",8);
	mn.Add("mark doubles",9);
	mn.AddMenu("Preferences");
	mn.Add("General...","f5",7);
	mn.Add("Transfer & Network...","F5",8);
	mn.Add("MIME, Helpers & Plugins...","F6",12);
	if (filtermaster.hasFilters()>0)
		mn.Add("Mail filter...","f6",9);
	mn.AddRuler();
	mn.Add("Edit signature...","f7",2);
//	mn.AddSub("Quote");
//	mn.AddSel("Autoquote",3);
//	mn.AddSel("User defined openings",4);
//	mn.EndSub();
#ifdef USEPGP
	mn.AddSel("PGP support",5);
	mn.AddSub("PGP default");
	char *pgpdefault[]={"no encryption","sign","encrypt","both",NULL};
	mn.AddMX(pgpdefault,6);
	mn.EndSub();
#endif
	mn.AddSub("Sorting default by");
	mn.AddMX(sortar,11);
	mn.EndSub();
	mn.AddRuler();
	mn.Add("Save preferences now",1);

	mn.AddHelpMenu("Xclasses");
	mn.Add("News/license agreement",1);
#ifdef SHOWREADME
	mn.Add(PROGRAMNAME" Readme",5);
	mn.Add(PROGRAMNAME" usage tips",6);
#endif
	mn.AddRuler();
#ifdef MAILLIST
	mn.AddSub("Mailing lists");
#ifdef MAILLIST_TO
	mn.Add("Write to "PROGRAMNAME" mailing list","f10",3);
	mn.AddRuler();
	mn.Add("Mail the authors","F10",2);
#else
	mn.Add("Mail the authors","F10",2);
#endif
#ifdef MAILLISTSUB_TO
	mn.AddRuler();
	mn.Add("Subscribe "PROGRAMNAME" mailing list",4);
	mn.Add("Subscribe "PROGRAMNAME"-announce mailing list",7);
#endif
	mn.AddRuler();
	mn.Add("Send testmail with auto reply",8);
	mn.EndSub();
#endif

	mn.AddMenu("Special");
	mn.Add("Addressbook...","f8",5);
	mn.Add("Folder manager...","f9",4);
	mn.AddRuler();

	mn.Add("Get POP3 mail now","l",1);
	mn.Add("Send spooled mail","k",2);
	mn.AddRuler();
	mn.Add("Empty all trash folders...",3);

	{
		pluginsmenustart=0;
		int f=0;
		for(int i=0;i<mainpluginmenucount;i++)
		{
			if (!f)
			{
				mn.AddMenu("Extras");
				f=1;
				pluginsmenustart=0x06000001;
			}
			if (mainpluginmenu[i].shortcut)
			{
				mn.Add(mainpluginmenu[i].text,mainpluginmenu[i].shortcut,i+1);
			}
			else
			{
				mn.Add(mainpluginmenu[i].text,i+1);
			}
		}
	}

	{
		int f=0;
		char buf[400];
		quickmenustart=0;

		for (int i=1;i<=abook.Count();i++)
		{
			if (atoi(abook.getField(i,AddressBook::QUICKMENU)))
			{
				char *fn = abook.getField(i,AddressBook::FIRSTNAME);
				char *ln = abook.getField(i,AddressBook::LASTNAME);
				char *an = abook.getField(i,AddressBook::EMAIL);

				if (fn[0] && ln[0])
					xc_snprintf(buf,sizeof(buf),"%s, %s", ln, fn);
				else if (fn[0])
					xc_snprintf(buf,sizeof(buf),"%s (%s)", fn, an);
				else if (ln[0])
					xc_snprintf(buf,sizeof(buf),"%s (%s)", ln, an);
				else
					xc_snprintf(buf,sizeof(buf),"%s", an);
				
				if (!f)
				{
					mn.AddMenu("Quick mail");
					f=1;
					if (pluginsmenustart) quickmenustart=pluginsmenustart+0x01000000; else quickmenustart=0x06000001;
				}
				mn.Add(buf,i);
			}
		}
	}

	if (md)
	{
		mn.Recreate();
	}
// 	else
// 	{
// 		static message msg;
// 		msg.Add(mn,new msgget_int(&mn,
// 			(int (callable::*)(void))&menu::Selection),
// 			NULL,NULL,NULL);
// 		msg.Add(status,NULL,NULL,new msgset_int(&status,
// 			(void (callable::*)(int))&bannertext::MenuHelpText),
// 			NULL);
// 	}

	if (spooled>0)
		mn.UnlockItem(5,2);
	else
		mn.LockItem(5,2);

//	mn.State(3,3,programconfig.autoquote?PRESSED:RELEASED);
//	mn.State(3,4,programconfig.quotesender?PRESSED:RELEASED);
	mn.Selected(2,1,programconfig.currentsortmode);
	mn.Selected(3,11,programconfig.sortmode);
#ifdef USEPGP
	mn.State(3,5,programconfig.usepgp?PRESSED:RELEASED);
	mn.Selected(3,6,programconfig.pgpmode);
	if (mn.State(3,5)==PRESSED)
		mn.UnlockHeadOf(3,6);
	else
		mn.LockHeadOf(3,6);
#endif
	checkButtons();
	folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
}
void makepopup(int md=0)
{
	if (md)
		mailspop.Clear();
	mailspop.AddHeadline("Mail");
	mailspop.Add("Select all",NULL,POPUP_SELECTALL);
	mailspop.Add("Unselect all",NULL,POPUP_UNSELECTALL);
	mailspop.AddRuler();
	mailspop.Add("Mark as read",NULL,POPUP_MARKREAD);
	mailspop.Add("Mark as unread",NULL,POPUP_MARKNEW);
	mailspop.Add("Remove attachments",NULL,POPUP_RMATTA);
	if (filtermaster.hasFilters()>0)
		mailspop.Add("Filter",NULL,POPUP_FILTER);
	mailspop.AddSub("Copy to folder");
	if (!programconfig.old_choose_folder)
	{
		mailspop.Add("choose from all...",NULL,POPUP_CHOOSECOPY);
		mailspop.AddRuler();
	}
	{
		int i=0;
		char **a=folderlist->readlist(RL_WRITEABLES);
		while (a[i])
		{
			if (a[i][0]!='>' || programconfig.old_choose_folder)
				mailspop.Add(a[i],NULL,POPUP_FOLDERBASE1+i);
			i++;
		}
	}
	mailspop.EndSub();
	mailspop.AddSub("Move to folder");
	if (!programconfig.old_choose_folder)
	{
		mailspop.Add("choose from all...",NULL,POPUP_CHOOSEMOVE);
		mailspop.AddRuler();
	}
	{
		int i=0;
		char **a=folderlist->readlist(RL_WRITEABLES);
		while (a[i])
		{
			if (a[i][0]!='>' || programconfig.old_choose_folder)
				mailspop.Add(a[i],NULL,POPUP_FOLDERBASE2+i);
			i++;
		}
	}
	mailspop.EndSub();
	mailspop.AddSub("Set visual flag");
	{
		mailspop.Add("none",NULL,POPUP_VB0);
		mailspop.Add("1",NULL,POPUP_VB1);
	}
	mailspop.EndSub();
	mailspop.AddRuler();
	mailspop.Add("Read...","e",POPUP_READ);
	mailspop.Add("Delete","d",POPUP_DELETE);
	mailspop.Add("Undelete","D",POPUP_UNDELETE);
	mailspop.Add("Resend...","M",POPUP_RESEND);
	checkButtons();
}
void initmainplugins(void)
{
	mainplugin *mp=NULL;

	while (mp=(mainplugin*)prgplugins->nextOfType(plugins::PT_Maintool,mp))
	{
		mp->init();
	}
}
void finishmainplugins(void)
{
	mainplugin *mp=NULL;

	while (mp=(mainplugin*)prgplugins->nextOfType(plugins::PT_Maintool,mp))
	{
		mp->finish();
	}
}

extern gfx_folder gx_folder;
extern gfx_readonly gx_readonly;
extern gfx_trash gx_trash;
extern gfx_received gx_received;
extern gfx_inbox gx_inbox;
extern gfx_outbox gx_outbox;

void setallboxes(void)
{
// 	int c=0,i,arc=0,l;
// 
// 	for(i=0;i<=MAXC*2;i++)
// 	{
// 		if (allfolderspopup[i]) free(allfolderspopup[i]);
// 		allfolderspopup[i]=NULL;
// 	}
// 	i=0;
// 	while (allfolders[c])
// 	{
// 		allfolderspopup[c]=strdup(allfolders[c]);
// 		allfoldersname[c]=allfolders[c];
// 		c++;
// 	}
// 	arc=c;
// 	while (allarcfolders[i])
// 	{
// 		l=strlen(allarcfolders[i]);
// 		allfolderspopup[c]=(char*)malloc(l+8);
// 		strcpy(allfolderspopup[c],">ARCHIV/");
// 		strcat(allfolderspopup[c],allarcfolders[i]+1);
// 		allfoldersname[c]=allarcfolders[i];
// 		c++; i++;
// 	}
// 	allfolderspopup[c]=NULL;
// 	f_allboxes.Items(allfolderspopup);
// 
// 	char buf[200];
// 	for(i=0;i<c;i++)
// 	{
// 		buf[0]='.';
// 		if (i<arc)
// 		{
// 			strcpy(&buf[1],allfolderspopup[i]);
// 			TranslateName(&buf[1]);
// 			strcat(buf,".graphic");
// 			if (!strcmp(allfolderspopup[i],TRASHFOLDER))
// 				f_allboxes.SetResource(buf,gx_trash.FullName());
// 			else if (i==0
// 			 || !strcmp(allfolderspopup[i],POP3ID)
// 			 || !strcmp(allfolderspopup[i],programconfig.outboxname)
// 			 || !strcmp(allfolderspopup[i],RECEIVEDFOLDER))
// 				f_allboxes.SetResource(buf,gx_extra.FullName());
// 			else
// 				f_allboxes.SetResource(buf,gx_folder.FullName());
// 		}
// 		else
// 		{
// 			strcpy(&buf[1],"ARCHIV.");
// 			strcpy(&buf[8],allfolderspopup[i]+8);
// 			TranslateName(&buf[8]);
// 			strcat(buf,".graphic");
// 			f_allboxes.SetResource(buf,gx_readonly.FullName());
// 		}
// 	}

	char **a=folderlist->readlist(RL_VISIBLES);
 	f_allboxes.Items(a);
	char buf[200];
	int i=0;
	vfolder *f;
	while (a[i])
	{
		buf[0]='.';

		f=folderlist->getfolder(i,RL_VISIBLES);
		if (f)
		{
			if (folderlist->currentfolder()==f)
			{
				f_allboxes.Selected(i);
			}
			strcpy(&buf[1],a[i]);
			TranslateName(&buf[1]);
			strcat(buf,".graphic");

			switch (f->getftype())
			{
				case FOLDERTYPE_INBOX:
					f_allboxes.SetResource(buf,gx_inbox.FullName());
					break;
				case FOLDERTYPE_TRASH:
					f_allboxes.SetResource(buf,gx_trash.FullName());
					break;
				case FOLDERTYPE_RECEIVED:
					f_allboxes.SetResource(buf,gx_received.FullName());
					break;
				case FOLDERTYPE_OUTBOX:
					f_allboxes.SetResource(buf,gx_outbox.FullName());
					break;
				default:
					if (f->readonly)
						f_allboxes.SetResource(buf,gx_readonly.FullName());
					else
						f_allboxes.SetResource(buf,gx_folder.FullName());
					break;
			}
		}
		i++;
	}
}
void rereadfolders(void)
{ // update folder list outputs
	setallboxes();
	makemenu(1);
	makepopup(1);
}
void checkfoldersize(void)
{ // TODO needs rewrite

// 	struct stat st;
// 	char buf[600];
// 	int size_trash=0,size_outbox=0;
// 	autoeasy_dialog *ed=new autoeasy_dialog;
// 
// 	strcpy(buf,mailclass::trashboxname());
// 	if (!stat(buf,&st))
// 		size_trash=st.st_size;
// 
// 	strcpy(buf,mailclass::outboxname());
// 	if (!stat(buf,&st))
// 		size_outbox=st.st_size;
// 
// 	buf[0]=0;
// 	if (programconfig.folderwarnsize && size_outbox>programconfig.folderwarnsize)
// 	{
// 		xc_snprintf(buf,sizeof(buf),"Warning:\nYour outbox folder is bigger than %d KB.\nYou should delete or move some mail.\n\n",programconfig.folderwarnsize/1024);
// 	}
// 	if (size_trash>WARNSIZE)
// 	{
// 		strcat(buf,"Warning:\nYour trash folder is bigger than "WARNSIZESTR" KB.\nYou should delete or move some mail.\n\n");
// 	}
// 	if (buf[0])
// 	{
// 		ed->Text(buf);
// 		ed->Options("_Ok");
// 		ed->Start(readerwin);
// 	}
}
void corehandler(int sig)
{
	static int i_was_here=0;
	if (i_was_here) _exit(127);
//	if (folderlist->currentfolder()) folderlist->currentfolder()->corehandler();
	fprintf(stderr,"------------------------------------------\n");
	fprintf(stderr,"You made it!\n");
	fprintf(stderr,"%s error!\n",PROGRAMNAME);
 	fprintf(stderr,"internal error, please try again to\n");
 	fprintf(stderr,"get this error and send a bug report\n");
 	fprintf(stderr,"with program version, system type\n");
 	fprintf(stderr,"and the way this bug happened to\n");
 	fprintf(stderr,"xcmail-developers@js-home.org\n");
 	fprintf(stderr,"Send NO core dumps!\n");
 	fprintf(stderr,"\nThanks for your cooperation!\n");
	fprintf(stderr,"------------------------------------------\n");
	i_was_here=1;
}
void pstatus(char *s, ...)
{
	static char buf[1000];
	buf[0]=0;

	if (s)
	{
		va_list valist;
		va_start(valist,s);
		xc_vsnprintf(buf, sizeof(buf), s, valist);
		va_end(valist);
	}
	else
	{
		xc_snprintf(buf, sizeof(buf), PROGRAMNAME" ready, %d messages",folderlist->currentfolder()?folderlist->currentfolder()->count():0);
	}
	status.Text(buf);
}
void OpenNewMailDialog_cancel(gadget *,int)
{
	appwindow *aw=(appwindow*)FindObject(readerwin.FullName(),".opennewmailwindow");
	if (aw)
	{
		aw->Close();
		DeleteObjectTree(aw->FullName());
	}
}
void OpenNewMailDialog_ok(gadget *,int)
{
	readerwin.UnIconify();
	OpenNewMailDialog_cancel(NULL,0);
	folder(&f_readnew,0);

	for(int i=0;i<mailslv.Count();i++)
	{
		mail *m=(mail*)mailslv.GetData(i);
		if (m && (m->status() & STATUS_NEW))
		{
			lvread(m);
			break;
		}
	}
}
void OpenNewMailDialog(void)
{
	if (FindObject(".mainwindow.opennewmailwindow")) return;

	int w,h;
	appwindow *aw=new appwindow;

	DisplaySize(readerwin.display(),w,h);
	aw->ParentClass(readerwin);
	aw->Name("opennewmailwindow");

	aw->InitSize(30);
	aw->Init();
	aw->Title("New mail");
	aw->IconTitle("New mail");

	aw->Adjust(0,0,w,h,ADJUST_MIDDLE|ADJUST_CENTER);

	spacegroup *maingp=new spacegroup;
	maingp->Vert();
	maingp->Border(4);
	maingp->Name("maingroup");
	 text *txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text("A new mail has arrived!\nOpen/update folder?");
	maingp->Add(txt);
	maingp->Add(new ruler);
	 group *gp=new group;
	 gp->Horiz();
	 gp->DialogMode();
	  button *b=new button;
	  b->Name("ok");
	  b->Text(" _Yes ");
	  b->Font(FONT_BIG);
	  b->Callback(OpenNewMailDialog_ok);
	 gp->Add(b);
	  b=new button;
	  b->Name("cancel");
	  b->Text(" _No ");
	  b->Font(FONT_BIG);
	  b->Callback(OpenNewMailDialog_cancel);
	  b->ApplyXKey(XK_Escape);
	 gp->Add(b);
	maingp->Add(gp);
	aw->SetGroup(maingp);
	aw->Callback((void (*)(appwindow *))OpenNewMailDialog_cancel);

	aw->Create();
}

static int updatebox_count=0,anybox_count=0;
void newmailarrived(int beeponly,vfolder *v)
{
	if (v)
		pstatus("New mail has arrived in %s!",v->g_foldername());

	f_readnew.Unlock();
	if (programconfig.openNewMailDialog && readerwin.IsIconified() && !(anyopen&AO_NEWMAIL))
	{
		OpenNewMailDialog();
	}
	if (beeponly || (v && v==folderlist->currentfolder()))
		f_readnew.Lock();
	else if (v)
		pstatus("New mail has arrived in %s! Press 'N' button (upper right) to see.",v->g_foldername());

	setNewMailIcon();
}
// void nonewmail(int foldertype)
// {
// 	if (foldertype==FT_POP)
// 	{
// 		new_popmail=0;
// 		pop_count=0;
// 	}
// }

static void buttonbar(void)
{
     allbuttons.Horiz();
      buttons1.Vert();
       b_read.Name("readmail");
       b_read.Callback(lvmgr);
       b_read.Text("R_ead...");
      buttons1.Add(b_read);
       buttonsshadow1.Name(NULL);
	   buttonsshadow1.Add(b_nextnew);
	    b_nextnew.Name("nextunread");
	    b_nextnew.Callback(lvmgr);
	    b_nextnew.Text("_next unread mail...");
      buttons1.Add(buttonsshadow1);
       buttonsshadow2.Name(NULL);
	   buttonsshadow2.Add(b_resend);
	    b_resend.Name("resend");
	    b_resend.Callback(lvmgr);
	    b_resend.Text("Resend...");
	   buttonsshadow1.AddShadow(buttonsshadow2);
     allbuttons.Add(buttons1);
      buttons2.Vert();
	   b_new.Name("newmail");
	   b_new.Callback(lvmgr);
	   b_new.Text("New _mail...");
	   b_new.HelpText("Create and send a new email.");
	  buttons2.Add(b_new);
       b_delete.Name("deletemail");
       b_delete.Callback(lvmgr);
       b_delete.Text("_Delete");
      buttons2.Add(b_delete);
     allbuttons.Add(buttons2);
      buttons3.Vert();
	   b_reply.Name("replymail");
	   b_reply.Callback(lvmgr);
	   b_reply.Text("_Reply...");
	   b_reply.HelpText("Send an answer to the sender of this email.");
	  buttons3.Add(b_reply);
       b_undelete.Name("undeletemail");
       b_undelete.Callback(lvmgr);
       b_undelete.Text("_Undelete");
      buttons3.Add(b_undelete);
     allbuttons.Add(buttons3);
      buttons4.Vert();
	   b_forward.Name("forward");
	   b_forward.Callback(lvmgr);
	   b_forward.Text("_Forward...");
	   b_forward.HelpText("Send this email to another person.");
	  buttons4.Add(b_forward);
	   b_exit.Name("exit");
	   b_exit.Callback((void (*)(gadget *,int))quitprg);
	   b_exit.Text("_Quit");
	  buttons4.Add(b_exit);
     allbuttons.Add(buttons4);
    maingp.Add(allbuttons);
}

//#define TIMECHECK	// print runtime durring initialize
extern int LibMajor(void);
extern int LibMinor(void);
int main(int argc,char *argv[])
{
#ifdef TIMECHECK
printf("%d: main() - CPS: %d\n",clock(),CLOCKS_PER_SEC);
#endif
	if (LibMajor()==1 && LibMinor()<3)
	{
		printf("Sorry, Xclasses 1.3 or higher is required!\n\n");
		exit(1);
	}

	int sendatstart=0;

	tzset();

#if defined(HAVE_LIBBSD)
    {
        time_t t=time(NULL);
        struct tm stm,gmt,*tms;
        tms=localtime(&t);
		stm=*tms;
        tms=gmtime(&t);
		gmt=*tms;
        int_timezone=(long int)difftime(mktime(&gmt), mktime(&stm));
    }
#else

#ifndef HAVE_TIMEZONE
	{
		time_t t=time(NULL);
		struct tm *stm;
		stm=localtime(&t);
		int_timezone=(stm->tm_gmtoff/3600)*100+(stm->tm_gmtoff/60)%60;
	}

#else
	int_timezone=timezone;
#endif
#endif

//#ifndef HAVE_DAYLIGHT
	{
		time_t t=time(NULL);
		struct tm *stm;
		stm=localtime(&t);
		int_daylight=stm->tm_isdst;
	}
//#else
//	int_daylight=daylight;
//#endif

//  	signal(SIGILL,corehandler);
//   	signal(SIGSEGV,corehandler);
//   	signal(SIGABRT,corehandler);
//   	signal(SIGFPE,corehandler);
//   	signal(SIGBUS,corehandler);

	signal(SIGPIPE, SIG_IGN);
	signal(SIGCHLD,SIG_IGN);

	subwindows.ParentClass(myprg);
	subwindows.Name("subwindows");

	readerwin.Name("mainwindow");
	readerwin.InitSize(99);
	if (!readerwin.Init(argc,argv))
	{
		printf("Can't open display %s.\n",readerwin.DisplayName());
		return 1;
	}

	int oc;
	while ((oc=getopt(argc,argv,"n:s"))!=-1)
	{
		switch (oc)
		{
			case 'n': // newmail
				mailto_mode=optarg;
				break;
			case 's': // send
				sendatstart=1;
				break;
		}
	}

	readerwin.Title(WINDOWTITLE);
	readerwin.IconTitle(PROGRAMNAME);
	readerwin.Callback((void (*)(appwindow*))quitprg);

	readconfig();
	readplugins();
	folderlist=new folders;

	maingp.Border(3);
	maingp.Name("maingroup");
	maingp.Vert();
	 f_gp.Horiz();
	 f_gp.Right();
	 f_gp.UseSmallest();
	 f_gp.Name("foldergroup");
#ifndef COOLMENU
	  mimage.NoBorder();
	  mimage.Object(f_xlogo);
	 f_gp.Add(mimage);
#endif

//	buttonbar();

	  foldername.Name("foldername");
	  foldername.Text("Folder:");
	  foldername.Output(" ");
	  foldername.Weight(200);
	  foldername.Font(FONT_SMALL);
	 f_gp.Add(foldername);
	  f_busymode.Name("busymode");
	 f_gp.Add(f_busymode);
	  f_mailbox.Name("mailboxfolder");
	  f_mailbox.Callback(folder);
	  f_mailbox.Text("Mail _inbox");
	  f_mailbox.Weight(50);
	  f_mailbox.Font(FONT_SMALL);
	  f_mailbox.HelpText("Opens your first incoming\nmail folder.");
	 f_gp.Add(f_mailbox);
	  f_allboxes.Name("allfolders");
	  f_allboxes.Callback(folder);
	  f_allboxes.Font(FONT_SMALL);
	  f_allboxes.Items(scanmaildir());
	  f_allboxes.Weight(50);
	  f_allboxes.HelpText("Choose a folder to open");
	 f_gp.Add(f_allboxes);
	  f_readnew.Name("readnew");
	  f_readnew.Callback(folder);
	  f_readnew.Font(FONT_SMALL);
//	  f_readnew.Weight(10);
	  f_readnew.Text("N");
	  f_readnew.Lock();
	  f_readnew.HelpText("Change to folder with new mail.");
	 f_gp.Add(f_readnew);
	maingp.Add(f_gp);

	 column_spec cs[4];
	 cs[0].flags=CSF_HOOK|CSF_USEWIDTH|CSF_SELECTABLE|CSF_TITLE;
	 cs[0].hook=lvhook;
	 cs[0].hookclass=NULL;
	 cs[0].width=20;
	 cs[0].title="Flags";
//	 cs[1].flags=CSF_USEWIDTH|CSF_SELECTABLE|CSF_SCALEABLE|CSF_ADJUST|CSF_TITLE;
	 cs[1].flags=CSF_SELECTABLE|CSF_SCALEABLE|CSF_ADJUST|CSF_TITLE|CSF_AUTOSCALE;
	 cs[1].width=50;
	 cs[1].adjust=ADJUST_RIGHT;
	 cs[1].title="Date";
	 cs[2].flags=CSF_USEWEIGHT|CSF_SELECTABLE|CSF_SCALEABLE|CSF_TITLE;
	 cs[2].weight=30;
	 cs[2].title="Sender";
	 cs[3].flags=CSF_USEWEIGHT|CSF_SELECTABLE|CSF_TITLE;
	 cs[3].weight=70;
	 cs[3].title="Subject";
	 mailslv.Name("maillist");
	 mailslv.Font(FONT_FIXED); 
     mailslv.Callback(lvmgr);
     mailslv.Columns(4,cs);
     mailslv.ShowSelected();
     mailslv.MultiSelect();
     mailslv.ContextPopup(mailspop);
      mailspop.Name("mailpopup");
      mailspop.Callback(lvmgr);
	maingp.Add(mailslv);
      
	 status.Font(FONT_SMALL);
    maingp.Add(status);

	buttonbar();
	readerwin.SetGroup(maingp);
	
	mn.Callback(menuhandler);

#ifdef COOLMENU
	group mgroup;
	mgroup.Name(NULL);
	mgroup.Horiz();
	mgroup.UseSmallest();
	mgroup.XDistance(2);
	mimage.Object(f_xlogo);
	mimage.NoBorder();

	mgroup.Add(mimage);
	mgroup.Add(mn);

	readerwin.SetMenu((menu*) (gadget*)&mgroup);
#else
	readerwin.SetMenu(mn);
#endif

	readerwin.Keyclass()->SendKeyTo(XK_Up,0,mailslv);
	readerwin.Keyclass()->SendKeyTo(XK_Down,0,mailslv);

	gx_folder.ParentClass(f_allboxes);
	gx_readonly.ParentClass(f_allboxes);
	gx_trash.ParentClass(f_allboxes);
	gx_inbox.ParentClass(f_allboxes);
	gx_outbox.ParentClass(f_allboxes);
	gx_received.ParentClass(f_allboxes);

	readmoreconfig();
	initmainplugins();
	setallboxes();
	makemenu();
	makepopup();
	readerwin.SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());

	folderlist->init();
	if (mailto_mode)
	{
		newmail *n=new newmail;

		if (n)
		{
			n->addTo(mailto_mode);
			input *txt=((input *)FindObject(n, ".subject"));
			txt->ActivateKey();
		}
		readerwin.NextEvent();
		readerwin.Close();
		freeplugins();
		return 0;
	}
	welcome();

	readerwin.Create();
	folder(&f_mailbox,0);
	checkfoldersize();

	checkExpire(&readerwin);
	anybox_count=0;
	updatebox_count=0;
	folderlist->cknew(1);
	{
		int res;
		int old_spooled=-1;
		checkspooled();
		if (sendatstart && spooled>0) sendspooled();

		if (programconfig.popcheckatstart)
		{
			checkpop3(programconfig.popcheckatstartdelayed?-1:1);
		}

		do
		{
			res=readerwin.TickEvent();
			if (res==EV_TICK)
			{
// new:
// pop3-count check
// inboxes check (file, imap, etc)
//

				if (++anybox_count>=50)
				{
					int n=folderlist->cknew();
					if (n&2)
					{
						folderinfo_update(folderlist->currentfolder(), (mail*)mailslv.GetData(mailslv.Selected()));
					}
					if (n&4)
					{
						newmailarrived(n&2);
					}
					anybox_count=0;
				}

// 				if (programconfig.autoupdatefolder && ++updatebox_count>programconfig.autoupdatefolderdelay*600)
// 				{
// 					updatefolder();
// 					updatebox_count=0;
// 				}

				if (programconfig.popautocheck)
				{
					checkpop3();
				}
				if (!folderlist->currentfolder())
				{
					anybox_count=0;
				}
				
				if (spooled!=old_spooled)
				{
					if (spooled>0)
						mn.UnlockItem(5,2);
					else
						mn.LockItem(5,2);
					old_spooled=spooled;
				}
			}
		}
		while (res!=EV_FINISH);
	}
	folderlist->unregisterfolderfunction(rereadfolders);
	writeconfig();
	folderlist->saveprefs();
	delete folderlist;

	freeplugins();
	return 0;
}
