/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: replylist.cxx,v 2.7 2002/04/18 13:54:19 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include "mailer.h"
#include "replylist.h"

#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/utsname.h>

#include "stringTokenizer.h"

replylist::replylist(void) : Xclasses(), addresses(NULL,",;")
{
	Name("replylist");
	otext=NULL;
}

replylist::~replylist()
{
}

int replylist::Start(appwindow *par,newmail *nm)
{
	if (addresses.count()==0) return 0;

	appwindow *aw=new appwindow;
	int x,y,w,h,ret=0;
	int vismode=1;

	ParentClass(par);
	par->Position(x,y);
	par->Size(w,h);

	aw->ParentClass(this);
	aw->Name("window");
	aw->InitSize(x,y,w/5,h-h/4);
	if (!aw->Init())
	{
		delete aw;
		return 0;
	}
	aw->Adjust(x,y,w,h,ADJUST_MIDDLE|ADJUST_CENTER);
	aw->Title("Reply to?");
	aw->IconTitle("");
	aw->TransientFor(par);

	spacegroup *g1=new spacegroup;
	g1->Border(20);
	g1->Vert();
	g1->Name("maingroup");
	 text *tx=new text;
	 tx->FixedText();
	 tx->NoUnderline();
	 tx->Font(FONT_BIG);
	 tx->Text(otext);
	g1->Add(tx);
	 group *g2;
	 if (addresses.count()>20) vismode=0;
	 if (vismode)
	 {
		 visible *v=new visible;
		 v->Name(NULL);
		  g2=new group;
		  g2->Name(NULL);
		  g2->Vert();

		  for(int i=0;i<addresses.count();i++)
		  {
			  	char n[20];
			  	xc_snprintf(n,sizeof(n),"a_%d",i);
			   	 checkbox *cb=new checkbox;
			   	 cb->Name(n);
			   	 cb->Text(addresses[i]);
			   	 cb->State(PRESSED);
			  	g2->Add(cb);
		  }
		 v->Apply(g2);
		g1->Add(v);
	}
	else
	{
		 int j=0;
		 listview *lv=new listview;
		 lv->Name("addresses");
		 lv->ShowSelected();
		 lv->MultiSelect();
		 lv->DirectMulti();
		 for(int i=0;i<addresses.count();i++)
		 {
		 	  lv->AddAtEnd(addresses[i],(void*)i);
			  lv->MarkItem(++j);
		 }
		g1->Add(lv);
	}
	g1->Add(new ruler);
	 g2=new group;
	 g2->Horiz();
	 g2->DialogMode();
	  fbutton *fb=new fbutton;
	  fb->Text(" To _selected ");
	  fb->Font(FONT_BIG);
	  fb->ID(1);
	 g2->Add(fb);
	  fb=new fbutton;
	  fb->Text(" To _all ");
	  fb->Font(FONT_BIG);
	  fb->ID(2);
	 g2->Add(fb);
	  fb=new fbutton;
	  fb->Text(" To _noone ");
	  fb->Font(FONT_BIG);
	  fb->ID(3);
	 g2->Add(fb);
	g1->Add(g2);
	
	aw->SetGroup(g1);
	aw->Create();	
	aw->BlockExcept();
	while (!ret)
	{
		int r=appwindow::NextEvent();
		switch(r)
		{
			case EV_WINDOWCLOSE:
				ret=3;
				break;
			case EV_GADGET:
				ret=aw->ID();
				break;
		}
	}
	switch (ret)
	{
		case 2: // all
			if(vismode)
			{
				for(int i=0;i<addresses.count();i++)
				{
					  char n[20];
					  xc_snprintf(n,sizeof(n),".a_%d",i);
					   checkbox *cb=(checkbox*)FindObject(FullName(),n);
					   cb->State(PRESSED);
				}
			}
			else
			{
				int j=0;
				listview *lv=(listview*)FindObject(FullName(),".addresses");
				for(int i=0;i<addresses.count();i++)
				{
					lv->MarkItem(++j);
				}
			}
		case 1: // selected
			if (vismode)
			{
				for(int i=0;i<addresses.count();i++)
				{
					char n[20];
					xc_snprintf(n,sizeof(n),".a_%d",i);
					checkbox *cb=(checkbox*)FindObject(FullName(),n);
					if (cb->State()==PRESSED)
					{
						nm->addCc(addresses[i],0);
					}
				}
			 }
			 else
			 {
			 	int j=0;
				listview *lv=(listview*)FindObject(FullName(),".addresses");
				for(int i=0;i<addresses.count();i++)
				{
					if (lv->IsMarked(++j))
					{
						nm->addCc(addresses[i],0);
					}
				}
			 }
			 break;
	}
	aw->UnblockExcept();
	aw->Close();
	DeleteObjectTree(aw->FullName());
	return ret;
}
void replylist::Text(char *t)
{
	otext=t;
}
void replylist::Addresses(mail *ml)
{
	char *b=new char[strlen(ml->to())+strlen(ml->cc())+2+strlen(ml->getTag("X-ReplyTo:"))+2];
	strcpy(b,ml->to());
	strcat(b,",");
	strcat(b,ml->cc());
	strcat(b,",");
	strcat(b,ml->getTag("X-ReplyTo:"));

	addresses.string(b);
	delete [] b;

	struct utsname nts;
	uname(&nts);
	char *u=getusername();
	char *n=new char[strlen(nts.nodename?nts.nodename:"")+2+strlen(u)];
	strcpy(n,u);
	strcat(n,"@");
	strcat(n,nts.nodename);

	for(int i=0;i<addresses.count();)
	{
		char *c=addresses[i];

		tokenizer tok1(c,"<"," >\t");

		if (tok1.count()>1)	// xxxxx <yyyyy>
		{
			addresses.set(i,tok1[1]);
		}
		else
		{
			tokenizer tok2(c,"("," )\t");
			addresses.set(i,tok2[0]);
		}
		char *addr=addresses[i];
		if (!*addr)
		{
			addresses.remove(i);
		}
		else if (!struhcmp(n,addr))
		{
			addresses.remove(i);
		}
		else if (!struhcmp(ml->from_email(),addr))
		{
			addresses.remove(i);
		}
		else if (!struhcmp(ml->replyto(),addr))
		{
			addresses.remove(i);
		}
		else if (programconfig.replyto[0] && !struhcmp(programconfig.replyto,addr))
		{
			addresses.remove(i);
		}
		else if (programconfig.authaddress[0] && !struhcmp(programconfig.authaddress,addr))
		{
			addresses.remove(i);
		}
		else if (programconfig.addresslist[0] && !strlistcmp(struhcmp,programconfig.addresslist,addr))
		{
			addresses.remove(i);
		}
		else
		{
			i++;
		}
	}
	delete [] n;
}
