/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: sendmail.cxx,v 2.34 2002/08/06 08:09:20 schmitzj Exp $ */


#include "configure.h"

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/stat.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/types.h>
#include <setjmp.h>
#include <signal.h>
#include <sys/time.h>

#include "mailer.h"
#include "sendmail.h"
#include "createmail.h"
#include "extraggs.h"
#include "npop3get.h"
#include "encoder.h"

#include <sys/utsname.h>

#ifdef HAVE_SIGLONGJMP
#	define SETJMP(x)	sigsetjmp(x,1)
#	define LONGJMP(x)	siglongjmp(x,1)
#elif defined(HAVE_setjmp)
#	define SETJMP(x)	setjmp(x)
#	define LONGJMP(x)	longjmp(x,1)
#endif

extern XCprogram myprg;
static void spstatus(char *t,int v=0);
static void spool_done(void);
static void anothermail(void);
static void closespoolstatuswin(void);

#define RTIMEOUT 20
#define STIMEOUT 30
static sigjmp_buf      jmpbuffer;

static void hmac_md5(unsigned char *text,int text_len,unsigned char* key,int key_len,unsigned char* digest);
class sendmail *currentsending=NULL;
static void getfile_timed_out(void)
{
    LONGJMP(jmpbuffer);
}
static char rbuf[201];
int sendmail::answer(char *buf,int maxsize)
{ // todo: read more than one line
	char *c=buf,cc=0;
	int r=0;
    if (SETJMP(jmpbuffer) != 0)
	{ //printf("ALARM\n");
		if (cc!='\n')
			r=-1;
	}
	else
	{
		int l=0;
		struct itimerval itv;
		do
		{
			signal(SIGALRM,(void (*)(int))getfile_timed_out);
			itv.it_value.tv_sec=(cc=='\n'?0:RTIMEOUT);
			itv.it_value.tv_usec=(cc=='\n'?5000:0);
			itv.it_interval.tv_sec=0;
			itv.it_interval.tv_usec=0;
			setitimer(ITIMER_REAL,&itv,NULL);
			itv.it_value.tv_sec=0;
			itv.it_value.tv_usec=0;
//			alarm(cc=='\n'?1:RTIMEOUT);

			r=recv(sockfd,&cc,1,0);
			setitimer(ITIMER_REAL,&itv,NULL);
//			alarm(0);
			if (r>0)
			{
				*c=cc;
				c++;
				l++;
				*c=0;
			}
		}
//		while (cc && cc!='\n' && l<maxsize);
		while (r>0 && l<maxsize);
	} // printf("R: %d, B: %s\n",r,buf);
	return r;
}
int sendmail::sendstring(char *b,int len)
{ // printf("Send: %s",b);
	int r=0;
	fcntl(sockfd,F_SETFL,O_NONBLOCK);

    if (SETJMP(jmpbuffer) != 0)
	{
		r=-1;
	}
	else
	{
		if (len==-1)
			len=strlen(b);
//		signal(SIGALRM,(void (*)(int))getfile_timed_out);
//		alarm(STIMEOUT);

//printf("%s",b);
		char *c1=b,*c2=b;
		int wasCR=0,i,j=0;
		for(i=0;i<len;i++)
		{
			if (*c1=='\n')
			{
				::send(sockfd,c2,j,0);
				if (!wasCR)
				{
					::send(sockfd,"\r\n",2,0);
				}
				else
				{
					::send(sockfd,"\n",1,0);
				}
				j=0;
				c2=c1+1;
				wasCR=0;
			}
			else if (*c1=='\r')
			{
				wasCR=1;
				j++;
			}
			else
				j++;
			c1++;
		}
		if (j>0)
		{
			::send(sockfd,c2,j,0);
		}		
//		::send(sockfd,b,len,0);
//		alarm(0);
	}
#ifdef O_FSYNC
// looks like this is required on freeBSD - hope this helps
	fcntl(sockfd,F_SETFL,O_FSYNC);
#else
	fcntl(sockfd,F_SETFL,O_SYNC); 
#endif
	return r;
}
int sendmail::RCPT(void)
{
	int r=1;
	if (!rcptfile)
	{
		char buf[strlen(mailfile)+6];
		char *c1=buf,*c2=buf;

		strcpy(buf,mailfile);
		strcat(buf,".rcpt");
		if (rcptfile=fopen(buf,"r"))
		{
			setvbuf(rcptfile,NULL,_IOFBF,2000);
		}
		else
			r=0;
	}
	if (rcptfile)
	{
		if (fgets(rbuf,sizeof(rbuf),rcptfile)>0)
		{
			int l=strlen(rbuf);
			if (l>0 && rbuf[l-1]=='\r') rbuf[l-1]=0;
			l=strlen(rbuf);
			if (l>0 && rbuf[l-1]=='\n') rbuf[l-1]=0;
			err=err || sendstring("RCPT TO: <");
			err=err || sendstring(rbuf);
			err=err || sendstring(">\r\n");
			char buf[100];
			xc_snprintf(buf,sizeof(buf),"RCPT: %s",rbuf);
			statusfunc(buf);
		}
		else
		{
			fclose(rcptfile);
			rcptfile=NULL;
			r=2;
		}
	}
	return r;
}
void sendmail::statusfunc(char *txt,int v)
{
	if (nm)
		nm->pstatus(txt);
	else
		spstatus(txt,v);
}
void sendmail::rmspool(void)
{
	remove(mailfile);

	char buf[strlen(mailfile)+6];
	strcpy(buf,mailfile);
	strcat(buf,".rcpt");
	remove(buf);
}
void sendmail::talkerror(char *t)
{
	if (sockfd)
	{
			gadget::RemoveFD(sockfd);
	}

	char buf[1000];
	autoeasy_dialog *ed=new autoeasy_dialog;
	if (t)
	{
		xc_snprintf(buf,sizeof(buf),"Error while talking to SMTP server:\n%s\n",t);
	}
	else
	{
		strcpy(buf,"Error while talking to SMTP server.\n");
	}
	ed->Text(buf);
	ed->Options("_Ignore & try again|_Remove this mail|_Abort transfer");
	ed->WaitMode();
	int res=ed->Start(aw);
	if (res==2) rmspool();
	if (res==3)
	{
		more=0;
		anyopen&=~AO_SENDING;
		closespoolstatuswin();
	}
}
void sendmail::writehandler(int fd)
{
// printf("writehandler %d\n",runmode);
	if (runmode==6 && f)
	{
		static int cc=0;
		char buf[300];
		int l;

		if ((l=fread(buf,1,sizeof(buf)-1,f))>0)
		{
			buf[l]=0;
			err=err || sendstring(buf,l);
		}
		sizedone+=l;
//		if (cc++>100)
		{
			statusfunc("Sending mail...",sizedone);
			cc=0;
		}
		if (l==0)
		{
			fclose(f);
			err=err || sendstring("\r\n.\r\n");
			cc=0;
			f=NULL;
		}
	}
}
void sendmail::readhandler(int fd)
{
// printf("readhandler %d\n",runmode);
	switch (runmode)
	{
		case 1:
			if (answer(rbuf,sizeof(rbuf))>0)
			{
				struct utsname nts;

				uname(&nts);
//				err=err || sendstring("HELO ");		// will be EHLO
				err=err || sendstring("EHLO ");
				err=err || sendstring(nts.nodename);
				err=err || sendstring("\r\n");
				runmode=2;
			}
			else
			{
				runmode=0;
				autoeasy_dialog *ed=new autoeasy_dialog;
				char buf[200];
				xc_snprintf(buf,sizeof(buf),"Can't talk to SMTP server\n'%s'!\n",programconfig.smtpsender);
				ed->Text(buf);
				ed->Start(aw);
			}
			break;
		case 2:
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				if (rbuf[0]!='2')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				}
				else
				{
					runmode=3;
					if (programconfig.use_smtp_auth)
					{
						tokenizer tk(rbuf,"\n","\n");
						for(int i=0;i<tk.count();i++)
						{
							char *c=tk[i];
							if (!strcncmp("250-AUTH",c))
							{
								tokenizer t2(c+9," \n\r"," \n\r");
								for(int j=0;j<t2.count();j++)
								{
									if (!strcscmp(t2[j],"PLAIN"))
										smtp_auth_can_plain=1;
									if (!strcscmp(t2[j],"LOGIN"))
										smtp_auth_can_login=1;
									if (!strcscmp(t2[j],"CRAM-MD5"))
										smtp_auth_can_crammd5=1;
								}
								if (smtp_auth_can_crammd5)
								{
									runmode=321;
									err=err || sendstring("AUTH CRAM-MD5\r\n");
								}
								else if (smtp_auth_can_login)
								{
									runmode=311;
									err=err || sendstring("AUTH LOGIN\r\n");
								}
								else if (smtp_auth_can_plain)
								{
									runmode=301;
									err=err || sendstring("AUTH PLAIN\r\n");
								}
								break;
							}
						}
					}
				}
			}

			if (runmode==3)
			{
				err=err || sendstring("MAIL FROM: <");
				err=err || sendstring(programconfig.authaddress);
				err=err || sendstring(">\r\n");
			}
			break;
		case 301: // smtp-auth: plain
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				if (rbuf[0]!='3' && rbuf[1]!='3' && rbuf[2]!='4')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				}
				runmode=302;
				err=err || sendstring(programconfig.smtp_auth_name);
				err=err || sendstring("\r\n");
				err=err || sendstring(programconfig.smtp_auth_pw);
				err=err || sendstring("\r\n");
			}
			break;
		case 302:
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				runmode=3;
				err=err || sendstring("MAIL FROM: <");
				err=err || sendstring(programconfig.authaddress);
				err=err || sendstring(">\r\n");
			}
			break;
		case 311: // smtp-auth: login
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				if (rbuf[0]!='3' && rbuf[1]!='3' && rbuf[2]!='4')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				}
				encoder *b64=prgencode->find("base64");
				int news;
				char *s=b64->data2mail(programconfig.smtp_auth_name,strlen(programconfig.smtp_auth_name),news,(char*)-1,(char*)1);
				runmode=312;
				err=err || sendstring(s);
				err=err || sendstring("\r\n");
				b64->dispose(s);
			}
			break;
		case 312:
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				if (rbuf[0]!='3' && rbuf[1]!='3' && rbuf[2]!='4')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				}
				char pass[sizeof(programconfig.smtp_auth_pw)*2],*pw;
				strdecodecpy(pass,programconfig.smtp_auth_pw);
				encoder *b64=prgencode->find("base64");
				int news;
				pw=strdup(pass);	// without this -> segfault!!!
				char *s=b64->data2mail(pw,strlen(pw),news,(char*)-1,(char*)1);
				runmode=313;
				err=err || sendstring(s);
				err=err || sendstring("\r\n");
				b64->dispose(s);
				free(pw);
			}
			break;
		case 313:
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				if (rbuf[0]!='2' && rbuf[1]!='3' && rbuf[2]!='5')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				}
				runmode=3;
				err=err || sendstring("MAIL FROM: <");
				err=err || sendstring(programconfig.authaddress);
				err=err || sendstring(">\r\n");
			}
			break;
		case 321: // smtp-auth: cram-md5
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				if (rbuf[0]!='3' && rbuf[1]!='3' && rbuf[2]!='4')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				} //printf("S: %s\n",rbuf);
				runmode=313;
				unsigned char digest[80];
				char sbuf[120],dbuf[16*2+1];
				char *serverdigest=rbuf+4;
				char pass[sizeof(programconfig.smtp_auth_pw)*2],*p;
				strdecodecpy(pass,programconfig.smtp_auth_pw);
				encoder *b64=prgencode->find("base64");
				int news;
				p=strdup(pass);
				char *s=b64->mail2data(serverdigest,strlen(serverdigest),news,NULL,NULL);
				s[news]=0;
				hmac_md5((unsigned char*)s,strlen(s),(unsigned char*)p,strlen(pass),(unsigned char*)&digest);
				free(p);
				p=dbuf;
				for(int i=0;i<16;i++)
				{
					sprintf(&dbuf[i*2],"%02hhx",digest[i]);
				}
				xc_snprintf(sbuf,sizeof(sbuf),"%s %s",programconfig.smtp_auth_name,dbuf);

				s=b64->data2mail(sbuf,strlen(sbuf),news,(char*)-1,(char*)1);
				err=err || sendstring(s);
				err=err || sendstring("\r\n");
			}
			break;
		case 3:
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
				break;
    		}
			else
			{
				if (rbuf[0]!='2')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				}
				else
					runmode=4;
			}
			switch (RCPT())
			{
				case 0: // error
					runmode=0;
					talkerror("No recipients file!");
					break;
				case 1: // next
					break;
				case 2: // last
					runmode=0;
					talkerror("No recipients specified!");
					break;
			}
			break;
		case 4:
    		if (answer(rbuf,sizeof(rbuf))<0 || rbuf[0]!='2')
    		{
				runmode=0;
				talkerror(rbuf);
    		}
			else
			{
				switch (RCPT())
				{
					case 1: // next
						break;
					case 2: // last
						err=err || sendstring("DATA\r\n");
	    				statusfunc("Going to send mail...");
						runmode=5;
						break;
				}
			}
			break;
		case 5:
    		if (answer(rbuf,sizeof(rbuf))<0)
    		{
				runmode=0;
				talkerror();
    		}
			else
			{
				if (rbuf[0]!='3')
				{
					runmode=0;
					talkerror(rbuf);
					break;
				}
				else
				{
					runmode=6;
					if (f=fopen(mailfile,"r"))
					{
						setvbuf(f,NULL,_IOFBF,2000);
			    		statusfunc("Sending mail...");
						gadget::AddWriteFD(sockfd,this,(FDHANDLER)&sendmail::writehandler);
					}
				}
			}
			break;
		case 6:
    		err=err || (answer(rbuf,sizeof(rbuf))<0);
			err=err || sendstring("QUIT\r\n");
			gadget::RemoveFD(sockfd);
			statusfunc("Mail sent.");
			if (sockfd) close(sockfd);
			sockfd=0;
			spool_done();
			rmspool();
			runmode=7;
			break;
	}
	if (err && runmode!=0 && runmode!=7)
	{
		talkerror("Timeout");
		runmode=0;
	}

	if (runmode==0)
	{
		if (sockfd)
		{
			gadget::RemoveFD(sockfd);
			close(sockfd);
		}
		sockfd=0;
	}

	if (runmode==7 || runmode==0)
	{
		if (more)
		{
			spooled--;
			anothermail();
		}
		ParentClass(&myprg);
		delete this;
	}
}
sendmail::sendmail(char *_mailfile,int _size,appwindow *_aw,class statusobj *_nm,int _more) : Xclasses("sendmail")
{
	f=NULL;
	sockfd=0;
	mailfile=strdup(_mailfile);
	aw=_aw;
	nm=_nm;
	more=_more?1:0;
	ParentClass(aw);
	sizetotal=_size;
	sizedone=0;
	err=0;
	rcptfile=NULL;
	smtp_auth_can_login=0;
	smtp_auth_can_plain=0;
	smtp_auth_can_crammd5=0;
}
sendmail::~sendmail()
{
	if (currentsending==this)
		currentsending=NULL;
	if (sockfd)
	{
		gadget::RemoveFD(sockfd);
		close(sockfd);
	}
	sockfd=0;
	if (rcptfile)
		fclose(rcptfile);
	rcptfile=NULL;
	if (mailfile) free(mailfile);
	mailfile=NULL;
}
int sendmail::send(void)
{
	int r=0;
	if (programconfig.smtpsenderon)
	{ // programconfig.smtpsender
		if (programconfig.authaddress[0])
		{
			struct hostent *host_info;

			statusfunc("Resolving hostname...");
    		readerwin.Update();

			char hostname[strlen(programconfig.smtpsender)+1];
			int portnum = 25;

			strcpy(hostname, programconfig.smtpsender);
			char *cP = strchr(hostname, ':');
			if (cP) {
				portnum = atol(cP+1);
				*cP = 0;
			}

			if (host_info=gethostbyname(hostname))
			{
				serv_addr.sin_family=host_info->h_addrtype;
				memcpy((char*)&serv_addr.sin_addr.s_addr,host_info->h_addr,host_info->h_length);
				serv_addr.sin_port=htons(portnum);
				for(int i=0;i<8;i++) serv_addr.sin_zero[i]=0;

				if (sockfd=socket(AF_INET,SOCK_STREAM,0))
				{
					cli_addr.sin_family=AF_INET;
					cli_addr.sin_addr.s_addr=htonl(INADDR_ANY);
					cli_addr.sin_port=htons(0);
					for(int i=0;i<8;i++) cli_addr.sin_zero[i]=0;
					if (bind(sockfd,(struct sockaddr*)&cli_addr,sizeof(cli_addr))==0)
					{
					    statusfunc("Connecting SMTP host...");
			    		readerwin.Update();
						if (connect(sockfd,(struct sockaddr*)&serv_addr,sizeof(serv_addr))>=0)
						{
					    	statusfunc("Connected.");
				    		readerwin.Update();
							runmode=1;
							gadget::AddReadFD(sockfd,this,(FDHANDLER)&sendmail::readhandler);
							r=2;
						}
						else
						{
							autoeasy_dialog *ed=new autoeasy_dialog;
							char buf[200];
							xc_snprintf(buf,sizeof(buf),"Can't connect SMTP server\n'%s'!\n",programconfig.smtpsender);
							ed->Text(buf);
							ed->Start(aw);
						}
					}
					else
					{
						autoeasy_dialog *ed=new autoeasy_dialog;
						ed->Text("Can't bind socket!\n");
						ed->Start(aw);
					}
				}
				else
				{
					autoeasy_dialog *ed=new autoeasy_dialog;
					ed->Text("Can't get socket!\n");
					ed->Start(aw);
				}
			}
			else
			{
				autoeasy_dialog *ed=new autoeasy_dialog;
				char buf[200];
				xc_snprintf(buf,sizeof(buf),"Unknown host '%s'\n",programconfig.smtpsender);
				ed->Text(buf);
				ed->Start(aw);
			}
		}
		else
		{
			autoeasy_dialog *ed=new autoeasy_dialog;
			char buf[200];
			xc_snprintf(buf,sizeof(buf),"You must specify your email address!\n");
			ed->Text(buf);
			ed->Start(aw);
		}
	}
	else
	{
	 	char com[300];
		xc_snprintf(com,sizeof(com),"("MAIL" <%s;rm %s)&",mailfile,mailfile);
		system(com);
	    pstatus("Mail sent.");
		char buf[strlen(mailfile)+6];
		strcpy(buf,mailfile);
		strcat(buf,".rcpt");
		remove(buf);
		if (more)
		{
			spooled--;
			anothermail();
		}
		r=1;
	}
	return r;
}

// -------------------------------------------------------------------

static void closespoolstatuswin(void);
static void ignoreme(appwindow *)
{
	if (currentsending)
	{
		delete currentsending;
		anyopen&=~AO_SENDING;
	}
	closespoolstatuswin();
}

static appwindow *spool_aw=NULL;
static listview  *spool_list=NULL;
static listview  *spool_donelist=NULL;
static indicator *spool_indi=NULL;
static char 	 spool_txtbuf[150]="";

static void spstatus(char *t,int v=0)
{
	if (spool_indi)
	{
		spool_indi->Value(v,t);
//	   	readerwin.Update();
	}
	else pstatus(t);
}

static void spool_done(void)
{
	if (spool_donelist)
	{
		spool_donelist->AddAtEnd(spool_txtbuf);
		spool_donelist->Top(spool_donelist->Count());
	}
}
static int spool_list_hook(struct hook_data *h)
{
	if (h->number==1)
		XSetBackground(h->drawable->display(),h->drawable->gg_gc(),h->drawable->col_markbackground());
	return 0;
}
static void makespoolstatuswin(int forceopen=0)
{
	if (spool_aw) return;

	if (!forceopen && programconfig.no_smtpstatewindow) return;

	int x,y,w,h;

	readerwin.Position(x,y);
	readerwin.Size(w,h);
	spool_aw=new appwindow;
	spool_aw->InitSize(x+w-50,y,w/3,h/2);
	if (!spool_aw->Init())
	{
		delete spool_aw;
		return;
	}
	spool_aw->Name("spoolstatuswindow");
	spool_aw->ParentClass(readerwin);
	spool_aw->TransientFor(readerwin);
	spool_aw->Adjust(x+w/3,y-10,w,h,ADJUST_RIGHT|ADJUST_BOTTOM);
	spool_aw->Title("Spool status");
	spool_aw->IconTitle("Spool status");

	spacegroup *sg=new spacegroup;
	sg->Name("maingroup");
	sg->Vert();
	sg->Border(4);
	sg->YDistance(4);
	 spool_donelist=new listview;
	 spool_donelist->Name("donespoolmails");
	 spool_donelist->ReadOnly();
	 spool_donelist->Font(FONT_SMALL);
	 spool_donelist->Weight(150);
	sg->Add(spool_donelist);
	 spool_list=new listview;
	 spool_list->Name("todospoolmails");
	 spool_list->ReadOnly();
	 spool_list->SetHook(spool_list_hook,NULL);
	 spool_list->Font(FONT_SMALL);
	 spool_list->Weight(150);
	sg->Add(spool_list);
	 spool_indi=new indicator;
	 spool_indi->Name("spoolindi");
	 spool_indi->Weight(5);
	sg->Add(spool_indi);

	spool_aw->SetGroup(sg);
	spool_aw->Callback(ignoreme);
	spool_aw->Create();
}
static void closespoolstatuswin(void)
{
	if (!spool_aw) return;
	spool_aw->Close();
	DeleteObjectTree(spool_aw->FullName());
	spool_aw=NULL;
	spool_list=NULL;
	spool_donelist=NULL;
	spool_indi=NULL;
}

static void anothermail(void)
{
	char *h=getenv("HOME");
	char tnam[150],buf[300];
	struct stat st;
	DIR *dfd;
	struct dirent *dptr;
	int l,r=0;
	
	xc_snprintf(tnam,sizeof(tnam),"%s/%s/%s/",h,HOMEMAIL,POPSPOOL);

	if (dfd=opendir(tnam))
	{
		class sendmail *s=NULL;
		if (spool_list) spool_list->RemoveAll();
		while ((dptr=readdir(dfd)) && r==0)
		{
			l=strlen(dptr->d_name);
			if (l>5 && !strcmp(&dptr->d_name[l-5],".rcpt"))
			{
				strcpy(buf,tnam);
				strcat(buf,dptr->d_name);
				buf[strlen(buf)-5]=0;
				if (!stat(buf,&st))
				{
					if (S_ISREG(st.st_mode))
					{
						char txtbuf[150];
						xc_snprintf(txtbuf,sizeof(txtbuf),"%s %d Bytes (%s)",s?"to send":"sending",st.st_size,dptr->d_name);
						if (spool_list) spool_list->AddAtEnd(txtbuf);
						if (!s)
						{
							s=new class sendmail(buf,st.st_size,&readerwin,NULL,1);
							xc_snprintf(spool_txtbuf,sizeof(spool_txtbuf),"sent %d Bytes (%s)",st.st_size,dptr->d_name);
							if (spool_indi) spool_indi->MaxValue(st.st_size);
						}
					}
				}
			}
		}
		closedir(dfd);
		if (s)
		{
			r=s->send();
			currentsending=s;
		}
	}
	if (!r)
	{
		pstatus("Spooled mail sent.");
		anyopen&=~AO_SENDING;
		closespoolstatuswin();
	}
}
void sendspooledNOW(void)
{
    pstatus("Sending spooled mail");
	anyopen|=AO_SENDING;
	anothermail();
}

void sendspooled(int forcewindow)
{
	if (!(anyopen & AO_SENDING))
	{
		if (programconfig.smtpafterpop3 && !programconfig.use_smtp_auth)
		{
			makespoolstatuswin(forcewindow);
		    pstatus("Waiting for POP3 authentification");
			smtpafterpop3();
			anyopen|=AO_SENDING;
		}
		else
		{
			makespoolstatuswin(forcewindow);
		    pstatus("Sending spooled mail");
			anyopen|=AO_SENDING;
			anothermail();
		}
	}
}

void checkspooled(void)
{
	char *h=getenv("HOME");
	char tnam[150],buf[300];
	struct stat st;
	DIR *dfd;
	struct dirent *dptr;
	int l;

	spooled=0;	
	xc_snprintf(tnam,sizeof(tnam),"%s/%s/%s/",h,HOMEMAIL,POPSPOOL);

	if (dfd=opendir(tnam))
	{
		while (dptr=readdir(dfd))
		{
			l=strlen(dptr->d_name);
			if (l>5 && !strcmp(&dptr->d_name[l-5],".rcpt"))
			{
				strcpy(buf,tnam);
				strcat(buf,dptr->d_name);
				stat(buf,&st);
				if (S_ISREG(st.st_mode))
				{
					spooled++;
				}
			}
		}
		closedir(dfd);
	}
}

/**********************************************************************/

/* $Id: sendmail.cxx,v 2.34 2002/08/06 08:09:20 schmitzj Exp $ */

/* POINTER defines a generic pointer type */
typedef unsigned char *POINTER;

/* UINT2 defines a two byte word */
typedef unsigned short int UINT2;

/* UINT4 defines a four byte word */
typedef unsigned long int UINT4;

/* MD5.H - header file for MD5C.C
 */

/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
rights reserved.
 
License to copy and use this software is granted provided that it
is identified as the "RSA Data Security, Inc. MD5 Message-Digest
Algorithm" in all material mentioning or referencing this software
or this function.
 
License is also granted to make and use derivative works provided
that such works are identified as "derived from the RSA Data
Security, Inc. MD5 Message-Digest Algorithm" in all material
mentioning or referencing the derived work.
 
RSA Data Security, Inc. makes no representations concerning either
the merchantability of this software or the suitability of this
software for any particular purpose. It is provided "as is"
without express or implied warranty of any kind.
These notices must be retained in any copies of any part of this
documentation and/or software.
 */

/* MD5 context. */
typedef struct
{
    UINT4 state[4];                                   /* state (ABCD) */
    UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
    unsigned char buffer[64];                         /* input buffer */
}
MD5_CTX;

static void MD5Init (MD5_CTX *);
static void MD5Update (MD5_CTX *, unsigned char *, unsigned int);
static void MD5Final (unsigned char [16], MD5_CTX *);

/* MD5C.C - RSA Data Security, Inc., MD5 message-digest algorithm
 */

/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
rights reserved.
 
License to copy and use this software is granted provided that it
is identified as the "RSA Data Security, Inc. MD5 Message-Digest
Algorithm" in all material mentioning or referencing this software
or this function.
 
License is also granted to make and use derivative works provided
that such works are identified as "derived from the RSA Data
Security, Inc. MD5 Message-Digest Algorithm" in all material
mentioning or referencing the derived work.
 
RSA Data Security, Inc. makes no representations concerning either
the merchantability of this software or the suitability of this
software for any particular purpose. It is provided "as is"
without express or implied warranty of any kind.
 
These notices must be retained in any copies of any part of this
documentation and/or software.
 */

/* Constants for MD5Transform routine.
 */

#define S11 7
#define S12 12
#define S13 17
#define S14 22
#define S21 5
#define S22 9
#define S23 14
#define S24 20
#define S31 4
#define S32 11
#define S33 16
#define S34 23
#define S41 6
#define S42 10
#define S43 15
#define S44 21

static void MD5Transform (UINT4 [4], unsigned char [64]);
static void Encode (unsigned char *, UINT4 *, unsigned int);
static void Decode (UINT4 *, unsigned char *, unsigned int);
static void MD5_memcpy (POINTER, POINTER, unsigned int);
static void MD5_memset (POINTER, int, unsigned int);

static unsigned char PADDING[64] = {
                                       0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
                                   };

/* F, G, H and I are basic MD5 functions.
 */
#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
#define G(x, y, z) (((x) & (z)) | ((y) & (~z)))
#define H(x, y, z) ((x) ^ (y) ^ (z))
#define I(x, y, z) ((y) ^ ((x) | (~z)))

/* ROTATE_LEFT rotates x left n bits.
 */
#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))

/* FF, GG, HH, and II transformations for rounds 1, 2, 3, and 4.
Rotation is separate from addition to prevent recomputation.
 */
#define FF(a, b, c, d, x, s, ac) { \
    (a) += F ((b), (c), (d)) + (x) + (UINT4)(ac); \
    (a) = ROTATE_LEFT ((a), (s)); \
    (a) += (b); \
}
#define GG(a, b, c, d, x, s, ac) { \
    (a) += G ((b), (c), (d)) + (x) + (UINT4)(ac); \
    (a) = ROTATE_LEFT ((a), (s)); \
    (a) += (b); \
}
#define HH(a, b, c, d, x, s, ac) { \
    (a) += H ((b), (c), (d)) + (x) + (UINT4)(ac); \
    (a) = ROTATE_LEFT ((a), (s)); \
    (a) += (b); \
}
#define II(a, b, c, d, x, s, ac) { \
    (a) += I ((b), (c), (d)) + (x) + (UINT4)(ac); \
    (a) = ROTATE_LEFT ((a), (s)); \
    (a) += (b); \
}

/* MD5 initialization. Begins an MD5 operation, writing a new context.
 */
void MD5Init (MD5_CTX *context)
{
    context->count[0] = context->count[1] = 0;
    /* Load magic initialization constants.
    */
    context->state[0] = 0x67452301;
    context->state[1] = 0xefcdab89;
    context->state[2] = 0x98badcfe;
    context->state[3] = 0x10325476;
}

/* MD5 block update operation. Continues an MD5 message-digest
  operation, processing another message block, and updating the
  context.
 */
void MD5Update (MD5_CTX *context,unsigned char *input,unsigned int inputLen)
{
    unsigned int i, index, partLen;

    /* Compute number of bytes mod 64 */
    index = (unsigned int)((context->count[0] >> 3) & 0x3F);

    /* Update number of bits */
    if ((context->count[0] += ((UINT4)inputLen << 3))
            < ((UINT4)inputLen << 3))
        context->count[1]++;
    context->count[1] += ((UINT4)inputLen >> 29);

    partLen = 64 - index;

    /* Transform as many times as possible.
    */
    if (inputLen >= partLen)
    {
        MD5_memcpy
        ((POINTER)&context->buffer[index], (POINTER)input, partLen);
        MD5Transform (context->state, context->buffer);

        for (i = partLen; i + 63 < inputLen; i += 64)
            MD5Transform (context->state, &input[i]);

        index = 0;
    }
    else
        i = 0;

    /* Buffer remaining input */
    MD5_memcpy
    ((POINTER)&context->buffer[index], (POINTER)&input[i],
     inputLen-i);
}

/* MD5 finalization. Ends an MD5 message-digest operation, writing the
  the message digest and zeroizing the context.
 */
void MD5Final (unsigned char digest[16],MD5_CTX *context)
{
    unsigned char bits[8];
    unsigned int index, padLen;

    /* Save number of bits */
    Encode (bits, context->count, 8);

    /* Pad out to 56 mod 64.
    */
    index = (unsigned int)((context->count[0] >> 3) & 0x3f);
    padLen = (index < 56) ? (56 - index) : (120 - index);
    MD5Update (context, PADDING, padLen);

    /* Append length (before padding) */
    MD5Update (context, bits, 8);

    /* Store state in digest */
    Encode (digest, context->state, 16);

    /* Zeroize sensitive information.
    */
    MD5_memset ((POINTER)context, 0, sizeof (*context));
}

/* MD5 basic transformation. Transforms state based on block.
 */
static void MD5Transform (UINT4 state[4],unsigned char block[64])
{
    UINT4 a = state[0], b = state[1], c = state[2], d = state[3], x[16];

    Decode (x, block, 64);

    /* Round 1 */
    FF (a, b, c, d, x[ 0], S11, 0xd76aa478); /* 1 */
    FF (d, a, b, c, x[ 1], S12, 0xe8c7b756); /* 2 */
    FF (c, d, a, b, x[ 2], S13, 0x242070db); /* 3 */
    FF (b, c, d, a, x[ 3], S14, 0xc1bdceee); /* 4 */
    FF (a, b, c, d, x[ 4], S11, 0xf57c0faf); /* 5 */
    FF (d, a, b, c, x[ 5], S12, 0x4787c62a); /* 6 */
    FF (c, d, a, b, x[ 6], S13, 0xa8304613); /* 7 */
    FF (b, c, d, a, x[ 7], S14, 0xfd469501); /* 8 */
    FF (a, b, c, d, x[ 8], S11, 0x698098d8); /* 9 */
    FF (d, a, b, c, x[ 9], S12, 0x8b44f7af); /* 10 */
    FF (c, d, a, b, x[10], S13, 0xffff5bb1); /* 11 */
    FF (b, c, d, a, x[11], S14, 0x895cd7be); /* 12 */
    FF (a, b, c, d, x[12], S11, 0x6b901122); /* 13 */
    FF (d, a, b, c, x[13], S12, 0xfd987193); /* 14 */
    FF (c, d, a, b, x[14], S13, 0xa679438e); /* 15 */
    FF (b, c, d, a, x[15], S14, 0x49b40821); /* 16 */

    /* Round 2 */
    GG (a, b, c, d, x[ 1], S21, 0xf61e2562); /* 17 */
    GG (d, a, b, c, x[ 6], S22, 0xc040b340); /* 18 */
    GG (c, d, a, b, x[11], S23, 0x265e5a51); /* 19 */
    GG (b, c, d, a, x[ 0], S24, 0xe9b6c7aa); /* 20 */
    GG (a, b, c, d, x[ 5], S21, 0xd62f105d); /* 21 */
    GG (d, a, b, c, x[10], S22,  0x2441453); /* 22 */
    GG (c, d, a, b, x[15], S23, 0xd8a1e681); /* 23 */
    GG (b, c, d, a, x[ 4], S24, 0xe7d3fbc8); /* 24 */
    GG (a, b, c, d, x[ 9], S21, 0x21e1cde6); /* 25 */
    GG (d, a, b, c, x[14], S22, 0xc33707d6); /* 26 */
    GG (c, d, a, b, x[ 3], S23, 0xf4d50d87); /* 27 */
    GG (b, c, d, a, x[ 8], S24, 0x455a14ed); /* 28 */
    GG (a, b, c, d, x[13], S21, 0xa9e3e905); /* 29 */
    GG (d, a, b, c, x[ 2], S22, 0xfcefa3f8); /* 30 */
    GG (c, d, a, b, x[ 7], S23, 0x676f02d9); /* 31 */
    GG (b, c, d, a, x[12], S24, 0x8d2a4c8a); /* 32 */

    /* Round 3 */
    HH (a, b, c, d, x[ 5], S31, 0xfffa3942); /* 33 */
    HH (d, a, b, c, x[ 8], S32, 0x8771f681); /* 34 */
    HH (c, d, a, b, x[11], S33, 0x6d9d6122); /* 35 */
    HH (b, c, d, a, x[14], S34, 0xfde5380c); /* 36 */
    HH (a, b, c, d, x[ 1], S31, 0xa4beea44); /* 37 */
    HH (d, a, b, c, x[ 4], S32, 0x4bdecfa9); /* 38 */
    HH (c, d, a, b, x[ 7], S33, 0xf6bb4b60); /* 39 */
    HH (b, c, d, a, x[10], S34, 0xbebfbc70); /* 40 */
    HH (a, b, c, d, x[13], S31, 0x289b7ec6); /* 41 */
    HH (d, a, b, c, x[ 0], S32, 0xeaa127fa); /* 42 */
    HH (c, d, a, b, x[ 3], S33, 0xd4ef3085); /* 43 */
    HH (b, c, d, a, x[ 6], S34,  0x4881d05); /* 44 */
    HH (a, b, c, d, x[ 9], S31, 0xd9d4d039); /* 45 */
    HH (d, a, b, c, x[12], S32, 0xe6db99e5); /* 46 */
    HH (c, d, a, b, x[15], S33, 0x1fa27cf8); /* 47 */
    HH (b, c, d, a, x[ 2], S34, 0xc4ac5665); /* 48 */

    /* Round 4 */
    II (a, b, c, d, x[ 0], S41, 0xf4292244); /* 49 */
    II (d, a, b, c, x[ 7], S42, 0x432aff97); /* 50 */
    II (c, d, a, b, x[14], S43, 0xab9423a7); /* 51 */
    II (b, c, d, a, x[ 5], S44, 0xfc93a039); /* 52 */
    II (a, b, c, d, x[12], S41, 0x655b59c3); /* 53 */
    II (d, a, b, c, x[ 3], S42, 0x8f0ccc92); /* 54 */
    II (c, d, a, b, x[10], S43, 0xffeff47d); /* 55 */
    II (b, c, d, a, x[ 1], S44, 0x85845dd1); /* 56 */
    II (a, b, c, d, x[ 8], S41, 0x6fa87e4f); /* 57 */
    II (d, a, b, c, x[15], S42, 0xfe2ce6e0); /* 58 */
    II (c, d, a, b, x[ 6], S43, 0xa3014314); /* 59 */
    II (b, c, d, a, x[13], S44, 0x4e0811a1); /* 60 */
    II (a, b, c, d, x[ 4], S41, 0xf7537e82); /* 61 */
    II (d, a, b, c, x[11], S42, 0xbd3af235); /* 62 */
    II (c, d, a, b, x[ 2], S43, 0x2ad7d2bb); /* 63 */
    II (b, c, d, a, x[ 9], S44, 0xeb86d391); /* 64 */

    state[0] += a;
    state[1] += b;
    state[2] += c;
    state[3] += d;

    /* Zeroize sensitive information.
    */
    MD5_memset ((POINTER)x, 0, sizeof (x));
}

/* Encodes input (UINT4) into output (unsigned char). Assumes len is
  a multiple of 4.
 */
static void Encode (unsigned char *output,UINT4 *input,unsigned int len)
{
    unsigned int i, j;

    for (i = 0, j = 0; j < len; i++, j += 4)
    {
        output[j] = (unsigned char)(input[i] & 0xff);
        output[j+1] = (unsigned char)((input[i] >> 8) & 0xff);
        output[j+2] = (unsigned char)((input[i] >> 16) & 0xff);
        output[j+3] = (unsigned char)((input[i] >> 24) & 0xff);
    }
}

/* Decodes input (unsigned char) into output (UINT4). Assumes len is
  a multiple of 4.
 */
static void Decode (UINT4 *output, unsigned char *input, unsigned int len)
{
    unsigned int i, j;

    for (i = 0, j = 0; j < len; i++, j += 4)
        output[i] = ((UINT4)input[j]) | (((UINT4)input[j+1]) << 8) |
                    (((UINT4)input[j+2]) << 16) | (((UINT4)input[j+3]) << 24);
}

/* Note: Replace "for loop" with standard memcpy if possible.
 */

static void MD5_memcpy (POINTER output, POINTER input, unsigned int len)
{
    unsigned int i;

    for (i = 0; i < len; i++)
        output[i] = input[i];
}

/* Note: Replace "for loop" with standard memset if possible.
 */
static void MD5_memset (POINTER output, int value, unsigned int len)
{
    unsigned int i;

    for (i = 0; i < len; i++)
        ((char *)output)[i] = (char)value;
}


/*
 *******************************************************************
*/

static void hmac_md5(unsigned char *text,int text_len,unsigned char* key,int key_len,unsigned char* digest)
/*
  text;                 pointer to data stream
  text_len;             length of data stream
  key;                  pointer to authentication key
  key_len;              length of authentication key
  digest;               caller digest to be filled in
*/
{
    MD5_CTX context;
    unsigned char k_ipad[65];    /* inner padding -
                                          * key XORd with ipad
                                          */
    unsigned char k_opad[65];    /* outer padding -
                                          * key XORd with opad
                                          */
    unsigned char tk[16];
    int i;
    /* if key is longer than 64 bytes reset it to key=MD5(key) */
    if (key_len > 64)
    {

        MD5_CTX      tctx;

        MD5Init(&tctx);
        MD5Update(&tctx, key, key_len);
        MD5Final(tk, &tctx);

        key = tk;
        key_len = 16;
    }

    /*
     * the HMAC_MD5 transform looks like:
     *
     * MD5(K XOR opad, MD5(K XOR ipad, text))
     *
     * where K is an n byte key
     * ipad is the byte 0x36 repeated 64 times
     * opad is the byte 0x5c repeated 64 times
     * and text is the data being protected
     */

    /* start out by storing key in pads */
    bzero( k_ipad, sizeof k_ipad);
    bzero( k_opad, sizeof k_opad);
    bcopy( key, k_ipad, key_len);
    bcopy( key, k_opad, key_len);

    /* XOR key with ipad and opad values */
    for (i=0; i<64; i++)
    {
        k_ipad[i] ^= 0x36;
        k_opad[i] ^= 0x5c;
    }
    /*
     * perform inner MD5
     */
    MD5Init(&context);                   /* init context for 1st
                                                  * pass */
    MD5Update(&context, k_ipad, 64);     /* start with inner pad */
    MD5Update(&context, text, text_len); /* then text of datagram */
    MD5Final(digest, &context);          /* finish up 1st pass */
    /*
     * perform outer MD5
     */
    MD5Init(&context);                   /* init context for 2nd
                                                  * pass */
    MD5Update(&context, k_opad, 64);     /* start with outer pad */
    MD5Update(&context, digest, 16);     /* then results of 1st
                                                  * hash */
    MD5Final(digest, &context);          /* finish up 2nd pass */
}


/*
 * SMTP-AUTH: (http://www.krkeegan.com/smtp_auth/)
 * C: ehlo ....
 * S: 250 AUTH=.....     ??? same but both used
 * S: 250 AUTH .....     ???
 *
 * C: auth cram-md5
 * S: 334 base64-string
 *    prgencode->find("base64") -> encoder -> str=mail2data(base64-string)
 *    hmac_md5(str,passwd,&digest)
 *    base64-string=data2mail(username+" "+digest)
 * C: digest
 * S: 235 -> OK!
 * S: 535 ?-> failure 
 *
 * C: auth plain
 * S: 334 Username:      <- line different or missing?
 * C: username
 * S: 334 Password:      <- line different or missing?
 * C: password
 * S: 235 -> OK!
 * S: 535 ?-> failure 
 *
 * C: auth login
 * S: 334 VXNlcm5hbWU6        ("Username" in base64)
 * C: username in base64
 * S: 334 UGFzc3dvcmQ6        ("Password" in base64)
 * C: password in base64
 * S: 235 -> OK!
 * S: 535 ?-> failure 
 *
 */
