/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: settings.cxx,v 2.86 2002/07/31 09:22:47 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/utsname.h>

#include "mailer.h"
#include "encoder.h"
#include "helper.h"
#include "address_book.h"
#include "maillist.h"
#include "xfacegg.h"
#include "license_dialog.h"
#include "pluginsmgr.h"
#include "filter_mgr.h"
#include "spellchecker.h"
#include "npop3get.h"
#include "folder.h"
#include "createmail.h"

prgcfg programconfig={
	1,						// autoquote
	1,						// quotesender
	4,  					// sortmode
	4,						// currentsortmode
	0,						// usepgp
	0,						// pgpmode
	0,						// outbox
	0,						// signdash
	0,						// opennewmailextras
	0,						// autotext
	2,						// newbeep
	"",						// beepcommand
	1,						// usetrash
	0,						// askmime
	0,						// askcompress
	0,						// transumlauts
	75,						// writelinelength
	0,						// autoreadnew
	WARNSIZE,				// folderwarnsize
	1,						// closeOnChangeFolder
	0,						// openNewMailDialog
	"lpr",					// printcom
	0,						// papersize
	"",						// outboxname
	".signature",			// signaturename
	"",						// reply-to
	"",						// defaultBCC
	"---Reply to mail from %n about %S",// replyopen
	"---End reply",						// replyclose
	"---Forward of mail from %n (%e)",	// forwardopen
	"---End forward",					// forwardclose
	"",						// organization
	"",						// xface
	"",						// popservers
	"localhost",			// smtpsender
	"",						// authname
	"",						// authaddress
	0,						// smtpsenderon
	1,						// smtpoutspool
	"",						// smtp_auth_name
	"",						// smtp_auth_pw
	0,						// use_smtp_auth
	0,						// popautocheck
	5,						// popcheckdelay
	0,						// popsendspooled
	0,						// popcheckatstart
	1,						// popcheckatstartdelayed
	1,						// helpline
	"pgp",					// pgpcommand
	"",						// pgpid
	"",						// pgppassphrase
	0,						// pgpleaveopen
	"english",				// spelllanguage
	"ispell",				// spellpath
	1,						// spellignoreurl
	1,						// spellignorespecials
	0,						// spellignoresig
	0,						// oneshowmail
	1,						// spellignorequoted
	0,						// rec_always
	0,						// rec_read
	0,						// rec_reply
	0,						// rec_forward
	0,						// rec_older
	7,						// rec_older_days
	"",						// xheader_name[0]
	"",						// xheader_name[1]
	"",						// xheader_name[2]
	"",						// xheader_name[3]
	"",						// xheader_name[4]
	"",						// xheader_name[5]
	"",						// xheader_value[0]
	"",						// xheader_value[1]
	"",						// xheader_value[2]
	"",						// xheader_value[3]
	"",						// xheader_value[4]
	"",						// xheader_value[5]
	0,						// xheader_mode[0]
	0,						// xheader_mode[1]
	0,						// xheader_mode[2]
	0,						// xheader_mode[3]
	0,						// xheader_mode[4]
	0,						// xheader_mode[5]
	1,						// reply_maillist
	1,						// reply_group
	0,						// addresscmp_dns
	"",						// addresslist
	"iso-8859-1",			// encoding8bit
	0,						// mailnewforXCmail
	0,						// mailnewfromPop3
	"",						// disabledPlugins
	0,						// autoupdatefolder
	30,						// autoupdatefolderdelay (min)
	0,						// outbox_noattachments
	0,						// vcard_enable
	1,						// longrecipient
	0,						// vcard_work_default
	0,						// no_pop3statewindow
	0,						// no_smtpstatewindow
	0,						// smtpafterpop3
	1,						// generate_autoabook
	0,						// no_mime_preamble
	0,						// vfolder_manager
	0,						// old_choose_folder
};

mimetype prgmime;
mailcap  prgcap;
encoding *prgencode=NULL;
helpers *prghelper=NULL;
char lastrelease[80]="0.0";
class AddressBook abook,abook_auto;
static int hasreceivedstartmail=0;
static int hasusedsetupwizard=0;

configopts cfg[]={
// alte Settingsnamen
{"B-O:popautocheck",(char*)&programconfig.popautocheck},
{"I-O:popcheckdelay",(char*)&programconfig.popcheckdelay},

{"B-O:popsenderon",(char*)&programconfig.smtpsenderon},
{"B-O:popoutspool",(char*)&programconfig.smtpoutspool},
{"T80-O:popsender",programconfig.smtpsender},
{"T80-O:popauthname",programconfig.authname},
{"T80-O:popauthaddress",programconfig.authaddress},

{"T80-O:pgpcommand",programconfig.pgpcommand},
{"T40-O:pgpid",programconfig.pgpid},
{"T250-O:pgppassphrase",programconfig.pgppassphrase},
{"B-O:pgpleaveopen",(char*)&programconfig.pgpleaveopen},

{"S64-O:spelllanguage",programconfig.spelllanguage},
{"S200-O:spellpath",programconfig.spellpath},
{"B-O:spellignoreurl",(char*)&programconfig.spellignoreurl},
{"B-O:spellignorespecials", (char*)&programconfig.spellignorespecials},
{"B-O:spellignoresig",(char*)&programconfig.spellignoresig},
{"B-O:spellignorequoted",(char*)&programconfig.spellignorequoted},

{"B-O:helpline",(char*)&programconfig.helpline},
{"B-O:oneshowmail",(char*)&programconfig.oneshowmail},

// ----

{"B:autoquote",(char*)&programconfig.autoquote},
{"B:quotesender",(char*)&programconfig.quotesender},
{"Enothing,sender,recipient,subject,senddate,revsenddate,newfirstrevsenddate,size,priority:sortby",(char*)&programconfig.sortmode},
{"B:usepgp",(char*)&programconfig.usepgp},
{"Enormal,sign,encrypt,both:pgpmode",(char*)&programconfig.pgpmode},
{"B:opennewmailextras",(char*)&programconfig.opennewmailextras},

{"B:outbox",(char*)&programconfig.outbox},
{"B:outboxnoattachments",(char*)&programconfig.outbox_noattachments},
{"B:signdash",(char*)&programconfig.signdash},
{"B:autotextbox",(char*)&programconfig.autotext},
{"B:usetrash",(char*)&programconfig.usetrash},
{"B:askmime",(char*)&programconfig.askmime},
{"B:askcompress",(char*)&programconfig.askcompress},
//{"B:autoreadnew",(char*)&programconfig.autoreadnew},
{"B:closeonchangefolder",(char*)&programconfig.closeOnChangeFolder},
{"B:opennewmaildialog",(char*)&programconfig.openNewMailDialog},
{"B:longrecipient",(char*)&programconfig.longrecipient},

{"Ecommand,one,two,sound:beepmode",(char*)&programconfig.newbeep},
{"T80:beepcommand",programconfig.beepcommand},

{"Equotedprintable,7bit,8bit:transferencoding",(char*)&programconfig.transumlauts},
{"I:writelinelength",(char*)&programconfig.writelinelength},
{"I:folderwarnsize",(char*)&programconfig.folderwarnsize},
{"B:vcard_enable",(char*)&programconfig.vcard_enable},
{"B:vcard_work_default",(char*)&programconfig.vcard_work_default},
{"B:no_mime_preamble",(char*)&programconfig.no_mime_preamble},

{"S80:printcom",programconfig.printcom},
{"EA4,letter,legal:papersize",(char*)&programconfig.papersize},

{"T"UNIQUE_ID_LEN_STR":outboxname",programconfig.outboxname},
{"T30:signaturename",programconfig.signaturename},

{"S50:replyopening",programconfig.replyopen},
{"S50:replyclosing",programconfig.replyclose},
{"S50:forwardopening",programconfig.forwardopen},
{"S50:forwardclosing",programconfig.forwardclose},
{"T350:xface",programconfig.xface},
{"T80:organization",programconfig.organization},
{"T50:replyto",programconfig.replyto},
{"T50:defaultbcc",programconfig.defaultBCC},
{"T20:encoding8bit",programconfig.encoding8bit},

{"T500:addresslist",programconfig.addresslist},
{"B:reply_maillist",(char*)&programconfig.reply_maillist},
{"B:reply_group",(char*)&programconfig.reply_group},
{"B:addresscmp_dns",(char*)&programconfig.addresscmp_dns},
{"B:generate_autoabook",(char*)&programconfig.generate_autoabook},

{"S19:release",lastrelease},
{"I:hasreceivedstartmail",(char*)&hasreceivedstartmail},
{"I:hasusedsetupwizzard",(char*)&hasusedsetupwizard},

//{"Eownfolder,openown,inbox:pop_default",(char*)&programconfig.popdefault},
//{"B:pop_useuidl",(char*)&programconfig.popuseuidl},
{"B:pop_autocheck",(char*)&programconfig.popautocheck},
{"I:pop_checkdelay",(char*)&programconfig.popcheckdelay},
{"B:pop_sendspooled",(char*)&programconfig.popsendspooled},
{"B:pop_nostatewindow",(char*)&programconfig.no_pop3statewindow},
{"B:pop_checkatstart",(char*)&programconfig.popcheckatstart},
{"B:pop_checkatstartdelayed",(char*)&programconfig.popcheckatstartdelayed},

{"T200:pop_servers",programconfig.popservers},

{"B:smtp_senderon",(char*)&programconfig.smtpsenderon},
{"B:smtp_outspool",(char*)&programconfig.smtpoutspool},
{"T80:smtp_sender",programconfig.smtpsender},
{"T80:smtp_authname",programconfig.authname},
{"T80:smtp_authaddress",programconfig.authaddress},
{"B:smtp_nostatewindow",(char*)&programconfig.no_smtpstatewindow},
{"B:smtp_smtpafterpop3",(char*)&programconfig.smtpafterpop3},
{"T80:smtp_auth_name",programconfig.smtp_auth_name},
{"T80:smtp_auth_pw",programconfig.smtp_auth_pw},
{"B:use_smtp_auth",(char*)&programconfig.use_smtp_auth},

{"T80:pgp_command",programconfig.pgpcommand},
{"T40:pgp_id",programconfig.pgpid},
{"T250:pgp_passphrase",programconfig.pgppassphrase},
{"B:pgp_leaveopen",(char*)&programconfig.pgpleaveopen},

{"S64:spell_language",programconfig.spelllanguage},
{"S200:spell_path",programconfig.spellpath},
{"B:spell_ignoreurl",(char*)&programconfig.spellignoreurl},
{"B:spell_ignorespecials", (char*)&programconfig.spellignorespecials},
{"B:spell_ignoresig",(char*)&programconfig.spellignoresig},
{"B:spell_ignorequoted",(char*)&programconfig.spellignorequoted},

{"B:misc_helpline",(char*)&programconfig.helpline},
{"B:misc_oneshowmail",(char*)&programconfig.oneshowmail},
{"B:misc_mailnewforXCmail",(char*)&programconfig.mailnewforXCmail},
{"B:misc_mailnewfromPop3",(char*)&programconfig.mailnewfromPop3},
{"B:misc_autoupdatefolder",(char*)&programconfig.autoupdatefolder},
{"I:misc_autoupdatefolderdelay",(char*)&programconfig.autoupdatefolderdelay},
{"T800:disabledPlugins",(char*)&programconfig.disabledPlugins},
{"B:misc_vfoldermanager",(char*)&programconfig.vfolder_manager},
{"B:misc_old_choose_folder",(char*)&programconfig.old_choose_folder},

{"B:rec_always",(char*)&programconfig.rec_always},
{"B:rec_read",(char*)&programconfig.rec_read},
{"B:rec_reply",(char*)&programconfig.rec_reply},
{"B:rec_forward",(char*)&programconfig.rec_forward},
{"B:rec_older",(char*)&programconfig.rec_older},
{"I:rec_older_days",(char*)&programconfig.rec_older_days},
{"T40:xheader_name0",(char*)&programconfig.xheader_name[0]},
{"T40:xheader_name1",(char*)&programconfig.xheader_name[1]},
{"T40:xheader_name2",(char*)&programconfig.xheader_name[2]},
{"T40:xheader_name3",(char*)&programconfig.xheader_name[3]},
{"T40:xheader_name4",(char*)&programconfig.xheader_name[4]},
{"T40:xheader_name5",(char*)&programconfig.xheader_name[5]},
{"T100:xheader_value0",(char*)&programconfig.xheader_value[0]},
{"T100:xheader_value1",(char*)&programconfig.xheader_value[1]},
{"T100:xheader_value2",(char*)&programconfig.xheader_value[2]},
{"T100:xheader_value3",(char*)&programconfig.xheader_value[3]},
{"T100:xheader_value4",(char*)&programconfig.xheader_value[4]},
{"T100:xheader_value5",(char*)&programconfig.xheader_value[5]},
{"Eon,off:xheader_mode0",(char*)&programconfig.xheader_mode[0]},
{"Eon,off:xheader_mode1",(char*)&programconfig.xheader_mode[1]},
{"Eon,off:xheader_mode2",(char*)&programconfig.xheader_mode[2]},
{"Eon,off:xheader_mode3",(char*)&programconfig.xheader_mode[3]},
{"Eon,off:xheader_mode4",(char*)&programconfig.xheader_mode[4]},
{"Eon,off:xheader_mode5",(char*)&programconfig.xheader_mode[5]},
{NULL,NULL},
};


static config cfg_file("~/."PROGRAMNAME"/settings");

void writeInternalMimeTypes(int m=0);	// 0: set, 1: set & save
void writeInternalMailCap(int m=0);		// 0: set, 1: set & save
void writeInternalEncoding(int m=0);	// 0: set, 1: set & save
void writeMimeTypes(void);
void writeMailCap(void);
void writeEncoding(void);
void readABook(void);
void readMimeTypes(void);
void readMailCap(void);
void readEncoding(void);


void programnews(void)
{
	license_dialog ld;
	ld.Text("<body bgcolor=#ffffff>\n"
			"<center>\n"
			"<h2>Welcome to "PROGRAMNAME" "VERSION" ("__DATE__")!</h2>"
			"The ultimate X11 Xclasses mailer.</center>"
#ifdef EXPIRE
			"<p align=center><i>This development release expires on "EXPIRE".</i></p>"
#endif
			"<h3>IF YOU DON'T ACCEPT THIS LICENSE AGREEMENT YOU MUST "
			"LEAVE THIS PROGRAM AT ONCE!</h3><p>"

			PROGRAMNAME" was made using Xclasses X11 layout library. "
			"The binaries of "PROGRAMNAME" "VERSION" may be copied and "
			"used free.<p>"
			"There is no warranty for any damage made by this program. "
			"If you plan to use "PROGRAMNAME" you may tell other users "
			"about this program so they might use it.<p>"
			"If you find some kind of bug you should tell it the authors "
			"with a reproducible error report. "

			"<p>This window will show you some more information about "PROGRAMNAME" like "
			"new idea behind it, the toolkits behind it and where to get "
			"more information on it.<p>\n"
#ifdef MAILLIST
			"Have a look at the Xclasses pull down menu and use "
			"the XCmail mailing list if you have questions or want to apply "
			"some ideas.<br>"
#endif
			"Mailing list is <b>'MAILLIST_TO'</b>, to subscribe write to "
			"<b>'"MAILLISTSUB_TO"'</b>, new releases of "PROGRAMNAME" will be "
			"announced in the <i>xcmail-announce</i> mailing list <b>'"ANNOUNCELIST_TO"'</b>, "
			"to subscribe write to <b>'"MAILLISTSUB_TO"'</b> - or simply have a look at "
			"the Xclasses pull pown menu. Subscribers of the xcmail list will automatically "
			"be part of xcmail-announce!<p>"

			"<h3>License:</h3>"
			"<ul>"
			"<li>"PROGRAMNAME" is published under the GNU GPL.\n"
			"</ul>"
			"<p>Usage tips may be found in the Xclasses pull down menu.\n"
			"<p>If you use "PROGRAMNAME" regularly you might want to add more features or "
			"help the other authors - look in the xcmail mailing list for this.\n"
			"<p>"
			"The endless quest for an useable GUI based mailer is over.... ;-)\n"
			"<p>\n"
			"</body>\n"
	);
	ld.Start(readerwin);
}
int checkExpire(appwindow *aw)
{
#ifdef EXPIRE
	time_t t;
	char buf[20];

	time(&t);
	strftime(buf,sizeof(buf)-1,"%Y%m%d",localtime(&t));

 	if (EXPIRE_DAY>atoi(buf))
 		return 1;
	else
	{
		easy_dialog ed;

		ed.Text("{FONT_BIG}Sorry, but this release of "PROGRAMNAME" "VERSION"\n"
				"has expired on "EXPIRE".{/FONT}\n\n"
				"Please check for a newer release at\n"
				"{FONT_FIXED}"HOMEPAGE"{/FONT}\n"
				"\n{FONT_BIG}All sendmail functions have been disabled!{/FONT}\n\n"
				"{FONT_SMALL}    This has been done to remove old (beta) releases with possible bugs and\n"
				"    to force people to use newer, better-working releases.\n"
				"    This expire function will be removed in later final releases and is only part\n"
				"    of pre-releases! Hope you understand this.\n{/FONT}"
				);
		ed.Options("_Ok");
		ed.Start(aw);

		return 0;
	}
#else
	return 1;
#endif
}
void readconfig(void)
{
	cfg_file.SetItems(cfg);
	if (cfg_file.Read())
	{
		char *h=getenv("HOME");
		if (h)
		{
			char buf[strlen("/."PROGRAMNAME)+strlen(h)+1];
			strcpy(buf,h);
			strcat(buf,"/."PROGRAMNAME);
			if (!mkdir(buf,S_IXUSR|S_IRUSR|S_IWUSR))
			{
				cfg_file.Write();
				writeInternalMimeTypes(1);
				writeInternalMailCap(1);
				writeInternalEncoding(1);
			}
		}
	}
	programconfig.currentsortmode=programconfig.sortmode;
	io_list_create();
}
void readmoreconfig(void)
{
	readMimeTypes();
	readMailCap();
	readEncoding();
	readABook();
	filtermaster.loadPrefs();
	readPop3Prefs();

	if (!prghelper) prghelper=new helpers;
	if (prghelper) prghelper->readconfigfiles();

	if (!prgplugins) prgplugins=new pluginmgr;
	if (prgplugins) prgplugins->readconfigfiles();
}
void addMail2Folder(vfolder *v,char *from,char *subject,char *txt)
{
	time_t tt;
	time(&tt);
	char *n=getusername();
	struct utsname nts;
	char tbuf[40];

	int tz_hour=0;
	int tz_min=0;
	int tz=int_timezone;
	char tzc[5]="+0";
	tzc[2]='\0';
	tz = -tz;

	if (int_daylight)		
		tz += 3600;

	tz = tz/60;
	tz_hour = tz / 60;
	tz_min = tz % 60;
	tz = tz_hour * 100;
	tz += tz_min;

	if(tz>=0)
		tzc[0]='+';
	else
		tzc[0]='-';

	if(abs(tz_hour) < 10)
	{
		tzc[1]='0';
		tzc[2]='\0';
	}
	else if(tz==0)
	{
		tzc[1]='0';
		tzc[2]='0';
		tzc[3]='0';
		tzc[4]='\0';
	}
	else
		tzc[1]='\0';

	uname(&nts);
	strftime(tbuf,sizeof(tbuf),"%a %b %d %H:%M:%S %Y ",localtime(&tt));

	char buf[10];
	xc_snprintf(buf,sizeof(buf),"%d",abs(tz));
	xcm_strbuf t;
	t+="From ";
	t+=n;
	t+="@";
	t+=nts.nodename;
	t+=" ";
	t+=tbuf;
	t+=" ";
	t+=tzc;
	t+=buf;
	t+="\n"
		"From: ";
	t+=from;
	t+="\n";
	t+="Reply-To: xcmail-dev@js-home.org\n"
		"Subject: ";
	t+=subject;
	t+="\n"
		"To: XCmail user\n"
		"Date: ";
	t+=tbuf;
	t+=" ";
	t+=tzc;
	t+=buf;
	t+="\n"
		"X-Face: \"FR\\wK{Zm?6>^!_ev=BONVJ2cJDp|5Sr;t9JO{l0R_Fa?yiFILBz&v#4-3unK#VI!^oFUSAN0(B?^-sY(-zb<P50s_pHiA/0qSKO\n"
		"X-Mailer: "PROGRAMNAME" "VERSION"\n"
		"X-Mailerorigin: "HOMEPAGE"\n"
		"X-XCmail-VisualBell: 1\n"
		"MIME-Version: 1.0\n"
		"Content-Type: text/plain; charset=iso-8859-1\n"
		"Content-Transfer-Encoding: 8bit\n"
		"\n";
	t+=txt;
	t+="\n\n\n";

	mail *m=new mail(strdup((char*)t));
	v->appendmail_default(m);
}
void welcome(void)
{
	if (strcmp(VERSION,lastrelease))
	{
		programnews();
		strcpy(lastrelease,VERSION);
		if (programconfig.outbox)
		{ // for updaters
			vfolder *v=folderlist->getfolder_byid(programconfig.outboxname);
			if (!v)
			{
				v=folderlist->getfolder(programconfig.outboxname);
				if (!v)
				{
					v=folderlist->getnextfolderoftype(NULL,RL_OUTBOXES);
					if (!v)
					{
						Alert(&readerwin,"Sorry, can't locate your outbox folder\nfrom your old settings.\nPlease check the Network & Send preferences window.");
					}
				}
				if (v)
				{
					strcpy(programconfig.outboxname,v->g_id());
				}
			}
		}
		int a=abook.getAddressByAlias("xcmail");
		if (a>0)
		{
			abook.setField(a,AddressBook::EMAIL,MAILLIST_TO);
		}
		cfg_file.Write();
		programconfig.helpline=1;
	}

	if (getenv("ALWAYSWIZARD")) // TODO: remove when finished
		hasusedsetupwizard=0;

	if (hasusedsetupwizard!=1)
	{
		run_setup_wizard();
		hasusedsetupwizard=1;
		writeconfig();
	}

	if (hasreceivedstartmail<=2)
	{
		vfolder *v=folderlist->getfolder(0,RL_INBOXES);
		if (v)
		{
			addMail2Folder(v,"XCmail development","Welcome to XCmail "VERSION,
				"Welcome to XCmail "VERSION"!\n\n"
				"With XCmail you got one of the most powerfull email client currently\n"
				"available for Unix and X Window Systems!\n\n"
				"It uses the Xclasses X11 layout library to give you as much comfort\n"
				"as possible for a graphical user interface.\n\n"
				"We, the XCmail developers, hope that you like and use this program\n"
				"and don't have any difficulties in using it. If you have and problems\n"
				"have a look at this nice animated texts above the button bar in the\n"
				"main window, consult the README, check the FAQ or subscribe to the\n"
				"XCmail mailing list at '"MAILLIST_TO"'. To subscribe write to\n"
				"'"MAILLISTSUB_TO"', place the text 'subscribe xcmail' in\n"
				"the body. Or look the XCmail homepage:\n"
				HOMEPAGE"\n\n"
				"To make the next releases of XCmail more usefull for you please\n"
				"answer the survey on the XCmail homepage:\n\n"
				HOMEPAGE"/survey\n\n"
				"If you work with XCmail you will find some more usefull functions,\n"
				"especially the 'Preferences' and 'Special' pull down menus have some\n"
				"nice features. Or press the right mouse button above the listed mails.\n\n"
				"If you don't know what a function stands for, move the mouse pointer\n"
				"above it, wait some seconds and you'll see a help text coming up.\n\n"
				"So we hope you like XCmail and tell your friends of it.\n\n\n"
				"Regards,\n\n"
				"  yours XCmail developers\n");

			addMail2Folder(v,"XCmail development","Folders and vFolders",
				"If you are new to XCmail you should keep this mail and maybe wait\n"
				"a few days until you read it! However, you can read it now - but\n"
				"keep it until you understand it...\n\n"
				"XCmail has a different concept of folder handling:\n\n"
				"Here is a part of the documentation which might help you, for\n"
				"more details read the documentation about the 'Folder manager'.\n\n"
				"XCmail has a new folder structure called virtual folders (or 'vfolders'). Only\n"
				"this vfolders are visible for a user. Vfolders may be aranged in different\n"
				"subdirectories for a better overview.\n"
				"\n"
				"Normally every vfolder belongs to one 'real' folder (eg. a file in your ~/Mail\n"
				"directory). However, a vfolder may have unlimited number of folders in it. This\n"
				"allows you to have one INBOX vfolder which includes all real inboxes (eg. in\n"
				"/var/spool/mail, your POP3 inbox and even a compressed inbox).\n"
				"\n"
				"Only vfolders have a folder type - like INBOX, Trash, Outbox, and so on.\n"
				"\n"
				"Real folders belong to so called 'IOs'. This IOs represent the access to\n"
				"directory, your /var/spool/mail inbox, compressed folders or in future an IMAP\n"
				"server.\n"
				"\n"
				"You can copy any folder from one IO to another - which could mean you compress\n"
				"a folder if you copy from ~/Mail IO to ~/Mail/ARCHIV IO.\n"
				"\n"
				"If you create a real folder a vfolder for this is automatically created - but\n"
				"not vice versa!\n"
				"\n"
				"Because of this IOs the vfolder concept was created - so you can hide\n"
				"different folders in different IOs and show and acces them in only one vfolder.\n"
				"\n"
				"");

			hasreceivedstartmail=3;
			cfg_file.Write();
		}
	}
}
void writeconfig(void)
{
	writePop3Prefs();
	cfg_file.Write();
	writeMimeTypes();
	writeMailCap();
	writeEncoding();
	prghelper->writeconfigfiles();
	prgplugins->writeconfigfiles();
	filtermaster.savePrefs();
	writeABook();
}
void writeMimeTypes(void)
{
	char *h=getenv("HOME");
	if (h)
	{
		FILE *f;
		char buf[strlen("/."PROGRAMNAME"/mime.types")+strlen(h)+1];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/mime.types");

		if (f=fopen(buf,"w"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgmime.save(f);
			fclose(f);
		}
	}
}
void writeMailCap(void)
{
	char *h=getenv("HOME");
	if (h)
	{
		FILE *f;
		char buf[strlen("/."PROGRAMNAME"/mailcap")+strlen(h)+1];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/mailcap");
		if (f=fopen(buf,"w"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgcap.save(f);
			fclose(f);
		}
	}
}
void writeEncoding(void)
{
	char *h=getenv("HOME");
	if (h)
	{
		FILE *f;
		char buf[strlen("/."PROGRAMNAME"/encoding")+strlen(h)+1];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/encoding");
		if (f=fopen(buf,"w"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgencode->save(f);
			fclose(f);
		}
	}
}
void writeABook(void)
{
	char *h=getenv("HOME");
	if (h)
	{
		FILE *f;
		char buf[strlen("/."PROGRAMNAME"/addressbook")+strlen(h)+1+5];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/addressbook");
		if (f=fopen(buf,"w"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			abook.save(f);
			fclose(f);
		}
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/addressbook_auto");
		if (f=fopen(buf,"w"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			abook_auto.save(f);
			fclose(f);
		}
	}
}
void readABook(void)
{
	abook.clearall();
	char *h=getenv("HOME");
	if (h)
	{
		FILE *f;
		char buf[strlen("/."PROGRAMNAME"/addressbook")+strlen(h)+1+5];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/addressbook");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			abook.load(f);
			fclose(f);
		}
		else
		{
			int n=abook.new_entry();
			n=abook.setField(n,AddressBook::ALIAS,"xcmail");
			n=abook.setField(n,AddressBook::LASTNAME,"XCmail mailinglist");
			n=abook.setField(n,AddressBook::EMAIL,MAILLIST_TO);
			n=abook.setField(n,AddressBook::QUICKMENU,1);
			n=abook.setField(n,AddressBook::NOTE,"The XCmail mailing list.\n\nIf you have questions, ideas, answers...");
			n=abook.setField(n,AddressBook::FIXEDALIAS,"1");
		}
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/addressbook_auto");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			abook_auto.load(f);
			fclose(f);
		}
	}
}
void readMimeTypes(void)
{
	char *h=getenv("HOME");

	writeInternalMimeTypes();
	{
		FILE *f;
		char buf[strlen("/etc/mime.types")+1];
		strcpy(buf,"/etc/mime.types");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgmime.load(f);
			fclose(f);
		}
	}
	{
		FILE *f;
		char buf[strlen(GLOBALCFGDIR)+strlen("/mime.types")+1];
		strcpy(buf,GLOBALCFGDIR);
		strcat(buf,"/mime.types");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgmime.load(f);
			fclose(f);
		}
	}
	if (h)
	{
		FILE *f;

		{
			char buf[strlen("/.mime.types")+strlen(h)+1];
			strcpy(buf,h);
			strcat(buf,"/.mime.types");
			if (f=fopen(buf,"r"))
			{
				setvbuf(f,NULL,_IOFBF,2000);
				prgmime.load(f);
				fclose(f);
			}
		}

		char buf[strlen("/."PROGRAMNAME"/mime.types")+strlen(h)+1];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/mime.types");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgmime.load(f);
			fclose(f);
		}
		else
			writeInternalMimeTypes(1);
		if (prgmime.Count()==0) writeInternalMimeTypes(1);
	}
}
void readMailCap(void)
{
	char *h=getenv("HOME");

	writeInternalMailCap();
	{
		FILE *f;
		char buf[strlen(GLOBALCFGDIR)+strlen("/mailcap")+1];
		strcpy(buf,GLOBALCFGDIR);
		strcat(buf,"/mailcap");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgcap.load(f);
			fclose(f);
		}
	}
	if (h)
	{
		FILE *f;
		char buf[strlen("/."PROGRAMNAME"/mailcap")+strlen(h)+1];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/mailcap");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgcap.load(f);
			fclose(f);
		}
		else
			writeInternalMailCap(1);
		if (prgcap.Count()==0) writeInternalMailCap(1);
	}
}
void readEncoding(void)
{
	char *h=getenv("HOME");

	writeInternalEncoding();
	{
		FILE *f;
		char buf[strlen(GLOBALCFGDIR)+strlen("/encoding")+1];
		strcpy(buf,GLOBALCFGDIR);
		strcat(buf,"/encoding");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgencode->load(f);
			fclose(f);
		}
	}
	if (h)
	{
		FILE *f;
		char buf[strlen("/."PROGRAMNAME"/encoding")+strlen(h)+1];
		strcpy(buf,h);
		strcat(buf,"/."PROGRAMNAME"/encoding");
		if (f=fopen(buf,"r"))
		{
			setvbuf(f,NULL,_IOFBF,2000);
			prgencode->load(f);
			fclose(f);
		}
		else
			writeInternalEncoding(1);
		if (prgencode->Count()==0) writeInternalEncoding(1);
	}
}

//--------------------------------------------------------------------
void writeInternalMimeTypes(int m)
{
	prgmime.clear();
	prgmime.add("application","activemessage","");
	prgmime.add("application","andrew-inset","");
	prgmime.add("application","applefile","");
	prgmime.add("application","atomicmail","");
	prgmime.add("application","dca-rft","");
	prgmime.add("application","dec-dx","");
	prgmime.add("application","mac-binhex40","hqx");
	prgmime.add("application","mac-compactpro","cpt");
	prgmime.add("application","macwriteii","");
	prgmime.add("application","msword","doc");
	prgmime.add("application","news-message-id","");
	prgmime.add("application","news-transmission","");
	prgmime.add("application","octet-stream","bin dms lha lzh exe class");
	prgmime.add("application","oda","oda");
	prgmime.add("application","pdf","pdf");
	prgmime.add("application","postscript","ai eps ps");
	prgmime.add("application","powerpoint","ppt");
	prgmime.add("application","remote-printing","");
	prgmime.add("application","rtf","rtf");
	prgmime.add("application","slate","");
	prgmime.add("application","wita","");
	prgmime.add("application","wordperfect5.1","");
	prgmime.add("application","x-bcpio","bcpio");
	prgmime.add("application","x-cdlink","vcd");
	prgmime.add("application","x-compress","");
	prgmime.add("application","x-cpio","cpio");
	prgmime.add("application","x-csh","csh");
	prgmime.add("application","x-director","dcr dir dxr");
	prgmime.add("application","x-dvi","dvi");
	prgmime.add("application","x-gtar","gtar");
	prgmime.add("application","x-gzip","");
	prgmime.add("application","x-hdf","hdf");
	prgmime.add("application","x-koan","skp skd skt skm");
	prgmime.add("application","x-latex","latex");
	prgmime.add("application","x-mif","mif");
	prgmime.add("application","x-netcdf","nc cdf");
	prgmime.add("application","x-sh","sh");
	prgmime.add("application","x-shar","shar");
	prgmime.add("application","x-stuffit","sit");
	prgmime.add("application","x-sv4cpio","sv4cpio");
	prgmime.add("application","x-sv4crc","sv4crc");
	prgmime.add("application","x-tar","tar");
	prgmime.add("application","x-tcl","tcl");
	prgmime.add("application","x-tex","tex");
	prgmime.add("application","x-texinfo","texinfo texi");
	prgmime.add("application","x-troff","t tr roff");
	prgmime.add("application","x-troff-man","man");
	prgmime.add("application","x-troff-me","me");
	prgmime.add("application","x-troff-ms","ms");
	prgmime.add("application","x-ustar","ustar");
	prgmime.add("application","x-wais-source","src");
	prgmime.add("application","zip","zip");
	prgmime.add("audio","basic","au snd");
	prgmime.add("audio","midi","mid midi kar");
	prgmime.add("audio","mpeg","mpga mp2 mp3");
	prgmime.add("audio","x-aiff","aif aiff aifc");
	prgmime.add("audio","x-pn-realaudio","ram");
	prgmime.add("audio","x-pn-realaudio-plugin","rpm");
	prgmime.add("audio","x-realaudio","ra");
	prgmime.add("audio","x-wav","wav");
	prgmime.add("chemical","x-pdb","pdb xyz");
	prgmime.add("image","gif","gif GIF");
	prgmime.add("image","ief","ief");
	prgmime.add("image","jpeg","jpeg jpg jpe JPG");
	prgmime.add("image","png","png PNG");
	prgmime.add("image","tiff","tiff tif TIF");
	prgmime.add("image","x-cmu-raster","ras");
	prgmime.add("image","x-portable-anymap","pnm");
	prgmime.add("image","x-portable-bitmap","pbm");
	prgmime.add("image","x-portable-graymap","pgm");
	prgmime.add("image","x-portable-pixmap","ppm");
	prgmime.add("image","x-rgb","rgb");
	prgmime.add("image","x-xbitmap","xbm");
	prgmime.add("image","x-xpixmap","xpm");
	prgmime.add("image","x-xwindowdump","xwd");
	prgmime.add("message","external-body","");
	prgmime.add("message","news","");
	prgmime.add("message","partial","");
	prgmime.add("message","rfc822","");
	prgmime.add("multipart","alternative","");
	prgmime.add("multipart","appledouble","");
	prgmime.add("multipart","digest","");
	prgmime.add("multipart","mixed","");
	prgmime.add("multipart","parallel","");
	prgmime.add("text","html","html htm");
	prgmime.add("text","plain","txt asc");
	prgmime.add("text","richtext","rtx");
	prgmime.add("text","tab-separated-values","tsv");
	prgmime.add("text","x-setext","etx");
	prgmime.add("text","x-sgml","sgml sgm");
	prgmime.add("video","mpeg","mpeg mpg mpe");
	prgmime.add("video","quicktime","qt mov");
	prgmime.add("video","x-msvideo","avi");
	prgmime.add("video","x-sgi-movie","movie");
	prgmime.add("x-conference","x-cooltalk","ice");
	prgmime.add("x-world","x-vrml","wrl vrml");

	if (m) writeMimeTypes();
}
void writeInternalMailCap(int m)
{
	prgcap.clear();
	prgcap.add("text","*","PREVIEW url");
	prgcap.add("text","html","PREVIEW html");
	prgcap.add("text","plain","PREVIEW url");
	prgcap.add("text","enriched","PREVIEW enriched");
	prgcap.add("text","x-vcard","PREVIEW vcard");
	prgcap.add("text","x-xcmail-pop3size","PREVIEW pop3size");
	prgcap.add("*","octet-stream","SAVE");
	prgcap.add("application","pdf","COMMAND acroread %s");
	prgcap.add("image","gif","COMMAND xv %s");
	prgcap.add("image","jpeg","COMMAND xv %s");
	prgcap.add("image","pjpeg","COMMAND xv %s");
	prgcap.add("image","tiff","COMMAND xv %s");
	prgcap.add("image","png","COMMAND xv %s");
	prgcap.add("image","bmp","COMMAND xv %s");
	prgcap.add("image","x-portable-anymap","COMMAND xv %s");
	prgcap.add("image","x-portable-bitmap","COMMAND xv %s");
	prgcap.add("image","x-portable-graymap","COMMAND xv %s");
	prgcap.add("image","x-portable-pixmap","COMMAND xv %s");
	prgcap.add("image","x-rgb","COMMAND xv %s");
	prgcap.add("image","x-xbitmap","COMMAND xv %s");
	prgcap.add("image","x-xpixmap","COMMAND xv %s");
	prgcap.add("message","*","PREVIEW url");
	prgcap.add("*","*","SAVE");
	if (m) writeMailCap();
}
void writeInternalEncoding(int m)
{
	if (!prgencode) prgencode=new encoding;
//	prgencode->add("uuencode","\"uuencode %s dummy\" \"uudecode %s\"");
	if (m) writeEncoding();
}

void sendWelcomeTestMail(void)
{
	createmail cm;
	cm.to("welcomexcmail@js-home.org");
	cm.subject("Test of "PROGRAMNAME" "VERSION" ("XC_UNAME")");

	cm.body("This is an automatic testmail of XCmail.\n");
	cm.send();
}
