/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: settings_general.cxx,v 2.6 2002/09/23 09:37:13 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/utsname.h>

#include "mailer.h"
#include "encoder.h"
#include "helper.h"
#include "address_book.h"
#include "maillist.h"
#include "xfacegg.h"
#include "license_dialog.h"
#include "pluginsmgr.h"
#include "filter_mgr.h"
#include "spellchecker.h"
#include "npop3get.h"
#include "folder.h"


//--------------------------------------------------------------------
// general prefs
static char *space2nl(char *t)
{
	static char buf[510];
	char *c1=buf,*c2=t;
	while (*c2)
	{
		if (*c2==' ' || *c2==',')
		{
			if (*(c2+1)!=' ' && *(c2+1)!=',')
			{
				*c1='\n';
				c1++;
			}
		}
		else
		{
			*c1=*c2;
			c1++;
		}
		c2++;
	}
	*c1=0;
	return buf;
}
static char *nl2space(char *t)
{
	static char buf[510];
	char *c1=buf,*c2=t;
	while (*c2)
	{
		if (*c2=='\n')
		{
			if (*(c2+1)!='\n' && *(c2+1)!=0)
			{
				*c1=',';
				c1++;
			}
		}
		else
		{
			*c1=*c2;
			c1++;
		}
		c2++;
	}
	*c1=0;
	return buf;
}
static void genprefs_close(void)
{
	appwindow *aw=(appwindow*)FindObject(".mainwindow.generalprefs");
	aw->Close();
	DeleteObjectTree(aw->FullName(),0);
}
// use button
static char xfacebuf[sizeof(programconfig.xface)+1];
static void genprefs_use(void)
{
	char buf[100];

// compose
	programconfig.signdash=((checkbox*)FindObject(".configcard.signdash"))->State()==PRESSED?1:0;
	programconfig.askmime=((checkbox*)FindObject(".configcard.askmime"))->State()==PRESSED?1:0;
//	programconfig.askcompress=((checkbox*)FindObject(".configcard.askcompress"))->State()==PRESSED?1:0;
	programconfig.reply_maillist=((checkbox*)FindObject(".configcard.reply_maillist"))->State()==PRESSED?1:0;
	programconfig.reply_group=((checkbox*)FindObject(".configcard.reply_group"))->State()==PRESSED?1:0;
	programconfig.opennewmailextras=((checkbox*)FindObject(".configcard.opennewmailextras"))->State()==PRESSED?1:0;
	programconfig.longrecipient=((checkbox*)FindObject(".configcard.longrecipient"))->State()==PRESSED?1:0;
	programconfig.autoquote=((checkbox*)FindObject(".configcard.autoquote"))->State()==PRESSED?1:0;
	programconfig.quotesender=((checkbox*)FindObject(".configcard.quotesender"))->State()==PRESSED?1:0;

	programconfig.writelinelength=((slider*)FindObject(".configcard.writelinelength"))->Value();
	((input*)FindObject(".configcard.signaturename"))->Input(programconfig.signaturename);

	int size=((textbox*)FindObject(".configcard.addresslist"))->TextSize()+1;
	if (size>sizeof(programconfig.addresslist)) size=sizeof(programconfig.addresslist);
	((textbox*)FindObject(".configcard.addresslist"))->CopyText(programconfig.addresslist,size);
	strcpy(programconfig.addresslist,nl2space(programconfig.addresslist));

	((input*)FindObject(".configcard.defaultBCC"))->Input(programconfig.defaultBCC);

	((input*)FindObject(".configcard.openings.oreply"))->Input(programconfig.replyopen);
	((input*)FindObject(".configcard.openings.creply"))->Input(programconfig.replyclose);
	((input*)FindObject(".configcard.openings.oforward"))->Input(programconfig.forwardopen);
	((input*)FindObject(".configcard.openings.cforward"))->Input(programconfig.forwardclose);

// send
// 	programconfig.outbox=((checkbox*)FindObject(".configcard.outbox"))->State()==PRESSED?1:0;
// 	strncpy(programconfig.outboxname,
// 		folderlist->getfolder(((choice*)FindObject(".configcard.outboxname"))->Selected(),RL_OUTBOXES,1)->g_id(),
// 		sizeof(programconfig.outboxname));
//	programconfig.folderwarnsize=((slider*)FindObject(".configcard.folderwarnsize"))->Value();
//	if (programconfig.folderwarnsize<100) programconfig.folderwarnsize=0;
//	programconfig.folderwarnsize*=1024;
//	programconfig.outbox_noattachments=((checkbox*)FindObject(".configcard.outbox_noattachments"))->State()==PRESSED?1:0;
	programconfig.no_mime_preamble=((checkbox*)FindObject(".configcard.no_mime_preamble"))->State()==PRESSED?1:0;
// outbox & outbox_noattachments will move to settings_net

	programconfig.vcard_enable=((checkbox*)FindObject(".configcard.vcard_enable"))->State()==PRESSED?1:0;
	programconfig.vcard_work_default=((checkbox*)FindObject(".configcard.vcard_work_default"))->State()==PRESSED?1:0;

//	((input*)FindObject(".configcard.replyto"))->Input(programconfig.replyto);
//	programconfig.transumlauts=((mxknob*)FindObject(".configcard.transumlauts"))->Selected();
// replyto & transumlauts will move to settings_net

	strcpy(programconfig.xface,xfacebuf);

// header
	((input*)FindObject(".configcard.organization"))->Input(programconfig.organization);

	 for(int xhi=0;xhi<XHEADERCOUNT;xhi++)
	 {
		xc_snprintf(buf,sizeof(buf),".configcard.xheader_%d.name",xhi);
		((input*)FindObject(buf))->Input(programconfig.xheader_name[xhi]);
		char *c=programconfig.xheader_name[xhi];
		while (*c)
		{
			if (*c==' ') *c='_';
			c++;
		}
		xc_snprintf(buf,sizeof(buf),".configcard.xheader_%d.value",xhi);
		((input*)FindObject(buf))->Input(programconfig.xheader_value[xhi]);
		xc_snprintf(buf,sizeof(buf),".configcard.xheader_%d.mode",xhi);
		programconfig.xheader_mode[xhi]=((choice*)FindObject(buf))->Selected();
	 }

// read & print
	programconfig.autotext=((checkbox*)FindObject(".configcard.autotext"))->State()==PRESSED?1:0;
	programconfig.oneshowmail=((checkbox*)FindObject(".configcard.oneshowmail"))->State()==PRESSED?1:0;
	((fileinput*)FindObject(".configcard.printcom"))->GetFile(programconfig.printcom,sizeof(programconfig.printcom));
	programconfig.papersize=((choice*)FindObject(".configcard.papersize"))->Selected();

// misc
	programconfig.newbeep=((choice*)FindObject(".configcard.misc.newbeep"))->Selected();
	((fileinput*)FindObject(".configcard.misc.beepcommand"))->GetFile(programconfig.beepcommand,sizeof(programconfig.beepcommand));

	programconfig.usetrash=((checkbox*)FindObject(".configcard.misc.usetrash"))->State()==PRESSED?1:0;
//	programconfig.autoreadnew=((checkbox*)FindObject(".configcard.misc.autoreadnew"))->State()==PRESSED?1:0;
	programconfig.openNewMailDialog=((checkbox*)FindObject(".configcard.misc.opennewmaildialog"))->State()==PRESSED?1:0;
	programconfig.addresscmp_dns=((checkbox*)FindObject(".configcard.misc.addresscmp_dns"))->State()==PRESSED?1:0;
	programconfig.closeOnChangeFolder=((checkbox*)FindObject(".configcard.misc.closeOnChangeFolder"))->State()==PRESSED?1:0;
	programconfig.mailnewforXCmail=((checkbox*)FindObject(".configcard.misc.mailnewforXCmail"))->State()==PRESSED?1:0;
	programconfig.mailnewfromPop3=((checkbox*)FindObject(".configcard.misc.mailnewfromPop3"))->State()==PRESSED?1:0;
	programconfig.generate_autoabook=((checkbox*)FindObject(".configcard.misc.generate_autoabook"))->State()==PRESSED?1:0;
	programconfig.vfolder_manager=((checkbox*)FindObject(".configcard.misc.vfolder_manager"))->State()==PRESSED?1:0;

	programconfig.rec_always=((checkbox*)FindObject(".configcard.misc.rec_always"))->State()==PRESSED?1:0;
	programconfig.rec_read=((checkbox*)FindObject(".configcard.misc.rec_read"))->State()==PRESSED?1:0;
	programconfig.rec_reply=((checkbox*)FindObject(".configcard.misc.rec_reply"))->State()==PRESSED?1:0;
	programconfig.rec_forward=((checkbox*)FindObject(".configcard.misc.rec_forward"))->State()==PRESSED?1:0;
	programconfig.rec_older=((checkbox*)FindObject(".configcard.misc.rec_older"))->State()==PRESSED?1:0;
	((input*)FindObject(".configcard.misc.rec_older_days"))->Input(buf);
	programconfig.rec_older_days=atoi(buf);


#ifdef USEPGP
// PGP
	((fileinput*)FindObject(".configcard.pgp.command"))->GetFile(programconfig.pgpcommand,sizeof(programconfig.pgpcommand));
	((input*)FindObject(".configcard.pgp.id"))->Input(programconfig.pgpid);
	char pdummy[40];
	((input*)FindObject(".configcard.pgp.passphrase"))->Input(pdummy);
	strencodecpy(programconfig.pgppassphrase,pdummy);

	programconfig.pgpleaveopen=((checkbox*)FindObject(".configcard.pgp.pgpleaveopen"))->State()==PRESSED?1:0;
#endif

// speller
	((fileinput*)FindObject(".speller.path"))->GetFile(programconfig.spellpath, sizeof(programconfig.spellpath));
	((input*)FindObject(".speller.language"))->Input(programconfig.spelllanguage);
	programconfig.spellignoreurl=((checkbox*)FindObject(".speller.ignoreurl"))->State()==PRESSED?1:0;
	programconfig.spellignorespecials=((checkbox*)FindObject(".speller.ignorespecials"))->State()==PRESSED?1:0;
	programconfig.spellignoresig=((checkbox*)FindObject(".speller.ignoresig"))->State()==PRESSED?1:0;
	programconfig.spellignorequoted=((checkbox*)FindObject(".speller.ignorequoted"))->State()==PRESSED?1:0;

	genprefs_close();

	writeconfig();
}
// misc / received folder (un)lock gadgets
static void genprefs_rec_locker(gadget *g,int i)
{
	if (!strcmp(g->Name(),"rec_always"))
	{
		if (((checkbox*)g)->State()==PRESSED)
		{
			((input*)FindObject(".configcard.misc.rec_older_days"))->Lock();
			((checkbox*)FindObject(".configcard.misc.rec_read"))->Lock();
			((checkbox*)FindObject(".configcard.misc.rec_reply"))->Lock();
			((checkbox*)FindObject(".configcard.misc.rec_forward"))->Lock();
			((checkbox*)FindObject(".configcard.misc.rec_older"))->Lock();
		}
		else
		{
			genprefs_rec_locker((gadget*)FindObject(".configcard.misc.rec_older"),0);
			((checkbox*)FindObject(".configcard.misc.rec_read"))->Unlock();
			((checkbox*)FindObject(".configcard.misc.rec_reply"))->Unlock();
			((checkbox*)FindObject(".configcard.misc.rec_forward"))->Unlock();
			((checkbox*)FindObject(".configcard.misc.rec_older"))->Unlock();
		}
	}
	else if (!strcmp(g->Name(),"rec_older"))
	{
		if (((checkbox*)g)->State()==PRESSED)
		{
			((input*)FindObject(".configcard.misc.rec_older_days"))->Unlock();
		}
		else
		{
			((input*)FindObject(".configcard.misc.rec_older_days"))->Lock();
		}
	}
}
// xface
static void genprefs_xface(gadget *g,int i)
{
	if (!strcmp(g->Name(),"xface_browse"))
	{
		static file_dialog fd;

		fd.LoadMode();
		fd.SetPattern("*.xbm");

		if (fd.Start((appwindow*)FindObject(".generalprefs")))
		{
			unsigned int rw,rh;
			int dummy;
			Pixmap rb;
			unsigned char *rd;
			char buf[800];
			char fbuf[200];
			fd.GetDir(buf,sizeof(buf));
			fd.GetFile(fbuf,sizeof(fbuf));
			strcat(buf,fbuf);

//#define USE_XREADBITMAPFILEDATA
#ifdef USE_XREADBITMAPFILEDATA
			if (!XReadBitmapFileData(buf,&rw,&rh,&rd,&dummy,&dummy))
#else
			if (!ReadBitmapFile(buf,&rw,&rh,&rd))
#endif
			{
				unsigned int v;
				unsigned int x,y,j,i;
				char *buffer=new char[(rw*7)*rh+2];
				char *c1=buffer;
				unsigned char *c2=rd;

				*c1=0;
				i=0;
				x=0;
				y=0;
				while (y<48)
				{
					v=0;
					if (x<rw && !i)
					{
						for(j=0;j<8;j++)
						{
							v|=((*c2&(1<<j))>>j)<<(7-j);
						}
					}
					c2++;
					x+=8;
					v=v<<8;
					if (x<rw && !i)
					{
						for(j=0;j<8;j++)
						{
							v|=((*c2&(1<<j))>>j)<<(7-j);
						}
					}
					c2++;
					x+=8;
					xc_snprintf(c1,((rw*7)*rh+2)-(c1-buffer),"0x%04x,",v);
					c1+=7;
					if (x>=48 || x>=rw)
					{
						x=0;
						y++;
						if (y>=rh)
						{
							i=1;
							c2=rd;
						}
						else
						{
							c2=rd+(rw+7)/8*y;
						}
					}
				}
				if (compface(buffer)>=0)
				{
					xfacegg *xfg=(xfacegg*)FindObject(".xfacegroup.xface");
					char *c2=xfacebuf;
					c1=buffer;
					while (*c1)
					{
 						if (*c1=='\n' || *c1==' ')
 						{
 						}
 						else
						{
							*c2=*c1;
							c2++;
						}
						c1++;
					}
					*c2=0;
					xfg->XFace(xfacebuf);
				}
				delete [] buffer;
#ifdef USE_XREADBITMAPFILEDATA
				XFree(rd);
#else
				free(rd);
#endif
			}
		}
	}
	else if (!strcmp(g->Name(),"xface_clear"))
	{
		xfacebuf[0]=0;
		xfacegg *xfg=(xfacegg*)FindObject(".xfacegroup.xface");
		xfg->XFace(xfacebuf);
	}
}
// MISC (un)lock gadgets
static void genprefs_miscbeep(gadget *g,int i)
{
	if (((choice*)g)->Selected()==0)
	{
		((fileinput*)FindObject(".configcard.misc.beepcommand"))->Unlock();
	}
	else
	{
		((fileinput*)FindObject(".configcard.misc.beepcommand"))->Lock();
	}
}
// static void outbox_handler(gadget *g,int)
// { // will move to settings_net
// 	if (((checkbox*)FindObject(".configcard.outbox"))->State()==PRESSED)
// 	{
// 		if (!folderlist->getfolder(0,RL_OUTBOXES,1))
// 		{
// 			io_class *io=allios->FindIO("file");
// 			if (io)
// 			{
// 				folder *t=folderlist->create(io,"Outbox");
// 				if (t)
// 				{
// 					vfolder *v=folderlist->create(FOLDERTYPE_OUTBOX,"Outbox");
// 					if (!v)
// 					{
// 						v=folderlist->getfolder("Outbox",1);
// 					}
// 					if (v)
// 					{
// 						folderlist->add(v,t);
// 					}
// 				}
// 			}
// 		}
// 	}
// }
// send
static void prefs_folderwarnsizeform(int val,char *buf,int size)
{
	if (val<100)
		strcpy(buf,"off");
	else
		xc_snprintf(buf,size,"%d KB",val);
}

// spellcheck
static char **dicts=NULL;
static void close_changespelldicts(void)
{
	appwindow *aw=(appwindow*)FindObject(".dictprefs");
	aw->Close();
	DeleteObjectTree(aw->FullName(),0);
}
static void use_changespelldicts(void)
{
	appwindow *pw=(appwindow*)FindObject(".mainwindow.generalprefs");
	appwindow *aw=(appwindow*)FindObject(".dictprefs");
	if (pw)
	{
		input *in=(input*)FindObject(pw, ".speller.language");
		if (in)
		{
			char buf[300];
			
			strcpy(buf,dicts[((choice*)FindObject(aw,".first"))->Selected()]);
			if (((checkbox*)FindObject(aw,".usesecond"))->State()==PRESSED)
			{
				strcat(buf,",");
				strcat(buf,dicts[((choice*)FindObject(aw,".second"))->Selected()]);
			}
			in->Default(buf);
		}
	}
	close_changespelldicts();
}
static void check_changespelldicts(gadget *g,int)
{
	appwindow *aw=(appwindow*)FindObject(".dictprefs");
	if (((checkbox*)g)->State()==PRESSED)
	{
		((choice*)FindObject(aw,".second"))->Unlock();
	}
	else
	{
		((choice*)FindObject(aw,".second"))->Lock();
	}
}
static void changespelldicts(void)
{
	int x,y,w,h;
	int i;
	char ispell[300];
	char d1[300];
	char *d2;
	
	appwindow *pw=(appwindow*)FindObject(".mainwindow.generalprefs");
	
	fileinput *fin=(fileinput*)FindObject(pw,".speller.path");
	fin->GetFile(ispell, sizeof(ispell));

	dicts=SpellChecker::GetDictList(ispell,pw);
	if (!dicts)	return;

	appwindow *aw=new appwindow;
	pw->Position(x,y);
	pw->Size(w,h);
	aw->ParentClass(pw);
	aw->Name("dictprefs");

	aw->InitSize(x,y,2);
	if (!aw->Init())
	{
		delete aw;
		pstatus("Error in opening window!");
		return;
	}

	input *in=(input*)FindObject(pw, ".speller.language");
	in->Input(d1);
	if (d2=strchr(d1,','), d2)
	{
		*(d2++)=0;
	}
	else
	{
		d2=d1+strlen(d1);
	}
	
	aw->Title("Dictionaries");
	aw->IconTitle("Dictionaries");
	aw->Adjust(x,y,w,h,ADJUST_MIDDLE|ADJUST_CENTER);
	aw->TransientFor(pw);

	spacegroup *g=new spacegroup;
	g->Border(5);
	g->Vert();
	g->Name("main");
	g->YDistance(5);
	g->XDistance(5);
		text *t=new text;
		t->Name(NULL);
		t->Font(FONT_SMALL);
		t->Text("Specify dictionary or dictionaries you want to use initially!\n");
	g->Add(t);
		choice *ch=new choice;
		ch->Name("first");
		ch->Items(dicts);
		for (i=0;dicts[i];i++)
		{
			if (strcmp(d1,dicts[i])==0)
			{
				ch->Selected(i);
				break;
			}
		}
	g->Add(ch,"_Primary dictionary");
		checkbox *cb=new checkbox;
		cb->Name("usesecond");
		cb->Text("_use secondary dictionary");
		cb->Callback(check_changespelldicts);
	g->Add(cb,NULL);
		ch=new choice;
		ch->Name("second");
		ch->Items(dicts);
		for (i=0;dicts[i];i++)
		{
			if (strcmp(d2,dicts[i])==0)
			{
				ch->Selected(i);
				break;
			}
		}
	g->Add(ch,"_Secondary dictionary");
	g->Add(new ruler);
		group *bgp=new group;
		bgp->Horiz();
		bgp->DialogMode();
	 		fbutton *b=new fbutton;
			b->Text("_Ok");
			b->Callback((void (*)(gadget*,int))use_changespelldicts);
		bgp->Add(b);
	 		b=new fbutton;
	 		b->Text("_Cancel");
			b->Callback((void (*)(gadget*,int))close_changespelldicts);
		bgp->Add(b);
	g->Add(bgp);

	if (*d2)
	{
		cb->State(PRESSED);
		ch->Unlock();
	}
	else
	{
		cb->State(RELEASED);
		ch->Lock();
	}

	aw->SetGroup(g);
	aw->Callback((void (*)(appwindow *))close_changespelldicts);
	aw->Create();		
}

// settings make window
void generalprefs(void)
{
	if (FindObject(".mainwindow.generalprefs")) return;

	char buf[100];
	int x,y;
	appwindow *aw=new appwindow;
	readerwin.Position(x,y);
	aw->ParentClass(readerwin);
	aw->Name("generalprefs");

	pstatus("Open general preferences window");

	aw->InitSize(x,y,5);
	if (!aw->Init())
	{
		delete aw;
		pstatus("Error in opening window!");
		return;
	}
	aw->Title("General preferences");
	aw->IconTitle("General preferences");
	aw->Callback((void (*)(appwindow *))genprefs_close);
	aw->Group(readerwin);
	aw->TransientFor(readerwin.window());

	group *maingp=new group;
	maingp->Name("cfggroup");
	maingp->Horiz();

	spacegroup *gp=new spacegroup;
	gp->Vert();
	gp->Name("maingroup");
	gp->YDistance(8);
	gp->Border(4);
	gp->Add(maingp);
	
	group *bgp=new group;
	bgp->Horiz();
	bgp->DialogMode();
	 fbutton *b=new fbutton;
	 b->Text(" _Use ");
	 b->Callback((void (*)(gadget*,int))genprefs_use);
	bgp->Add(b);
	 b=new fbutton;
	 b->Text(" _Cancel ");
	 b->Callback((void (*)(gadget*,int))genprefs_close);
	 b->ApplyXKey(XK_Escape);
	bgp->Add(b);
	gp->Add(bgp);

	card *ccard=new card;
	ccard->Name("configcard");
	maingp->Add(ccard);
	bordergroup *g1,*cg,*bg;
	group *g2,*g3;
	choice *ch;

	cg=new bordergroup;
	 cg->Name(NULL);
	 cg->Vert();
	 cg->YDistance(10);
	ccard->Add("Compose mail",cg);
	  g2=new group;
	  g2->Horiz();
	  g2->Name(NULL);
	  g2->UseSmallest();
	  bordergroup *bg1;
	   bg1=new bordergroup;
	   bg1->Name(NULL);
	   bg1->Vert();
	   bg1->YDistance(4);

	    checkbox *cb=new checkbox;
	    cb->Name("askmime");
	    cb->Text("_allow mime type selection for attachments");
	    cb->HelpText("Allows selection of mime type\nwhen attaching a file.");
	    cb->State(programconfig.askmime?PRESSED:RELEASED);
	   bg1->Add(cb);
/*       cb=new checkbox;
	    cb->Name("askcompress");
	    cb->Text("a_llow conversions compression");
	    cb->HelpText("Allows you to compress a file only\nfor sending - this is not\nsupported by all mailers!");
	    cb->State(programconfig.askcompress?PRESSED:RELEASED);
	   bg1->Add(cb); */
	    cb=new checkbox;
	    cb->Name("signdash");
	    cb->Text("_dashes above signature");
	    cb->HelpText("Add 2 dashes before signature.");
	    cb->State(programconfig.signdash?PRESSED:RELEASED);
	   bg1->Add(cb);
	    cb=new checkbox;
	    cb->Name("reply_maillist");
	    cb->Text("open dialog _before mailing list reply");
	    cb->HelpText("This requires some extra "PROGRAMNAME"\nX-Headers added by the list agent.");
	    cb->State(programconfig.reply_maillist?PRESSED:RELEASED);
	   bg1->Add(cb);
	    cb=new checkbox;
	    cb->Name("reply_group");
	    cb->Text("open dialog as_king to send a CC");
	    cb->HelpText("If the writer of a mail sended his mail\nalso to other persons this option enabled\nmay ask you to send a copy of your reply\nalso to this people.");
	    cb->State(programconfig.reply_group?PRESSED:RELEASED);
	   bg1->Add(cb);
	    cb=new checkbox;
	    cb->Name("opennewmailextras");
	    cb->Text("open extra fields in _newmail window");
	    cb->HelpText("Opens the extra fields by defaults,\nif disabled this fields may be opened by\npull down menu.");
	    cb->State(programconfig.opennewmailextras?PRESSED:RELEASED);
	   bg1->Add(cb);
	    cb=new checkbox;
	    cb->Name("longrecipient");
	    cb->Text("e_xpand email addesses");
	    cb->HelpText("Expands known email addresses (from the addressbook)\nfor full names (like this: name <address>).");
	    cb->State(programconfig.longrecipient?PRESSED:RELEASED);
	   bg1->Add(cb);
	    cb=new checkbox;
	    cb->Name("autoquote");
	    cb->Text("always _quote when replaying email");
	    cb->HelpText("Automatically quotes the received mail when replaying\nto it. If disabled quoting can be done by an extra button\nin the newmail window.");
	    cb->State(programconfig.autoquote?PRESSED:RELEASED);
	   bg1->Add(cb);
	    cb=new checkbox;
	    cb->Name("quotesender");
	    cb->Text("use user defined _openings");
	    cb->HelpText("Use the defined openings/closings below - or use the buildins.");
	    cb->State(programconfig.quotesender?PRESSED:RELEASED);
	   bg1->Add(cb);
	  g2->Add(bg1);

	   bg1=new bordergroup;
	   bg1->Name(NULL);
	   bg1->Vert();
	   bg1->YDistance(4);
	    slider *sl=new slider;
	    sl->Name("writelinelength");
	    sl->MinValue(40);
	    sl->MaxValue(150);
	    sl->Value(programconfig.writelinelength);
	    sl->Horiz();
	    sl->HelpText("Linelength for new mail,\ndefault is 75");
	   bg1->Add(sl,"_Max line length");
	    input *ip=new input;
	    ip->Name("signaturename");
	    ip->Text("_Signature filename");
	    ip->Default(programconfig.signaturename);
	    ip->MaxChars(sizeof(programconfig.signaturename));
	    ip->HelpText("Filename of your signature file\nalways placed in your home\n(eg '.signature').");
	   bg1->Add(ip);
	    textbox *tb=new textbox;
	    tb->Name("addresslist");
	    tb->AppendText(space2nl(programconfig.addresslist));
	    tb->HelpText("If you have multiple addresses or a central mail server\nenter your addresses here (by comma or newline seperated),\nthe group reply window will use this.");
	   bg1->Add(tb,"Address _list");
	    ip=new input;
	    ip->Name("defaultBCC");
	    ip->Text("defaul_t BCC");
	    ip->Default(programconfig.defaultBCC);
	    ip->MaxChars(sizeof(programconfig.defaultBCC));
	    ip->HelpText("default address placed in the BCC field");
	   bg1->Add(ip);
	  g2->Add(bg1);
	 cg->Add(g2);

      g1=new bordergroup;
      g1->Vert();
      g1->Name("openings");
      g1->Title("User defined openings/closings");
      g1->HelpText("Openings/Closings directives:\n{FONT_FIXED} %n -{/FONT} sender name\n{FONT_FIXED} %e -{/FONT} sender email address\n{FONT_FIXED} %d -{/FONT} send date\n{FONT_FIXED} %s -{/FONT} subject\n{FONT_FIXED} %S -{/FONT} normalized subject\n{FONT_FIXED} %% -{/FONT} percent\n{FONT_FIXED} \\\\n -{/FONT} new line");
       ip=new input;
       ip->Name("oreply");
       ip->MaxChars(sizeof(programconfig.replyopen));
       ip->Text("_Reply opening");
       ip->Default(programconfig.replyopen);
      g1->Add(ip);
       ip=new input;
       ip->Name("creply");
       ip->MaxChars(sizeof(programconfig.replyclose));
       ip->Text("R_eply closing");
       ip->Default(programconfig.replyclose);
      g1->Add(ip);
       ip=new input;
       ip->Name("oforward");
       ip->MaxChars(sizeof(programconfig.forwardopen));
       ip->Text("_Forward opening");
       ip->Default(programconfig.forwardopen);
      g1->Add(ip);
       ip=new input;
       ip->Name("cforward");
       ip->MaxChars(sizeof(programconfig.forwardclose));
       ip->Text("For_ward closing");
       ip->Default(programconfig.forwardclose);
      g1->Add(ip);
	 cg->Add(g1);


	cg=new bordergroup;
	 cg->Name(NULL);
	 cg->Vert();
	 cg->YDistance(4);
	ccard->Add("Send",cg);
	  g2=new group;
	  g2->Vert();
	  g2->Center();
	  g2->YDistance(4);
	  g2->Name(NULL);
	   bg=new bordergroup;
	   bg->Name("xfacegroup");
	   bg->Title("X-Face");
	   bg->Horiz();
	   bg->XDistance(15);
	   bg->UseSmallest();
	   bg->Center();
	   bg->HelpText("X-Face allows you to send a small picture of yourself\nwith any mail. This will be displayed when the mail is read.");
		xfacegg *xfg=new xfacegg;
		xfg->Name("xface");
		strcpy(xfacebuf,programconfig.xface);
		xfg->XFace(xfacebuf);
	   bg->Add(xfg);
		group *xfgp=new group;
		xfgp->Name(NULL);
		xfgp->Vert();
		xfgp->DialogMode();
	     fbutton *gb=new fbutton;
	     gb->Name("xface_browse");
	     gb->Text("_import xbm as xface...");
	     gb->Callback(genprefs_xface);
	     gb->HelpText("Import an X11 bitmap file (xbm) and\nconverts it into an x-face.\nThe picture maybe a 48x48 pixels B/W image.\n(eg made with 'xv')");
	     xfgp->Add(gb);
	     gb=new fbutton;
	     gb->Name("xface_clear");
	     gb->Text("c_lear xface");
	     gb->Callback(genprefs_xface);
		xfgp->Add(gb);
	   bg->Add(xfgp);
	  g2->Add(bg);
	   bg=new bordergroup;
	   bg->Name(NULL);
	   bg->Vert();
	   bg->XDistance(15);
	  
		cb=new checkbox;
		cb->Name("no_mime_preamble");
		cb->Text("don't add _MIME preamble");
		cb->HelpText("Some tools (like majordomo) don't handle\nMIME preambles correctly. If you often use\nthese disable the preamble.\nThe MIME preamble is for historic reason for\nnon MIME capable mailers to give the user a\nhint to use a MIME capable mailer.");
		cb->State(programconfig.no_mime_preamble?PRESSED:RELEASED);
	   bg->Add(cb,"");
		g3=new group;
		g3->Name(NULL);
		g3->Horiz();
		g3->XDistance(10);
		g3->UseSmallest();
		g3->Center();
		 cb=new checkbox;
		 cb->Name("vcard_enable");
		 cb->Text("add personal _vCard to every mail");
		 cb->State(programconfig.vcard_enable?PRESSED:RELEASED);
		g3->Add(cb);
		 fbutton *vcbut=new fbutton;
		 vcbut->Name("vcsettings_priv");
		 vcbut->Text("edit _private...");
		 vcbut->Callback((void(*)(gadget *,int))ownAddressMode);
		 vcbut->Weight(10);
		g3->Add(vcbut);
		 vcbut=new fbutton;
		 vcbut->Name("vcsettings_work");
		 vcbut->Text("edit _work...");
		 vcbut->Callback((void(*)(gadget *,int))ownAddressMode);
		 vcbut->Weight(10);
		g3->Add(vcbut);
		 cb=new checkbox;
		 cb->Name("vcard_work_default");
		 cb->Text("wor_k card is default");
		 cb->State(programconfig.vcard_work_default?PRESSED:RELEASED);
		g3->Add(cb);
		 gadget *vcdummy=new gadget;
		 vcdummy->Weight(200);
		 vcdummy->Background(vcdummy->col_background());
		g3->Add(vcdummy);
	   bg->Add(g3,"");
	  g2->Add(bg);
	 cg->Add(g2);


	 cg=new bordergroup;
	 cg->Name(NULL);
	 cg->Vert();
	 cg->YDistance(4);
//	 cg->UseSmallest();
	 cg->Center();
	ccard->Add("Headers",cg);
	  ip=new input;
	  ip->Name("organization");
	  ip->Text("Or_ganization");
	  ip->MaxChars(sizeof(programconfig.organization));
	  ip->Default(programconfig.organization);
	  ip->HelpText("If not empty this organization name is placed in each mail.");
	 cg->Add(ip);

	 static char *mitms[]={"on","off",NULL};
	 for(int xhi=0;xhi<XHEADERCOUNT;xhi++)
	 {
	 	char buf[30];
		group *xhg=new group;
		xc_snprintf(buf,sizeof(buf),"xheader_%d",xhi);
		xhg->Name(buf);
		xhg->Horiz();
		 ip=new input;
		 ip->Name("name");
		 ip->Weight(40);
		 ip->MaxChars(sizeof(programconfig.xheader_name[xhi]));
		 ip->Default(programconfig.xheader_name[xhi]);
		xhg->Add(ip);
		 ip=new input;
		 ip->Name("value");
		 ip->Text(":");
		 ip->MaxChars(sizeof(programconfig.xheader_value[xhi]));
		 ip->Default(programconfig.xheader_value[xhi]);
		xhg->Add(ip);
		 ch=new choice;
		 ch->Name("mode");
		 ch->Items(mitms);
		 ch->Selected(programconfig.xheader_mode[xhi]);
		 ch->Weight(10);
		xhg->Add(ch);
	   cg->Add(xhg,"X-");
	 }


	 cg=new bordergroup;
	 cg->Name(NULL);
	 cg->Vert();
	 cg->YDistance(4);
//	 cg->UseSmallest();
	 cg->Center();
	ccard->Add("Read/Print mail",cg);
	  g1=new bordergroup;
	  g1->Name(NULL);
	  g1->Horiz();
	  g1->XDistance(4);
	  g1->Title("Read");
	   g2=new group;
	   g2->Name(NULL);
	   g2->Vert();
	   g2->YDistance(4);
	    cb=new checkbox;
	    cb->Name("autotext");
	    cb->Text("_wrap mail text:\n{FONT_SMALL}wrap long lines to fit into reader window");
	    cb->State(programconfig.autotext?PRESSED:RELEASED);
	   g2->Add(cb);
	    cb=new checkbox;
	    cb->Name("oneshowmail");
	    cb->Text("use only _one window for mail output");
	    cb->State(programconfig.oneshowmail?PRESSED:RELEASED);
	   g2->Add(cb);
	  g1->Add(g2);
	 cg->Add(g1);

	  g1=new bordergroup;
	  g1->Name(NULL);
	  g1->Vert();
	  g1->YDistance(4);
	  g1->Title("Print");
	 cg->Add(g1);
 	  fileinput *fip=new fileinput;
	  fip->Name("printcom");
	  fip->SetFile(programconfig.printcom);
	  fip->ModeCommand();
	 g1->Add(fip,"_Print spooler");
	  ch=new choice;
	  static char *chit1[]={"A4","Letter","Legal",NULL};
      ch->Name("papersize");
      ch->Items(chit1);
	  ch->Selected(programconfig.papersize);
	 g1->Add(ch,"Paper_size");


 	cg=new bordergroup;
 	cg->Name("misc");
 	cg->Horiz();
	cg->UseSmallest();
 	ccard->Add("Misc",cg);
 	 g2=new group;
 	 g2->Name(NULL);
 	 g2->Vert();
 	 g2->YDistance(4);
	 g2->UseSmallest();
	  static char *beep[]={"command","one beep","two beeps","beep sound",NULL};
	  ch=new choice;
	  ch->Name("newbeep");
	  ch->Items(beep);
	  ch->Selected(programconfig.newbeep);
	  ch->Callback(genprefs_miscbeep);
	 g2->Add(ch,"_New mail sound");
	  fip=new fileinput;
	  fip->Name("beepcommand");
	  fip->ModeCommand();
	  fip->SetFile(programconfig.beepcommand);
	 g2->Add(fip,"external command");
	  cb=new checkbox;
	  cb->Name("usetrash");
	  cb->Text("mo_ve deleted mail to trash folder");
	  cb->State(programconfig.usetrash?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
// 	  cb=new checkbox;
// 	  cb->Name("autoreadnew");
// 	  cb->Text("_automatically read new received mail");
// 	  cb->State(programconfig.autoreadnew?PRESSED:RELEASED);
// 	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("opennewmaildialog");
	  cb->Text("op_en window when new mail arrived");
	  cb->State(programconfig.openNewMailDialog?PRESSED:RELEASED);
	 g2->Add(cb,NULL);

	  cb=new checkbox;
	  cb->Name("addresscmp_dns");
	  cb->Text("enable hostname resolution by _DNS");
	  cb->HelpText("If enabled all hostnames in email addresses will\nbe checks by DNS to checkout alias hostnames.\nThis is used by the group reply function.");
	  cb->State(programconfig.addresscmp_dns?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("closeOnChangeFolder");
	  cb->Text("close _mailwindows if folder is changed");
	  cb->State(programconfig.closeOnChangeFolder?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("mailnewforXCmail");
	  cb->Text("mark un_known mail as new");
	  cb->State(programconfig.mailnewforXCmail?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("mailnewfromPop3");
	  cb->Text("mark all POP3 received mail a_s new");
	  cb->State(programconfig.mailnewfromPop3?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("generate_autoabook");
	  cb->Text("add new mail addresses into automatic addressbook");
	  cb->State(programconfig.generate_autoabook?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("vfolder_manager");
	  cb->Text("advanced vfolder concept");
	  cb->State(programconfig.vfolder_manager?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	cg->Add(g2);
	cg->Add(new ruler);
	 g2=new group;
	 g2->Name(NULL);
	 g2->Vert();
	 g2->YDistance(2);
	 g2->UseSmallest();
	  text *txt=new text;
 	  txt->FixedText();
 	  txt->Text("Move mail into received folder\neach folder may have its own\nsettingsin folder manager");
// 	  txt->Right();
// 	  txt->Font(FONT_SMALL);
 	 g2->Add(txt);
	  cb=new checkbox;
	  cb->Name("rec_always");
	  cb->Text("al_ways");
	  cb->State(programconfig.rec_always?PRESSED:RELEASED);
	  cb->Callback(genprefs_rec_locker);
	 g2->Add(cb," ");
	  cb=new checkbox;
	  cb->Name("rec_read");
	  cb->Text("if _read");
	  cb->State(programconfig.rec_read?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("rec_reply");
	  cb->Text("if re_plyed");
	  cb->State(programconfig.rec_reply?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("rec_forward");
	  cb->Text("if _forwarded");
	  cb->State(programconfig.rec_forward?PRESSED:RELEASED);
	 g2->Add(cb,NULL);
	  cb=new checkbox;
	  cb->Name("rec_older");
	  cb->Text("if _older than days");
	  cb->State(programconfig.rec_older?PRESSED:RELEASED);
	  cb->Callback(genprefs_rec_locker);
	 g2->Add(cb,NULL);
 	  ip=new input;
 	  ip->Name("rec_older_days");
 	  ip->Text("Da_ys");
 	  ip->MaxChars(10);
	  ip->IntegerMode();
	  xc_snprintf(buf,sizeof(buf),"%d",programconfig.rec_older_days);
 	  ip->Default(buf);
     g2->Add(ip,NULL);

	cg->Add(g2);


#ifdef USEPGP
	g1=new bordergroup;
	g1->Name("pgp");
	g1->Vert();
	g1->YDistance(4);
	ccard->Add("PGP",g1);
 	 txt=new text;
 	 txt->FixedText();
 	 txt->Text("PGP: Pretty Good Privacy\nEncrypt and decrypt your mail.");
 	 txt->Right();
 	 txt->Font(FONT_SMALL);
 	g1->Add(txt,NULL);
 	 fip=new fileinput;
 	 fip->Name("command");
 	 fip->SetFile(programconfig.pgpcommand);
 	 fip->HelpText("Full name and path to PGP command.");
	 fip->ModeCommand();
    g1->Add(fip,"PGP c_ommand + path");
 	 ip=new input;
 	 ip->Name("id");
 	 ip->Text("PGP _ID");
 	 ip->MaxChars(sizeof(programconfig.pgpid));
 	 ip->Default(programconfig.pgpid);
 	 ip->HelpText("Your PGP username.");
    g1->Add(ip);
 	 ip=new input;
 	 ip->Name("passphrase");
 	 ip->Text("PGP _pass phrase");
 	 ip->InvisibleMode();
 	 ip->MaxChars(40);
 	 char pdummy[40];
	 strdecodecpy(pdummy,programconfig.pgppassphrase);
 	 ip->Default(pdummy);
 	 ip->HelpText("Secret key pass phrase.");
    g1->Add(ip);
 	 txt=new text;
 	 txt->FixedText();
 	 txt->Text("saving your pass phrase in a file is a security risk\nbetter enter your pass phrase each time it is required!");
 	 txt->Font(FONT_SMALL);
 	g1->Add(txt,NULL);

     cb=new checkbox;
     cb->Name("pgpleaveopen");
     cb->Text("_leave PGP output window open");
	 cb->State(programconfig.pgpleaveopen?PRESSED:RELEASED);
	 cb->HelpText("A PGP output window is opened durring PGP code/decode\nwhich is closed if all was fine.\nBut if you like to read the output enable this.");
	g1->Add(cb,NULL);
#endif


	g1=new bordergroup;
	g1->Name("speller");
	g1->Vert();
	g1->XDistance(5);
	g1->YDistance(5);
	ccard->Add("Spellcheck",g1);
		txt=new text;
		txt->FixedText();
		txt->Text("ispell:\nUse ispell to correct your spelling.");
		txt->Right();
		txt->Font(FONT_SMALL);
	g1->Add(txt, NULL);
		fip=new fileinput;
		fip->Name("path");
	 	fip->SetFile(programconfig.spellpath);
	 	fip->HelpText("Full name and path to ispell command.");
		fip->ModeCommand();
	g1->Add(fip,"ispell c_ommand");
		group *sg = new group;
		sg->Name(NULL);
		sg->XDistance(4);
		sg->Horiz();
		sg->UseSmallest();
			ip=new input;
			ip->Name("language");
			ip->Text("Default _language");
			ip->MaxChars(sizeof(programconfig.spelllanguage));
			ip->Default(programconfig.spelllanguage);
		sg->Add(ip);
			button *sfb=new button;
			sfb->Name("editdicts");
//			sfb->Font(FONT_SMALL);
			sfb->Text("c_hange");
			sfb->Callback((void (*)(gadget*,int))changespelldicts);
			sfb->Weight(1);
		sg->Add(sfb);
			txt=new text;
			txt->FixedText();
			txt->Text("Use this dictionaries by default. You may specify an\nalternative second language separated by a comma.");
			txt->Left();
			txt->Font(FONT_SMALL);
		sg->Add(txt);
	g1->Add(sg); 
	g1->Add(new ruler);
		cb=new checkbox;
		cb->Name("ignoreurl");
		cb->Text("ignore _URLs and EMail adresses");
		cb->State(programconfig.spellignoreurl?PRESSED:RELEASED);
	g1->Add(cb, NULL);
		cb=new checkbox;
		cb->Name("ignorespecials");
		cb->Text("ignore special _words (e.g. Re:, Fwd:, (Fwd), etc.)");
		cb->State(programconfig.spellignorespecials?PRESSED:RELEASED);
	g1->Add(cb, NULL);
		cb=new checkbox;
		cb->Name("ignoresig");
		cb->Text("ignore _signature (requires 'dashes above signature' to be set!)");
		cb->State(programconfig.spellignoresig?PRESSED:RELEASED);
	g1->Add(cb, NULL);
		cb=new checkbox;
		cb->Name("ignorequoted");
		cb->Text("ignore _quoted lines");
		cb->State(programconfig.spellignorequoted?PRESSED:RELEASED);
	g1->Add(cb, NULL);

	aw->SetGroup(gp);
	genprefs_rec_locker((checkbox*)FindObject(".configcard.misc.rec_always"),0);
	genprefs_miscbeep((choice*)FindObject(".configcard.misc.newbeep"),0);
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
	aw->Create();
}
