/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: settings_net.cxx,v 2.6 2002/07/04 13:34:49 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/utsname.h>

#include "mailer.h"
#include "encoder.h"
#include "helper.h"
#include "address_book.h"
#include "maillist.h"
#include "xfacegg.h"
#include "license_dialog.h"
#include "pluginsmgr.h"
#include "filter_mgr.h"
#include "spellchecker.h"
#include "npop3get.h"
#include "folder.h"


//--------------------------------------------------------------------
// net prefs
static char *space2nl(char *t)
{
	static char buf[510];
	char *c1=buf,*c2=t;
	while (*c2)
	{
		if (*c2==' ' || *c2==',')
		{
			if (*(c2+1)!=' ' && *(c2+1)!=',')
			{
				*c1='\n';
				c1++;
			}
		}
		else
		{
			*c1=*c2;
			c1++;
		}
		c2++;
	}
	*c1=0;
	return buf;
}
static char *nl2space(char *t)
{
	static char buf[510];
	char *c1=buf,*c2=t;
	while (*c2)
	{
		if (*c2=='\n')
		{
			if (*(c2+1)!='\n' && *(c2+1)!=0)
			{
				*c1=',';
				c1++;
			}
		}
		else
		{
			*c1=*c2;
			c1++;
		}
		c2++;
	}
	*c1=0;
	return buf;
}
static void changeHandler(void);
static void netprefs_close(void)
{
	folderlist->unregisterfolderfunction(changeHandler);

	appwindow *aw=(appwindow*)FindObject(".mainwindow.netprefs");
	aw->Close();
	DeleteObjectTree(aw->FullName(),0);
}
static void netprefs_pop3servers(gadget *g,int);
static void netprefs_use(void)
{
	char buf[100];

// send
	programconfig.outbox=((checkbox*)FindObject(".configcard.outbox"))->State()==PRESSED?1:0;
	strncpy(programconfig.outboxname,
		folderlist->getfolder(((choice*)FindObject(".configcard.outboxname"))->Selected(),RL_OUTBOXES,1)->g_id(),
		sizeof(programconfig.outboxname));
	programconfig.folderwarnsize=((slider*)FindObject(".configcard.folderwarnsize"))->Value();
	if (programconfig.folderwarnsize<100) programconfig.folderwarnsize=0;
	programconfig.folderwarnsize*=1024;
	programconfig.outbox_noattachments=((checkbox*)FindObject(".configcard.outbox_noattachments"))->State()==PRESSED?1:0;

	((input*)FindObject(".configcard.replyto"))->Input(programconfig.replyto);
	programconfig.transumlauts=((mxknob*)FindObject(".configcard.transumlauts"))->Selected();


// POP3
	char dummy[50];
	programconfig.popautocheck=((checkbox*)FindObject(".configcard.pop.popautocheck"))->State()==PRESSED?1:0;
	((input*)FindObject(".configcard.pop.popcheckdelay"))->Input(dummy);
	programconfig.popcheckdelay=atoi(dummy);

	programconfig.popcheckatstart=((checkbox*)FindObject(".configcard.pop.popcheckatstart"))->State()==PRESSED?1:0;
	programconfig.popsendspooled=((checkbox*)FindObject(".configcard.pop.popsendspooled"))->State()==PRESSED?1:0;
	programconfig.no_pop3statewindow=((checkbox*)FindObject(".configcard.pop.no_pop3statewindow"))->State()==PRESSED?1:0;
	netprefs_pop3servers((gadget*)FindObject(".configcard.pop.servers"),0);

// SMTP
	programconfig.smtpsenderon=((checkbox*)FindObject(".configcard.smtp.senderon"))->State()==PRESSED?1:0;
	programconfig.smtpoutspool=((checkbox*)FindObject(".configcard.smtp.outspool"))->State()==PRESSED?1:0;
	((input*)FindObject(".configcard.smtp.sender"))->Input(programconfig.smtpsender);
	((input*)FindObject(".configcard.smtp.authname"))->Input(programconfig.authname);
	((input*)FindObject(".configcard.smtp.authaddress"))->Input(programconfig.authaddress);
	programconfig.no_smtpstatewindow=((checkbox*)FindObject(".configcard.smtp.no_smtpstatewindow"))->State()==PRESSED?1:0;
	programconfig.smtpafterpop3=((checkbox*)FindObject(".configcard.smtp.smtpafterpop3"))->State()==PRESSED?1:0;

	programconfig.use_smtp_auth=((checkbox*)FindObject(".configcard.smtp.use_smtp_auth"))->State()==PRESSED?1:0;
	((input*)FindObject(".configcard.smtp.smtp_auth_name"))->Input(programconfig.smtp_auth_name);
	char pass[sizeof(programconfig.smtp_auth_pw)];
	((input*)FindObject(".configcard.smtp.smtp_auth_pw"))->Input(pass);
	strencodecpy(programconfig.smtp_auth_pw,pass);

	netprefs_close();

	writeconfig();
}
static void changeHandler(void)
{
	vfolder *v=folderlist->getfolder(((choice*)FindObject(".configcard.outboxname"))->Selected(),RL_OUTBOXES,1);
	((choice*)FindObject(".configcard.outboxname"))->Items(folderlist->readlist(RL_OUTBOXES,1));
	if (v)
		((choice*)FindObject(".configcard.outboxname"))->Selected(folderlist->getfolder(v,RL_OUTBOXES,1));

	v=folderlist->getfolder(((choice*)FindObject(".configcard.pop.popdefault"))->Selected(),RL_INBOXES,1);
	((choice*)FindObject(".configcard.pop.popdefault"))->Items(folderlist->readlist(RL_INBOXES,1));
	if (v)
		((choice*)FindObject(".configcard.pop.popdefault"))->Selected(folderlist->getfolder(v,RL_INBOXES,1));
}
static void netprefs_smtpafterpop_check(gadget *,int)
{
	if (((checkbox*)FindObject(".configcard.pop.smtpafterpop3"))->State()==PRESSED)
	{
		((checkbox*)FindObject(".configcard.smtp.smtpafterpop3"))->State(PRESSED);
	}
}
// POP3 (un)lock gadgets
static void netprefs_poplockcheck(gadget *,int)
{
	int popdeleteonserver=0;

	if (((checkbox*)FindObject(".configcard.pop.popautocheck"))->State()==PRESSED)
	{
		((input*)FindObject(".configcard.pop.popcheckdelay"))->Unlock();
		((checkbox*)FindObject(".configcard.pop.popsendspooled"))->Unlock();
	}
	else
	{
		((input*)FindObject(".configcard.pop.popcheckdelay"))->Lock();
		((checkbox*)FindObject(".configcard.pop.popsendspooled"))->Lock();
	}

	if (((mxknob*)FindObject(".configcard.pop.popleave"))->Selected()!=0)
	{
		popdeleteonserver|=1;
	}

	if (popdeleteonserver)
		((checkbox*)FindObject(".configcard.pop.popdeleteonserver"))->Lock();
	else
		((checkbox*)FindObject(".configcard.pop.popdeleteonserver"))->Unlock();
}
static int pop3_old_server=0;
void netprefs_pop3servers(gadget *g,int)
{
	char dummy[50];
	int i;
	listview *lv=(listview*)FindObject(".configcard.pop.servers");
	Pop3User *u=(Pop3User*)lv->GetData(lv->Selected());

	if (!strcmp(g->Name(),"servers"))
	{
		if (pop3_old_server>0)
		{
			u=(Pop3User*)lv->GetData(pop3_old_server);
			((input*)FindObject(".configcard.pop.popserver"))->Input(u->_host);
			((input*)FindObject(".configcard.pop.popuser"))->Input(u->user);
			((input*)FindObject(".configcard.pop.poppasswd"))->Input(u->pass);

			u->popleave=((mxknob*)FindObject(".configcard.pop.popleave"))->Selected();
			((input*)FindObject(".configcard.pop.popmaxsize"))->Input(dummy);
			u->popmaxsize=atoi(dummy);
			u->popdeleteonserver=((checkbox*)FindObject(".configcard.pop.popdeleteonserver"))->State()==PRESSED?1:0;
			u->smtpafterpop3=((checkbox*)FindObject(".configcard.pop.smtpafterpop3"))->State()==PRESSED?1:0;

			i=((choice*)FindObject(".configcard.pop.popdefault"))->Selected();
			vfolder *v=folderlist->getfolder(i,RL_INBOXES,1);
			if (v)
			{
				strcpy(u->vfoldername,v->g_id());
				u->v=v;
			}
	   		xc_snprintf(dummy,sizeof(dummy),"%s:%s (%s)",u->_host,u->user,u->name);
	   		lv->Replace(pop3_old_server,dummy);
			verifyPop3beforeSMTP(u);
		}
		pop3_old_server=lv->Selected();
		u=(Pop3User*)lv->GetData(pop3_old_server);
		if (u)
		{
			((input*)FindObject(".configcard.pop.popserver"))->Default(u->_host);
			((input*)FindObject(".configcard.pop.popserver"))->Unlock();
			((input*)FindObject(".configcard.pop.popuser"))->Default(u->user);
			((input*)FindObject(".configcard.pop.popuser"))->Unlock();
			((input*)FindObject(".configcard.pop.poppasswd"))->Default(u->pass);
			((input*)FindObject(".configcard.pop.poppasswd"))->Unlock();

			((mxknob*)FindObject(".configcard.pop.popleave"))->Selected(u->popleave);
			((mxknob*)FindObject(".configcard.pop.popleave"))->Unlock();
			sprintf(dummy,"%d",u->popmaxsize);
			((input*)FindObject(".configcard.pop.popmaxsize"))->Default(dummy);
			((input*)FindObject(".configcard.pop.popmaxsize"))->Unlock();
			((checkbox*)FindObject(".configcard.pop.popdeleteonserver"))->State(u->popdeleteonserver?PRESSED:RELEASED);
			((checkbox*)FindObject(".configcard.pop.popdeleteonserver"))->Unlock();

			((checkbox*)FindObject(".configcard.pop.smtpafterpop3"))->State(u->smtpafterpop3?PRESSED:RELEASED);
			((checkbox*)FindObject(".configcard.pop.smtpafterpop3"))->Unlock();

        	((choice*)FindObject(".configcard.pop.popdefault"))->Items(folderlist->readlist(RL_INBOXES,1));
			i=folderlist->getfolder(folderlist->getfolder_byid(u->vfoldername),RL_INBOXES,1);
			((choice*)FindObject(".configcard.pop.popdefault"))->Selected(i);
			((choice*)FindObject(".configcard.pop.popdefault"))->Unlock();
			((fbutton*)FindObject(".configcard.pop.del"))->Unlock();
			((fbutton*)FindObject(".configcard.pop.own"))->Unlock();
		}
		netprefs_poplockcheck(NULL,0);
	}
	else if (!strcmp(g->Name(),"add"))
	{
		u=addPop3User();
		strcpy(u->_host,"empty");
		strcpy(u->user,"empty");
   		xc_snprintf(dummy,sizeof(dummy),"%s:%s (%s)",u->_host,u->user,u->name);
   		lv->AddAtEnd(dummy,(void*)u);
		lv->Selected(lv->Count());
		netprefs_pop3servers(lv,0);
	}
	else if (!strcmp(g->Name(),"del"))
	{
		u=(Pop3User*)lv->GetData(pop3_old_server);
		lv->Remove(pop3_old_server);
		lv->Selected(0);
		pop3_old_server=0;
		rmPop3User(u);
		((input*)FindObject(".configcard.pop.popserver"))->Lock();
		((input*)FindObject(".configcard.pop.popuser"))->Lock();
		((input*)FindObject(".configcard.pop.poppasswd"))->Lock();

		((mxknob*)FindObject(".configcard.pop.popleave"))->Lock();
		((input*)FindObject(".configcard.pop.popmaxsize"))->Lock();
		((checkbox*)FindObject(".configcard.pop.popdeleteonserver"))->Lock();

        ((choice*)FindObject(".configcard.pop.popdefault"))->Lock();
		((checkbox*)FindObject(".configcard.pop.smtpafterpop3"))->Lock();

		((fbutton*)FindObject(".configcard.pop.del"))->Lock();
		((fbutton*)FindObject(".configcard.pop.own"))->Lock();
		netprefs_poplockcheck(NULL,0);
	}
	else if (!strcmp(g->Name(),"popserver"))
	{
		netprefs_pop3servers(lv,0);
		((input*)FindObject(".configcard.pop.popuser"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"popuser"))
	{
		netprefs_pop3servers(lv,0);
		((input*)FindObject(".configcard.pop.poppasswd"))->ActivateKey();
	}
	else if (!strcmp(g->Name(),"poppasswd"))
	{
		netprefs_pop3servers(lv,0);
	}
	else if (!strcmp(g->Name(),"own"))
	{
		io_class *io=allios->FindIO("file");
		if (io)
		{
			folder *f;
			vfolder *v;
			char buf[50];
			int i=1,ok=0;
			do
			{
				xc_snprintf(buf,sizeof(buf),"POP3INBOX%d",i);
				if (!folderlist->getfolder(buf,1) && !folderlist->getfolder(io,buf))
				{
					ok=i;
					break;
				}
				i++;
			}
			while (!ok);
			if (ok)
			{
				f=folderlist->create(io,buf);
				v=folderlist->create(FOLDERTYPE_INBOX,buf);
				if (v && f)
				{
					folderlist->add(v,f);
					((choice*)FindObject(".configcard.pop.popdefault"))->Selected(folderlist->getfolder(v,RL_INBOXES,1));
				}
			}
		}
	}
}

// SMTP (un)lock gadgets
static void netprefs_smtpsenderon(gadget *g,int i)
{
	if (!strcmp(g->Name(),"senderon"))
	{
		if (((checkbox*)g)->State()==PRESSED)
		{
			((checkbox*)FindObject(".configcard.smtp.outspool"))->Unlock();
			((checkbox*)FindObject(".configcard.smtp.use_smtp_auth"))->Unlock();
			((checkbox*)FindObject(".configcard.smtp.smtpafterpop3"))->Unlock();
			((checkbox*)FindObject(".configcard.smtp.no_smtpstatewindow"))->Unlock();
			((input*)FindObject(".configcard.smtp.sender"))->Unlock();
			((input*)FindObject(".configcard.smtp.authname"))->Unlock();
			((input*)FindObject(".configcard.smtp.authaddress"))->Unlock();
			netprefs_smtpsenderon((checkbox*)FindObject(".configcard.smtp.use_smtp_auth"),0);
		}
		else
		{
			((checkbox*)FindObject(".configcard.smtp.outspool"))->Lock();
			((checkbox*)FindObject(".configcard.smtp.use_smtp_auth"))->Lock();
			((checkbox*)FindObject(".configcard.smtp.smtpafterpop3"))->Lock();
			((checkbox*)FindObject(".configcard.smtp.no_smtpstatewindow"))->Lock();
			((input*)FindObject(".configcard.smtp.sender"))->Lock();
			((input*)FindObject(".configcard.smtp.authname"))->Lock();
			((input*)FindObject(".configcard.smtp.authaddress"))->Lock();
			((input*)FindObject(".configcard.smtp.smtp_auth_name"))->Lock();
			((input*)FindObject(".configcard.smtp.smtp_auth_pw"))->Lock();
		}
	}
	else if (!strcmp(g->Name(),"use_smtp_auth"))
	{
		if (((checkbox*)g)->State()==PRESSED)
		{
			((input*)FindObject(".configcard.smtp.smtp_auth_name"))->Unlock();
			((input*)FindObject(".configcard.smtp.smtp_auth_pw"))->Unlock();
			((checkbox*)FindObject(".configcard.smtp.smtpafterpop3"))->Lock();
		}
		else
		{
			((input*)FindObject(".configcard.smtp.smtp_auth_name"))->Lock();
			((input*)FindObject(".configcard.smtp.smtp_auth_pw"))->Lock();
			((checkbox*)FindObject(".configcard.smtp.smtpafterpop3"))->Unlock();
		}
	}
}
static void outbox_handler(gadget *g,int)
{
	if (((checkbox*)FindObject(".configcard.outbox"))->State()==PRESSED)
	{
		if (!folderlist->getfolder(0,RL_OUTBOXES,1))
		{
			io_class *io=allios->FindIO("file");
			if (io)
			{
				folder *t=folderlist->create(io,"Outbox");
				if (t)
				{
					vfolder *v=folderlist->create(FOLDERTYPE_OUTBOX,"Outbox");
					if (!v)
					{
						v=folderlist->getfolder("Outbox",1);
					}
					if (v)
					{
						folderlist->add(v,t);
					}
				}
			}
		}
	}
}
// send
static void prefs_folderwarnsizeform(int val,char *buf,int size)
{
	if (val<100)
		strcpy(buf,"off");
	else
		xc_snprintf(buf,size,"%d KB",val);
}


// settings make window
void netprefs(void)
{
	if (FindObject(".mainwindow.netprefs")) return;

	char buf[100];
	int x,y;
	appwindow *aw=new appwindow;
	readerwin.Position(x,y);
	aw->ParentClass(readerwin);
	aw->Name("netprefs");

	pstatus("Open net preferences window");

	aw->InitSize(x,y,5);
	if (!aw->Init())
	{
		delete aw;
		pstatus("Error in opening window!");
		return;
	}
	aw->Title("Transfer & network preferences");
	aw->IconTitle("Transfer & network preferences");
	aw->Callback((void (*)(appwindow *))netprefs_close);
	aw->Group(readerwin);
	aw->TransientFor(readerwin.window());

	group *maingp=new group;
	maingp->Name("cfggroup");
	maingp->Horiz();

	spacegroup *gp=new spacegroup;
	gp->Vert();
	gp->Name("maingroup");
	gp->YDistance(8);
	gp->Border(4);
	gp->Add(maingp);
	
	group *bgp=new group;
	bgp->Horiz();
	bgp->DialogMode();
	 fbutton *b=new fbutton;
	 b->Text(" _Use ");
	 b->Callback((void (*)(gadget*,int))netprefs_use);
	bgp->Add(b);
	 b=new fbutton;
	 b->Text(" _Cancel ");
	 b->Callback((void (*)(gadget*,int))netprefs_close);
	 b->ApplyXKey(XK_Escape);
	bgp->Add(b);
	gp->Add(bgp);

	card *ccard=new card;
	ccard->Name("configcard");
	maingp->Add(ccard);
	bordergroup *g1,*cg;
	group *g2;
	checkbox *cb;
	slider *sl;
	input *ip;
	text *txt;

	cg=new bordergroup;
	 cg->Name(NULL);
	 cg->Vert();
	 cg->XDistance(4);
	ccard->Add("Send",cg);

	  cb=new checkbox;
	  cb->Name("outbox");
	  cb->Text("_save sent mail in outbox");
	  cb->HelpText("Save all sent mail in an outbox folder.");
	  cb->State(programconfig.outbox?PRESSED:RELEASED);
	  cb->Callback(outbox_handler);
	 cg->Add(cb,"");
      choice *ch=new choice;
      ch->Name("outboxname");
      ch->Items(folderlist->readlist(RL_OUTBOXES,1));
	  vfolder *v=folderlist->getfolder(programconfig.outboxname);
	  if (v)
	  	ch->Selected(folderlist->getfolder(v,RL_OUTBOXES,1));
	  ch->HelpText("Outbox - where to place your sent mails.");
	 cg->Add(ch,"Outbox folder");

	  sl=new slider;
	  sl->Name("folderwarnsize");
	  sl->MinValue(99);
	  sl->MaxValue(2000);
	  sl->Horiz();
	  sl->Value(programconfig.folderwarnsize/1024);
	  sl->TextCallback(prefs_folderwarnsizeform);
	  sl->HelpText("Opens a warning window if size of the\noutbox folder is bigger than this value.");

	  sl->Lock();		// not working, so locked
	  sl->Value(99);	// not working, so turned off

	 cg->Add(sl,"_Folder warning size");
	  cb=new checkbox;
	  cb->Name("outbox_noattachments");
	  cb->Text("_don't save attachments in outbox");
	  cb->HelpText("If enabled atachments will not be saved in\noutbox folder.");
	  cb->State(programconfig.outbox_noattachments?PRESSED:RELEASED);
	 cg->Add(cb,"");
	 cg->Add(new ruler);
	  ip=new input;
	  ip->Name("replyto");
	  ip->Text("_Reply-To address");
	  ip->MaxChars(sizeof(programconfig.replyto));
	  ip->Default(programconfig.replyto);
	  ip->HelpText("If not empty this address is places in\nany mail as reply to address.");
	 cg->Add(ip);
	 cg->Add(new ruler);

	  static char *trit[]={"quoted printable{FONT_SMALL} (default){/FONT}","translated 7bit{FONT_SMALL} (umlaut translation){/FONT}","full 8bit",NULL};
	  mxknob *mk=new mxknob;
	  mk->Name("transumlauts");
	  mk->Items(trit);
	  mk->Selected(programconfig.transumlauts);
	  mk->HelpText("use 'quoted printable' if you don't know\n8bit is not supported by all mail systems\ntranslated 7bit is nonreverable");
	 cg->Add(mk,"Transfer _encoding");


 	g1=new bordergroup;
 	g1->Name("pop");
 	g1->Vert();
 	g1->YDistance(4);
 	ccard->Add("POP3",g1);
 	 txt=new text;
 	 txt->FixedText();
 	 txt->Text("Post Office Protocol 3:\nGet remote mail from mailserver.");
 	 txt->Right();
 	 txt->Font(FONT_SMALL);
 	g1->Add(txt,NULL);

     bordergroup *bg=new bordergroup;
	 bg->Horiz();
	 bg->Name(NULL);
	 bg->Title("POP3 Servers");
	  g2=new group;
	  g2->Vert();
	  g2->Name(NULL);
	  g2->Weight(50);
	   char dummy[50];
	   pop3_old_server=0;
	   listview *lv=new listview;
	   lv->Name("servers");
	   lv->ShowSelected();
	   lv->Callback(netprefs_pop3servers);
	   Pop3User *u=(Pop3User*)pop3userlist.head;
	   while (u->next)
	   {
	   		xc_snprintf(dummy,sizeof(dummy),"%s:%s (%s)",u->_host,u->user,u->name);
	   		lv->AddAtEnd(dummy,(void*)u);
	   		u=(Pop3User*)u->next;
	   }
	  g2->Add(lv);
	   group *g3=new group;
	   g3->Horiz();
	   g3->Name(NULL);
	    fbutton *fb=new fbutton;
		fb->Name("add");
		fb->Text("Add");
		fb->Callback(netprefs_pop3servers);
	   g3->Add(fb);
	    fb=new fbutton;
		fb->Name("del");
		fb->Text("Del");
		fb->Callback(netprefs_pop3servers);
		fb->Lock();
	   g3->Add(fb);
	  g2->Add(g3);
	 bg->Add(g2);
	  g2=new group;
	  g2->Vert();
 	  g2->YDistance(4);
	  g2->Name(NULL);
 	   ip=new input;
 	   ip->Name("popserver");
 	   ip->Text("Mail _server hostname");
 	   ip->MaxChars(POP_HOST_LEN);
 	   ip->HelpText("POP3 server (servername or servername:port)");
	   ip->Lock();
	   ip->Callback(netprefs_pop3servers);
      g2->Add(ip);
 	   ip=new input;
 	   ip->Name("popuser");
 	   ip->Text("Mail account _name");
 	   ip->MaxChars(POP_USER_LEN);
	   ip->Lock();
 	   ip->HelpText("POP3 account name");
	   ip->Callback(netprefs_pop3servers);
      g2->Add(ip);
 	   ip=new input;
 	   ip->Name("poppasswd");
 	   ip->Text("Mail account pass_word");
 	   ip->MaxChars(POP_PASS_LEN);
 	   ip->InvisibleMode();
	   ip->Lock();
 	   ip->HelpText("POP3 account password\nWill be saved in a file that\ncould be world readable!!");
	   ip->Callback(netprefs_pop3servers);
      g2->Add(ip);
       mk=new mxknob;
       char *mktxt[]={"leave on server","remove from server",NULL};
       mk->Name("popleave");
       mk->Items(mktxt);
       mk->Horiz();
	   mk->HelpText("Mail may be removed from server.\nThis will speed up later POP3 connections.");
	   mk->Callback(netprefs_poplockcheck);
	   mk->Lock();
	  g2->Add(mk,"_After getting");
  	   g3=new group;
	   g3->Horiz();
	   g3->Center();
	   g3->Name(NULL);
	   g3->HelpText("Do not transfer mails bigger than given value - 0 to transfer all");
	    ip=new input;
	    ip->Name("popmaxsize");
	    ip->IntegerMode();
	    ip->MaxChars(5);
	    ip->Weight(10);
	    ip->ApplyKey('k');
		ip->Lock();
	   g3->Add(ip);
 	    txt=new text;
 	    txt->Text(" _KB");
	    txt->Weight(150);
 	   g3->Add(txt);
	  g2->Add(g3,"No mail bigger than");
       cb=new checkbox;
       cb->Name("popdeleteonserver");
       cb->Text("_Remove all locally deleted mails on server");
	   cb->Lock();
	   cb->HelpText("This is only done by 'fast' delete - otherwise\nthe popup selection is used.");
	  g2->Add(cb,NULL);
	   g3=new group;
	   g3->Name(NULL);
	   g3->Horiz();
        ch=new choice;
        ch->Name("popdefault");
	    ch->Lock();
        ch->Items(folderlist->readlist(RL_INBOXES,1));
	   g3->Add(ch);
	    fb=new fbutton;
		fb->Name("own");
		fb->Text("create own inbox for server");
		fb->Callback(netprefs_pop3servers);
		fb->Weight(10);
		fb->Lock();
	   g3->Add(fb);
	  g2->Add(g3,"P_OP3 folder");
       cb=new checkbox;
       cb->Name("smtpafterpop3");
       cb->Text("Check this POP3 server before SMTP after POP3");
	   cb->Lock();
	   cb->Callback(netprefs_smtpafterpop_check);
	   cb->HelpText("When you need to POP3 before SMTP (sending mail)\nenable this if this it the required POP3 server to connect");
	  g2->Add(cb,NULL);
	 bg->Add(g2);
	g1->Add(bg);
	 g2=new group;
	 g2->Name(NULL);
	 g2->Horiz();
	 g2->Center();
      cb=new checkbox;
      cb->Name("popautocheck");
      cb->Text("Check for new _POP3 mail every");
	  cb->State(programconfig.popautocheck?PRESSED:RELEASED);
	  cb->Callback(netprefs_poplockcheck);
	 g2->Add(cb);
	  xc_snprintf(dummy,sizeof(dummy),"%d",programconfig.popcheckdelay);
	  ip=new input;
	  ip->Name("popcheckdelay");
	  ip->IntegerMode();
	  ip->MaxChars(5);
	  ip->Default(dummy);
	  ip->Weight(50);
	  ip->ApplyKey('m');
	 g2->Add(ip);
 	  txt=new text;
 	  txt->Text(" _minutes");
	  txt->Weight(150);
 	 g2->Add(txt);
	g1->Add(g2,NULL);
     cb=new checkbox;
     cb->Name("popcheckatstart");
     cb->Text("C_onnect to servers after program start");
     cb->State(programconfig.popcheckatstart?PRESSED:RELEASED);
	g1->Add(cb,NULL);
     cb=new checkbox;
     cb->Name("popsendspooled");
     cb->Text("S_end spooled mail when connected to POP3 server");
     cb->State(programconfig.popsendspooled?PRESSED:RELEASED);
	g1->Add(cb,NULL);

     cb=new checkbox;
     cb->Name("no_pop3statewindow");
     cb->Text("_Do not open POP3 transfer window");
     cb->State(programconfig.no_pop3statewindow?PRESSED:RELEASED);
	 cb->HelpText("Useful if your window manager raises\nthis window so creating a new\nmail is interupted.");
	g1->Add(cb,NULL);

 	g1=new bordergroup;
 	g1->Name("smtp");
 	g1->Vert();
 	g1->YDistance(4);
 	ccard->Add("SMTP",g1);
 	 txt=new text;
 	 txt->FixedText();
 	 txt->Text("Simple Mail Transfer Protocol:\nMail transfer via remote mail server");
 	 txt->Right();
 	 txt->Font(FONT_SMALL);
 	g1->Add(txt,NULL);
     cb=new checkbox;
     cb->Name("senderon");
     cb->Text("Use remote SMTP _host to send mail");
	 cb->State(programconfig.smtpsenderon?PRESSED:RELEASED);
	 cb->Callback(netprefs_smtpsenderon);
	 cb->HelpText("Use remote SMTP host to send mail,\nmostly yes if you use POP3.");
	g1->Add(cb,NULL);
     cb=new checkbox;
     cb->Name("outspool");
     cb->Text("Spool _outgoing mail before sending");
	 cb->State(programconfig.smtpoutspool?PRESSED:RELEASED);
	 cb->HelpText("Spool new mail in a local directory.\nThen, if you are online, you can send all\nmail in a block.");
	g1->Add(cb,NULL);
 	 ip=new input;
 	 ip->Name("sender");
 	 ip->Text("Mail sende_r host");
 	 ip->MaxChars(sizeof(programconfig.smtpsender));
 	 ip->Default(programconfig.smtpsender);
 	 ip->HelpText("SMTP hostname, use <hostname> or <hostname>:<port>");
    g1->Add(ip);
 	 ip=new input;
 	 ip->Name("authname");
 	 ip->Text("_Your name");
 	 ip->MaxChars(sizeof(programconfig.authname));
 	 ip->Default(programconfig.authname);
 	 ip->HelpText("Your full name for the email header.");
    g1->Add(ip);
 	 ip=new input;
 	 ip->Name("authaddress");
 	 ip->Text("EMail a_ddress");
 	 ip->MaxChars(sizeof(programconfig.authaddress));
 	 ip->Default(programconfig.authaddress);
 	 ip->HelpText("Your EMail address for the email header.");
    g1->Add(ip);

     cb=new checkbox;
     cb->Name("use_smtp_auth");
     cb->Text("Use _SMTP authentication {FONT_SMALL}(SMTP-AUTH){/FONT}");
	 cb->State(programconfig.use_smtp_auth?PRESSED:RELEASED);
	 cb->HelpText("Some SMTP server require the user to\nauthenticate himself before sending mail.");
	 cb->Callback(netprefs_smtpsenderon);
	g1->Add(cb,NULL);
 	 ip=new input;
 	 ip->Name("smtp_auth_name");
 	 ip->Text("SMTP _login name");
 	 ip->MaxChars(sizeof(programconfig.smtp_auth_name));
 	 ip->Default(programconfig.smtp_auth_name);
 	 ip->HelpText("Your login name - eg from POP3.");
    g1->Add(ip);
 	 ip=new input;
 	 ip->Name("smtp_auth_pw");
 	 ip->Text("SMTP _password");
	 ip->InvisibleMode();
 	 ip->MaxChars(sizeof(programconfig.smtp_auth_pw));
	 char pass[sizeof(programconfig.smtp_auth_pw)];
	 strdecodecpy(pass,programconfig.smtp_auth_pw);
 	 ip->Default(pass);
 	 ip->HelpText("Your login password - eg from POP3.");
    g1->Add(ip);

     cb=new checkbox;
     cb->Name("smtpafterpop3");
     cb->Text("SMTP _after POP3\n{FONT_SMALL}Please choose the POP3 server in the POP3 settings{/FONT}");
	 cb->State(programconfig.smtpafterpop3?PRESSED:RELEASED);
	 cb->HelpText("Some SMTP server require a valid POP3 authentication\nbefore you may send a mail through it.");
	g1->Add(cb,NULL);
     cb=new checkbox;
     cb->Name("no_smtpstatewindow");
     cb->Text("Do _not open SMTP transfer window");
	 cb->State(programconfig.no_smtpstatewindow?PRESSED:RELEASED);
	 cb->HelpText("Useful if your window manager raises\nthis window so creating a new\nmail is interupted.");
	g1->Add(cb,NULL);


	aw->SetGroup(gp);
	netprefs_poplockcheck((checkbox*)FindObject(".configcard.pop.popautocheck"),0);
	netprefs_smtpsenderon((checkbox*)FindObject(".configcard.smtp.senderon"),0);
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
	aw->Create();
	folderlist->registerfolderfunction(changeHandler);
}
