/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: settings_wizzard.cxx,v 2.21 2002/02/26 15:28:45 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/utsname.h>

#include "mailer.h"
#include "npop3get.h"
#include "folder.h"
#include "createmail.h"
#include "maillist.h"

#include "../plugins/trashmgr/trashmgr.h"
#include "../plugins/check_new_release/check_new_release.h"


/*
 *
 * This will do:
 * (1) - check for /var/spool/mail/<user> file and size >10 -> local mails
 *     - ask user for mail receiving way, local preselected if local mails
 *      - local mails: add vfolder entry for local mails
 *      - POP3 mails: ask for pop3 server, username passwort
 *        delete remote mails, delete on server if deleted locally
 * (2) - check for running sendmail process (???)
 *     - ask user for mail sending way, local preselected if sendmail was found (MX)
 *      - if remote: ask for server, user email address and full name and for spooling
 *        (send during POP3 is enabled) 
 * (3) - ask some for some interesting settings of general prefs
 * (4) - give some short discription about vfolder system
 *  
 */

#define WIZ_STEPS 12
#define NEWOG(x,n,tx)	w_ogroup[x]=new bordergroup; \
						w_ogroup[0]->AddShadow(w_ogroup[x]); \
						w_ogroup[x]->Name(n); \
						w_ogroup[x]->Title(tx); \
						ogp=new group; \
						ogp->Name(NULL); \
						ogp->Vert(); \
						w_ogroup[x]->Add(ogp);

static appwindow *w_aw=NULL;
static text *w_output=NULL;
static bordergroup *w_ogroup[WIZ_STEPS];
static button *w_abort=NULL;
static button *w_next=NULL;
static button *w_back=NULL;
static indicator *w_indicator=NULL;

static int wiz_position=0;
static void close_wizard(appwindow *)
{
	w_aw->Close();
	DeleteObjectTree(w_aw->FullName());
}
static void wiz_abort(gadget *,int)
{
	close_wizard(NULL);
}
static void wiz_testmail(gadget *g,int)
{
	g->Lock();
	sendWelcomeTestMail();
}
static int wiz_check_empty(char *ipname,int bufsize)
{ // 0: empty
	input *ip=(input*)FindObject(ipname);
	int r=0;
	if (ip)
	{
		char *b=new char[bufsize+1];
		ip->Input(b);
		r=b[0];
		delete [] b;
	}
	return r;
}
int wiz_store(void)
{ // 0: ok, <0: error, >0: error & wiz_position (should not be used!)
	checkbox *cb;
	mxknob *mx;
	input *ip;
	int haspop;

	haspop=0;
	cb=(checkbox*)FindObject(".r1.localmail");
	vfolder *v=folderlist->getfolder("INBOX");
	if (cb->State()==PRESSED)
	{
		if (!v)
		{ // create INBOX /var/spool/mail
			char dir[300];
			dir[0]=0;
			char *mf=getenv("MAIL");
			if (mf)
			{
				strcpy(dir,mf);
			}
			else
			{
    			char *uname=getusername();
    			if (uname)
    			{
           			strcpy(dir,MAILFOLDER);
           			strcat(dir,"/");
           			strcat(dir,uname);
    			}
			}

			FILE *f;
			if (f=fopen(dir,"w"))
			{
				fclose(f);
				chmod(dir,S_IRUSR|S_IWUSR);
			}
			folders *old_folderlist=folderlist;
			folderlist->saveprefs();
			folderlist=new folders(old_folderlist);
			delete old_folderlist;
			folderlist->init();
			vfolder *v=folderlist->getfolder("INBOX");
		}
		if (v)
		{
			folderlist->change_vfolder_data_hidden(v,0);
		}
	}
	else
	{
		if (v)
		{
			folderlist->change_vfolder_data_hidden(v,1);
		}
	}
	cb=(checkbox*)FindObject(".r1.pop3mail");
	if (cb->State()==PRESSED)
	{
		char dummy[20];
		haspop=1;

		Pop3User *u=addPop3User();

		((input*)FindObject(".r2.popserver"))->Input(u->_host);
		((input*)FindObject(".r2.popuser"))->Input(u->user);
		((input*)FindObject(".r2.poppasswd"))->Input(u->pass);

		u->popleave=((mxknob*)FindObject(".r3.popleave"))->Selected();
		((input*)FindObject(".r3.popmaxsize"))->Input(dummy);
		u->popmaxsize=atoi(dummy);
		u->popdeleteonserver=((checkbox*)FindObject(".r3.popdeleteonserver"))->State()==PRESSED?1:0;

		io_class *io=allios->FindIO("file");
		if (io)
		{
			folder *f;
			vfolder *v;
			char buf[50];
			int i=1,ok=0;
			do
			{
				xc_snprintf(buf,sizeof(buf),"POP3INBOX%d",i);
				if (!folderlist->getfolder(buf,1) && !folderlist->getfolder(io,buf))
				{
					ok=i;
					break;
				}
				i++;
			}
			while (!ok);
			if (ok)
			{
				f=folderlist->create(io,buf);
				v=folderlist->create(FOLDERTYPE_INBOX,buf);
				if (v && f)
				{
					folderlist->add(v,f);
				}
			}
			strcpy(u->vfoldername,v->g_id());
			u->v=v;
		}
	}

	mx=(mxknob*)FindObject(".s1.sendmail");
	if (mx->Selected()==1)
	{
		programconfig.smtpsenderon=1;
		((input*)FindObject(".s2.sender"))->Input(programconfig.smtpsender);
		((input*)FindObject(".s2.authname"))->Input(programconfig.authname);
		((input*)FindObject(".s2.authaddress"))->Input(programconfig.authaddress);

		programconfig.smtpoutspool=((checkbox*)FindObject(".s3.outspool"))->State()==PRESSED?1:0;
	}


	programconfig.addresscmp_dns=((checkbox*)FindObject(".g1.alwaysconnected"))->State()==PRESSED?1:0;
	programconfig.autoquote=((checkbox*)FindObject(".g1.autoquote"))->State()==PRESSED?1:0;
	programconfig.outbox=((checkbox*)FindObject(".g1.useoutbox"))->State()==PRESSED?1:0;
	if (programconfig.outbox)
	{
		vfolder *v=folderlist->getnextfolderoftype(NULL,RL_OUTBOXES);
		if (!v)
		{
			io_class *io=allios->FindIO("file");
			if (io)
			{
				folder *f=folderlist->getfolder(io,"Outbox");
				if (!f)
					f=folderlist->getfolder(io,"outbox");
				if (!f)
					f=folderlist->create(io,"Outbox");

				v=folderlist->getfolder("Outbox",1);
				if (!v)
					v=folderlist->create(FOLDERTYPE_OUTBOX,"Outbox");
				if (v && f)
				{
					folderlist->add(v,f);
				}
			}
		}
		strncpy(programconfig.outboxname,v->g_id(),sizeof(programconfig.outboxname));
	}

	v=folderlist->getnextfolderoftype(NULL,RL_TRASHES);
	if (!v)
	{
		io_class *io=allios->FindIO("file");
		if (io)
		{
			folder *f=folderlist->getfolder(io,"Trash");
			if (!f)
				f=folderlist->getfolder(io,"trash");
			if (!f)
				f=folderlist->create(io,"Trash");
			v=folderlist->getfolder("Trash",1);
			if (!v)
				v=folderlist->create(FOLDERTYPE_TRASH,"Trash");
			if (v && f)
			{
				folderlist->add(v,f);
			}
		}
	}
	{
		io_class *io=allios->FindIO("file");
		if (io)
		{
			folder *f=folderlist->getfolder(io,"Received");
			if (!f)
				f=folderlist->getfolder(io,"received");
			if (!f)
				f=folderlist->create(io,"Received");
			v=folderlist->getfolder("Received",1);
			if (!v)
				v=folderlist->getfolder("received",1);
			if (!v)
				v=folderlist->create(FOLDERTYPE_RECEIVED,"Received");
			if (v && f)
			{
				folderlist->add(v,f);
				addMail2Folder(v,"XCmail development","The received folder",
					"This folder allows you to store old email automatically.\n\n"
					"To enable this feature open the general preferences window\n"
					"and click the 'Misc' card. Take a look at the right part of\n"
					"this card to learn more about this feature.\n");
			}
		}
	}
	{
		io_class *io=allios->FindIO("gzfile");
		if (io)
		{
			folder *f=folderlist->getfolder(io,"Compressed_example");
			if (!f)
				f=folderlist->create(io,"Compressed_example");
			v=folderlist->getfolder("Compressed_example",1);
			if (!v)
				v=folderlist->create(FOLDERTYPE_UNKNOWN,"Compressed_example");
			if (v && f)
			{
				folderlist->add(v,f);
				addMail2Folder(v,"XCmail development","Compressing folders",
					"This folder is compressed.\n\n"
					"That means is requires less diskspace but is a little slower\n"
					"when read or saved.\n\n"
					"However it is a good place to store old mail. You can convert\n"
					"an existing folder into a compressed or only copy or move mail\n"
					"from a non compressed folder into a compressed one and vice versa.\n\n"
					"Compressed folders are stored in the directory Mail/ARCHIV in\n"
					"your home directory. To create a compressed folder you have to do\n"
					"the same things like creating a 'normal' folder - but in the\n"
					"ARCHIV sub directory:\n\n"
					"Opens the folder manager window and choose the ARCHIV directory\n"
					"in the left popup menu on the 'folder controller' card and simply\n"
					"press 'New...'.\n\n"
					"Compressed folders may have the same names like umcompressed, so it's\n"
					"a good idea to add a special suffix to the name.\n\n"
					"Anyway, after creating the folder it is located in the virtual\n"
					"sub directory gzfile in the main window.\n\n"
					"");
			}
		}
	}
	plugins *pl;
	if (pl=prgplugins->find("Trash manager"))
	{
		if (((checkbox*)FindObject(".g2.trashmanager"))->State()==PRESSED)
		{
			((trashmgr*)pl)->runmode=1;
			((trashmgr*)pl)->timelimit=14;
		}
		else
		{
			((trashmgr*)pl)->runmode=2;
			((trashmgr*)pl)->timelimit=14;
		}
	}
	if (pl=prgplugins->find("check new release"))
	{
		if (((checkbox*)FindObject(".g2.checknewrelease"))->State()==PRESSED)
		{
			((check_new_release*)pl)->mode=0;
			((check_new_release*)pl)->enable=1;
		}
	}

	return 0;
}
static void wiz_back(gadget *,int)
{
	switch (wiz_position)
	{
		case 0:
		case 1:
			wiz_position=0;
			w_next->Lock();
			w_back->Lock();
			break;
		case 2:
		case 3:
		case 4:
			wiz_position=1;
			break;		
		case 5:
		case 6:
		case 7:
			wiz_position=4;
			break;
		case 8:
			wiz_position=7;
			break;
		case 9:
			wiz_position=8;
			break;
		case 10:
			wiz_position=9;
			break;
		case 12:
			wiz_position=10;
			break;
	}
	w_ogroup[wiz_position]->Show();
	w_indicator->Value(wiz_position);
}
static void wiz_next(gadget *,int)
{
	switch (wiz_position)
	{
		case 0:
			wiz_position++;
			w_next->Unlock();
			w_back->Unlock();
			break;
		case 1: // POP3 ?
			if (((checkbox*)FindObject(".r1.pop3mail"))->State()==PRESSED)
				wiz_position=2;
			else if (((checkbox*)FindObject(".r1.localmail"))->State()==PRESSED)
				wiz_position=4;
			else
			{
				if (Alert(w_aw,"Generally it makes no sense\nto have neither a local nor a pop3 configuration!|Ignore|Change")==1)
				{
					wiz_position=4;
				}
			}
			break;
		case 2:
			if (!wiz_check_empty(".r2.popserver",POP_HOST_LEN))
			{
				Alert(w_aw,"Please enter a POP3 server hostname.");
				break;
			}
			if (!wiz_check_empty(".r2.popuser",POP_USER_LEN))
			{
				Alert(w_aw,"Please enter a POP3 account name.");
				break;
			}
			if (!wiz_check_empty(".r2.poppasswd",POP_PASS_LEN))
			{
				Alert(w_aw,"Please enter a POP3 account password.");
				break;
			}
		case 3:
			wiz_position++;
			break;
		case 4: // SMTP ?
			if (((mxknob*)FindObject(".s1.sendmail"))->Selected()==0)
				wiz_position=7;
			else
				wiz_position=5;
			break;
		case 5:
			if (!wiz_check_empty(".s2.sender",sizeof(programconfig.smtpsender)))
			{
				Alert(w_aw,"Please enter a SMTP server.");
				break;
			}
			if (!wiz_check_empty(".s2.authname",sizeof(programconfig.authname)))
			{
				Alert(w_aw,"Please enter your name.");
				break;
			}
			if (!wiz_check_empty(".s2.authaddress",sizeof(programconfig.authaddress)))
			{
				Alert(w_aw,"Please enter your email address.");
				break;
			}
		case 6:
		case 7:
		case 8:
		case 9:
			wiz_position++;
			break;
		case 10: // finished, start?
			wiz_position++;
			break;
		case 11: // finish & work
			wiz_position++;
			break;
		case 12: // finished - fine
			if (((checkbox*)FindObject(".g2.announcelist"))->State()==PRESSED)
			{
				createmail cm;
				cm.to(MAILLISTSUB_TO);
				cm.subject(PROGRAMNAME" "VERSION);
				cm.body(MAILLISTASUB_TEXT);
				cm.send();
			}
			if (((checkbox*)FindObject(".g2.mailinglist"))->State()==PRESSED)
			{
				createmail cm;
				cm.to(MAILLISTSUB_TO);
				cm.subject(PROGRAMNAME" "VERSION);
				cm.body(MAILLISTSUB_TEXT);
				cm.send();
			}

			close_wizard(NULL);
			break;
	}
	w_ogroup[wiz_position]->Show();
	w_indicator->Value(wiz_position);
	if (wiz_position==11)
	{
		int r;
		appwindow::UpdateEvent();
		if (r=wiz_store())
		{ // error
			wiz_position=r>0?r:10;
		}
		else
		{ // fine
			wiz_position=12;
		}
		w_ogroup[wiz_position]->Show();
		w_indicator->Value(wiz_position);
	}
}
static group *wiz_mkggs(void)
{
	text *txt;
	fbutton *fb;
	checkbox *cb;
	choice *ch;
	input *ip;
	group *gp1,*gp2,*ogp;
	mxknob *mk;

	w_ogroup[0]=new bordergroup;
	w_ogroup[0]->Name("g0");
	 txt=new text;
	 txt->Center();
	 txt->Text("{FONT_BIG}Welcome to "PROGRAMNAME" "VERSION"{/FONT}\n"
	           "This wizard will guide you though the "
			   "first steps of configuring "PROGRAMNAME".\n\n"
			   "If you don't want this (eg you know the program "
			   "already or don't like this or what ever)\n"
			   "you have now leave it.\n\n"
			   "You may change all settings later in the different\n"
			   "preferences dialogs.\n\n");
	w_ogroup[0]->Add(txt);
	 gp1=new group;
	 gp1->Horiz();
	  fb=new fbutton;
	  fb->Callback(wiz_abort);
	  fb->Text("leave wizard");
	 gp1->Add(fb);
	  fb=new fbutton;
	  fb->Callback(wiz_next);
	  fb->Text("use wizard");
	 gp1->Add(fb);
	w_ogroup[0]->Add(gp1);
	 txt=new text;
	 txt->Center();
	 txt->Text("This wizard is experimental and\nthe settings are not stored yet!\n");
	w_ogroup[0]->Add(txt);

	NEWOG(1,"r1","Receiving mail");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text("How do you receive mail?\n");
	ogp->Add(txt);
	 int haslocal=0;
	 cb=new checkbox;
	 cb->Name("localmail");
	 cb->Text("mail is locally available (mostly /var/spool/mail)\nor mounted via NFS");
	{
		char dir[300];
        dir[0]=0;
        char *mf=getenv("MAIL");
        if (mf)
        {
			strcpy(dir,mf);
        }
        else
        {
            char *uname=getusername();
            if (uname)
            {
                    strcpy(dir,MAILFOLDER);
                    strcat(dir,"/");
                    strcat(dir,uname);
            }
        }
		struct stat st;
		if (!stat(dir,&st))
		{
			if (st.st_size>0)
			{
				cb->State(PRESSED);
				haslocal=1;
			}
		}
	}
	ogp->Add(cb);
	 cb=new checkbox;
	 cb->Name("pop3mail");
	 cb->Text("I get mail from remote (eg an internet provider or a webmail)\nwith this POP3");
	 if (!haslocal)
	 	cb->State(PRESSED);
	ogp->Add(cb);


	NEWOG(2,"r2","POP3");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text("Specifiy the server from which you will\nget the mail - ie the POP3 server of your ISP.\n");
	ogp->Add(txt);
	 ip=new input;
 	 ip->Name("popserver");
 	 ip->Text("Server hostname");
 	 ip->MaxChars(POP_HOST_LEN);
 	 ip->HelpText("POP3 server (servername or servername:port)");
    ogp->Add(ip);
 	 ip=new input;
 	 ip->Name("popuser");
 	 ip->Text("Your account name");
 	 ip->MaxChars(POP_USER_LEN);
 	 ip->HelpText("POP3 account name");
    ogp->Add(ip);
 	 ip=new input;
 	 ip->Name("poppasswd");
 	 ip->Text("Account's password");
 	 ip->MaxChars(POP_PASS_LEN);
 	 ip->InvisibleMode();
 	 ip->HelpText("POP3 account password\nWill be saved in a file that\ncould be world readable!!");
    ogp->Add(ip);

	NEWOG(3,"r3","POP3 extras");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text("POP3 allows some nice features:\n");
	ogp->Add(txt);
     mk=new mxknob;
     char *mktxt[]={"leave on server","remove from server",NULL};
     mk->Name("popleave");
     mk->Items(mktxt);
     mk->Horiz();
	 mk->HelpText("Mail may be removed from server.\nThis will speed up later POP3 connections.");
	 mk->Selected(1);
	ogp->Add(mk,"After transfering the mail");
	 txt=new text;
	 txt->Text("Normally you should remove the mail because you have a\nlocal copy and some ISP's have a limit of mail which may\nbe stored on their servers.");
	ogp->Add(txt,"");
	ogp->Add(new ruler);
  	 gp2=new group;
	 gp2->Horiz();
	 gp2->Center();
	 gp2->Name(NULL);
	 gp2->HelpText("Do not transfer mails bigger than given value - 0 to transfer all");
	  ip=new input;
	  ip->Name("popmaxsize");
	  ip->IntegerMode();
	  ip->MaxChars(5);
	  ip->Weight(10);
	  ip->Default("500");
	 gp2->Add(ip);
 	  txt=new text;
 	  txt->Text(" KB automatically");
	  txt->Weight(150);
 	 gp2->Add(txt);
	ogp->Add(gp2,"Do not transfer mail bigger than");
	 txt=new text;
	 txt->Text("However, bigger mail can be received explicitely from within\nthe mail reader window.");
	ogp->Add(txt,"");
	ogp->Add(new ruler);
     cb=new checkbox;
     cb->Name("popdeleteonserver");
     cb->Text("Remove all locally deleted mails on server");
	ogp->Add(cb,NULL);
	 txt=new text;
	 txt->Text("If you do not want to remove the received mail on the server\nyou may remove individual mail. If you enable this all locally removed\nmail will also be removed on the server.");
	ogp->Add(txt,"");


	NEWOG(4,"s1","Sending mail");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text("How do you send mail?\n");
	ogp->Add(txt);
	 mk=new mxknob;
     char *mktxt2[]={"   local sendmail should be used\n   If you receive mail locally this is mostly possible.","   use remote server - a so called SMTP server\n   This is typically required if you use POP3 to get mail.",NULL};
     mk->Name("sendmail");
     mk->Items(mktxt2);
	 mk->Selected(1);
    {
		if (((checkbox*)FindObject(".localmail"))->State()==PRESSED)
			mk->Selected(0);
		else
			mk->Selected(1);
	}
	ogp->Add(mk);


	NEWOG(5,"s2","SMTP");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text("Specifiy the server for\nsending mail - ie the SMTP server of your ISP.\n");
	ogp->Add(txt);
 	 ip=new input;
 	 ip->Name("sender");
 	 ip->Text("Mail sender host (SMTP server)");
 	 ip->MaxChars(sizeof(programconfig.smtpsender));
 	 ip->HelpText("SMTP hostname, use <hostname> or <hostname>:<port>");
    ogp->Add(ip);
 	 ip=new input;
 	 ip->Name("authname");
 	 ip->Text("Your name");
 	 ip->MaxChars(sizeof(programconfig.authname));
 	 ip->HelpText("Your full name for the email header.");
    ogp->Add(ip);
 	 ip=new input;
 	 ip->Name("authaddress");
 	 ip->Text("Your email address");
 	 ip->MaxChars(sizeof(programconfig.authaddress));
 	 ip->HelpText("Your email address for the email header.");
    ogp->Add(ip);

	NEWOG(6,"s3","SMTP extras");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text("SMTP allows some nice features:\n");
	ogp->Add(txt);
     cb=new checkbox;
     cb->Name("outspool");
     cb->Text("Spool outgoing mail before sending\nSpool new mail in a local directory. Then, if you are online, you can\nsend all mail in a block.");
	 cb->State(PRESSED);
	ogp->Add(cb,NULL);


	NEWOG(7,"g1","General settings");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text(PROGRAMNAME" allows some features to be used:\n");
	ogp->Add(txt);
     cb=new checkbox;
     cb->Name("alwaysconnected");
     cb->Text("Are you always connected to the internet (eg a flat rate)?\nIf yes "PROGRAMNAME" may make some DNS queries it you specify an email recipient");
	ogp->Add(cb,NULL);
	ogp->Add(new ruler);
     cb=new checkbox;
     cb->Name("autoquote");
     cb->Text("automatically quote emails if replying\nIf you disable this you may quote an email manually when replying.");
	 cb->State(PRESSED);
	ogp->Add(cb,NULL);
	ogp->Add(new ruler);
     cb=new checkbox;
     cb->Name("useoutbox");
     cb->Text("Store all sent mail in an extra folder called 'outbox'?");
	 cb->State(PRESSED);
	ogp->Add(cb,NULL);

	NEWOG(8,"g2","General settings");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text(PROGRAMNAME" allows some features to be used:\n");
	ogp->Add(txt);
	if (prgplugins->find("Trash manager"))
	{
		 ogp->Add(new ruler);
    	  cb=new checkbox;
    	  cb->Name("trashmanager");
    	  cb->Text("Should deleted mail in the trash folder be removed\nafter 14 days automatically?");
		  cb->State(PRESSED);
		 ogp->Add(cb,NULL);
	}
	if (prgplugins->find("check new release"))
	{
		 ogp->Add(new ruler);
    	  cb=new checkbox;
    	  cb->Name("checknewrelease");
    	  cb->Text("Do you want to check for a new release of XCmail\nevery time you start XCmail - requires an internet connection!");
		 ogp->Add(cb,NULL);
	}
	ogp->Add(new ruler);
     cb=new checkbox;
     cb->Name("announcelist");
     cb->Text("Do you want subscribe the xcmail-announce mailing list\nwhich has less traffic and will inform you about new\nreleases and security issues on XCmail?");
	 cb->State(PRESSED);
	ogp->Add(cb,NULL);
	ogp->Add(new ruler);
     cb=new checkbox;
     cb->Name("mailinglist");
     cb->Text("Do you want subscribe the xcmail mailing list?\nIt's the main address to discusss problems, ask\nquestions and help other users.");
	ogp->Add(cb,NULL);


	NEWOG(9,"h1","Some hints");
	 txt=new text;
	 txt->Font(FONT_BIG);
	 txt->Text(PROGRAMNAME" note\n");
	ogp->Add(txt);
	 html_gadget *helptxt=new html_gadget;
	 helptxt->Text("<body>
XCmail has a special kind of mail folder management which
allows more flexibility:<p>
<center>Virtual folders</center><p>
A virtual folder (vfolder) may contain one or more real folders.
Real folders are for example the files on your hard disk (as you
might know it from other mail programs).<p>

Normally easy vfolder has only one real folder in it which has the same
name (filename) and you don't worry about it (if you want to use vfolders
you have to enable this function in the general preferences).<p>

However XCmail offers different places where and how to store folders
and you might hide this behind a vfolder. This different places are for
example:
<dl>
<dd>the Inbox
<dd>a POP3 Inbox
<dd>a 'normal' folder
<dd>a compressed folder
</dl><p>
This places are called IOs. A vfolder may contain as many real folders
from every IO as you want. But a typicall usage could be:
<dl>
<dd>a vfolder with all POP3 inboxes - so every POP3 server has an own
real folder where to story the mail but one vfolder for the user to
read and manage it
<dd>a vfolder with a normal folder and an archived compressed folder
</dl><p>
Finally there are different type of vfolders:
<ul>
<li>Inbox: XCmail checks this folders for new mail and will alert you
<li>Outbox: Sent mails could be stored in an outbox vfolder (which one
has to be setup in the network and transfer prefs) and if you open an
Outbox vfolder the recipient not the sender is shown in the mail list
<li>Trash: deleted mail is moved into the trash vfolder before it is
really removed - the first trash vfolder of each IO is used
<li>Received: this is not a really special vfolder - if you have enabled
to move mail into the received folder (general prefs/misc) the first
found received vfolder of each IO is used
<li>Folder: a 'normal' vfolder
</ul><p>
For more details on vfolders read the manual and check the folder manager
window ('Special' pull down menu).
</body>");
	ogp->Add(helptxt);


	NEWOG(10,"f1","Finished");
	 txt=new text;
	 txt->Center();
	 txt->Font(FONT_BIG);
	 txt->Text("We made it!\nPress 'next' to use this settings.");
	ogp->Add(txt);

	NEWOG(11,"f2","Setup");
	 txt=new text;
	 txt->Center();
	 txt->Font(FONT_BIG);
	 txt->Text("Working on it....");
	ogp->Add(txt);

	NEWOG(12,"f3","Finished");
	 txt=new text;
	 txt->Center();
	 txt->Text("{FONT_BIG}All fine!\n{/FONT}\nYou may now send a test email to a\nspecial auto answer robot on the XCmail\nhome server.\n\nLater, you can make this by selecting\nthe Xclasses pull down menu in the main window\nand choosing the entry 'Mailing lists/Send testmail with auto reply'.");
	ogp->Add(txt);
	 txt=new text;
	 txt->Center();
	 txt->Text("If you spool you mail you have to go online\nand then pop3 check to send the mail - and pop3 check\nafter a few minutes to check for new mail.");
	ogp->Add(txt);
	 fb=new fbutton;
	 fb->Callback(wiz_testmail);
	 fb->Text("send testmail");
	ogp->Add(fb);
	 txt=new text;
	 txt->Center();
	 txt->Text("You should get the auto reply in a few minutes.\nIf you don't get anything after 1/2 hour your\nsettings may be wrong!");
	ogp->Add(txt);
	
	return w_ogroup[0];
}
void run_setup_wizard(void)
{
	w_aw=new appwindow;
//	w_aw->InitSize(10);
	if (!w_aw->Init())
		return;

	w_aw->Name("wizardwindow");
	w_aw->Title(PROGRAMNAME" setup wizard");
	w_aw->IconTitle(PROGRAMNAME" setup wizard");
	w_aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
 	w_aw->Callback(close_wizard);

	spacegroup *maingp=new spacegroup;
	maingp->Name("maingroup");
	maingp->Vert();
	maingp->Border(4);
	 group *gp1=new group;
	 gp1->Horiz();
	 gp1->Name("titlegroup");
	 gp1->Center();
	 gp1->XDistance(5);
	  image *mimage=new image;
	  mimage->Object(f_xlogo);
	  mimage->NoBorder();
	 gp1->Add(mimage);
	  text *txt=new text;
	  txt->Font(FONT_BIG);
	  txt->Text(PROGRAMNAME" setup wizard");
	 gp1->Add(txt);
	maingp->Add(gp1);
	 gp1=new group;
	 gp1->Horiz();
	 gp1->UseSmallest();
	  txt=new text;
	  txt->Text("");
	  w_output=txt;
	 gp1->Add(txt);
	  indicator *ind=new indicator;
	  ind->HorizIndicator();
	  ind->MaxValue(WIZ_STEPS-1);
	  w_indicator=ind;
	 gp1->Add(ind);
	maingp->Add(gp1);
	maingp->Add(wiz_mkggs());
	maingp->Add(new ruler);
	 gp1=new group;
	 gp1->Horiz();
	 gp1->Name("controlgroup");
	 gp1->Center();
	 gp1->DialogMode();
	  button *b=new button;
	  b->Name("abort");
	  b->Text("Abort");
	  b->Callback(wiz_abort);
	  w_abort=b;
	 gp1->Add(b);
	  b=new button;
	  b->Name("back");
	  b->Text("<< Back");
	  b->Lock();
	  b->Callback(wiz_back);
	  w_back=b;
	 gp1->Add(b);
	  b=new button;
	  b->Name("next");
	  b->Text("Next >>");
	  b->Lock();
	  b->Callback(wiz_next);
	  w_next=b;
	 gp1->Add(b);
	maingp->Add(gp1);
	maingp->Add(new ruler);

	w_aw->SetGroup(maingp);
	w_aw->Create();

	while (appwindow::NextEvent()!=EV_FINISH) ;
}
