/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: showmail.cxx,v 2.30 2002/05/23 11:45:16 schmitzj Exp $ */


#include "configure.h"

#include <Xclasses/Xclasses.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <fcntl.h>

#include "mailer.h"
#include "encoder.h"
#include "helper.h"
#include "address_book.h"
#include "xfacegg.h"
#include "pluginsmgr.h"
#include "xc_snprintf.h"
#include "extraggs.h"

extern char *allfolders[];
static int opened=0;

void showmail::genname(void)
{
	if (!programconfig.oneshowmail)
	{ // Problem: bei gleicher Mail mehrfach - Name gleich,
	  //  deshalb Speicheradresse mit im Namen - keine gute Lsung.....
		int l=8+strlen(ml->from())+strlen(ml->subject())+strlen(ml->messageid())+strlen(ml->date())+20;
		objname=new char[l+1];
		xc_snprintf(objname,l+1,"%08x%s%s%s%s",ml,ml->from(),ml->subject(),ml->messageid(),ml->date());
	}
	else
	{
		objname=new char[21];
		strcpy(objname,"one_showmail");
	}
	TranslateName(objname);
}

showmail::showmail(Xclasses *parent,mail *m) : decoder_abstract(), fd(), clonedplugins()
{
	showmail *sm;
	ml=m;
	ml->addreferer();
	mtype=SHOW;
	genname();
	ParentClass(parent);
	Name("showmail");
	h=NULL;
	helper_count=0;
	for (int i=0;i<=MAXUSERMAIL;i++)
		allfolders[i]=NULL;
	useautotext=programconfig.autotext;

	pluginsmenu=0;
	helpermenu=0;
	showmailpluginmenucount=0;

	if (sm=(showmail*)FindObject(parent->FullName(),objname))
	{
		sm->raise(m);
		delete this;
	}
	else
	{
		Name(objname);
		opened++;
		headw=NULL;
		makewin();
		add_auto_book(ml->from(),ml->from_email(),ml->xface());
		folderlist->registerfolderfunction(this);
	}
}
showmail::showmail(Xclasses *parent,mail *m,int x,int y,int w,int h) : decoder_abstract(), fd(), clonedplugins()
{
	showmail *sm;
	ml=m;
	ml->addreferer();
	mtype=SHOW;
	genname();
	ParentClass(parent);
	Name("showmail");
	showmail::h=NULL;
	helper_count=0;
	for (int i=0;i<=MAXUSERMAIL;i++)
		allfolders[i]=NULL;
	useautotext=programconfig.autotext;

	pluginsmenu=0;
	helpermenu=0;
	showmailpluginmenucount=0;

	if (sm=(showmail*)FindObject(parent->FullName(),objname))
	{
		sm->raise(m);
		delete this;
	}
	else
	{
		Name(objname);
		opened++;
		headw=NULL;
		makewin(x,y,w,h);
		folderlist->registerfolderfunction(this);
	}
}
showmail::~showmail()
{
	folderlist->unregisterfolderfunction(this);

	showmailplugin *sp;
	while (sp=(showmailplugin*)clonedplugins.RemTail())
	{
		sp->finish(this);
		if (sp->flags & PLF_CLONEUSE)
		{
			delete sp;
		}
	}

	group *g=(group*)FindObject(FullName(),".textboxgroup");
	if (g) g->Show();
	visible *v=(visible*)FindObject(FullName(),".visiblegroup.helpervisible");
	if (v) v->Apply(NULL);
	if (h) delete h;
	DeleteObjectTree(FullName(),DOT_NOTBASE);
	opened--;
	ml->freemem();
	delete objname;
	for (int i=0;i<=MAXUSERMAIL;i++)
		if (allfolders[i]) free(allfolders[i]);
	ml->remreferer();
}

void showmail::quit(gadget *g,int i)
{
	((appwindow*)FindObject(FullName(),"window"))->Close();
	delete this;
}
void showmail::bigtext(char *t)
{
	((text*)FindObject(FullName(),".etext"))->Text(t);
	((group*)FindObject(FullName(),".externalgroup"))->Show();
}
void showmail::showtext(char *txt,int size)
{
	int mmen=0;
	if (mtype==PREVIEW || mtype==SHOW)
		((group*)FindObject(FullName(),".textboxgroup"))->Show();
	((visible*)FindObject(FullName(),".helpervisible"))->Apply(NULL);
	if (h) delete h;
	h=NULL;

	if (size>0)
	{
		if (mtype==PREVIEW)
		{ // call helper, set for txt to show it
			h=prghelper->find(command);
			if (h) h=h->clone(txt,size);
			if (h)
			{
				h->mail=(void*)ml;
				h->partnb=((listview*)FindObject(FullName(),".attachments"))->Selected();
				char *t=h->go(size);
				if (t) txt=t;
				if (h->flags & HL_GADGETS)
				{
					if (h->makegadget((visible*)FindObject(FullName(),".helpervisible")))
					{
						((group*)FindObject(FullName(),".visiblegroup"))->Show();
					}
				}
				if (h->flags & HL_PDMENU)
				{
					makemenu((menu*)FindObject(FullName(),".menu"));
					mmen=1;
				}
			}
		}
		else if (mtype==COMMAND)
		{ // start program
			char *name=ml->getContentTag("Name=",((listview*)FindObject(FullName(),".attachments"))->Selected());
			if (!name) name="a";
			char buf[100+strlen(name)],com[110+COMMANDLEN+strlen(name)],scom[110+COMMANDLEN+110+50+strlen(name)];
			FILE *f;
			int p;

			xc_snprintf(buf,sizeof(buf),TMPDIR"/"PROGRAMNAME"_helper_%x_%d%d_%s",this,helper_count++,opened,name);
			char *c=buf+strlen(TMPDIR"/"PROGRAMNAME);

			while (*c)
			{
				if (!isalnum(*c)) *c='_';
				c++;
			}

			if (f=fopen(buf,"w"))
			{
				fwrite(txt,1,size,f);
				fclose(f);

				fcntl(ConnectionNumber(((menu*)FindObject(FullName(),".menu"))->display()),F_SETFD,1);

				p=fork();
				if (p==0)
				{
					xc_snprintf(com,sizeof(com),command,buf);
					xc_snprintf(scom,sizeof(scom),"%s;rm -f %s",com,buf);
					execl("/bin/sh","sh","-c",scom,0);
					remove(buf);
					_exit(127);
				}
			}
			if (!mmen) makemenu((menu*)FindObject(FullName(),".menu"));
			return;
		}
	}

	if (!mmen) makemenu((menu*)FindObject(FullName(),".menu"));
	if (useautotext)
	{
		((autotextbox*)FindObject(FullName(),".mailbody"))->ReplaceText(txt);
	}
	else
	{
		((textbox*)FindObject(FullName(),".mailbody"))->ReplaceText(txt);
	}
}
void showmail::decode(int s,char *path,char *filename)
{
	if (decoder_abstract::decode((appwindow*)FindObject(FullName(),"window"),s,path,filename))
	{ // write unsuccessfull
		easy_dialog ed;
		ed.Text("Couldn't write file\non disk - maybe it's full.");
		ed.Options("_Ok");
		ed.Start((appwindow*)FindObject(FullName(),"window"));
	}
}
int showmail::attahook(struct hook_data *hd)
{
	if (ml->getfreeflag(hd->number,1))
	{
		if (hd->flags & HD_SELECTED)
			XSetForeground(hd->drawable->display(),hd->drawable->gg_gc(),hd->drawable->col_active());
		else
			XSetForeground(hd->drawable->display(),hd->drawable->gg_gc(),hd->drawable->col_shadow());
	}
	return 1;
}
void showmail::handler(gadget *g,int i)
{
	if (!strcmp(g->Name(),"delete"))
	{
		ml->deleteMail((deletebutton*)g);
// obsolete		updateoutput(ml);
		if (!programconfig.oneshowmail) quit(NULL,0);
	}
	else if (!strcmp(g->Name(),"forward"))
	{
		lvforward(ml);
		if (!programconfig.oneshowmail) quit(NULL,0);
	}
	else if (!strcmp(g->Name(),"reply"))
	{
		lvreply(ml);
		if (!programconfig.oneshowmail) quit(NULL,0);
	}
	else if (!strcmp(g->Name(),"delete_nextunread"))
	{
		int x,y,w,h;
		appwindow *aw=((appwindow*)FindObject(FullName(),"window"));

		aw->WMPosition(x,y);
		aw->Size(w,h);
		ml->deleteMail((deletebutton*)g);
// obsolete		updateoutput(ml);
		lvnext(ml,x,y,w,h);
		if (!programconfig.oneshowmail) quit(NULL,0);
	}
	else if (!strcmp(g->Name(),"nextunread"))
	{
		int x,y,w,h;
		appwindow *aw=((appwindow*)FindObject(FullName(),"window"));

		aw->WMPosition(x,y);
		aw->Size(w,h);
		lvnext(ml,x,y,w,h);
		if (!programconfig.oneshowmail) quit(NULL,0);
	}
	else if (!strcmp(g->Name(),"next"))
	{
		int x,y,w,h;
		appwindow *aw=((appwindow*)FindObject(FullName(),"window"));

		aw->WMPosition(x,y);
		aw->Size(w,h);
		lvnextmailof(ml,x,y,w,h);
// obsolete		updateoutput();
		if (!programconfig.oneshowmail) quit(NULL,0);
	}
	else if (!strcmp(g->Name(),"prev"))
	{
		int x,y,w,h;
		appwindow *aw=((appwindow*)FindObject(FullName(),"window"));

		aw->WMPosition(x,y);
		aw->Size(w,h);
		lvprevmailof(ml,x,y,w,h);
// obsolete		updateoutput();
		if (!programconfig.oneshowmail) quit(NULL,0);
	}
	else if (!strcmp(g->Name(),"attachments"))
	{
		int size=0;
		HANDLEMAIL t;
//		textbox *txt=(textbox*)FindObject(FullName(),".mailbody");
		int s=((listview*)g)->Selected();
		char *name=ml->getContentTag("Name=",s);

		ml->setfreeflag(s,1,1);
		if (prgcap.find(ml->submime1(s),ml->submime2(s),t,command,name))
		{
			mtype=t;
			if (t==SHOW)
			{
				decode(s);
				lastselected=s;
			}
			else if (t==SAVE)
			{
				bigtext("Part not showable,\nsaving...\n");
				fd.SaveMode();
				if (strlen(name))
					fd.SetFile(name);
				if (fd.Start((appwindow*)FindObject(FullName(),"window")))
				{
					char buf[400];
					char f[200];

					fd.GetDir(buf,sizeof(buf));
					fd.GetFile(f,sizeof(f));

					decode(s,buf,f);
				}
				if (s!=lastselected)
				{
					((listview*)g)->Selected(lastselected);
					char *name=ml->getContentTag("Name=",lastselected);
					prgcap.find(ml->submime1(lastselected),ml->submime2(lastselected),t,command,name);
					mtype=t;
					decode(lastselected);
				}
			}
			else if (t==PREVIEW)
			{
				decode(s);
				lastselected=s;
			}
			else
			{
				int size=0;

				bigtext("Part not showable,\nlaunching external progamm...\n");
				decode(s);
				lastselected=s;
			}
		}
		else
		{
			decode(s);
			lastselected=s;
		}
	}
	else if (!strcmp(g->Name(),"addaddress"))
	{
		addressbookupdate(ml->from(),ml->replyto(),NULL,NULL,NULL,ml->xface());
	}
	else if (!strcmp(g->Name(),"menu"))
	{
		switch (((menu*)g)->Selection())
		{
			case 0x01000001: // Close
				quit(NULL,0);
				break;
			case 0x01000002: // Quit
				quitprg();
				break;
			case 0x01000003: // Header
				if (((menu*)g)->State(1,3))
				{ // header
					if (!headw)
					{
						makeheadw();
					}
				}
				else
				{
					closehead(NULL);
				}
				break;
			case 0x01000004: // Save as
				{
					group fdgp;
					choice savemd;
					char *it[4];

					char *name=ml->getContentTag("Name=",((listview*)FindObject(FullName(),".attachments"))->Selected());

					if (strlen(name))
						fd.SetFile(name);
					fd.SaveMode();
					if (mtype==PREVIEW)
					{
						it[0]="encoded text";
						it[1]="parsed text";
						it[2]="original text";
						it[3]=NULL;
					}
					else if (mtype==COMMAND)
					{
						it[0]="original";
						it[1]=NULL;
					}
					else
					{
						it[0]="encoded text";
						it[1]="original text";
						it[2]=NULL;
					}

					fdgp.Add(savemd);
					 savemd.Items(it);
					fd.InsertGroup(fdgp);
					if (fd.Start((appwindow*)FindObject(FullName(),"window")))
					{
						char buf[400];
						char f[200];
						FILE *fl;
						fd.GetDir(buf,sizeof(buf));
						fd.GetFile(f,sizeof(f));
						if (savemd.Selected()==0)
						{
							decode(((listview*)FindObject(FullName(),".attachments"))->Selected(),buf,f);
						}
						else if (mtype==PREVIEW && savemd.Selected()==1)
						{
							strcat(buf,f);
							if (fl=fopen(buf,"w"))
							{
								int size=0;
								char *buf;
								if (useautotext)
								{
									size=((autotextbox*)FindObject(FullName(),".mailbody"))->TextSize();
									buf=new char[size+1];
									((autotextbox*)FindObject(FullName(),".mailbody"))->CopyText(buf,size+1);
								}
								else
								{
									size=((textbox*)FindObject(FullName(),".mailbody"))->TextSize();
									buf=new char[size+1];
									((textbox*)FindObject(FullName(),".mailbody"))->CopyText(buf,size+1);
								}
								fwrite(buf,1,size,fl);
								fclose(fl);
							}
						}
						else
						{
							strcat(buf,f);
							if (fl=fopen(buf,"w"))
							{
								int size=0;
								char *m=ml->mailbody(size,((listview*)FindObject(FullName(),".attachments"))->Selected());
								fwrite(m,1,size,fl);
								fclose(fl);
							}
						}
					}
				}
				break;
			case 0x01000005: // Print
				new printmail((appwindow*)FindObject(FullName(),"window"),ml,((listview*)FindObject(FullName(),".attachments"))->Selected());
				break;
#ifdef USEPGP
			case 0x01000006: // add PGP key to keyring
				{
					int size;
					PGPaddkey((appwindow*)FindObject(FullName(),"window"),ml->mailbody(size,((listview*)FindObject(FullName(),".attachments"))->Selected()));
				}
				break;
#endif

			case 0x01000007: // new mail
				new newmail;
				break;
			case 0x01000008: // copy to - choose
			case 0x01000009: // move to - choose
				{
 					int sve=(((menu*)g)->Selection()==0x01000009?STATUS_DELETE:0);
					char *t;
					if (sve==0)
						t="Copy mail to...";
					else
						t="Move mail to...";

					vfolder *v=folderlist->chooseFolder(((appwindow*)FindObject(FullName(),"window")),RL_WRITEABLES,t);
					if (v)
					{
						mail *m2=new mail(ml);
						m2->addreferer();
						m2->status(m2->status() & ~STATUS_DELETE & ~STATUS_SERVERDELETE);
						m2->clearsavedate();
						if (!v->appendmail_default(m2))
						{
							ml->status(ml->status() | STATUS_SAVED);
							if (sve)
								ml->deleteLocalMail();
						}
						m2->remreferer();
					}
				}
				break;
			default:
				if (((menu*)g)->Selection()>=0x01001000 && ((menu*)g)->Selection()<0x01003000)
				{ // copy/move to folder
 					int sub=(((menu*)g)->Selection()>=0x01002000?0x01002000:0x01001000);
 					int sve=(((menu*)g)->Selection()>=0x01002000?STATUS_DELETE:0);

					vfolder *v=folderlist->getfolder(((menu*)g)->Selection()-sub,RL_WRITEABLES);
					if (v)
					{
						mail *m2=new mail(ml);
						m2->addreferer();
						m2->status(m2->status() & ~STATUS_DELETE & ~STATUS_SERVERDELETE);
						m2->clearsavedate();
						if (!v->appendmail_default(m2))
						{
							ml->status(ml->status() | STATUS_SAVED);
							if (sve)
								ml->deleteLocalMail();
						}
						m2->remreferer();
					}
				}
				else if (h && helpermenu && ((menu*)g)->Menu()>=helpermenu)
				{
					h->menuhandler((menu*)g,((menu*)g)->MID());
				}
				else if (pluginsmenu && ((menu*)g)->Menu()>=pluginsmenu)
				{
					showmailpluginmenu[((menu*)g)->MID()-1].pl->handle(showmailpluginmenu[((menu*)g)->MID()-1].id,this);
				}
				break;
		}
	}
}
int showmail::askBeforeShow(void)
{
	char *txt;
	if ((txt=ml->getTag("X-AskBefore:")) && strlen(txt))
	{
		char buf[500];
		easy_dialog ed;

		Translate728Line(txt);

		xc_snprintf(buf,sizeof(buf),"{FONT_BIG}The sender wants you to know this\nbefore reading the mail:{/FONT}\n\n{FONT_FIXED}%s{/FONT}\n",txt);
		ed.Text(buf);
		ed.Options("_Show mail now|_Don't show");
		return ed.Start((appwindow*)FindObject(FullName(),"window"))==1?1:0;
	}
	return 1;
}

void showmail::updatefolders(void)
{
	makemenu((menu*)FindObject(FullName(),".menu"));
}

void showmail::makemenu(menu *mne)
{
	if (!mne) return;

	mne->Clear();
	mne->AddMenu("Message");
	mne->AddSel("Show header",3);
	mne->AddRuler();
	mne->AddSub("Copy to folder");
	if (!programconfig.old_choose_folder)
	{
		mne->Add("choose from all...",8);
		mne->AddRuler();
	}
	{
		int i=0;
		char **a=folderlist->readlist(RL_WRITEABLES);
		while (a[i])
		{
			if (a[i][0]!='>' || programconfig.old_choose_folder)
				mne->Add(a[i],0x1000+i);
			i++;
		}
	}
	mne->EndSub();
	mne->AddSub("Move to folder");
	mne->Add("choose from all...",9);
	mne->AddRuler();
	{
		int i=0;
		char **a=folderlist->readlist(RL_WRITEABLES);
		while (a[i])
		{
			if (a[i][0]!='>')
				mne->Add(a[i],0x2000+i);
			i++;
		}
	}
	mne->EndSub();
	mne->Add("Save as...","s",4);
	mne->Add("Print...","p",5);
	mne->AddRuler();
	mne->Add("Create new mail...","m",7);
	mne->AddRuler();
#ifdef USEPGP
	if (programconfig.usepgp)
	{
		mne->Add("Add PGP key to keyring","k",6);
		if (!ispgpkey) mne->LockItem(1,6);
		mne->AddRuler();
	}
#endif
	mne->Add("Close","w",1);
	mne->Add("Quit program","q",2);

	{
		int f=0;
		for(int i=0;i<showmailpluginmenucount;i++)
		{
			if (!f)
			{
				mne->AddMenu("Extras");
				f=1;
				pluginsmenu=2;
			}
			if (showmailpluginmenu[i].shortcut)
			{
				mne->Add(showmailpluginmenu[i].text,showmailpluginmenu[i].shortcut,i+1);
			}
			else
			{
				mne->Add(showmailpluginmenu[i].text,i+1);
			}
		}
	}

	if (h && (h->flags & HL_PDMENU))
	{
		if (pluginsmenu) helpermenu=3; else helpermenu=2;
		h->makemenu(mne,helpermenu);
	}

	mne->Recreate();
}

void showmail::makewin(int x,int y,int w,int h)
{
	char buf[300];
	appwindow *aw=new appwindow;

	aw->ParentClass(this);
	aw->Name("window");

	if (h>0)
	{
		aw->InitSize(x,y,w,h);
	}
	else
	{
		readerwin.WMPosition(x,y);
		aw->InitSize(x+(opened-1)*5,y+(opened-1)*5,40);
	}
	pstatus("Open reader window");

	if (!aw->Init())
	{
		delete this;
		pstatus("Error in opening window!");
	}
	aw->Callback(this,(CLOSECALLBACK)&showmail::quit);
	aw->Group(readerwin);
//	aw->TransientFor(readerwin.window());

	spacegroup *maingp=new spacegroup;
	maingp->Name("maingroup");
	maingp->Border(4);
	maingp->YDistance(5);
	maingp->Vert();
	 group *gp1=new group,*gp2=new group;
	maingp->Add(gp1);
	 gp1->Name(NULL);
	 gp1->UseSmallest();
	 gp1->Horiz();
	  gp2->Name(NULL);
	  gp2->Weight(150);
	  gp2->Vert();
	   text *txt1=new text;
	    txt1->Name("mailercool");
	    txt1->Right();
	    char *dummy=ml->getTag("X-Mailer:");
	    if (dummy && !strcncmp(PROGRAMNAME,dummy))
		    txt1->Text(PROGRAMNAME);
	    else
		    txt1->Text("");
	  gp2->Add(txt1);
	   group *gp3=new group;
	   gp3->Horiz();
	   gp3->UseSmallest();
	   gp3->Name(NULL);
	    xc_snprintf(buf,sizeof(buf),"%s <%s>",ml->displayfrom(),ml->from_email());
	    output *op=new output;
		op->Name("from");
	    op->Output(buf);
	   gp3->Add(op);
	    button *bt=new button;
	    bt->Name("addaddress");
	    bt->Text("to _addressbook...");
	    bt->Callback(this,(CALLBACK)&showmail::handler);
	    bt->Weight(10);
	   gp3->Add(bt);
	  gp2->Add(gp3,"From");
	   op=new output;
	   op->Name("to");
	   op->Text("To");
	   op->Output(ml->displayto());
	  gp2->Add(op);
	   op=new output;
	   op->Name("cc");
	   op->Text("Cc");
	   op->Output(ml->displaycc());
	  gp2->Add(op);
	   op=new output;
	   op->Name("subject");
	   op->Text("Subject");
	   op->Output(ml->subject());
	  gp2->Add(op);
	   op=new output;
	   op->Name("date");
	   op->Text("Date");

	    char dbuf[100];
		int d1,d2,d3,d4,d5,d6;
		time_t t = ml->parsefromdate(d1,d2,d3,d4,d5,d6);
		xc_snprintf(dbuf,sizeof(dbuf), "%s (sender %s)", ctime(&t),ml->date());
		op->Output(dbuf);

	  gp2->Add(op);
	 gp1->Add(gp2);
	  ruler *rl1=new ruler;
	  rl1->Vert();
	 gp1->Add(rl1);
	 gp2=new group;
	  gp2->Name(NULL);
	  gp2->Weight(50);
	  gp2->Vert();
	   text *txt2=new text;
	    txt2->Center();
	    txt2->Text("Attachments");
	   gp2->Add(txt2);
	   listview *atta=new listview;
	   atta->Name("attachments");
	   atta->SetHook(this,(SETHOOK) &showmail::attahook,NULL);
	   atta->ShowSelected();
	  gp2->Add(atta);
	 gp1->Add(gp2);

	textbox *atxt;
	 if (useautotext)
	 {
		atxt=new autotextbox;
	 }
	 else
	 {
		atxt=new textbox;
	 }
	 atxt->Name("mailbody");
	 atxt->ReadOnly();
	 atxt->MinCols(40);
	 atxt->MinRows(4);
	 gp1=new group;
	 gp1->Name("textboxgroup");
	 gp1->Add(atxt);
	 gp2=new group;
	 gp2->Name("visiblegroup");
	 gp1->AddShadow(gp2);
	 visible *vis=new visible;
	 vis->Name("helpervisible");
	 gp2->Add(vis);

	 gp2=new group;
	 gp2->Name("externalgroup");
	 gp2->Center();
	 gp1->AddShadow(gp2);
	 text *etxt=new text;
	 etxt->Name("etext");
	 etxt->Font(FONT_BIG);
	 etxt->Center();
	 etxt->NoUnderline();
	 etxt->Text("\n\n");
	 gp2->Add(etxt);

	maingp->Add(gp1);
//	maingp->Add(atxt);

	 group *ctl=new group;
	maingp->Add(ctl);
	 ctl->Horiz();
	 ctl->UseSmallest();
	  ruler *r;
	  fbutton *b;
	  deletebutton *db;
	  b=new fbutton;
	  b->Name("nextunread");
	  b->Text("_Next unread...");
	  b->Callback(this,(CALLBACK)&showmail::handler);
	 ctl->Add(b);
	  b=new fbutton;
	  b->Name("next");
	  b->Text("N_ext...");
	  b->Callback(this,(CALLBACK)&showmail::handler);
	 ctl->Add(b);
	  b=new fbutton;
	  b->Name("prev");
	  b->Text("_Prev...");
	  b->Callback(this,(CALLBACK)&showmail::handler);
	 ctl->Add(b);
	  r=new ruler;
	  r->Vert();
	 ctl->Add(r);
	  b=new fbutton;
	  b->Name("reply");
	  b->Text("_Reply...");
	  b->Callback(this,(CALLBACK)&showmail::handler);
	 ctl->Add(b);
	  b=new fbutton;
	  b->Name("forward");
	  b->Text("_Forward...");
	  b->Callback(this,(CALLBACK)&showmail::handler);
	 ctl->Add(b);
	  r=new ruler;
	  r->Vert();
	 ctl->Add(r);
	  db=new deletebutton;
	  db->Name("delete");
	  db->Text("_Delete");
	  db->Callback(this,(CALLBACK)&showmail::handler);
	  db->CheckMailStatus(ml);
	  if (ml->g_parent()->readonly) db->Lock();
	 ctl->Add(db);

	  db=new deletebutton;
	  db->Name("delete_nextunread");
	  db->Text("& next _unread");
	  db->Callback(this,(CALLBACK)&showmail::handler);
	  db->Weight(10);
	  db->HelpText("delete this mail and\nshow next unread mail");
	  db->CheckMailStatus(ml);
	  if (ml->g_parent()->readonly) db->Lock();
	 ctl->Add(db);

	  r=new ruler;
	  r->Vert();
	 ctl->Add(r);
	  b=new fbutton;
	  b->Name("close");
	  b->Weight(150);
	  b->Text("_Close");
	  b->Callback(this,(CALLBACK)&showmail::quit);
	  b->ApplyXKey(XK_Escape);
	 ctl->Add(b);
	aw->SetGroup(maingp);

	{
		showmailplugin *mp=NULL;

		while (mp=(showmailplugin*)prgplugins->nextOfType(plugins::PT_Showmailtool,mp))
		{
			if (mp->flags & PLF_CLONEUSE)
			{
				showmailplugin *m=mp->clone();
				clonedplugins.AddTail(m);
				m->init(this);
			}
			else
				mp->init(this);
		}
	}
	showmailpluginmenucount=::showmailpluginmenucount;
	for(int j=0;j<showmailpluginmenucount;j++)
		showmailpluginmenu[j]=::showmailpluginmenu[j];
	::showmailpluginmenucount=0;

	menu *mne=new menu;
	mne->Name("menu");
	mne->Callback(this,(CALLBACK)&showmail::handler);
	makemenu(mne);

	char *xface=ml->xface();
	xfacegg *xf=NULL;
#ifdef COOLMENU
	if ((xface && strlen(xface)) || programconfig.oneshowmail)
	{
		group *mgroup=new group;
		mgroup->Name(NULL);
		mgroup->Horiz();
		mgroup->UseSmallest();
		mgroup->XDistance(1);
		xf=new xfacegg;
		xf->Name("xface");
		xf->XFace(xface);
		mgroup->Add(xf);
		mgroup->Add(mne);
		aw->SetMenu((menu*) (gadget*)mgroup);
	}
	else
		aw->SetMenu(mne);
#else
	aw->SetMenu(mne);
#endif

 	strncpy(buf,ml->from(),sizeof(buf)-1); buf[sizeof(buf)-1]=0;
 	strncat(buf,": ",sizeof(buf)-strlen(buf)-1); buf[sizeof(buf)-1]=0;
 	strncat(buf,ml->subject(),sizeof(buf)-strlen(buf)-1); buf[sizeof(buf)-1]=0;
	aw->Title(buf);
	aw->IconTitle(buf);

	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
	aw->Keyclass()->SendKeyTo(XK_Up,0,atxt);
	aw->Keyclass()->SendKeyTo(XK_Down,0,atxt);
	aw->Create();

	if (xf && strlen(xface))
		aw->SetIcon(xf->iconmap(),xf->shadowmap());

	int pr=1;
	if (ml->totalparts()<0 && !(pr=ml->PGPdecode(aw)))
	{
		bigtext("PGP error:\nCan't decode mail.");
		return;
	}

	atta=(listview*)FindObject(FullName(),".attachments");
	if (ml->totalparts()==0)
	{
		atta->AddAtEnd(ml->partname(0));
	}
	else
	{
		char buf[200],*b;
		for(int i=1;i<=abs(ml->totalparts());i++)
		{
			ml->setfreeflag(i,1,0);
			b=ml->getContentTag("name=",i);
			if (b && strlen(b))
				xc_snprintf(buf,sizeof(buf),"%s (%s) (%s/%s)",ml->partname(i),b,ml->submime1(i),ml->submime2(i));
			else
				xc_snprintf(buf,sizeof(buf),"%s (%s/%s)",ml->partname(i),ml->submime1(i),ml->submime2(i));
			atta->AddAtEnd(buf);
		}
		atta->Callback(this,(CALLBACK)&showmail::handler);
	}
	atta->Selected(1);
	lastselected=1;

	if (askBeforeShow()) handler(atta,0);
	atxt->ActivateKey();
}

void showmail::updatemail(void)
{
	appwindow *aw=((appwindow*)FindObject(FullName(),"window"));
	listview *atta=(listview*)FindObject(FullName(),".attachments");
	atta->RemoveAll();

	char buf[300];
 	strncpy(buf,ml->from(),sizeof(buf)-1); buf[sizeof(buf)-1]=0;
 	strncat(buf,": ",sizeof(buf)-strlen(buf)-1); buf[sizeof(buf)-1]=0;
 	strncat(buf,ml->subject(),sizeof(buf)-strlen(buf)-1); buf[sizeof(buf)-1]=0;
	aw->Title(buf);
	aw->IconTitle(buf);

    char *dummy=ml->getTag("X-Mailer:");
    if (dummy && !strcncmp(PROGRAMNAME,dummy))
	    ((text*)FindObject(FullName(),".mailercool"))->Text(PROGRAMNAME);
    else
	    ((text*)FindObject(FullName(),".mailercool"))->Text("");

    xc_snprintf(buf,sizeof(buf),"%s <%s>",ml->displayfrom(),ml->from_email());
	((output*)FindObject(FullName(),".from"))->Output(buf);
	((output*)FindObject(FullName(),".to"))->Output(ml->displayto());
	((output*)FindObject(FullName(),".cc"))->Output(ml->displaycc());
	((output*)FindObject(FullName(),".subject"))->Output(ml->subject());
	((textbox*)FindObject(FullName(),".mailbody"))->ReplaceText("");


	((deletebutton*)FindObject(FullName(),".delete"))->CheckMailStatus(ml);
	if (ml->g_parent()->readonly)
		((deletebutton*)FindObject(FullName(),".delete"))->Lock();
	else
		((deletebutton*)FindObject(FullName(),".delete"))->Unlock();

	((deletebutton*)FindObject(FullName(),".delete_nextunread"))->CheckMailStatus(ml);
	if (ml->g_parent()->readonly)
		((deletebutton*)FindObject(FullName(),".delete_nextunread"))->Lock();
	else
		((deletebutton*)FindObject(FullName(),".delete_nextunread"))->Unlock();

	char dbuf[100],dbuf2[50];
	int d1,d2,d3,d4,d5,d6;
	time_t t = ml->parsefromdate(d1,d2,d3,d4,d5,d6);
	xc_snprintf(dbuf,sizeof(buf), "%s (sender %s)", ctime(&t),ml->date());
	((output*)FindObject(FullName(),".date"))->Output(dbuf);


	int pr=1;
	if (ml->totalparts()<0 && !(pr=ml->PGPdecode(aw)))
	{
		bigtext("PGP error:\nCan't decode mail.");
		return;
	}

	if (ml->totalparts()==0)
	{
		atta->AddAtEnd(ml->partname(0));
		atta->Callback(NULL,(CALLBACK)0);
	}
	else
	{
		char buf[200],*b;
		for(int i=1;i<=abs(ml->totalparts());i++)
		{
			ml->setfreeflag(i,1,0);
			b=ml->getContentTag("name=",i);
			if (b && strlen(b))
				xc_snprintf(buf,sizeof(buf),"%s (%s) (%s/%s)",ml->partname(i),b,ml->submime1(i),ml->submime2(i));
			else
				xc_snprintf(buf,sizeof(buf),"%s (%s/%s)",ml->partname(i),ml->submime1(i),ml->submime2(i));
			atta->AddAtEnd(buf);
		}
		atta->Callback(this,(CALLBACK)&showmail::handler);
	}

#ifdef COOLMENU
	char *xface=ml->xface();
	xfacegg *xf=(xfacegg*)FindObject(FullName(),".xface");
	xf->XFace(xface);

	if (xf && strlen(xface))
		aw->SetIcon(xf->iconmap(),xf->shadowmap());
	else
		aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
#endif

	atta->Selected(1);
	lastselected=1;

	if (askBeforeShow()) handler(atta,0);
	((textbox*)FindObject(FullName(),".mailbody"))->CursorTo(0,0);
	((textbox*)FindObject(FullName(),".mailbody"))->TopLine(0);
	((textbox*)FindObject(FullName(),".mailbody"))->ActivateKey();
}
void showmail::raise(mail *m)
{
	if (m && m!=ml)
	{
		ml->remreferer();
		ml=m;
		m->addreferer();
		
		updatemail();
		updatehead();

		add_auto_book(ml->from(),ml->from_email(),ml->xface());
	}
	appwindow *aw=((appwindow*)FindObject(FullName(),"window"));
	aw->Raise();
	aw->Open();
}

void showmail::updatehead(void)
{
	if (headw)
	{
		((textbox*)FindObject(headw->FullName(),".headtext"))->ReplaceText(ml->header());
	}
}
void showmail::closehead(appwindow *aw)
{
	if (headw)
	{
		((menu*)FindObject(FullName(),".menu"))->State(1,3,RELEASED);
		DeleteObjectTree(headw->FullName(),0);
		headw=NULL;
	}
}
void showmail::makeheadw(void)
{
	if (headw) return;

	headw=new appwindow;
	headw->ParentClass(this);
	headw->Name("header_window");
	headw->InitSize(60);
	headw->Init();
	headw->Title("Mail header");
	headw->IconTitle("Mail header");
	headw->Callback(this,(CLOSECALLBACK)&showmail::closehead);
	headw->Group(readerwin);
	headw->TransientFor(((appwindow*)FindObject(FullName(),"window")));

	bordergroup *g=new bordergroup;
	g->Name(NULL);
	g->Vert();
	g->YDistance(5);
	textbox *t=new textbox;
	g->Add(t);
	 t->Name("headtext");
	 t->ReadOnly();
	 t->MinCols(40);
	 t->MinRows(4);
	 t->AppendText(ml->header());
	fbutton *b=new fbutton;
	g->Add(b);
	 b->Text("_Close");
	 b->Callback(this,(CALLBACK)&showmail::closehead);
	 b->ApplyXKey(XK_Escape);

	headw->SetGroup(g);
	headw->Create();
}

// PGP:
//
// main mime: multipart/encrypted
//            multipart/signed
//   protocol="application/pgp-encrypted"
//            "application/pgp-signature"
//
// (1) signature:
//  part 1 -> pgp+part 2: part 1 new mail()
//
// (2) encrypted:
//  part 2 -> pgp: result new mail()
//
// new mail set as body mail
