/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: signature.cxx,v 2.3 2001/11/10 22:24:32 schmitzj Exp $ */


#include "configure.h"

#include "signature.h"
#include <string.h>
#include <stdio.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>


allsignatures::allsignatures(void)
{
	signatures_count=1;
	signatures[0]="default";
	readsigs();
}
allsignatures::~allsignatures()
{
	if (signatures_count>1)
	{
		for (int i=1;i<signatures_count;i++)
		{
			free(signatures[i]);
		}
		signatures_count=0;
	}
}
void allsignatures::readsigs(void)
{
	if (signatures_count>1)
	{
		for (int i=1;i<signatures_count;i++)
		{
			free(signatures[i]);
		}
		signatures_count=1;
	}

	char *h=getenv("HOME");
	char buf[300],tnam[60];
	struct stat st;
	DIR *dfd;
	struct dirent *dptr;
	xc_snprintf(tnam,sizeof(tnam),"%s.",SIGNATURE);
	int l=strlen(tnam);

	if (strlen(SIGNATURE) && (dfd=opendir(h)))
	{
		while ((dptr=readdir(dfd))&&signatures_count<MAXSIGNATURES)
		{
			if (!strnncmp(tnam,dptr->d_name))
			{
				strcpy(buf,h);
				strcat(buf,"/");
				strcat(buf,dptr->d_name);
				if (!stat(buf,&st))
				{
					if (S_ISREG(st.st_mode))
					{
						signatures[signatures_count++]=strdup(&dptr->d_name[l]);
					}
				}
			}
		}
		closedir(dfd);
	}
	signatures[signatures_count]=NULL;
}

// -------------------------------------------------------------------


signature::signature(char *suffix) : addedsignature()
{
	if (!suffix || !strcmp(suffix,"default"))
		read(NULL);
	else
		read(suffix);
}
signature::~signature()
{
}

void signature::read(char *subname)
{
	FILE *file;
	char name[800],*h=getenv("HOME"),*c;
	if (!h) return;
	xc_snprintf(name,sizeof(name),"%s/%s%s%s",h,SIGNATURE,subname?".":"",subname?subname:"");

	if (strlen(SIGNATURE) && (file=fopen(name,"r")))
	{
		setvbuf(file,NULL,_IOFBF,2000);

		if (programconfig.signdash)
		{
			addedsignature+="\n-- \n";
		}
		else
		{
			addedsignature+="\n";
		}
		while (!feof(file))
		{
			if (fgets(name,sizeof(name),file))
			{
				c=name;
				while (*c && *c!='`')
				{
					c++;
				}
				if (*c=='`')
				{
					char *cmd;
					FILE *file2;
					char buf[300];

					*c=0;
					addedsignature+=name;
					c++;
					cmd=c;
					while (*c && *c!='`')
					{
						c++;
					}
					*c=0;

					if (file2=popen(cmd,"r"))
					{
						while (fgets(buf,sizeof(buf)-1,file2)>0)
						{
							buf[sizeof(buf)-1]=0;
							addedsignature+=buf;
						}
						pclose(file2);
					}

					c++;
					addedsignature+=c;
				}
				else
				{
					addedsignature+=name;
				}
			}
		}
		fclose(file);
	}
}
char *signature::get(void)
{
	return addedsignature();
}
