/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: signatureed.cxx,v 2.5 2000/05/30 00:39:06 schmitzj Exp $ */


#include "configure.h"

#include "signatureed.h"
#include "mailer.h"
#include "signature.h"

#include <Xclasses/Xclasses.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/utsname.h>
#include <dirent.h>

void editsig(void)
{
	if (FindObject(".mainwindow.editsignature")) return;
	new signatureed;
}

static char *lastsignature=NULL;

signatureed::signatureed(void)
{
	ParentClass(readerwin);
	Name("editsignature");
	currentsig=NULL;
	allsigs=NULL;
	makewin();
}
signatureed::~signatureed()
{
	DeleteObjectTree(FullName(),DOT_NOTBASE);
	if (currentsig) free(currentsig);
}
void signatureed::close(gadget *g,int i)
{
	appwindow *aw=(appwindow*)FindObject(FullName(),".window");
	aw->Close();

	if (lastsignature) free(lastsignature);
	choice *ch=(choice*)FindObject(FullName(),".sigselect");
	if (ch->Selected()>0)
	{
		lastsignature=strdup(allsigs->signatures[ch->Selected()]);
	}

	delete this;
}
void signatureed::save(gadget *g,int i)
{
	savesig(currentsig);
	close(NULL,0);
}
void signatureed::menuhandler(gadget *g,int i)
{
	switch (((menu*)g)->Selection())
	{
		case 0x01000001: // Load
			{
				char dirbuf[600],filebuf[300];
				FILE *afile1;
				file_dialog fd;

				fd.ParentClass(g);
				fd.LoadMode();
				fd.SingleSelect();
				if (fd.Start((appwindow*)FindObject(FullName(),".window")))
				{
					fd.GetFile(filebuf,sizeof(filebuf));
					fd.GetDir(dirbuf,sizeof(dirbuf));
					strcat(dirbuf,filebuf);
					if (afile1=fopen(dirbuf,"r"))
					{
						setvbuf(afile1,NULL,_IOFBF,2000);
						textbox *txt=((textbox*)FindObject(FullName(),".signature"));
						struct stat st;
						char *buf;
						stat(dirbuf,&st);
			
						if (buf=new char[st.st_size+1])
						{
							if (fread(buf,1,st.st_size,afile1))
							{
								buf[st.st_size]=0;
								txt->ReplaceText(buf);
							}
						}
						fclose(afile1);
						txt->ActivateKey();
					}
				}
			}
			break;
		case 0x01000002: // Insert
			{
				char dirbuf[600],filebuf[300];
				FILE *afile1;
				file_dialog fd;

				fd.ParentClass(g);
				fd.LoadMode();
				fd.SingleSelect();
				if (fd.Start((appwindow*)FindObject(FullName(),".window")))
				{
					fd.GetFile(filebuf,sizeof(filebuf));
					fd.GetDir(dirbuf,sizeof(dirbuf));
					strcat(dirbuf,filebuf);
					if (afile1=fopen(dirbuf,"r"))
					{
						setvbuf(afile1,NULL,_IOFBF,2000);
						textbox *txt=((textbox*)FindObject(FullName(),".signature"));
						struct stat st;
						char *buf;
						stat(dirbuf,&st);
			
						if (buf=new char[st.st_size+1])
						{
							int x,y;

							txt->Cursor(x,y);
							if (x>0) y++;

							if (fread(buf,1,st.st_size,afile1))
							{
								buf[st.st_size]=0;
								txt->InsertText(buf,0,y);
							}
							txt->CursorTo(0,y);
						}
						fclose(afile1);
						txt->ActivateKey();
					}
				}
			}
			break;
	}
}
void signatureed::sigselect(gadget *g,int i)
{
	choice *ch=(choice*)FindObject(FullName(),".sigselect");

	if (!strcmp(g->Name(),"sigselect"))
	{
		savesig(currentsig);
		loadsig(ch->Selected());
	}
	else if (!strcmp(g->Name(),"new"))
	{
		appwindow *a=new appwindow;
		appwindow *aw=(appwindow*)FindObject(FullName(),".window");
		int x,y;

		GetPositionOnRoot(g->display(),g->gg_win(),x,y);
		a->InitSize(x,y,90);
		if (!a->Init())
		{
			delete aw;
			return;
		}
		a->TransientFor(aw);
		a->Name("newsigwindow");
		a->ParentClass(this);
		a->Title("Signature name...");
		a->IconTitle("Signature name...");
		a->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());

		spacegroup *sg1=new spacegroup;
		group *g1=new group;
		input *ip=new input;
		fbutton *fb1=new fbutton,*fb2=new fbutton;

		sg1->Border(4);
		sg1->Vert();
		sg1->Name(NULL);
		 ip->Name("name");
		 ip->Text("Signature name");
		 ip->MaxChars(30);
		 ip->Default("New Signature");
		 ip->Callback(this,(CALLBACK)&signatureed::sigselect);
		sg1->Add(ip);
		sg1->Add(new ruler);
		 g1->Horiz();
		 g1->Name(NULL);
		 g1->DialogMode();
		  fb1->Name("okbutton");
		  fb1->Text("_Ok");
		  fb1->Callback(this,(CALLBACK)&signatureed::sigselect);
		 g1->Add(fb1);
		  fb2->Name("cancelbutton");
		  fb2->Text("_Cancel");
		  fb2->Callback(this,(CALLBACK)&signatureed::sigselect);
		  fb2->ApplyXKey(XK_Escape);
		 g1->Add(fb2);
		sg1->Add(g1);
		a->SetGroup(sg1);
		a->Create();
		ip->ActivateKey();
		aw->Block();
	}
	else if (!strcmp(g->Name(),"del"))
	{
		if (ch->Selected()>0)
		{
			if (((appwindow*)FindObject(FullName(),".window"))->Alert("Really remove signature\n'%s'?","_Yes|_No",allsigs->signatures[ch->Selected()])==1)
			{
				remove(currentsig);
				readsigs();
				ch->Selected(0);
				loadsig();
			}
		}
		else
		{
			((appwindow*)FindObject(FullName(),".window"))->Alert("Can't delete default signature!","_Ok");
		}
	}
	else if (!strcmp(g->Name(),"name") || !strcmp(g->Name(),"okbutton") || !strcmp(g->Name(),"cancelbutton"))
	{
		appwindow *aw=(appwindow*)FindObject(FullName(),".window");
		aw->Unblock();

		if (!strcmp(g->Name(),"okbutton") || !strcmp(g->Name(),"name"))
		{
			savesig(currentsig);

			textbox *txt=(textbox*)FindObject(FullName(),".signature");
			char buf[31];
			txt->ReplaceText("");
			((input*)FindObject(FullName(),".newsigwindow.name"))->Input(buf);

			savesig(buf);
			readsigs();
			ch->Selected(0);
			for(int i=0;i<allsigs->signatures_count;i++)
			{
				if (!strcmp(allsigs->signatures[i],buf))
				{
					ch->Selected(i);
				}
			}
			loadsig(ch->Selected());
		}
		appwindow *a=(appwindow*)FindObject(FullName(),".newsigwindow");
		a->Close();
		DeleteObjectTree(a->FullName());
	}
}
void signatureed::makewin(void)
{
	int x,y;
	appwindow *aw=new appwindow;
	readerwin.Position(x,y);
	aw->ParentClass(this);
	aw->Name("window");

	pstatus("Open signature editor");

	aw->InitSize(x,y,30);
	if (!aw->Init())
	{
		pstatus("Error in opening window!");
		delete this;
	}
	aw->Title("Signature editor");
	aw->IconTitle("Edit signature");
	aw->SetIcon(f_xicon1.pixmap(),f_xicon1.shadowmap());
	aw->Callback(this,(CLOSECALLBACK)&signatureed::close);
	aw->Group(readerwin);
	aw->TransientFor(readerwin.window());

	spacegroup *maingp=new spacegroup;
	maingp->Name("maingroup");
	maingp->YDistance(4);
	maingp->Vert();
	maingp->Border(4);

	 group *g1=new group;
	 g1->Name("ctlgroup");
	 g1->Horiz();
	 static char *items[]={"",NULL};
	  choice *ch=new choice;
	  ch->Name("sigselect");
	  ch->Callback(this,(CALLBACK)&signatureed::sigselect);
	  ch->Items(items);
	  ch->HelpText("choose a signature to edit");
	 g1->Add(ch,"_Signature");
	  fbutton *fb1=new fbutton;
	  fb1->Name("new");
	  fb1->Text("_new signature...");
	  fb1->Callback(this,(CALLBACK)&signatureed::sigselect);
	  fb1->Weight(50);
	  ch->HelpText("create a new signature");
	 g1->Add(fb1);
	  fb1=new fbutton;
	  fb1->Name("del");
	  fb1->Text("_delete this...");
	  fb1->Callback(this,(CALLBACK)&signatureed::sigselect);
	  fb1->Weight(50);
	  ch->HelpText("remove the shown signature");
	 g1->Add(fb1);
	maingp->Add(g1);

	 textbox *atxt=new textbox;
	 atxt->Name("signature");
	 atxt->MinCols(50);
	 atxt->MinRows(5);
	 atxt->HelpText("Enter your signature, you may place any\n"
	 				"command in backquotes (`) in one line which\n"
	 				"will be executed every time a signature\n"
	 				"is added - e.g. `fortune`.");
	maingp->Add(atxt);
	maingp->Add(new ruler);

	 g1=new group;
	 g1->Name(NULL);
	 g1->Horiz();
	 g1->DialogMode();
     fbutton *b;
	  b=new fbutton;
	  b->Text("_Save");
	  b->Callback(this,(CALLBACK)&signatureed::save);
	 g1->Add(b);
	  b=new fbutton;
	  b->Text("_Cancel");
	  b->Callback(this,(CALLBACK)&signatureed::close);
	  b->ApplyXKey(XK_Escape);
	 g1->Add(b);
	maingp->Add(g1);

	aw->SetGroup(maingp);

	menu *mn=new menu;
	mn->NoHelpMenu(REASON_SUBWINDOW,(Xwindows*)aw);
	mn->Callback(this,(CALLBACK)&signatureed::menuhandler);

	mn->AddMenu("File");
	mn->Add("Load...","l",1);
	mn->Add("Insert...","i",2);

	aw->SetMenu(mn);
	aw->Create();
	readsigs();
	if (lastsignature)
	{
		for (int i=1;i<allsigs->signatures_count;i++)
		{
			if (!strcmp(allsigs->signatures[i],lastsignature))
			{
				((choice*)FindObject(FullName(),".sigselect"))->Selected(i);
			}
		}
	}
	loadsig(((choice*)FindObject(FullName(),".sigselect"))->Selected());
}

void signatureed::loadsig(int s)
{
	if (s==0)
		loadsig();
	else
		loadsig(allsigs->signatures[s]);
}
void signatureed::loadsig(char *suffix)
{
	FILE *file;
	char name[300],*h=getenv("HOME");

	if (h)
	{
		textbox *atxt=((textbox*)FindObject(FullName(),".signature"));
		atxt->ReplaceText("");
		if (suffix && suffix[0]=='/')
			strcpy(name,suffix);
		else
			xc_snprintf(name,sizeof(name),"%s/%s%s%s",h,SIGNATURE,suffix?".":"",suffix?suffix:"");
		if (file=fopen(name,"r"))
		{
			if (currentsig) free(currentsig);
			currentsig=strdup(name);

			setvbuf(file,NULL,_IOFBF,2000);
			while (!feof(file))
			{
				if (fgets(name,sizeof(name),file))
				{
					atxt->AppendText(name);
				}
			}
			fclose(file);
		}
		atxt->ActivateKey();
		atxt->CursorTo(0,0);
	}
}
void signatureed::savesig(char *suffix)
{
	textbox *txt=(textbox*)FindObject(FullName(),".signature");
	FILE *file;
	char name[300],*h=getenv("HOME");

	if (h)
	{
		char *t=new char[txt->TextSize()+2];
		txt->CopyText(t,txt->TextSize()+1);
		if (suffix && suffix[0]=='/')
			strcpy(name,suffix);
		else
			xc_snprintf(name,sizeof(name),"%s/%s%s%s",h,SIGNATURE,suffix?".":"",suffix?suffix:"");

		if (file=fopen(name,"w"))
		{
			fwrite(t,strlen(t),1,file);
			fclose(file);
		}
	}
}
void signatureed::readsigs(void)
{
	delete allsigs;
	allsigs=new allsignatures;
	((choice*)FindObject(FullName(),".sigselect"))->Items(allsigs->signatures);
}
