/* 
 * This file is part of XCmail and is subject to the 
 * XCmail license agreement
 */

/* $Id: strbuf.cxx,v 2.10 2001/10/10 17:12:04 schmitzj Exp $ */


#include "configure.h"

#include <string.h>
#include <stdlib.h>
#include "strbuf.h"

char *xcm_strbuf::operator+(char *t)
{
	operator+=(t);
	return buf;
}
char *xcm_strbuf::operator+(char t)
{
	operator+=(t);
	return buf;
}

#define MIN(x1,x2)	(x1<x2?x1:x2)
void *myrealloc(void *oldp,int size,int oldsize)
{
	void *newp = malloc(size);
	if (NULL != newp)
	{
		if (oldp)
		{ //printf("New: %x, old: %x\n",newp,oldp);
	    	memcpy(newp, oldp, MIN(size, oldsize));
		    free(oldp);
		}
	}
	return newp;
}

void xcm_strbuf::operator+=(char *t)
{
	int wlen=1;
	char *c=t;

	while (*c)
	{
		if (*c=='\t')
			wlen+=4;	// worst case!
		else
			wlen++;
		c++;
	}
	if (used+wlen>=size || !buf)
	{
		char *nbuf=(char*)realloc(buf,used+wlen+100);
		if (!nbuf) return;
		buf=nbuf;
		size=used+wlen+100;
		buf[used]=0;
	}
	char *c2=t;
	while (*c2)
	{
		buf[used++]=*c2;
		if (*c2=='\t')
		{
			buf[used-1]=' ';
			int d=4-(x%4)-1;
 			for (int i=0;i<d;i++)
			{
				buf[used++]=' ';
			}
		}
		else if (*c2=='\n')
			x=0;
		else
			x++;
		c2++;
	}
	buf[used]=0;
}
void xcm_strbuf::operator+=(char t)
{
	char buf[2];
	buf[0]=t;
	buf[1]=0;
	operator+=(buf);
}
xcm_strbuf::operator char *() const
{
	return buf?buf:(char*)"";
}

char *xcm_strbuf::operator()(void)
{
	return buf?buf:(char*)"";
}
void xcm_strbuf::operator()(int nsize)
{
	if (nsize>=size)
	{
		char *bufold=buf;
		buf=(char*)realloc(buf,nsize+1);
		if (!buf)
		{
			buf=bufold;
			return;
		}
		size=nsize+1;
		used=0;
		buf[used]=0;
	}
}
void xcm_strbuf::update(void)
{
	used=strlen(buf);
}
void xcm_strbuf::clear(void)
{
	if (buf)
	{
		free(buf);
	}
	buf=NULL;
	used=0;
	size=0;
}

void xcm_strbuf::resize(int r)
{
	if (r<used)
	{
		buf[r]=0;
		used=r;
	}
}
int xcm_strbuf::length(void)
{
	return used;
}
